import * as coreClient from "@azure/core-client";
import * as coreAuth from "@azure/core-auth";
import { Operations, AvailabilitySets, ProximityPlacementGroups, DedicatedHostGroups, DedicatedHosts, SshPublicKeys, VirtualMachineExtensionImages, VirtualMachineExtensions, VirtualMachineImages, VirtualMachineImagesEdgeZone, UsageOperations, VirtualMachines, VirtualMachineScaleSets, VirtualMachineSizes, Images, RestorePointCollections, RestorePoints, CapacityReservationGroups, CapacityReservations, VirtualMachineScaleSetExtensions, VirtualMachineScaleSetRollingUpgrades, VirtualMachineScaleSetVMExtensions, VirtualMachineScaleSetVMs, LogAnalytics, VirtualMachineRunCommands, VirtualMachineScaleSetVMRunCommands, ResourceSkus, Disks, Snapshots, DiskEncryptionSets, DiskAccesses, DiskRestorePointOperations, Galleries, GalleryImages, GalleryImageVersions, GalleryApplications, GalleryApplicationVersions, GallerySharingProfile, SharedGalleries, SharedGalleryImages, SharedGalleryImageVersions, CommunityGalleries, CommunityGalleryImages, CommunityGalleryImageVersions, CloudServiceRoleInstances, CloudServiceRoles, CloudServices, CloudServicesUpdateDomain, CloudServiceOperatingSystems } from "./operationsInterfaces";
import { ComputeManagementClientOptionalParams } from "./models";
export declare class ComputeManagementClient extends coreClient.ServiceClient {
    $host: string;
    subscriptionId: string;
    /**
     * Initializes a new instance of the ComputeManagementClient class.
     * @param credentials Subscription credentials which uniquely identify client subscription.
     * @param subscriptionId Subscription credentials which uniquely identify Microsoft Azure subscription.
     *                       The subscription ID forms part of the URI for every service call.
     * @param options The parameter options
     */
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: ComputeManagementClientOptionalParams);
    operations: Operations;
    availabilitySets: AvailabilitySets;
    proximityPlacementGroups: ProximityPlacementGroups;
    dedicatedHostGroups: DedicatedHostGroups;
    dedicatedHosts: DedicatedHosts;
    sshPublicKeys: SshPublicKeys;
    virtualMachineExtensionImages: VirtualMachineExtensionImages;
    virtualMachineExtensions: VirtualMachineExtensions;
    virtualMachineImages: VirtualMachineImages;
    virtualMachineImagesEdgeZone: VirtualMachineImagesEdgeZone;
    usageOperations: UsageOperations;
    virtualMachines: VirtualMachines;
    virtualMachineScaleSets: VirtualMachineScaleSets;
    virtualMachineSizes: VirtualMachineSizes;
    images: Images;
    restorePointCollections: RestorePointCollections;
    restorePoints: RestorePoints;
    capacityReservationGroups: CapacityReservationGroups;
    capacityReservations: CapacityReservations;
    virtualMachineScaleSetExtensions: VirtualMachineScaleSetExtensions;
    virtualMachineScaleSetRollingUpgrades: VirtualMachineScaleSetRollingUpgrades;
    virtualMachineScaleSetVMExtensions: VirtualMachineScaleSetVMExtensions;
    virtualMachineScaleSetVMs: VirtualMachineScaleSetVMs;
    logAnalytics: LogAnalytics;
    virtualMachineRunCommands: VirtualMachineRunCommands;
    virtualMachineScaleSetVMRunCommands: VirtualMachineScaleSetVMRunCommands;
    resourceSkus: ResourceSkus;
    disks: Disks;
    snapshots: Snapshots;
    diskEncryptionSets: DiskEncryptionSets;
    diskAccesses: DiskAccesses;
    diskRestorePointOperations: DiskRestorePointOperations;
    galleries: Galleries;
    galleryImages: GalleryImages;
    galleryImageVersions: GalleryImageVersions;
    galleryApplications: GalleryApplications;
    galleryApplicationVersions: GalleryApplicationVersions;
    gallerySharingProfile: GallerySharingProfile;
    sharedGalleries: SharedGalleries;
    sharedGalleryImages: SharedGalleryImages;
    sharedGalleryImageVersions: SharedGalleryImageVersions;
    communityGalleries: CommunityGalleries;
    communityGalleryImages: CommunityGalleryImages;
    communityGalleryImageVersions: CommunityGalleryImageVersions;
    cloudServiceRoleInstances: CloudServiceRoleInstances;
    cloudServiceRoles: CloudServiceRoles;
    cloudServices: CloudServices;
    cloudServicesUpdateDomain: CloudServicesUpdateDomain;
    cloudServiceOperatingSystems: CloudServiceOperatingSystems;
}
//# sourceMappingURL=computeManagementClient.d.ts.map