/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
export var acceptLanguage = {
    parameterPath: "acceptLanguage",
    mapper: {
        serializedName: "accept-language",
        defaultValue: 'en-US',
        type: {
            name: "String"
        }
    }
};
export var apiVersion0 = {
    parameterPath: "apiVersion",
    mapper: {
        required: true,
        serializedName: "api-version",
        type: {
            name: "String"
        }
    }
};
export var apiVersion1 = {
    parameterPath: "apiVersion",
    mapper: {
        required: true,
        isConstant: true,
        serializedName: "api-version",
        defaultValue: '2015-11-01',
        type: {
            name: "String"
        }
    }
};
export var filter = {
    parameterPath: "filter",
    mapper: {
        required: true,
        isConstant: true,
        serializedName: "$filter",
        defaultValue: 'resourceType eq \'Microsoft.KeyVault/vaults\'',
        type: {
            name: "String"
        }
    }
};
export var location = {
    parameterPath: "location",
    mapper: {
        required: true,
        serializedName: "location",
        type: {
            name: "String"
        }
    }
};
export var nextPageLink = {
    parameterPath: "nextPageLink",
    mapper: {
        required: true,
        serializedName: "nextLink",
        type: {
            name: "String"
        }
    },
    skipEncoding: true
};
export var operationKind = {
    parameterPath: "operationKind",
    mapper: {
        required: true,
        serializedName: "operationKind",
        type: {
            name: "Enum",
            allowedValues: [
                "add",
                "replace",
                "remove"
            ]
        }
    }
};
export var resourceGroupName = {
    parameterPath: "resourceGroupName",
    mapper: {
        required: true,
        serializedName: "resourceGroupName",
        type: {
            name: "String"
        }
    }
};
export var subscriptionId = {
    parameterPath: "subscriptionId",
    mapper: {
        required: true,
        serializedName: "subscriptionId",
        type: {
            name: "String"
        }
    }
};
export var top = {
    parameterPath: [
        "options",
        "top"
    ],
    mapper: {
        serializedName: "$top",
        type: {
            name: "Number"
        }
    }
};
export var vaultName0 = {
    parameterPath: "vaultName",
    mapper: {
        required: true,
        serializedName: "vaultName",
        constraints: {
            Pattern: /^[a-zA-Z0-9-]{3,24}$/
        },
        type: {
            name: "String"
        }
    }
};
export var vaultName1 = {
    parameterPath: "vaultName",
    mapper: {
        required: true,
        serializedName: "vaultName",
        type: {
            name: "String"
        }
    }
};
//# sourceMappingURL=parameters.js.map