import * as coreClient from "@azure/core-client";
import * as coreAuth from "@azure/core-auth";
import { Operations, Deployments, Providers, ProviderResourceTypes, Resources, ResourceGroups, TagsOperations, DeploymentOperations } from "./operationsInterfaces";
import { ResourceManagementClientOptionalParams } from "./models";
export declare class ResourceManagementClient extends coreClient.ServiceClient {
    $host: string;
    apiVersion: string;
    subscriptionId: string;
    /**
     * Initializes a new instance of the ResourceManagementClient class.
     * @param credentials Subscription credentials which uniquely identify client subscription.
     * @param subscriptionId The Microsoft Azure subscription ID.
     * @param options The parameter options
     */
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: ResourceManagementClientOptionalParams);
    operations: Operations;
    deployments: Deployments;
    providers: Providers;
    providerResourceTypes: ProviderResourceTypes;
    resources: Resources;
    resourceGroups: ResourceGroups;
    tagsOperations: TagsOperations;
    deploymentOperations: DeploymentOperations;
}
//# sourceMappingURL=resourceManagementClient.d.ts.map