/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
export const ComputeOperationListResult = {
    type: {
        name: "Composite",
        className: "ComputeOperationListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ComputeOperationValue"
                        }
                    }
                }
            }
        }
    }
};
export const ComputeOperationValue = {
    type: {
        name: "Composite",
        className: "ComputeOperationValue",
        modelProperties: {
            origin: {
                serializedName: "origin",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            operation: {
                serializedName: "display.operation",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            resource: {
                serializedName: "display.resource",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "display.description",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            provider: {
                serializedName: "display.provider",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SubResource = {
    type: {
        name: "Composite",
        className: "SubResource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const InstanceViewStatus = {
    type: {
        name: "Composite",
        className: "InstanceViewStatus",
        modelProperties: {
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            level: {
                serializedName: "level",
                type: {
                    name: "Enum",
                    allowedValues: ["Info", "Warning", "Error"]
                }
            },
            displayStatus: {
                serializedName: "displayStatus",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            },
            time: {
                serializedName: "time",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export const Sku = {
    type: {
        name: "Composite",
        className: "Sku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const Resource = {
    type: {
        name: "Composite",
        className: "Resource",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                required: true,
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            }
        }
    }
};
export const UpdateResource = {
    type: {
        name: "Composite",
        className: "UpdateResource",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            }
        }
    }
};
export const AvailabilitySetListResult = {
    type: {
        name: "Composite",
        className: "AvailabilitySetListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AvailabilitySet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineSizeListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineSizeListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineSize"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineSize = {
    type: {
        name: "Composite",
        className: "VirtualMachineSize",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            numberOfCores: {
                serializedName: "numberOfCores",
                type: {
                    name: "Number"
                }
            },
            osDiskSizeInMB: {
                serializedName: "osDiskSizeInMB",
                type: {
                    name: "Number"
                }
            },
            resourceDiskSizeInMB: {
                serializedName: "resourceDiskSizeInMB",
                type: {
                    name: "Number"
                }
            },
            memoryInMB: {
                serializedName: "memoryInMB",
                type: {
                    name: "Number"
                }
            },
            maxDataDiskCount: {
                serializedName: "maxDataDiskCount",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const ProximityPlacementGroupListResult = {
    type: {
        name: "Composite",
        className: "ProximityPlacementGroupListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ProximityPlacementGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SubResourceReadOnly = {
    type: {
        name: "Composite",
        className: "SubResourceReadOnly",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DedicatedHostGroupInstanceView = {
    type: {
        name: "Composite",
        className: "DedicatedHostGroupInstanceView",
        modelProperties: {
            hosts: {
                serializedName: "hosts",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHostInstanceViewWithName"
                        }
                    }
                }
            }
        }
    }
};
export const DedicatedHostInstanceView = {
    type: {
        name: "Composite",
        className: "DedicatedHostInstanceView",
        modelProperties: {
            assetId: {
                serializedName: "assetId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            availableCapacity: {
                serializedName: "availableCapacity",
                type: {
                    name: "Composite",
                    className: "DedicatedHostAvailableCapacity"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const DedicatedHostAvailableCapacity = {
    type: {
        name: "Composite",
        className: "DedicatedHostAvailableCapacity",
        modelProperties: {
            allocatableVMs: {
                serializedName: "allocatableVMs",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHostAllocatableVM"
                        }
                    }
                }
            }
        }
    }
};
export const DedicatedHostAllocatableVM = {
    type: {
        name: "Composite",
        className: "DedicatedHostAllocatableVM",
        modelProperties: {
            vmSize: {
                serializedName: "vmSize",
                type: {
                    name: "String"
                }
            },
            count: {
                serializedName: "count",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const DedicatedHostGroupListResult = {
    type: {
        name: "Composite",
        className: "DedicatedHostGroupListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHostGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DedicatedHostListResult = {
    type: {
        name: "Composite",
        className: "DedicatedHostListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DedicatedHost"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SshPublicKeysGroupListResult = {
    type: {
        name: "Composite",
        className: "SshPublicKeysGroupListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SshPublicKeyResource"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SshPublicKeyGenerateKeyPairResult = {
    type: {
        name: "Composite",
        className: "SshPublicKeyGenerateKeyPairResult",
        modelProperties: {
            privateKey: {
                serializedName: "privateKey",
                required: true,
                type: {
                    name: "String"
                }
            },
            publicKey: {
                serializedName: "publicKey",
                required: true,
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineExtensionInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionInstanceView",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            typeHandlerVersion: {
                serializedName: "typeHandlerVersion",
                type: {
                    name: "String"
                }
            },
            substatuses: {
                serializedName: "substatuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineExtensionsListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionsListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtension"
                        }
                    }
                }
            }
        }
    }
};
export const PurchasePlan = {
    type: {
        name: "Composite",
        className: "PurchasePlan",
        modelProperties: {
            publisher: {
                serializedName: "publisher",
                required: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            product: {
                serializedName: "product",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const OSDiskImage = {
    type: {
        name: "Composite",
        className: "OSDiskImage",
        modelProperties: {
            operatingSystem: {
                serializedName: "operatingSystem",
                required: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }
        }
    }
};
export const DataDiskImage = {
    type: {
        name: "Composite",
        className: "DataDiskImage",
        modelProperties: {
            lun: {
                serializedName: "lun",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const AutomaticOSUpgradeProperties = {
    type: {
        name: "Composite",
        className: "AutomaticOSUpgradeProperties",
        modelProperties: {
            automaticOSUpgradeSupported: {
                serializedName: "automaticOSUpgradeSupported",
                required: true,
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const DisallowedConfiguration = {
    type: {
        name: "Composite",
        className: "DisallowedConfiguration",
        modelProperties: {
            vmDiskType: {
                serializedName: "vmDiskType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineImageFeature = {
    type: {
        name: "Composite",
        className: "VirtualMachineImageFeature",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ExtendedLocation = {
    type: {
        name: "Composite",
        className: "ExtendedLocation",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudError = {
    type: {
        name: "Composite",
        className: "CloudError",
        modelProperties: {
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export const ApiError = {
    type: {
        name: "Composite",
        className: "ApiError",
        modelProperties: {
            details: {
                serializedName: "details",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApiErrorBase"
                        }
                    }
                }
            },
            innererror: {
                serializedName: "innererror",
                type: {
                    name: "Composite",
                    className: "InnerError"
                }
            },
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ApiErrorBase = {
    type: {
        name: "Composite",
        className: "ApiErrorBase",
        modelProperties: {
            code: {
                serializedName: "code",
                type: {
                    name: "String"
                }
            },
            target: {
                serializedName: "target",
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const InnerError = {
    type: {
        name: "Composite",
        className: "InnerError",
        modelProperties: {
            exceptiontype: {
                serializedName: "exceptiontype",
                type: {
                    name: "String"
                }
            },
            errordetail: {
                serializedName: "errordetail",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ListUsagesResult = {
    type: {
        name: "Composite",
        className: "ListUsagesResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Usage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const Usage = {
    type: {
        name: "Composite",
        className: "Usage",
        modelProperties: {
            unit: {
                defaultValue: "Count",
                isConstant: true,
                serializedName: "unit",
                type: {
                    name: "String"
                }
            },
            currentValue: {
                serializedName: "currentValue",
                required: true,
                type: {
                    name: "Number"
                }
            },
            limit: {
                serializedName: "limit",
                required: true,
                type: {
                    name: "Number"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "Composite",
                    className: "UsageName"
                }
            }
        }
    }
};
export const UsageName = {
    type: {
        name: "Composite",
        className: "UsageName",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            },
            localizedValue: {
                serializedName: "localizedValue",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachine"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const Plan = {
    type: {
        name: "Composite",
        className: "Plan",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            product: {
                serializedName: "product",
                type: {
                    name: "String"
                }
            },
            promotionCode: {
                serializedName: "promotionCode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const HardwareProfile = {
    type: {
        name: "Composite",
        className: "HardwareProfile",
        modelProperties: {
            vmSize: {
                serializedName: "vmSize",
                type: {
                    name: "String"
                }
            },
            vmSizeProperties: {
                serializedName: "vmSizeProperties",
                type: {
                    name: "Composite",
                    className: "VMSizeProperties"
                }
            }
        }
    }
};
export const VMSizeProperties = {
    type: {
        name: "Composite",
        className: "VMSizeProperties",
        modelProperties: {
            vCPUsAvailable: {
                serializedName: "vCPUsAvailable",
                type: {
                    name: "Number"
                }
            },
            vCPUsPerCore: {
                serializedName: "vCPUsPerCore",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const StorageProfile = {
    type: {
        name: "Composite",
        className: "StorageProfile",
        modelProperties: {
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "OSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DataDisk"
                        }
                    }
                }
            }
        }
    }
};
export const OSDisk = {
    type: {
        name: "Composite",
        className: "OSDisk",
        modelProperties: {
            osType: {
                serializedName: "osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSettings"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            vhd: {
                serializedName: "vhd",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            diffDiskSettings: {
                serializedName: "diffDiskSettings",
                type: {
                    name: "Composite",
                    className: "DiffDiskSettings"
                }
            },
            createOption: {
                serializedName: "createOption",
                required: true,
                type: {
                    name: "String"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            deleteOption: {
                serializedName: "deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskEncryptionSettings = {
    type: {
        name: "Composite",
        className: "DiskEncryptionSettings",
        modelProperties: {
            diskEncryptionKey: {
                serializedName: "diskEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultSecretReference"
                }
            },
            keyEncryptionKey: {
                serializedName: "keyEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultKeyReference"
                }
            },
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const KeyVaultSecretReference = {
    type: {
        name: "Composite",
        className: "KeyVaultSecretReference",
        modelProperties: {
            secretUrl: {
                serializedName: "secretUrl",
                required: true,
                type: {
                    name: "String"
                }
            },
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export const KeyVaultKeyReference = {
    type: {
        name: "Composite",
        className: "KeyVaultKeyReference",
        modelProperties: {
            keyUrl: {
                serializedName: "keyUrl",
                required: true,
                type: {
                    name: "String"
                }
            },
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export const VirtualHardDisk = {
    type: {
        name: "Composite",
        className: "VirtualHardDisk",
        modelProperties: {
            uri: {
                serializedName: "uri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiffDiskSettings = {
    type: {
        name: "Composite",
        className: "DiffDiskSettings",
        modelProperties: {
            option: {
                serializedName: "option",
                type: {
                    name: "String"
                }
            },
            placement: {
                serializedName: "placement",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DataDisk = {
    type: {
        name: "Composite",
        className: "DataDisk",
        modelProperties: {
            lun: {
                serializedName: "lun",
                required: true,
                type: {
                    name: "Number"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            vhd: {
                serializedName: "vhd",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            createOption: {
                serializedName: "createOption",
                required: true,
                type: {
                    name: "String"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            toBeDetached: {
                serializedName: "toBeDetached",
                type: {
                    name: "Boolean"
                }
            },
            diskIopsReadWrite: {
                serializedName: "diskIOPSReadWrite",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadWrite: {
                serializedName: "diskMBpsReadWrite",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            detachOption: {
                serializedName: "detachOption",
                type: {
                    name: "String"
                }
            },
            deleteOption: {
                serializedName: "deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const AdditionalCapabilities = {
    type: {
        name: "Composite",
        className: "AdditionalCapabilities",
        modelProperties: {
            ultraSSDEnabled: {
                serializedName: "ultraSSDEnabled",
                type: {
                    name: "Boolean"
                }
            },
            hibernationEnabled: {
                serializedName: "hibernationEnabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const OSProfile = {
    type: {
        name: "Composite",
        className: "OSProfile",
        modelProperties: {
            computerName: {
                serializedName: "computerName",
                type: {
                    name: "String"
                }
            },
            adminUsername: {
                serializedName: "adminUsername",
                type: {
                    name: "String"
                }
            },
            adminPassword: {
                serializedName: "adminPassword",
                type: {
                    name: "String"
                }
            },
            customData: {
                serializedName: "customData",
                type: {
                    name: "String"
                }
            },
            windowsConfiguration: {
                serializedName: "windowsConfiguration",
                type: {
                    name: "Composite",
                    className: "WindowsConfiguration"
                }
            },
            linuxConfiguration: {
                serializedName: "linuxConfiguration",
                type: {
                    name: "Composite",
                    className: "LinuxConfiguration"
                }
            },
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultSecretGroup"
                        }
                    }
                }
            },
            allowExtensionOperations: {
                serializedName: "allowExtensionOperations",
                type: {
                    name: "Boolean"
                }
            },
            requireGuestProvisionSignal: {
                serializedName: "requireGuestProvisionSignal",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const WindowsConfiguration = {
    type: {
        name: "Composite",
        className: "WindowsConfiguration",
        modelProperties: {
            provisionVMAgent: {
                serializedName: "provisionVMAgent",
                type: {
                    name: "Boolean"
                }
            },
            enableAutomaticUpdates: {
                serializedName: "enableAutomaticUpdates",
                type: {
                    name: "Boolean"
                }
            },
            timeZone: {
                serializedName: "timeZone",
                type: {
                    name: "String"
                }
            },
            additionalUnattendContent: {
                serializedName: "additionalUnattendContent",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "AdditionalUnattendContent"
                        }
                    }
                }
            },
            patchSettings: {
                serializedName: "patchSettings",
                type: {
                    name: "Composite",
                    className: "PatchSettings"
                }
            },
            winRM: {
                serializedName: "winRM",
                type: {
                    name: "Composite",
                    className: "WinRMConfiguration"
                }
            }
        }
    }
};
export const AdditionalUnattendContent = {
    type: {
        name: "Composite",
        className: "AdditionalUnattendContent",
        modelProperties: {
            passName: {
                defaultValue: "OobeSystem",
                isConstant: true,
                serializedName: "passName",
                type: {
                    name: "String"
                }
            },
            componentName: {
                defaultValue: "Microsoft-Windows-Shell-Setup",
                isConstant: true,
                serializedName: "componentName",
                type: {
                    name: "String"
                }
            },
            settingName: {
                serializedName: "settingName",
                type: {
                    name: "Enum",
                    allowedValues: ["AutoLogon", "FirstLogonCommands"]
                }
            },
            content: {
                serializedName: "content",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PatchSettings = {
    type: {
        name: "Composite",
        className: "PatchSettings",
        modelProperties: {
            patchMode: {
                serializedName: "patchMode",
                type: {
                    name: "String"
                }
            },
            enableHotpatching: {
                serializedName: "enableHotpatching",
                type: {
                    name: "Boolean"
                }
            },
            assessmentMode: {
                serializedName: "assessmentMode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const WinRMConfiguration = {
    type: {
        name: "Composite",
        className: "WinRMConfiguration",
        modelProperties: {
            listeners: {
                serializedName: "listeners",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "WinRMListener"
                        }
                    }
                }
            }
        }
    }
};
export const WinRMListener = {
    type: {
        name: "Composite",
        className: "WinRMListener",
        modelProperties: {
            protocol: {
                serializedName: "protocol",
                type: {
                    name: "Enum",
                    allowedValues: ["Http", "Https"]
                }
            },
            certificateUrl: {
                serializedName: "certificateUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const LinuxConfiguration = {
    type: {
        name: "Composite",
        className: "LinuxConfiguration",
        modelProperties: {
            disablePasswordAuthentication: {
                serializedName: "disablePasswordAuthentication",
                type: {
                    name: "Boolean"
                }
            },
            ssh: {
                serializedName: "ssh",
                type: {
                    name: "Composite",
                    className: "SshConfiguration"
                }
            },
            provisionVMAgent: {
                serializedName: "provisionVMAgent",
                type: {
                    name: "Boolean"
                }
            },
            patchSettings: {
                serializedName: "patchSettings",
                type: {
                    name: "Composite",
                    className: "LinuxPatchSettings"
                }
            }
        }
    }
};
export const SshConfiguration = {
    type: {
        name: "Composite",
        className: "SshConfiguration",
        modelProperties: {
            publicKeys: {
                serializedName: "publicKeys",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SshPublicKey"
                        }
                    }
                }
            }
        }
    }
};
export const SshPublicKey = {
    type: {
        name: "Composite",
        className: "SshPublicKey",
        modelProperties: {
            path: {
                serializedName: "path",
                type: {
                    name: "String"
                }
            },
            keyData: {
                serializedName: "keyData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const LinuxPatchSettings = {
    type: {
        name: "Composite",
        className: "LinuxPatchSettings",
        modelProperties: {
            patchMode: {
                serializedName: "patchMode",
                type: {
                    name: "String"
                }
            },
            assessmentMode: {
                serializedName: "assessmentMode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VaultSecretGroup = {
    type: {
        name: "Composite",
        className: "VaultSecretGroup",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            vaultCertificates: {
                serializedName: "vaultCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultCertificate"
                        }
                    }
                }
            }
        }
    }
};
export const VaultCertificate = {
    type: {
        name: "Composite",
        className: "VaultCertificate",
        modelProperties: {
            certificateUrl: {
                serializedName: "certificateUrl",
                type: {
                    name: "String"
                }
            },
            certificateStore: {
                serializedName: "certificateStore",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const NetworkProfile = {
    type: {
        name: "Composite",
        className: "NetworkProfile",
        modelProperties: {
            networkInterfaces: {
                serializedName: "networkInterfaces",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "NetworkInterfaceReference"
                        }
                    }
                }
            },
            networkApiVersion: {
                serializedName: "networkApiVersion",
                type: {
                    name: "String"
                }
            },
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineNetworkInterfaceConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineNetworkInterfaceConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineNetworkInterfaceConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            },
            enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            },
            enableFpga: {
                serializedName: "properties.enableFpga",
                type: {
                    name: "Boolean"
                }
            },
            enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            },
            networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineNetworkInterfaceDnsSettingsConfiguration"
                }
            },
            ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineNetworkInterfaceIPConfiguration"
                        }
                    }
                }
            },
            dscpConfiguration: {
                serializedName: "properties.dscpConfiguration",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export const VirtualMachineNetworkInterfaceDnsSettingsConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineNetworkInterfaceDnsSettingsConfiguration",
        modelProperties: {
            dnsServers: {
                serializedName: "dnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineNetworkInterfaceIPConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineNetworkInterfaceIPConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            },
            publicIPAddressConfiguration: {
                serializedName: "properties.publicIPAddressConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachinePublicIPAddressConfiguration"
                }
            },
            privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            },
            applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            },
            applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            },
            loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachinePublicIPAddressConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachinePublicIPAddressConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "PublicIPAddressSku"
                }
            },
            idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachinePublicIPAddressDnsSettingsConfiguration"
                }
            },
            ipTags: {
                serializedName: "properties.ipTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineIpTag"
                        }
                    }
                }
            },
            publicIPPrefix: {
                serializedName: "properties.publicIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            publicIPAddressVersion: {
                serializedName: "properties.publicIPAddressVersion",
                type: {
                    name: "String"
                }
            },
            publicIPAllocationMethod: {
                serializedName: "properties.publicIPAllocationMethod",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachinePublicIPAddressDnsSettingsConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachinePublicIPAddressDnsSettingsConfiguration",
        modelProperties: {
            domainNameLabel: {
                serializedName: "domainNameLabel",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineIpTag = {
    type: {
        name: "Composite",
        className: "VirtualMachineIpTag",
        modelProperties: {
            ipTagType: {
                serializedName: "ipTagType",
                type: {
                    name: "String"
                }
            },
            tag: {
                serializedName: "tag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PublicIPAddressSku = {
    type: {
        name: "Composite",
        className: "PublicIPAddressSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SecurityProfile = {
    type: {
        name: "Composite",
        className: "SecurityProfile",
        modelProperties: {
            uefiSettings: {
                serializedName: "uefiSettings",
                type: {
                    name: "Composite",
                    className: "UefiSettings"
                }
            },
            encryptionAtHost: {
                serializedName: "encryptionAtHost",
                type: {
                    name: "Boolean"
                }
            },
            securityType: {
                serializedName: "securityType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const UefiSettings = {
    type: {
        name: "Composite",
        className: "UefiSettings",
        modelProperties: {
            secureBootEnabled: {
                serializedName: "secureBootEnabled",
                type: {
                    name: "Boolean"
                }
            },
            vTpmEnabled: {
                serializedName: "vTpmEnabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const DiagnosticsProfile = {
    type: {
        name: "Composite",
        className: "DiagnosticsProfile",
        modelProperties: {
            bootDiagnostics: {
                serializedName: "bootDiagnostics",
                type: {
                    name: "Composite",
                    className: "BootDiagnostics"
                }
            }
        }
    }
};
export const BootDiagnostics = {
    type: {
        name: "Composite",
        className: "BootDiagnostics",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            storageUri: {
                serializedName: "storageUri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const BillingProfile = {
    type: {
        name: "Composite",
        className: "BillingProfile",
        modelProperties: {
            maxPrice: {
                serializedName: "maxPrice",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const VirtualMachineInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineInstanceView",
        modelProperties: {
            platformUpdateDomain: {
                serializedName: "platformUpdateDomain",
                type: {
                    name: "Number"
                }
            },
            platformFaultDomain: {
                serializedName: "platformFaultDomain",
                type: {
                    name: "Number"
                }
            },
            computerName: {
                serializedName: "computerName",
                type: {
                    name: "String"
                }
            },
            osName: {
                serializedName: "osName",
                type: {
                    name: "String"
                }
            },
            osVersion: {
                serializedName: "osVersion",
                type: {
                    name: "String"
                }
            },
            hyperVGeneration: {
                serializedName: "hyperVGeneration",
                type: {
                    name: "String"
                }
            },
            rdpThumbPrint: {
                serializedName: "rdpThumbPrint",
                type: {
                    name: "String"
                }
            },
            vmAgent: {
                serializedName: "vmAgent",
                type: {
                    name: "Composite",
                    className: "VirtualMachineAgentInstanceView"
                }
            },
            maintenanceRedeployStatus: {
                serializedName: "maintenanceRedeployStatus",
                type: {
                    name: "Composite",
                    className: "MaintenanceRedeployStatus"
                }
            },
            disks: {
                serializedName: "disks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskInstanceView"
                        }
                    }
                }
            },
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtensionInstanceView"
                        }
                    }
                }
            },
            vmHealth: {
                serializedName: "vmHealth",
                type: {
                    name: "Composite",
                    className: "VirtualMachineHealthStatus"
                }
            },
            bootDiagnostics: {
                serializedName: "bootDiagnostics",
                type: {
                    name: "Composite",
                    className: "BootDiagnosticsInstanceView"
                }
            },
            assignedHost: {
                serializedName: "assignedHost",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            patchStatus: {
                serializedName: "patchStatus",
                type: {
                    name: "Composite",
                    className: "VirtualMachinePatchStatus"
                }
            }
        }
    }
};
export const VirtualMachineAgentInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineAgentInstanceView",
        modelProperties: {
            vmAgentVersion: {
                serializedName: "vmAgentVersion",
                type: {
                    name: "String"
                }
            },
            extensionHandlers: {
                serializedName: "extensionHandlers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtensionHandlerInstanceView"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineExtensionHandlerInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionHandlerInstanceView",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            typeHandlerVersion: {
                serializedName: "typeHandlerVersion",
                type: {
                    name: "String"
                }
            },
            status: {
                serializedName: "status",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            }
        }
    }
};
export const MaintenanceRedeployStatus = {
    type: {
        name: "Composite",
        className: "MaintenanceRedeployStatus",
        modelProperties: {
            isCustomerInitiatedMaintenanceAllowed: {
                serializedName: "isCustomerInitiatedMaintenanceAllowed",
                type: {
                    name: "Boolean"
                }
            },
            preMaintenanceWindowStartTime: {
                serializedName: "preMaintenanceWindowStartTime",
                type: {
                    name: "DateTime"
                }
            },
            preMaintenanceWindowEndTime: {
                serializedName: "preMaintenanceWindowEndTime",
                type: {
                    name: "DateTime"
                }
            },
            maintenanceWindowStartTime: {
                serializedName: "maintenanceWindowStartTime",
                type: {
                    name: "DateTime"
                }
            },
            maintenanceWindowEndTime: {
                serializedName: "maintenanceWindowEndTime",
                type: {
                    name: "DateTime"
                }
            },
            lastOperationResultCode: {
                serializedName: "lastOperationResultCode",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "RetryLater",
                        "MaintenanceAborted",
                        "MaintenanceCompleted"
                    ]
                }
            },
            lastOperationMessage: {
                serializedName: "lastOperationMessage",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskInstanceView = {
    type: {
        name: "Composite",
        className: "DiskInstanceView",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskEncryptionSettings"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineHealthStatus = {
    type: {
        name: "Composite",
        className: "VirtualMachineHealthStatus",
        modelProperties: {
            status: {
                serializedName: "status",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            }
        }
    }
};
export const BootDiagnosticsInstanceView = {
    type: {
        name: "Composite",
        className: "BootDiagnosticsInstanceView",
        modelProperties: {
            consoleScreenshotBlobUri: {
                serializedName: "consoleScreenshotBlobUri",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            serialConsoleLogBlobUri: {
                serializedName: "serialConsoleLogBlobUri",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            status: {
                serializedName: "status",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            }
        }
    }
};
export const VirtualMachinePatchStatus = {
    type: {
        name: "Composite",
        className: "VirtualMachinePatchStatus",
        modelProperties: {
            availablePatchSummary: {
                serializedName: "availablePatchSummary",
                type: {
                    name: "Composite",
                    className: "AvailablePatchSummary"
                }
            },
            lastPatchInstallationSummary: {
                serializedName: "lastPatchInstallationSummary",
                type: {
                    name: "Composite",
                    className: "LastPatchInstallationSummary"
                }
            },
            configurationStatuses: {
                serializedName: "configurationStatuses",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const AvailablePatchSummary = {
    type: {
        name: "Composite",
        className: "AvailablePatchSummary",
        modelProperties: {
            status: {
                serializedName: "status",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            assessmentActivityId: {
                serializedName: "assessmentActivityId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            rebootPending: {
                serializedName: "rebootPending",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            criticalAndSecurityPatchCount: {
                serializedName: "criticalAndSecurityPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            otherPatchCount: {
                serializedName: "otherPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            startTime: {
                serializedName: "startTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            lastModifiedTime: {
                serializedName: "lastModifiedTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export const LastPatchInstallationSummary = {
    type: {
        name: "Composite",
        className: "LastPatchInstallationSummary",
        modelProperties: {
            status: {
                serializedName: "status",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            installationActivityId: {
                serializedName: "installationActivityId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            maintenanceWindowExceeded: {
                serializedName: "maintenanceWindowExceeded",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            notSelectedPatchCount: {
                serializedName: "notSelectedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            excludedPatchCount: {
                serializedName: "excludedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            pendingPatchCount: {
                serializedName: "pendingPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            installedPatchCount: {
                serializedName: "installedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            failedPatchCount: {
                serializedName: "failedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            startTime: {
                serializedName: "startTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            lastModifiedTime: {
                serializedName: "lastModifiedTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export const ScheduledEventsProfile = {
    type: {
        name: "Composite",
        className: "ScheduledEventsProfile",
        modelProperties: {
            terminateNotificationProfile: {
                serializedName: "terminateNotificationProfile",
                type: {
                    name: "Composite",
                    className: "TerminateNotificationProfile"
                }
            }
        }
    }
};
export const TerminateNotificationProfile = {
    type: {
        name: "Composite",
        className: "TerminateNotificationProfile",
        modelProperties: {
            notBeforeTimeout: {
                serializedName: "notBeforeTimeout",
                type: {
                    name: "String"
                }
            },
            enable: {
                serializedName: "enable",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const CapacityReservationProfile = {
    type: {
        name: "Composite",
        className: "CapacityReservationProfile",
        modelProperties: {
            capacityReservationGroup: {
                serializedName: "capacityReservationGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export const ApplicationProfile = {
    type: {
        name: "Composite",
        className: "ApplicationProfile",
        modelProperties: {
            galleryApplications: {
                serializedName: "galleryApplications",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VMGalleryApplication"
                        }
                    }
                }
            }
        }
    }
};
export const VMGalleryApplication = {
    type: {
        name: "Composite",
        className: "VMGalleryApplication",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "String"
                }
            },
            order: {
                serializedName: "order",
                type: {
                    name: "Number"
                }
            },
            packageReferenceId: {
                serializedName: "packageReferenceId",
                required: true,
                type: {
                    name: "String"
                }
            },
            configurationReference: {
                serializedName: "configurationReference",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineIdentity = {
    type: {
        name: "Composite",
        className: "VirtualMachineIdentity",
        modelProperties: {
            principalId: {
                serializedName: "principalId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tenantId: {
                serializedName: "tenantId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "SystemAssigned",
                        "UserAssigned",
                        "SystemAssigned, UserAssigned",
                        "None"
                    ]
                }
            },
            userAssignedIdentities: {
                serializedName: "userAssignedIdentities",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "Composite",
                            className: "UserAssignedIdentitiesValue"
                        }
                    }
                }
            }
        }
    }
};
export const UserAssignedIdentitiesValue = {
    type: {
        name: "Composite",
        className: "UserAssignedIdentitiesValue",
        modelProperties: {
            principalId: {
                serializedName: "principalId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            clientId: {
                serializedName: "clientId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const UpgradePolicy = {
    type: {
        name: "Composite",
        className: "UpgradePolicy",
        modelProperties: {
            mode: {
                serializedName: "mode",
                type: {
                    name: "Enum",
                    allowedValues: ["Automatic", "Manual", "Rolling"]
                }
            },
            rollingUpgradePolicy: {
                serializedName: "rollingUpgradePolicy",
                type: {
                    name: "Composite",
                    className: "RollingUpgradePolicy"
                }
            },
            automaticOSUpgradePolicy: {
                serializedName: "automaticOSUpgradePolicy",
                type: {
                    name: "Composite",
                    className: "AutomaticOSUpgradePolicy"
                }
            }
        }
    }
};
export const RollingUpgradePolicy = {
    type: {
        name: "Composite",
        className: "RollingUpgradePolicy",
        modelProperties: {
            maxBatchInstancePercent: {
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 5
                },
                serializedName: "maxBatchInstancePercent",
                type: {
                    name: "Number"
                }
            },
            maxUnhealthyInstancePercent: {
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 5
                },
                serializedName: "maxUnhealthyInstancePercent",
                type: {
                    name: "Number"
                }
            },
            maxUnhealthyUpgradedInstancePercent: {
                constraints: {
                    InclusiveMaximum: 100,
                    InclusiveMinimum: 0
                },
                serializedName: "maxUnhealthyUpgradedInstancePercent",
                type: {
                    name: "Number"
                }
            },
            pauseTimeBetweenBatches: {
                serializedName: "pauseTimeBetweenBatches",
                type: {
                    name: "String"
                }
            },
            enableCrossZoneUpgrade: {
                serializedName: "enableCrossZoneUpgrade",
                type: {
                    name: "Boolean"
                }
            },
            prioritizeUnhealthyInstances: {
                serializedName: "prioritizeUnhealthyInstances",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const AutomaticOSUpgradePolicy = {
    type: {
        name: "Composite",
        className: "AutomaticOSUpgradePolicy",
        modelProperties: {
            enableAutomaticOSUpgrade: {
                serializedName: "enableAutomaticOSUpgrade",
                type: {
                    name: "Boolean"
                }
            },
            disableAutomaticRollback: {
                serializedName: "disableAutomaticRollback",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const AutomaticRepairsPolicy = {
    type: {
        name: "Composite",
        className: "AutomaticRepairsPolicy",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            gracePeriod: {
                serializedName: "gracePeriod",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMProfile",
        modelProperties: {
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetOSProfile"
                }
            },
            storageProfile: {
                serializedName: "storageProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetStorageProfile"
                }
            },
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetNetworkProfile"
                }
            },
            securityProfile: {
                serializedName: "securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            },
            diagnosticsProfile: {
                serializedName: "diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            },
            extensionProfile: {
                serializedName: "extensionProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetExtensionProfile"
                }
            },
            licenseType: {
                serializedName: "licenseType",
                type: {
                    name: "String"
                }
            },
            priority: {
                serializedName: "priority",
                type: {
                    name: "String"
                }
            },
            evictionPolicy: {
                serializedName: "evictionPolicy",
                type: {
                    name: "String"
                }
            },
            billingProfile: {
                serializedName: "billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            },
            scheduledEventsProfile: {
                serializedName: "scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            },
            userData: {
                serializedName: "userData",
                type: {
                    name: "String"
                }
            },
            capacityReservation: {
                serializedName: "capacityReservation",
                type: {
                    name: "Composite",
                    className: "CapacityReservationProfile"
                }
            },
            applicationProfile: {
                serializedName: "applicationProfile",
                type: {
                    name: "Composite",
                    className: "ApplicationProfile"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetOSProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetOSProfile",
        modelProperties: {
            computerNamePrefix: {
                serializedName: "computerNamePrefix",
                type: {
                    name: "String"
                }
            },
            adminUsername: {
                serializedName: "adminUsername",
                type: {
                    name: "String"
                }
            },
            adminPassword: {
                serializedName: "adminPassword",
                type: {
                    name: "String"
                }
            },
            customData: {
                serializedName: "customData",
                type: {
                    name: "String"
                }
            },
            windowsConfiguration: {
                serializedName: "windowsConfiguration",
                type: {
                    name: "Composite",
                    className: "WindowsConfiguration"
                }
            },
            linuxConfiguration: {
                serializedName: "linuxConfiguration",
                type: {
                    name: "Composite",
                    className: "LinuxConfiguration"
                }
            },
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultSecretGroup"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetStorageProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetStorageProfile",
        modelProperties: {
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetDataDisk"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetOSDisk = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetOSDisk",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            createOption: {
                serializedName: "createOption",
                required: true,
                type: {
                    name: "String"
                }
            },
            diffDiskSettings: {
                serializedName: "diffDiskSettings",
                type: {
                    name: "Composite",
                    className: "DiffDiskSettings"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            osType: {
                serializedName: "osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            vhdContainers: {
                serializedName: "vhdContainers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetManagedDiskParameters"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetManagedDiskParameters = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetManagedDiskParameters",
        modelProperties: {
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            diskEncryptionSet: {
                serializedName: "diskEncryptionSet",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSetParameters"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetDataDisk = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetDataDisk",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            lun: {
                serializedName: "lun",
                required: true,
                type: {
                    name: "Number"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            createOption: {
                serializedName: "createOption",
                required: true,
                type: {
                    name: "String"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetManagedDiskParameters"
                }
            },
            diskIopsReadWrite: {
                serializedName: "diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadWrite: {
                serializedName: "diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetNetworkProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetNetworkProfile",
        modelProperties: {
            healthProbe: {
                serializedName: "healthProbe",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            },
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetNetworkConfiguration"
                        }
                    }
                }
            },
            networkApiVersion: {
                serializedName: "networkApiVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ApiEntityReference = {
    type: {
        name: "Composite",
        className: "ApiEntityReference",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetNetworkConfigurationDnsSettings = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetNetworkConfigurationDnsSettings",
        modelProperties: {
            dnsServers: {
                serializedName: "dnsServers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetPublicIPAddressConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetPublicIPAddressConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "PublicIPAddressSku"
                }
            },
            idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings"
                }
            },
            ipTags: {
                serializedName: "properties.ipTags",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetIpTag"
                        }
                    }
                }
            },
            publicIPPrefix: {
                serializedName: "properties.publicIPPrefix",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            publicIPAddressVersion: {
                serializedName: "properties.publicIPAddressVersion",
                type: {
                    name: "String"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings",
        modelProperties: {
            domainNameLabel: {
                serializedName: "domainNameLabel",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetIpTag = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIpTag",
        modelProperties: {
            ipTagType: {
                serializedName: "ipTagType",
                type: {
                    name: "String"
                }
            },
            tag: {
                serializedName: "tag",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetExtensionProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtensionProfile",
        modelProperties: {
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetExtension"
                        }
                    }
                }
            },
            extensionsTimeBudget: {
                serializedName: "extensionsTimeBudget",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ScaleInPolicy = {
    type: {
        name: "Composite",
        className: "ScaleInPolicy",
        modelProperties: {
            rules: {
                serializedName: "rules",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            forceDeletion: {
                serializedName: "forceDeletion",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const SpotRestorePolicy = {
    type: {
        name: "Composite",
        className: "SpotRestorePolicy",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                type: {
                    name: "Boolean"
                }
            },
            restoreTimeout: {
                serializedName: "restoreTimeout",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetIdentity = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIdentity",
        modelProperties: {
            principalId: {
                serializedName: "principalId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tenantId: {
                serializedName: "tenantId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "SystemAssigned",
                        "UserAssigned",
                        "SystemAssigned, UserAssigned",
                        "None"
                    ]
                }
            },
            userAssignedIdentities: {
                serializedName: "userAssignedIdentities",
                type: {
                    name: "Dictionary",
                    value: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue",
        modelProperties: {
            principalId: {
                serializedName: "principalId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            clientId: {
                serializedName: "clientId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ImageStorageProfile = {
    type: {
        name: "Composite",
        className: "ImageStorageProfile",
        modelProperties: {
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "ImageOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ImageDataDisk"
                        }
                    }
                }
            },
            zoneResilient: {
                serializedName: "zoneResilient",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const ImageDisk = {
    type: {
        name: "Composite",
        className: "ImageDisk",
        modelProperties: {
            snapshot: {
                serializedName: "snapshot",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            blobUri: {
                serializedName: "blobUri",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            diskEncryptionSet: {
                serializedName: "diskEncryptionSet",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSetParameters"
                }
            }
        }
    }
};
export const ImageListResult = {
    type: {
        name: "Composite",
        className: "ImageListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Image"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineCaptureParameters = {
    type: {
        name: "Composite",
        className: "VirtualMachineCaptureParameters",
        modelProperties: {
            vhdPrefix: {
                serializedName: "vhdPrefix",
                required: true,
                type: {
                    name: "String"
                }
            },
            destinationContainerName: {
                serializedName: "destinationContainerName",
                required: true,
                type: {
                    name: "String"
                }
            },
            overwriteVhds: {
                serializedName: "overwriteVhds",
                required: true,
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const RestorePointCollectionSourceProperties = {
    type: {
        name: "Composite",
        className: "RestorePointCollectionSourceProperties",
        modelProperties: {
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RestorePointSourceMetadata = {
    type: {
        name: "Composite",
        className: "RestorePointSourceMetadata",
        modelProperties: {
            hardwareProfile: {
                serializedName: "hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            },
            storageProfile: {
                serializedName: "storageProfile",
                type: {
                    name: "Composite",
                    className: "RestorePointSourceVMStorageProfile"
                }
            },
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            },
            diagnosticsProfile: {
                serializedName: "diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            },
            licenseType: {
                serializedName: "licenseType",
                type: {
                    name: "String"
                }
            },
            vmId: {
                serializedName: "vmId",
                type: {
                    name: "String"
                }
            },
            securityProfile: {
                serializedName: "securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            },
            location: {
                serializedName: "location",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RestorePointSourceVMStorageProfile = {
    type: {
        name: "Composite",
        className: "RestorePointSourceVMStorageProfile",
        modelProperties: {
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "RestorePointSourceVmosDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePointSourceVMDataDisk"
                        }
                    }
                }
            }
        }
    }
};
export const RestorePointSourceVmosDisk = {
    type: {
        name: "Composite",
        className: "RestorePointSourceVmosDisk",
        modelProperties: {
            osType: {
                serializedName: "osType",
                type: {
                    name: "String"
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSettings"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            diskRestorePoint: {
                serializedName: "diskRestorePoint",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }
        }
    }
};
export const RestorePointSourceVMDataDisk = {
    type: {
        name: "Composite",
        className: "RestorePointSourceVMDataDisk",
        modelProperties: {
            lun: {
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            },
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "ManagedDiskParameters"
                }
            },
            diskRestorePoint: {
                serializedName: "diskRestorePoint",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }
        }
    }
};
export const ProxyResource = {
    type: {
        name: "Composite",
        className: "ProxyResource",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RestorePointCollectionListResult = {
    type: {
        name: "Composite",
        className: "RestorePointCollectionListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePointCollection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CapacityReservationGroupInstanceView = {
    type: {
        name: "Composite",
        className: "CapacityReservationGroupInstanceView",
        modelProperties: {
            capacityReservations: {
                serializedName: "capacityReservations",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CapacityReservationInstanceViewWithName"
                        }
                    }
                }
            }
        }
    }
};
export const CapacityReservationInstanceView = {
    type: {
        name: "Composite",
        className: "CapacityReservationInstanceView",
        modelProperties: {
            utilizationInfo: {
                serializedName: "utilizationInfo",
                type: {
                    name: "Composite",
                    className: "CapacityReservationUtilization"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const CapacityReservationUtilization = {
    type: {
        name: "Composite",
        className: "CapacityReservationUtilization",
        modelProperties: {
            virtualMachinesAllocated: {
                serializedName: "virtualMachinesAllocated",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }
        }
    }
};
export const CapacityReservationGroupListResult = {
    type: {
        name: "Composite",
        className: "CapacityReservationGroupListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CapacityReservationGroup"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CapacityReservationListResult = {
    type: {
        name: "Composite",
        className: "CapacityReservationListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CapacityReservation"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineReimageParameters = {
    type: {
        name: "Composite",
        className: "VirtualMachineReimageParameters",
        modelProperties: {
            tempDisk: {
                serializedName: "tempDisk",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const RetrieveBootDiagnosticsDataResult = {
    type: {
        name: "Composite",
        className: "RetrieveBootDiagnosticsDataResult",
        modelProperties: {
            consoleScreenshotBlobUri: {
                serializedName: "consoleScreenshotBlobUri",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            serialConsoleLogBlobUri: {
                serializedName: "serialConsoleLogBlobUri",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineAssessPatchesResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineAssessPatchesResult",
        modelProperties: {
            status: {
                serializedName: "status",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            assessmentActivityId: {
                serializedName: "assessmentActivityId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            rebootPending: {
                serializedName: "rebootPending",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            criticalAndSecurityPatchCount: {
                serializedName: "criticalAndSecurityPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            otherPatchCount: {
                serializedName: "otherPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            startDateTime: {
                serializedName: "startDateTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            availablePatches: {
                serializedName: "availablePatches",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineSoftwarePatchProperties"
                        }
                    }
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export const VirtualMachineSoftwarePatchProperties = {
    type: {
        name: "Composite",
        className: "VirtualMachineSoftwarePatchProperties",
        modelProperties: {
            patchId: {
                serializedName: "patchId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            version: {
                serializedName: "version",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            kbId: {
                serializedName: "kbId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            classifications: {
                serializedName: "classifications",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            rebootBehavior: {
                serializedName: "rebootBehavior",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            activityId: {
                serializedName: "activityId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            publishedDate: {
                serializedName: "publishedDate",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            lastModifiedDateTime: {
                serializedName: "lastModifiedDateTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            assessmentState: {
                serializedName: "assessmentState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineInstallPatchesParameters = {
    type: {
        name: "Composite",
        className: "VirtualMachineInstallPatchesParameters",
        modelProperties: {
            maximumDuration: {
                serializedName: "maximumDuration",
                type: {
                    name: "String"
                }
            },
            rebootSetting: {
                serializedName: "rebootSetting",
                required: true,
                type: {
                    name: "String"
                }
            },
            windowsParameters: {
                serializedName: "windowsParameters",
                type: {
                    name: "Composite",
                    className: "WindowsParameters"
                }
            },
            linuxParameters: {
                serializedName: "linuxParameters",
                type: {
                    name: "Composite",
                    className: "LinuxParameters"
                }
            }
        }
    }
};
export const WindowsParameters = {
    type: {
        name: "Composite",
        className: "WindowsParameters",
        modelProperties: {
            classificationsToInclude: {
                serializedName: "classificationsToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            kbNumbersToInclude: {
                serializedName: "kbNumbersToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            kbNumbersToExclude: {
                serializedName: "kbNumbersToExclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            excludeKbsRequiringReboot: {
                serializedName: "excludeKbsRequiringReboot",
                type: {
                    name: "Boolean"
                }
            },
            maxPatchPublishDate: {
                serializedName: "maxPatchPublishDate",
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export const LinuxParameters = {
    type: {
        name: "Composite",
        className: "LinuxParameters",
        modelProperties: {
            classificationsToInclude: {
                serializedName: "classificationsToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            packageNameMasksToInclude: {
                serializedName: "packageNameMasksToInclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            packageNameMasksToExclude: {
                serializedName: "packageNameMasksToExclude",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            maintenanceRunId: {
                serializedName: "maintenanceRunId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineInstallPatchesResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineInstallPatchesResult",
        modelProperties: {
            status: {
                serializedName: "status",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            installationActivityId: {
                serializedName: "installationActivityId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            rebootStatus: {
                serializedName: "rebootStatus",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            maintenanceWindowExceeded: {
                serializedName: "maintenanceWindowExceeded",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            excludedPatchCount: {
                serializedName: "excludedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            notSelectedPatchCount: {
                serializedName: "notSelectedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            pendingPatchCount: {
                serializedName: "pendingPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            installedPatchCount: {
                serializedName: "installedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            failedPatchCount: {
                serializedName: "failedPatchCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            patches: {
                serializedName: "patches",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PatchInstallationDetail"
                        }
                    }
                }
            },
            startDateTime: {
                serializedName: "startDateTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export const PatchInstallationDetail = {
    type: {
        name: "Composite",
        className: "PatchInstallationDetail",
        modelProperties: {
            patchId: {
                serializedName: "patchId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            version: {
                serializedName: "version",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            kbId: {
                serializedName: "kbId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            classifications: {
                serializedName: "classifications",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            installationState: {
                serializedName: "installationState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetUpdateVMProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateVMProfile",
        modelProperties: {
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateOSProfile"
                }
            },
            storageProfile: {
                serializedName: "storageProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateStorageProfile"
                }
            },
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateNetworkProfile"
                }
            },
            securityProfile: {
                serializedName: "securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            },
            diagnosticsProfile: {
                serializedName: "diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            },
            extensionProfile: {
                serializedName: "extensionProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetExtensionProfile"
                }
            },
            licenseType: {
                serializedName: "licenseType",
                type: {
                    name: "String"
                }
            },
            billingProfile: {
                serializedName: "billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            },
            scheduledEventsProfile: {
                serializedName: "scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            },
            userData: {
                serializedName: "userData",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetUpdateOSProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateOSProfile",
        modelProperties: {
            customData: {
                serializedName: "customData",
                type: {
                    name: "String"
                }
            },
            windowsConfiguration: {
                serializedName: "windowsConfiguration",
                type: {
                    name: "Composite",
                    className: "WindowsConfiguration"
                }
            },
            linuxConfiguration: {
                serializedName: "linuxConfiguration",
                type: {
                    name: "Composite",
                    className: "LinuxConfiguration"
                }
            },
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VaultSecretGroup"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetUpdateStorageProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateStorageProfile",
        modelProperties: {
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            osDisk: {
                serializedName: "osDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateOSDisk"
                }
            },
            dataDisks: {
                serializedName: "dataDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetDataDisk"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetUpdateOSDisk = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateOSDisk",
        modelProperties: {
            caching: {
                serializedName: "caching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            writeAcceleratorEnabled: {
                serializedName: "writeAcceleratorEnabled",
                type: {
                    name: "Boolean"
                }
            },
            diskSizeGB: {
                serializedName: "diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            image: {
                serializedName: "image",
                type: {
                    name: "Composite",
                    className: "VirtualHardDisk"
                }
            },
            vhdContainers: {
                serializedName: "vhdContainers",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            managedDisk: {
                serializedName: "managedDisk",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetManagedDiskParameters"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetUpdateNetworkProfile = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateNetworkProfile",
        modelProperties: {
            healthProbe: {
                serializedName: "healthProbe",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            },
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetUpdateNetworkConfiguration"
                        }
                    }
                }
            },
            networkApiVersion: {
                serializedName: "networkApiVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetUpdatePublicIPAddressConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdatePublicIPAddressConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            idleTimeoutInMinutes: {
                serializedName: "properties.idleTimeoutInMinutes",
                type: {
                    name: "Number"
                }
            },
            dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings"
                }
            },
            deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMInstanceIDs = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMInstanceIDs",
        modelProperties: {
            instanceIds: {
                serializedName: "instanceIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMInstanceRequiredIDs = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMInstanceRequiredIDs",
        modelProperties: {
            instanceIds: {
                serializedName: "instanceIds",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetInstanceView",
        modelProperties: {
            virtualMachine: {
                serializedName: "virtualMachine",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetInstanceViewStatusesSummary"
                }
            },
            extensions: {
                serializedName: "extensions",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetVMExtensionsSummary"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            orchestrationServices: {
                serializedName: "orchestrationServices",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OrchestrationServiceSummary"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetInstanceViewStatusesSummary = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetInstanceViewStatusesSummary",
        modelProperties: {
            statusesSummary: {
                serializedName: "statusesSummary",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineStatusCodeCount"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineStatusCodeCount = {
    type: {
        name: "Composite",
        className: "VirtualMachineStatusCodeCount",
        modelProperties: {
            code: {
                serializedName: "code",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            count: {
                serializedName: "count",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMExtensionsSummary = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtensionsSummary",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            statusesSummary: {
                serializedName: "statusesSummary",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineStatusCodeCount"
                        }
                    }
                }
            }
        }
    }
};
export const OrchestrationServiceSummary = {
    type: {
        name: "Composite",
        className: "OrchestrationServiceSummary",
        modelProperties: {
            serviceName: {
                serializedName: "serviceName",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            serviceState: {
                serializedName: "serviceState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetExtensionListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtensionListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetExtension"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetListWithLinkResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListWithLinkResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetListSkusResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListSkusResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetSku"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetSku = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetSku",
        modelProperties: {
            resourceType: {
                serializedName: "resourceType",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetSkuCapacity"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetSkuCapacity = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetSkuCapacity",
        modelProperties: {
            minimum: {
                serializedName: "minimum",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            maximum: {
                serializedName: "maximum",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            defaultCapacity: {
                serializedName: "defaultCapacity",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            scaleType: {
                serializedName: "scaleType",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Automatic", "None"]
                }
            }
        }
    }
};
export const VirtualMachineScaleSetListOSUpgradeHistory = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetListOSUpgradeHistory",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "UpgradeOperationHistoricalStatusInfo"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const UpgradeOperationHistoricalStatusInfo = {
    type: {
        name: "Composite",
        className: "UpgradeOperationHistoricalStatusInfo",
        modelProperties: {
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "UpgradeOperationHistoricalStatusInfoProperties"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const UpgradeOperationHistoricalStatusInfoProperties = {
    type: {
        name: "Composite",
        className: "UpgradeOperationHistoricalStatusInfoProperties",
        modelProperties: {
            runningStatus: {
                serializedName: "runningStatus",
                type: {
                    name: "Composite",
                    className: "UpgradeOperationHistoryStatus"
                }
            },
            progress: {
                serializedName: "progress",
                type: {
                    name: "Composite",
                    className: "RollingUpgradeProgressInfo"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            },
            startedBy: {
                serializedName: "startedBy",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Unknown", "User", "Platform"]
                }
            },
            targetImageReference: {
                serializedName: "targetImageReference",
                type: {
                    name: "Composite",
                    className: "ImageReference"
                }
            },
            rollbackInfo: {
                serializedName: "rollbackInfo",
                type: {
                    name: "Composite",
                    className: "RollbackStatusInfo"
                }
            }
        }
    }
};
export const UpgradeOperationHistoryStatus = {
    type: {
        name: "Composite",
        className: "UpgradeOperationHistoryStatus",
        modelProperties: {
            code: {
                serializedName: "code",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["RollingForward", "Cancelled", "Completed", "Faulted"]
                }
            },
            startTime: {
                serializedName: "startTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                serializedName: "endTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export const RollingUpgradeProgressInfo = {
    type: {
        name: "Composite",
        className: "RollingUpgradeProgressInfo",
        modelProperties: {
            successfulInstanceCount: {
                serializedName: "successfulInstanceCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            failedInstanceCount: {
                serializedName: "failedInstanceCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            inProgressInstanceCount: {
                serializedName: "inProgressInstanceCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            pendingInstanceCount: {
                serializedName: "pendingInstanceCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const RollbackStatusInfo = {
    type: {
        name: "Composite",
        className: "RollbackStatusInfo",
        modelProperties: {
            successfullyRolledbackInstanceCount: {
                serializedName: "successfullyRolledbackInstanceCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            failedRolledbackInstanceCount: {
                serializedName: "failedRolledbackInstanceCount",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            rollbackError: {
                serializedName: "rollbackError",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            }
        }
    }
};
export const RollingUpgradeRunningStatus = {
    type: {
        name: "Composite",
        className: "RollingUpgradeRunningStatus",
        modelProperties: {
            code: {
                serializedName: "code",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["RollingForward", "Cancelled", "Completed", "Faulted"]
                }
            },
            startTime: {
                serializedName: "startTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            lastAction: {
                serializedName: "lastAction",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Start", "Cancel"]
                }
            },
            lastActionTime: {
                serializedName: "lastActionTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }
        }
    }
};
export const RecoveryWalkResponse = {
    type: {
        name: "Composite",
        className: "RecoveryWalkResponse",
        modelProperties: {
            walkPerformed: {
                serializedName: "walkPerformed",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            nextPlatformUpdateDomain: {
                serializedName: "nextPlatformUpdateDomain",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const VMScaleSetConvertToSinglePlacementGroupInput = {
    type: {
        name: "Composite",
        className: "VMScaleSetConvertToSinglePlacementGroupInput",
        modelProperties: {
            activePlacementGroupId: {
                serializedName: "activePlacementGroupId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const OrchestrationServiceStateInput = {
    type: {
        name: "Composite",
        className: "OrchestrationServiceStateInput",
        modelProperties: {
            serviceName: {
                serializedName: "serviceName",
                required: true,
                type: {
                    name: "String"
                }
            },
            action: {
                serializedName: "action",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMExtensionsListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtensionsListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetVMExtension"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMInstanceView",
        modelProperties: {
            platformUpdateDomain: {
                serializedName: "platformUpdateDomain",
                type: {
                    name: "Number"
                }
            },
            platformFaultDomain: {
                serializedName: "platformFaultDomain",
                type: {
                    name: "Number"
                }
            },
            rdpThumbPrint: {
                serializedName: "rdpThumbPrint",
                type: {
                    name: "String"
                }
            },
            vmAgent: {
                serializedName: "vmAgent",
                type: {
                    name: "Composite",
                    className: "VirtualMachineAgentInstanceView"
                }
            },
            maintenanceRedeployStatus: {
                serializedName: "maintenanceRedeployStatus",
                type: {
                    name: "Composite",
                    className: "MaintenanceRedeployStatus"
                }
            },
            disks: {
                serializedName: "disks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskInstanceView"
                        }
                    }
                }
            },
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtensionInstanceView"
                        }
                    }
                }
            },
            vmHealth: {
                serializedName: "vmHealth",
                type: {
                    name: "Composite",
                    className: "VirtualMachineHealthStatus"
                }
            },
            bootDiagnostics: {
                serializedName: "bootDiagnostics",
                type: {
                    name: "Composite",
                    className: "BootDiagnosticsInstanceView"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            },
            assignedHost: {
                serializedName: "assignedHost",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            placementGroupId: {
                serializedName: "placementGroupId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMNetworkProfileConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMNetworkProfileConfiguration",
        modelProperties: {
            networkInterfaceConfigurations: {
                serializedName: "networkInterfaceConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetNetworkConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMProtectionPolicy = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMProtectionPolicy",
        modelProperties: {
            protectFromScaleIn: {
                serializedName: "protectFromScaleIn",
                type: {
                    name: "Boolean"
                }
            },
            protectFromScaleSetActions: {
                serializedName: "protectFromScaleSetActions",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const VirtualMachineScaleSetVMListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetVM"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const LogAnalyticsInputBase = {
    type: {
        name: "Composite",
        className: "LogAnalyticsInputBase",
        modelProperties: {
            blobContainerSasUri: {
                serializedName: "blobContainerSasUri",
                required: true,
                type: {
                    name: "String"
                }
            },
            fromTime: {
                serializedName: "fromTime",
                required: true,
                type: {
                    name: "DateTime"
                }
            },
            toTime: {
                serializedName: "toTime",
                required: true,
                type: {
                    name: "DateTime"
                }
            },
            groupByThrottlePolicy: {
                serializedName: "groupByThrottlePolicy",
                type: {
                    name: "Boolean"
                }
            },
            groupByOperationName: {
                serializedName: "groupByOperationName",
                type: {
                    name: "Boolean"
                }
            },
            groupByResourceName: {
                serializedName: "groupByResourceName",
                type: {
                    name: "Boolean"
                }
            },
            groupByClientApplicationId: {
                serializedName: "groupByClientApplicationId",
                type: {
                    name: "Boolean"
                }
            },
            groupByUserAgent: {
                serializedName: "groupByUserAgent",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const LogAnalyticsOperationResult = {
    type: {
        name: "Composite",
        className: "LogAnalyticsOperationResult",
        modelProperties: {
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "LogAnalyticsOutput"
                }
            }
        }
    }
};
export const LogAnalyticsOutput = {
    type: {
        name: "Composite",
        className: "LogAnalyticsOutput",
        modelProperties: {
            output: {
                serializedName: "output",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RunCommandListResult = {
    type: {
        name: "Composite",
        className: "RunCommandListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandDocumentBase"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RunCommandDocumentBase = {
    type: {
        name: "Composite",
        className: "RunCommandDocumentBase",
        modelProperties: {
            schema: {
                serializedName: "$schema",
                required: true,
                type: {
                    name: "String"
                }
            },
            id: {
                serializedName: "id",
                required: true,
                type: {
                    name: "String"
                }
            },
            osType: {
                serializedName: "osType",
                required: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            },
            label: {
                serializedName: "label",
                required: true,
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RunCommandParameterDefinition = {
    type: {
        name: "Composite",
        className: "RunCommandParameterDefinition",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                required: true,
                type: {
                    name: "String"
                }
            },
            defaultValue: {
                serializedName: "defaultValue",
                type: {
                    name: "String"
                }
            },
            required: {
                defaultValue: false,
                serializedName: "required",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const RunCommandInput = {
    type: {
        name: "Composite",
        className: "RunCommandInput",
        modelProperties: {
            commandId: {
                serializedName: "commandId",
                required: true,
                type: {
                    name: "String"
                }
            },
            script: {
                serializedName: "script",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            parameters: {
                serializedName: "parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }
        }
    }
};
export const RunCommandInputParameter = {
    type: {
        name: "Composite",
        className: "RunCommandInputParameter",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RunCommandResult = {
    type: {
        name: "Composite",
        className: "RunCommandResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineRunCommandScriptSource = {
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandScriptSource",
        modelProperties: {
            script: {
                serializedName: "script",
                type: {
                    name: "String"
                }
            },
            scriptUri: {
                serializedName: "scriptUri",
                type: {
                    name: "String"
                }
            },
            commandId: {
                serializedName: "commandId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const VirtualMachineRunCommandInstanceView = {
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandInstanceView",
        modelProperties: {
            executionState: {
                serializedName: "executionState",
                type: {
                    name: "String"
                }
            },
            executionMessage: {
                serializedName: "executionMessage",
                type: {
                    name: "String"
                }
            },
            exitCode: {
                serializedName: "exitCode",
                type: {
                    name: "Number"
                }
            },
            output: {
                serializedName: "output",
                type: {
                    name: "String"
                }
            },
            error: {
                serializedName: "error",
                type: {
                    name: "String"
                }
            },
            startTime: {
                serializedName: "startTime",
                type: {
                    name: "DateTime"
                }
            },
            endTime: {
                serializedName: "endTime",
                type: {
                    name: "DateTime"
                }
            },
            statuses: {
                serializedName: "statuses",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const VirtualMachineRunCommandsListResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandsListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineRunCommand"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ResourceSkusResult = {
    type: {
        name: "Composite",
        className: "ResourceSkusResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSku"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ResourceSku = {
    type: {
        name: "Composite",
        className: "ResourceSku",
        modelProperties: {
            resourceType: {
                serializedName: "resourceType",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            size: {
                serializedName: "size",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            family: {
                serializedName: "family",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            kind: {
                serializedName: "kind",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Composite",
                    className: "ResourceSkuCapacity"
                }
            },
            locations: {
                serializedName: "locations",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            locationInfo: {
                serializedName: "locationInfo",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuLocationInfo"
                        }
                    }
                }
            },
            apiVersions: {
                serializedName: "apiVersions",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            costs: {
                serializedName: "costs",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuCosts"
                        }
                    }
                }
            },
            capabilities: {
                serializedName: "capabilities",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuCapabilities"
                        }
                    }
                }
            },
            restrictions: {
                serializedName: "restrictions",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuRestrictions"
                        }
                    }
                }
            }
        }
    }
};
export const ResourceSkuCapacity = {
    type: {
        name: "Composite",
        className: "ResourceSkuCapacity",
        modelProperties: {
            minimum: {
                serializedName: "minimum",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            maximum: {
                serializedName: "maximum",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            default: {
                serializedName: "default",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            scaleType: {
                serializedName: "scaleType",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Automatic", "Manual", "None"]
                }
            }
        }
    }
};
export const ResourceSkuLocationInfo = {
    type: {
        name: "Composite",
        className: "ResourceSkuLocationInfo",
        modelProperties: {
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            zones: {
                serializedName: "zones",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            zoneDetails: {
                serializedName: "zoneDetails",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuZoneDetails"
                        }
                    }
                }
            },
            extendedLocations: {
                serializedName: "extendedLocations",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ResourceSkuZoneDetails = {
    type: {
        name: "Composite",
        className: "ResourceSkuZoneDetails",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            capabilities: {
                serializedName: "capabilities",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceSkuCapabilities"
                        }
                    }
                }
            }
        }
    }
};
export const ResourceSkuCapabilities = {
    type: {
        name: "Composite",
        className: "ResourceSkuCapabilities",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ResourceSkuCosts = {
    type: {
        name: "Composite",
        className: "ResourceSkuCosts",
        modelProperties: {
            meterID: {
                serializedName: "meterID",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            quantity: {
                serializedName: "quantity",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            extendedUnit: {
                serializedName: "extendedUnit",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ResourceSkuRestrictions = {
    type: {
        name: "Composite",
        className: "ResourceSkuRestrictions",
        modelProperties: {
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Location", "Zone"]
                }
            },
            values: {
                serializedName: "values",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            restrictionInfo: {
                serializedName: "restrictionInfo",
                type: {
                    name: "Composite",
                    className: "ResourceSkuRestrictionInfo"
                }
            },
            reasonCode: {
                serializedName: "reasonCode",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["QuotaId", "NotAvailableForSubscription"]
                }
            }
        }
    }
};
export const ResourceSkuRestrictionInfo = {
    type: {
        name: "Composite",
        className: "ResourceSkuRestrictionInfo",
        modelProperties: {
            locations: {
                serializedName: "locations",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            zones: {
                serializedName: "zones",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const DiskSku = {
    type: {
        name: "Composite",
        className: "DiskSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PurchasePlanAutoGenerated = {
    type: {
        name: "Composite",
        className: "PurchasePlanAutoGenerated",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            publisher: {
                serializedName: "publisher",
                required: true,
                type: {
                    name: "String"
                }
            },
            product: {
                serializedName: "product",
                required: true,
                type: {
                    name: "String"
                }
            },
            promotionCode: {
                serializedName: "promotionCode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SupportedCapabilities = {
    type: {
        name: "Composite",
        className: "SupportedCapabilities",
        modelProperties: {
            acceleratedNetwork: {
                serializedName: "acceleratedNetwork",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const CreationData = {
    type: {
        name: "Composite",
        className: "CreationData",
        modelProperties: {
            createOption: {
                serializedName: "createOption",
                required: true,
                type: {
                    name: "String"
                }
            },
            storageAccountId: {
                serializedName: "storageAccountId",
                type: {
                    name: "String"
                }
            },
            imageReference: {
                serializedName: "imageReference",
                type: {
                    name: "Composite",
                    className: "ImageDiskReference"
                }
            },
            galleryImageReference: {
                serializedName: "galleryImageReference",
                type: {
                    name: "Composite",
                    className: "ImageDiskReference"
                }
            },
            sourceUri: {
                serializedName: "sourceUri",
                type: {
                    name: "String"
                }
            },
            sourceResourceId: {
                serializedName: "sourceResourceId",
                type: {
                    name: "String"
                }
            },
            sourceUniqueId: {
                serializedName: "sourceUniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            uploadSizeBytes: {
                serializedName: "uploadSizeBytes",
                type: {
                    name: "Number"
                }
            },
            logicalSectorSize: {
                serializedName: "logicalSectorSize",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const ImageDiskReference = {
    type: {
        name: "Composite",
        className: "ImageDiskReference",
        modelProperties: {
            id: {
                serializedName: "id",
                required: true,
                type: {
                    name: "String"
                }
            },
            lun: {
                serializedName: "lun",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const EncryptionSettingsCollection = {
    type: {
        name: "Composite",
        className: "EncryptionSettingsCollection",
        modelProperties: {
            enabled: {
                serializedName: "enabled",
                required: true,
                type: {
                    name: "Boolean"
                }
            },
            encryptionSettings: {
                serializedName: "encryptionSettings",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "EncryptionSettingsElement"
                        }
                    }
                }
            },
            encryptionSettingsVersion: {
                serializedName: "encryptionSettingsVersion",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const EncryptionSettingsElement = {
    type: {
        name: "Composite",
        className: "EncryptionSettingsElement",
        modelProperties: {
            diskEncryptionKey: {
                serializedName: "diskEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultAndSecretReference"
                }
            },
            keyEncryptionKey: {
                serializedName: "keyEncryptionKey",
                type: {
                    name: "Composite",
                    className: "KeyVaultAndKeyReference"
                }
            }
        }
    }
};
export const KeyVaultAndSecretReference = {
    type: {
        name: "Composite",
        className: "KeyVaultAndSecretReference",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SourceVault"
                }
            },
            secretUrl: {
                serializedName: "secretUrl",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SourceVault = {
    type: {
        name: "Composite",
        className: "SourceVault",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const KeyVaultAndKeyReference = {
    type: {
        name: "Composite",
        className: "KeyVaultAndKeyReference",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SourceVault"
                }
            },
            keyUrl: {
                serializedName: "keyUrl",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const Encryption = {
    type: {
        name: "Composite",
        className: "Encryption",
        modelProperties: {
            diskEncryptionSetId: {
                serializedName: "diskEncryptionSetId",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ShareInfoElement = {
    type: {
        name: "Composite",
        className: "ShareInfoElement",
        modelProperties: {
            vmUri: {
                serializedName: "vmUri",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PropertyUpdatesInProgress = {
    type: {
        name: "Composite",
        className: "PropertyUpdatesInProgress",
        modelProperties: {
            targetTier: {
                serializedName: "targetTier",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskSecurityProfile = {
    type: {
        name: "Composite",
        className: "DiskSecurityProfile",
        modelProperties: {
            securityType: {
                serializedName: "securityType",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskUpdate = {
    type: {
        name: "Composite",
        className: "DiskUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "DiskSku"
                }
            },
            osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            },
            diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            },
            diskIopsReadWrite: {
                serializedName: "properties.diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadWrite: {
                serializedName: "properties.diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            },
            diskIopsReadOnly: {
                serializedName: "properties.diskIOPSReadOnly",
                type: {
                    name: "Number"
                }
            },
            diskMBpsReadOnly: {
                serializedName: "properties.diskMBpsReadOnly",
                type: {
                    name: "Number"
                }
            },
            maxShares: {
                serializedName: "properties.maxShares",
                type: {
                    name: "Number"
                }
            },
            encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            },
            networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            },
            diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "properties.tier",
                type: {
                    name: "String"
                }
            },
            burstingEnabled: {
                serializedName: "properties.burstingEnabled",
                type: {
                    name: "Boolean"
                }
            },
            purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlanAutoGenerated"
                }
            },
            supportedCapabilities: {
                serializedName: "properties.supportedCapabilities",
                type: {
                    name: "Composite",
                    className: "SupportedCapabilities"
                }
            },
            propertyUpdatesInProgress: {
                serializedName: "properties.propertyUpdatesInProgress",
                type: {
                    name: "Composite",
                    className: "PropertyUpdatesInProgress"
                }
            },
            supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            },
            publicNetworkAccess: {
                serializedName: "properties.publicNetworkAccess",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskList = {
    type: {
        name: "Composite",
        className: "DiskList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Disk"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GrantAccessData = {
    type: {
        name: "Composite",
        className: "GrantAccessData",
        modelProperties: {
            access: {
                serializedName: "access",
                required: true,
                type: {
                    name: "String"
                }
            },
            durationInSeconds: {
                serializedName: "durationInSeconds",
                required: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const AccessUri = {
    type: {
        name: "Composite",
        className: "AccessUri",
        modelProperties: {
            accessSAS: {
                serializedName: "accessSAS",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SnapshotSku = {
    type: {
        name: "Composite",
        className: "SnapshotSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SnapshotUpdate = {
    type: {
        name: "Composite",
        className: "SnapshotUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "SnapshotSku"
                }
            },
            osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            },
            diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            },
            encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            },
            encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            },
            networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            },
            diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            },
            supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            },
            publicNetworkAccess: {
                serializedName: "properties.publicNetworkAccess",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SnapshotList = {
    type: {
        name: "Composite",
        className: "SnapshotList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Snapshot"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const EncryptionSetIdentity = {
    type: {
        name: "Composite",
        className: "EncryptionSetIdentity",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            principalId: {
                serializedName: "principalId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tenantId: {
                serializedName: "tenantId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const KeyForDiskEncryptionSet = {
    type: {
        name: "Composite",
        className: "KeyForDiskEncryptionSet",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SourceVault"
                }
            },
            keyUrl: {
                serializedName: "keyUrl",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskEncryptionSetUpdate = {
    type: {
        name: "Composite",
        className: "DiskEncryptionSetUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            },
            identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "EncryptionSetIdentity"
                }
            },
            encryptionType: {
                serializedName: "properties.encryptionType",
                type: {
                    name: "String"
                }
            },
            activeKey: {
                serializedName: "properties.activeKey",
                type: {
                    name: "Composite",
                    className: "KeyForDiskEncryptionSet"
                }
            },
            rotationToLatestKeyVersionEnabled: {
                serializedName: "properties.rotationToLatestKeyVersionEnabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const DiskEncryptionSetList = {
    type: {
        name: "Composite",
        className: "DiskEncryptionSetList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskEncryptionSet"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ResourceUriList = {
    type: {
        name: "Composite",
        className: "ResourceUriList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PrivateEndpointConnection = {
    type: {
        name: "Composite",
        className: "PrivateEndpointConnection",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            privateEndpoint: {
                serializedName: "properties.privateEndpoint",
                type: {
                    name: "Composite",
                    className: "PrivateEndpoint"
                }
            },
            privateLinkServiceConnectionState: {
                serializedName: "properties.privateLinkServiceConnectionState",
                type: {
                    name: "Composite",
                    className: "PrivateLinkServiceConnectionState"
                }
            },
            provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PrivateEndpoint = {
    type: {
        name: "Composite",
        className: "PrivateEndpoint",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PrivateLinkServiceConnectionState = {
    type: {
        name: "Composite",
        className: "PrivateLinkServiceConnectionState",
        modelProperties: {
            status: {
                serializedName: "status",
                type: {
                    name: "String"
                }
            },
            description: {
                serializedName: "description",
                type: {
                    name: "String"
                }
            },
            actionsRequired: {
                serializedName: "actionsRequired",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskAccessUpdate = {
    type: {
        name: "Composite",
        className: "DiskAccessUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            }
        }
    }
};
export const DiskAccessList = {
    type: {
        name: "Composite",
        className: "DiskAccessList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskAccess"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PrivateLinkResourceListResult = {
    type: {
        name: "Composite",
        className: "PrivateLinkResourceListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateLinkResource"
                        }
                    }
                }
            }
        }
    }
};
export const PrivateLinkResource = {
    type: {
        name: "Composite",
        className: "PrivateLinkResource",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            groupId: {
                serializedName: "properties.groupId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            requiredMembers: {
                serializedName: "properties.requiredMembers",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            requiredZoneNames: {
                serializedName: "properties.requiredZoneNames",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const PrivateEndpointConnectionListResult = {
    type: {
        name: "Composite",
        className: "PrivateEndpointConnectionListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpointConnection"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const ProxyOnlyResource = {
    type: {
        name: "Composite",
        className: "ProxyOnlyResource",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const DiskRestorePointList = {
    type: {
        name: "Composite",
        className: "DiskRestorePointList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DiskRestorePoint"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryIdentifier = {
    type: {
        name: "Composite",
        className: "GalleryIdentifier",
        modelProperties: {
            uniqueName: {
                serializedName: "uniqueName",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SharingProfile = {
    type: {
        name: "Composite",
        className: "SharingProfile",
        modelProperties: {
            permissions: {
                serializedName: "permissions",
                type: {
                    name: "String"
                }
            },
            groups: {
                serializedName: "groups",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharingProfileGroup"
                        }
                    }
                }
            }
        }
    }
};
export const SharingProfileGroup = {
    type: {
        name: "Composite",
        className: "SharingProfileGroup",
        modelProperties: {
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            ids: {
                serializedName: "ids",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const SoftDeletePolicy = {
    type: {
        name: "Composite",
        className: "SoftDeletePolicy",
        modelProperties: {
            isSoftDeleteEnabled: {
                serializedName: "isSoftDeleteEnabled",
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const UpdateResourceDefinition = {
    type: {
        name: "Composite",
        className: "UpdateResourceDefinition",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            }
        }
    }
};
export const GalleryImageIdentifier = {
    type: {
        name: "Composite",
        className: "GalleryImageIdentifier",
        modelProperties: {
            publisher: {
                serializedName: "publisher",
                required: true,
                type: {
                    name: "String"
                }
            },
            offer: {
                serializedName: "offer",
                required: true,
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RecommendedMachineConfiguration = {
    type: {
        name: "Composite",
        className: "RecommendedMachineConfiguration",
        modelProperties: {
            vCPUs: {
                serializedName: "vCPUs",
                type: {
                    name: "Composite",
                    className: "ResourceRange"
                }
            },
            memory: {
                serializedName: "memory",
                type: {
                    name: "Composite",
                    className: "ResourceRange"
                }
            }
        }
    }
};
export const ResourceRange = {
    type: {
        name: "Composite",
        className: "ResourceRange",
        modelProperties: {
            min: {
                serializedName: "min",
                type: {
                    name: "Number"
                }
            },
            max: {
                serializedName: "max",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const Disallowed = {
    type: {
        name: "Composite",
        className: "Disallowed",
        modelProperties: {
            diskTypes: {
                serializedName: "diskTypes",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const ImagePurchasePlan = {
    type: {
        name: "Composite",
        className: "ImagePurchasePlan",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            product: {
                serializedName: "product",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryImageFeature = {
    type: {
        name: "Composite",
        className: "GalleryImageFeature",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            value: {
                serializedName: "value",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryArtifactPublishingProfileBase = {
    type: {
        name: "Composite",
        className: "GalleryArtifactPublishingProfileBase",
        modelProperties: {
            targetRegions: {
                serializedName: "targetRegions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "TargetRegion"
                        }
                    }
                }
            },
            replicaCount: {
                serializedName: "replicaCount",
                type: {
                    name: "Number"
                }
            },
            excludeFromLatest: {
                serializedName: "excludeFromLatest",
                type: {
                    name: "Boolean"
                }
            },
            publishedDate: {
                serializedName: "publishedDate",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            endOfLifeDate: {
                serializedName: "endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            },
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            replicationMode: {
                serializedName: "replicationMode",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const TargetRegion = {
    type: {
        name: "Composite",
        className: "TargetRegion",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            regionalReplicaCount: {
                serializedName: "regionalReplicaCount",
                type: {
                    name: "Number"
                }
            },
            storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            },
            encryption: {
                serializedName: "encryption",
                type: {
                    name: "Composite",
                    className: "EncryptionImages"
                }
            }
        }
    }
};
export const EncryptionImages = {
    type: {
        name: "Composite",
        className: "EncryptionImages",
        modelProperties: {
            osDiskImage: {
                serializedName: "osDiskImage",
                type: {
                    name: "Composite",
                    className: "OSDiskImageEncryption"
                }
            },
            dataDiskImages: {
                serializedName: "dataDiskImages",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DataDiskImageEncryption"
                        }
                    }
                }
            }
        }
    }
};
export const DiskImageEncryption = {
    type: {
        name: "Composite",
        className: "DiskImageEncryption",
        modelProperties: {
            diskEncryptionSetId: {
                serializedName: "diskEncryptionSetId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryImageVersionStorageProfile = {
    type: {
        name: "Composite",
        className: "GalleryImageVersionStorageProfile",
        modelProperties: {
            source: {
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "GalleryArtifactVersionSource"
                }
            },
            osDiskImage: {
                serializedName: "osDiskImage",
                type: {
                    name: "Composite",
                    className: "GalleryOSDiskImage"
                }
            },
            dataDiskImages: {
                serializedName: "dataDiskImages",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryDataDiskImage"
                        }
                    }
                }
            }
        }
    }
};
export const GalleryArtifactVersionSource = {
    type: {
        name: "Composite",
        className: "GalleryArtifactVersionSource",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            uri: {
                serializedName: "uri",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryDiskImage = {
    type: {
        name: "Composite",
        className: "GalleryDiskImage",
        modelProperties: {
            sizeInGB: {
                serializedName: "sizeInGB",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            hostCaching: {
                serializedName: "hostCaching",
                type: {
                    name: "Enum",
                    allowedValues: ["None", "ReadOnly", "ReadWrite"]
                }
            },
            source: {
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "GalleryArtifactVersionSource"
                }
            }
        }
    }
};
export const ReplicationStatus = {
    type: {
        name: "Composite",
        className: "ReplicationStatus",
        modelProperties: {
            aggregatedState: {
                serializedName: "aggregatedState",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            summary: {
                serializedName: "summary",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RegionalReplicationStatus"
                        }
                    }
                }
            }
        }
    }
};
export const RegionalReplicationStatus = {
    type: {
        name: "Composite",
        className: "RegionalReplicationStatus",
        modelProperties: {
            region: {
                serializedName: "region",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            state: {
                serializedName: "state",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            details: {
                serializedName: "details",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            progress: {
                serializedName: "progress",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const UserArtifactSource = {
    type: {
        name: "Composite",
        className: "UserArtifactSource",
        modelProperties: {
            mediaLink: {
                serializedName: "mediaLink",
                required: true,
                type: {
                    name: "String"
                }
            },
            defaultConfigurationLink: {
                serializedName: "defaultConfigurationLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const UserArtifactManage = {
    type: {
        name: "Composite",
        className: "UserArtifactManage",
        modelProperties: {
            install: {
                serializedName: "install",
                required: true,
                type: {
                    name: "String"
                }
            },
            remove: {
                serializedName: "remove",
                required: true,
                type: {
                    name: "String"
                }
            },
            update: {
                serializedName: "update",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryList = {
    type: {
        name: "Composite",
        className: "GalleryList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Gallery"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryImageList = {
    type: {
        name: "Composite",
        className: "GalleryImageList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryImageVersionList = {
    type: {
        name: "Composite",
        className: "GalleryImageVersionList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryApplicationList = {
    type: {
        name: "Composite",
        className: "GalleryApplicationList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryApplication"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryApplicationVersionList = {
    type: {
        name: "Composite",
        className: "GalleryApplicationVersionList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryApplicationVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SharingUpdate = {
    type: {
        name: "Composite",
        className: "SharingUpdate",
        modelProperties: {
            operationType: {
                serializedName: "operationType",
                required: true,
                type: {
                    name: "String"
                }
            },
            groups: {
                serializedName: "groups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharingProfileGroup"
                        }
                    }
                }
            }
        }
    }
};
export const SharedGalleryList = {
    type: {
        name: "Composite",
        className: "SharedGalleryList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharedGallery"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PirResource = {
    type: {
        name: "Composite",
        className: "PirResource",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SharedGalleryImageList = {
    type: {
        name: "Composite",
        className: "SharedGalleryImageList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharedGalleryImage"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SharedGalleryImageVersionList = {
    type: {
        name: "Composite",
        className: "SharedGalleryImageVersionList",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SharedGalleryImageVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const PirCommunityGalleryResource = {
    type: {
        name: "Composite",
        className: "PirCommunityGalleryResource",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            uniqueId: {
                serializedName: "identifier.uniqueId",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RoleInstance = {
    type: {
        name: "Composite",
        className: "RoleInstance",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                readOnly: true,
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "InstanceSku"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "RoleInstanceProperties"
                }
            }
        }
    }
};
export const InstanceSku = {
    type: {
        name: "Composite",
        className: "InstanceSku",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RoleInstanceProperties = {
    type: {
        name: "Composite",
        className: "RoleInstanceProperties",
        modelProperties: {
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "RoleInstanceNetworkProfile"
                }
            },
            instanceView: {
                serializedName: "instanceView",
                type: {
                    name: "Composite",
                    className: "RoleInstanceView"
                }
            }
        }
    }
};
export const RoleInstanceNetworkProfile = {
    type: {
        name: "Composite",
        className: "RoleInstanceNetworkProfile",
        modelProperties: {
            networkInterfaces: {
                serializedName: "networkInterfaces",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }
        }
    }
};
export const RoleInstanceView = {
    type: {
        name: "Composite",
        className: "RoleInstanceView",
        modelProperties: {
            platformUpdateDomain: {
                serializedName: "platformUpdateDomain",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            platformFaultDomain: {
                serializedName: "platformFaultDomain",
                readOnly: true,
                type: {
                    name: "Number"
                }
            },
            privateId: {
                serializedName: "privateId",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            statuses: {
                serializedName: "statuses",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceInstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const ResourceInstanceViewStatus = {
    type: {
        name: "Composite",
        className: "ResourceInstanceViewStatus",
        modelProperties: {
            code: {
                serializedName: "code",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            displayStatus: {
                serializedName: "displayStatus",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            message: {
                serializedName: "message",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            time: {
                serializedName: "time",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            },
            level: {
                serializedName: "level",
                type: {
                    name: "Enum",
                    allowedValues: ["Info", "Warning", "Error"]
                }
            }
        }
    }
};
export const RoleInstanceListResult = {
    type: {
        name: "Composite",
        className: "RoleInstanceListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RoleInstance"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudServiceRole = {
    type: {
        name: "Composite",
        className: "CloudServiceRole",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleSku"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleProperties"
                }
            }
        }
    }
};
export const CloudServiceRoleSku = {
    type: {
        name: "Composite",
        className: "CloudServiceRoleSku",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            tier: {
                serializedName: "tier",
                type: {
                    name: "String"
                }
            },
            capacity: {
                serializedName: "capacity",
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const CloudServiceRoleProperties = {
    type: {
        name: "Composite",
        className: "CloudServiceRoleProperties",
        modelProperties: {
            uniqueId: {
                serializedName: "uniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudServiceRoleListResult = {
    type: {
        name: "Composite",
        className: "CloudServiceRoleListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceRole"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudService = {
    type: {
        name: "Composite",
        className: "CloudService",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                required: true,
                type: {
                    name: "String"
                }
            },
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "CloudServiceProperties"
                }
            }
        }
    }
};
export const CloudServiceProperties = {
    type: {
        name: "Composite",
        className: "CloudServiceProperties",
        modelProperties: {
            packageUrl: {
                serializedName: "packageUrl",
                type: {
                    name: "String"
                }
            },
            configuration: {
                serializedName: "configuration",
                type: {
                    name: "String"
                }
            },
            configurationUrl: {
                serializedName: "configurationUrl",
                type: {
                    name: "String"
                }
            },
            startCloudService: {
                serializedName: "startCloudService",
                type: {
                    name: "Boolean"
                }
            },
            allowModelOverride: {
                serializedName: "allowModelOverride",
                type: {
                    name: "Boolean"
                }
            },
            upgradeMode: {
                serializedName: "upgradeMode",
                type: {
                    name: "String"
                }
            },
            roleProfile: {
                serializedName: "roleProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleProfile"
                }
            },
            osProfile: {
                serializedName: "osProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceOsProfile"
                }
            },
            networkProfile: {
                serializedName: "networkProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceNetworkProfile"
                }
            },
            extensionProfile: {
                serializedName: "extensionProfile",
                type: {
                    name: "Composite",
                    className: "CloudServiceExtensionProfile"
                }
            },
            provisioningState: {
                serializedName: "provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            uniqueId: {
                serializedName: "uniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudServiceRoleProfile = {
    type: {
        name: "Composite",
        className: "CloudServiceRoleProfile",
        modelProperties: {
            roles: {
                serializedName: "roles",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceRoleProfileProperties"
                        }
                    }
                }
            }
        }
    }
};
export const CloudServiceRoleProfileProperties = {
    type: {
        name: "Composite",
        className: "CloudServiceRoleProfileProperties",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "CloudServiceRoleSku"
                }
            }
        }
    }
};
export const CloudServiceOsProfile = {
    type: {
        name: "Composite",
        className: "CloudServiceOsProfile",
        modelProperties: {
            secrets: {
                serializedName: "secrets",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceVaultSecretGroup"
                        }
                    }
                }
            }
        }
    }
};
export const CloudServiceVaultSecretGroup = {
    type: {
        name: "Composite",
        className: "CloudServiceVaultSecretGroup",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            vaultCertificates: {
                serializedName: "vaultCertificates",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudServiceVaultCertificate"
                        }
                    }
                }
            }
        }
    }
};
export const CloudServiceVaultCertificate = {
    type: {
        name: "Composite",
        className: "CloudServiceVaultCertificate",
        modelProperties: {
            certificateUrl: {
                serializedName: "certificateUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudServiceNetworkProfile = {
    type: {
        name: "Composite",
        className: "CloudServiceNetworkProfile",
        modelProperties: {
            loadBalancerConfigurations: {
                serializedName: "loadBalancerConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancerConfiguration"
                        }
                    }
                }
            },
            swappableCloudService: {
                serializedName: "swappableCloudService",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }
        }
    }
};
export const LoadBalancerConfiguration = {
    type: {
        name: "Composite",
        className: "LoadBalancerConfiguration",
        modelProperties: {
            id: {
                serializedName: "id",
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "LoadBalancerConfigurationProperties"
                }
            }
        }
    }
};
export const LoadBalancerConfigurationProperties = {
    type: {
        name: "Composite",
        className: "LoadBalancerConfigurationProperties",
        modelProperties: {
            frontendIPConfigurations: {
                serializedName: "frontendIPConfigurations",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "LoadBalancerFrontendIPConfiguration"
                        }
                    }
                }
            }
        }
    }
};
export const LoadBalancerFrontendIPConfiguration = {
    type: {
        name: "Composite",
        className: "LoadBalancerFrontendIPConfiguration",
        modelProperties: {
            name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "LoadBalancerFrontendIPConfigurationProperties"
                }
            }
        }
    }
};
export const LoadBalancerFrontendIPConfigurationProperties = {
    type: {
        name: "Composite",
        className: "LoadBalancerFrontendIPConfigurationProperties",
        modelProperties: {
            publicIPAddress: {
                serializedName: "publicIPAddress",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            subnet: {
                serializedName: "subnet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            privateIPAddress: {
                serializedName: "privateIPAddress",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudServiceExtensionProfile = {
    type: {
        name: "Composite",
        className: "CloudServiceExtensionProfile",
        modelProperties: {
            extensions: {
                serializedName: "extensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Extension"
                        }
                    }
                }
            }
        }
    }
};
export const Extension = {
    type: {
        name: "Composite",
        className: "Extension",
        modelProperties: {
            name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "CloudServiceExtensionProperties"
                }
            }
        }
    }
};
export const CloudServiceExtensionProperties = {
    type: {
        name: "Composite",
        className: "CloudServiceExtensionProperties",
        modelProperties: {
            publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                type: {
                    name: "String"
                }
            },
            typeHandlerVersion: {
                serializedName: "typeHandlerVersion",
                type: {
                    name: "String"
                }
            },
            autoUpgradeMinorVersion: {
                serializedName: "autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            },
            settings: {
                serializedName: "settings",
                type: {
                    name: "String"
                }
            },
            protectedSettings: {
                serializedName: "protectedSettings",
                type: {
                    name: "String"
                }
            },
            protectedSettingsFromKeyVault: {
                serializedName: "protectedSettingsFromKeyVault",
                type: {
                    name: "Composite",
                    className: "CloudServiceVaultAndSecretReference"
                }
            },
            forceUpdateTag: {
                serializedName: "forceUpdateTag",
                type: {
                    name: "String"
                }
            },
            provisioningState: {
                serializedName: "provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            rolesAppliedTo: {
                serializedName: "rolesAppliedTo",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const CloudServiceVaultAndSecretReference = {
    type: {
        name: "Composite",
        className: "CloudServiceVaultAndSecretReference",
        modelProperties: {
            sourceVault: {
                serializedName: "sourceVault",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            },
            secretUrl: {
                serializedName: "secretUrl",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const CloudServiceUpdate = {
    type: {
        name: "Composite",
        className: "CloudServiceUpdate",
        modelProperties: {
            tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            }
        }
    }
};
export const CloudServiceInstanceView = {
    type: {
        name: "Composite",
        className: "CloudServiceInstanceView",
        modelProperties: {
            roleInstance: {
                serializedName: "roleInstance",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatusesSummary"
                }
            },
            sdkVersion: {
                serializedName: "sdkVersion",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            privateIds: {
                serializedName: "privateIds",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            },
            statuses: {
                serializedName: "statuses",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ResourceInstanceViewStatus"
                        }
                    }
                }
            }
        }
    }
};
export const InstanceViewStatusesSummary = {
    type: {
        name: "Composite",
        className: "InstanceViewStatusesSummary",
        modelProperties: {
            statusesSummary: {
                serializedName: "statusesSummary",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "StatusCodeCount"
                        }
                    }
                }
            }
        }
    }
};
export const StatusCodeCount = {
    type: {
        name: "Composite",
        className: "StatusCodeCount",
        modelProperties: {
            code: {
                serializedName: "code",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            count: {
                serializedName: "count",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }
        }
    }
};
export const CloudServiceListResult = {
    type: {
        name: "Composite",
        className: "CloudServiceListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "CloudService"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const RoleInstances = {
    type: {
        name: "Composite",
        className: "RoleInstances",
        modelProperties: {
            roleInstances: {
                serializedName: "roleInstances",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        }
    }
};
export const UpdateDomain = {
    type: {
        name: "Composite",
        className: "UpdateDomain",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const UpdateDomainListResult = {
    type: {
        name: "Composite",
        className: "UpdateDomainListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "UpdateDomain"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const OSVersion = {
    type: {
        name: "Composite",
        className: "OSVersion",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "OSVersionProperties"
                }
            }
        }
    }
};
export const OSVersionProperties = {
    type: {
        name: "Composite",
        className: "OSVersionProperties",
        modelProperties: {
            family: {
                serializedName: "family",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            familyLabel: {
                serializedName: "familyLabel",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            version: {
                serializedName: "version",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            label: {
                serializedName: "label",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            isDefault: {
                serializedName: "isDefault",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            isActive: {
                serializedName: "isActive",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const OSVersionListResult = {
    type: {
        name: "Composite",
        className: "OSVersionListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OSVersion"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const OSFamily = {
    type: {
        name: "Composite",
        className: "OSFamily",
        modelProperties: {
            id: {
                serializedName: "id",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            location: {
                serializedName: "location",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            properties: {
                serializedName: "properties",
                type: {
                    name: "Composite",
                    className: "OSFamilyProperties"
                }
            }
        }
    }
};
export const OSFamilyProperties = {
    type: {
        name: "Composite",
        className: "OSFamilyProperties",
        modelProperties: {
            name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            label: {
                serializedName: "label",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            versions: {
                serializedName: "versions",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OSVersionPropertiesBase"
                        }
                    }
                }
            }
        }
    }
};
export const OSVersionPropertiesBase = {
    type: {
        name: "Composite",
        className: "OSVersionPropertiesBase",
        modelProperties: {
            version: {
                serializedName: "version",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            label: {
                serializedName: "label",
                readOnly: true,
                type: {
                    name: "String"
                }
            },
            isDefault: {
                serializedName: "isDefault",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            },
            isActive: {
                serializedName: "isActive",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            }
        }
    }
};
export const OSFamilyListResult = {
    type: {
        name: "Composite",
        className: "OSFamilyListResult",
        modelProperties: {
            value: {
                serializedName: "value",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "OSFamily"
                        }
                    }
                }
            },
            nextLink: {
                serializedName: "nextLink",
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const GalleryArtifactSource = {
    type: {
        name: "Composite",
        className: "GalleryArtifactSource",
        modelProperties: {
            managedImage: {
                serializedName: "managedImage",
                type: {
                    name: "Composite",
                    className: "ManagedArtifact"
                }
            }
        }
    }
};
export const ManagedArtifact = {
    type: {
        name: "Composite",
        className: "ManagedArtifact",
        modelProperties: {
            id: {
                serializedName: "id",
                required: true,
                type: {
                    name: "String"
                }
            }
        }
    }
};
export const SubResourceWithColocationStatus = {
    type: {
        name: "Composite",
        className: "SubResourceWithColocationStatus",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { colocationStatus: {
                serializedName: "colocationStatus",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            } })
    }
};
export const VirtualMachineImageResource = {
    type: {
        name: "Composite",
        className: "VirtualMachineImageResource",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            }, location: {
                serializedName: "location",
                required: true,
                type: {
                    name: "String"
                }
            }, tags: {
                serializedName: "tags",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "String" } }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            } })
    }
};
export const ImageReference = {
    type: {
        name: "Composite",
        className: "ImageReference",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { publisher: {
                serializedName: "publisher",
                type: {
                    name: "String"
                }
            }, offer: {
                serializedName: "offer",
                type: {
                    name: "String"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "String"
                }
            }, version: {
                serializedName: "version",
                type: {
                    name: "String"
                }
            }, exactVersion: {
                serializedName: "exactVersion",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, sharedGalleryImageId: {
                serializedName: "sharedGalleryImageId",
                type: {
                    name: "String"
                }
            } })
    }
};
export const DiskEncryptionSetParameters = {
    type: {
        name: "Composite",
        className: "DiskEncryptionSetParameters",
        modelProperties: Object.assign({}, SubResource.type.modelProperties)
    }
};
export const ManagedDiskParameters = {
    type: {
        name: "Composite",
        className: "ManagedDiskParameters",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { storageAccountType: {
                serializedName: "storageAccountType",
                type: {
                    name: "String"
                }
            }, diskEncryptionSet: {
                serializedName: "diskEncryptionSet",
                type: {
                    name: "Composite",
                    className: "DiskEncryptionSetParameters"
                }
            } })
    }
};
export const NetworkInterfaceReference = {
    type: {
        name: "Composite",
        className: "NetworkInterfaceReference",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineScaleSetIPConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetIPConfiguration",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, publicIPAddressConfiguration: {
                serializedName: "properties.publicIPAddressConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetPublicIPAddressConfiguration"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerInboundNatPools: {
                serializedName: "properties.loadBalancerInboundNatPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            } })
    }
};
export const VirtualMachineScaleSetNetworkConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetNetworkConfiguration",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                required: true,
                type: {
                    name: "String"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            }, enableFpga: {
                serializedName: "properties.enableFpga",
                type: {
                    name: "Boolean"
                }
            }, networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetNetworkConfigurationDnsSettings"
                }
            }, ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetIPConfiguration"
                        }
                    }
                }
            }, enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineCaptureResult = {
    type: {
        name: "Composite",
        className: "VirtualMachineCaptureResult",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { schema: {
                serializedName: "$schema",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, contentVersion: {
                serializedName: "contentVersion",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, parameters: {
                serializedName: "parameters",
                readOnly: true,
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, resources: {
                serializedName: "resources",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Dictionary",
                            value: { type: { name: "any" } }
                        }
                    }
                }
            } })
    }
};
export const VirtualMachineScaleSetUpdateIPConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateIPConfiguration",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, subnet: {
                serializedName: "properties.subnet",
                type: {
                    name: "Composite",
                    className: "ApiEntityReference"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, publicIPAddressConfiguration: {
                serializedName: "properties.publicIPAddressConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdatePublicIPAddressConfiguration"
                }
            }, privateIPAddressVersion: {
                serializedName: "properties.privateIPAddressVersion",
                type: {
                    name: "String"
                }
            }, applicationGatewayBackendAddressPools: {
                serializedName: "properties.applicationGatewayBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, applicationSecurityGroups: {
                serializedName: "properties.applicationSecurityGroups",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerBackendAddressPools: {
                serializedName: "properties.loadBalancerBackendAddressPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, loadBalancerInboundNatPools: {
                serializedName: "properties.loadBalancerInboundNatPools",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            } })
    }
};
export const VirtualMachineScaleSetUpdateNetworkConfiguration = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdateNetworkConfiguration",
        modelProperties: Object.assign(Object.assign({}, SubResource.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, primary: {
                serializedName: "properties.primary",
                type: {
                    name: "Boolean"
                }
            }, enableAcceleratedNetworking: {
                serializedName: "properties.enableAcceleratedNetworking",
                type: {
                    name: "Boolean"
                }
            }, enableFpga: {
                serializedName: "properties.enableFpga",
                type: {
                    name: "Boolean"
                }
            }, networkSecurityGroup: {
                serializedName: "properties.networkSecurityGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, dnsSettings: {
                serializedName: "properties.dnsSettings",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetNetworkConfigurationDnsSettings"
                }
            }, ipConfigurations: {
                serializedName: "properties.ipConfigurations",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineScaleSetUpdateIPConfiguration"
                        }
                    }
                }
            }, enableIPForwarding: {
                serializedName: "properties.enableIPForwarding",
                type: {
                    name: "Boolean"
                }
            }, deleteOption: {
                serializedName: "properties.deleteOption",
                type: {
                    name: "String"
                }
            } })
    }
};
export const AvailabilitySet = {
    type: {
        name: "Composite",
        className: "AvailabilitySet",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, platformUpdateDomainCount: {
                serializedName: "properties.platformUpdateDomainCount",
                type: {
                    name: "Number"
                }
            }, platformFaultDomainCount: {
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, statuses: {
                serializedName: "properties.statuses",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            } })
    }
};
export const ProximityPlacementGroup = {
    type: {
        name: "Composite",
        className: "ProximityPlacementGroup",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { proximityPlacementGroupType: {
                serializedName: "properties.proximityPlacementGroupType",
                type: {
                    name: "String"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceWithColocationStatus"
                        }
                    }
                }
            }, virtualMachineScaleSets: {
                serializedName: "properties.virtualMachineScaleSets",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceWithColocationStatus"
                        }
                    }
                }
            }, availabilitySets: {
                serializedName: "properties.availabilitySets",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceWithColocationStatus"
                        }
                    }
                }
            }, colocationStatus: {
                serializedName: "properties.colocationStatus",
                type: {
                    name: "Composite",
                    className: "InstanceViewStatus"
                }
            } })
    }
};
export const DedicatedHostGroup = {
    type: {
        name: "Composite",
        className: "DedicatedHostGroup",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, platformFaultDomainCount: {
                constraints: {
                    InclusiveMinimum: 1
                },
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, hosts: {
                serializedName: "properties.hosts",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostGroupInstanceView"
                }
            }, supportAutomaticPlacement: {
                serializedName: "properties.supportAutomaticPlacement",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const DedicatedHost = {
    type: {
        name: "Composite",
        className: "DedicatedHost",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, platformFaultDomain: {
                constraints: {
                    InclusiveMinimum: 0
                },
                serializedName: "properties.platformFaultDomain",
                type: {
                    name: "Number"
                }
            }, autoReplaceOnFailure: {
                serializedName: "properties.autoReplaceOnFailure",
                type: {
                    name: "Boolean"
                }
            }, hostId: {
                serializedName: "properties.hostId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "Windows_Server_Hybrid",
                        "Windows_Server_Perpetual"
                    ]
                }
            }, provisioningTime: {
                serializedName: "properties.provisioningTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostInstanceView"
                }
            } })
    }
};
export const SshPublicKeyResource = {
    type: {
        name: "Composite",
        className: "SshPublicKeyResource",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { publicKey: {
                serializedName: "properties.publicKey",
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineExtensionImage = {
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionImage",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { operatingSystem: {
                serializedName: "properties.operatingSystem",
                type: {
                    name: "String"
                }
            }, computeRole: {
                serializedName: "properties.computeRole",
                type: {
                    name: "String"
                }
            }, handlerSchema: {
                serializedName: "properties.handlerSchema",
                type: {
                    name: "String"
                }
            }, vmScaleSetEnabled: {
                serializedName: "properties.vmScaleSetEnabled",
                type: {
                    name: "Boolean"
                }
            }, supportsMultipleExtensions: {
                serializedName: "properties.supportsMultipleExtensions",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const VirtualMachineExtension = {
    type: {
        name: "Composite",
        className: "VirtualMachineExtension",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, typePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineExtensionInstanceView"
                }
            }, suppressFailures: {
                serializedName: "properties.suppressFailures",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const VirtualMachine = {
    type: {
        name: "Composite",
        className: "VirtualMachine",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, resources: {
                serializedName: "resources",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtension"
                        }
                    }
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineIdentity"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, hardwareProfile: {
                serializedName: "properties.hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "StorageProfile"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, osProfile: {
                serializedName: "properties.osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            }, networkProfile: {
                serializedName: "properties.networkProfile",
                type: {
                    name: "Composite",
                    className: "NetworkProfile"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            }, diagnosticsProfile: {
                serializedName: "properties.diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            }, availabilitySet: {
                serializedName: "properties.availabilitySet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, virtualMachineScaleSet: {
                serializedName: "properties.virtualMachineScaleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, priority: {
                serializedName: "properties.priority",
                type: {
                    name: "String"
                }
            }, evictionPolicy: {
                serializedName: "properties.evictionPolicy",
                type: {
                    name: "String"
                }
            }, billingProfile: {
                serializedName: "properties.billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            }, host: {
                serializedName: "properties.host",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostGroup: {
                serializedName: "properties.hostGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineInstanceView"
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "String"
                }
            }, vmId: {
                serializedName: "properties.vmId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, extensionsTimeBudget: {
                serializedName: "properties.extensionsTimeBudget",
                type: {
                    name: "String"
                }
            }, platformFaultDomain: {
                serializedName: "properties.platformFaultDomain",
                type: {
                    name: "Number"
                }
            }, scheduledEventsProfile: {
                serializedName: "properties.scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            }, userData: {
                serializedName: "properties.userData",
                type: {
                    name: "String"
                }
            }, capacityReservation: {
                serializedName: "properties.capacityReservation",
                type: {
                    name: "Composite",
                    className: "CapacityReservationProfile"
                }
            }, applicationProfile: {
                serializedName: "properties.applicationProfile",
                type: {
                    name: "Composite",
                    className: "ApplicationProfile"
                }
            } })
    }
};
export const VirtualMachineScaleSet = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSet",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetIdentity"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, upgradePolicy: {
                serializedName: "properties.upgradePolicy",
                type: {
                    name: "Composite",
                    className: "UpgradePolicy"
                }
            }, automaticRepairsPolicy: {
                serializedName: "properties.automaticRepairsPolicy",
                type: {
                    name: "Composite",
                    className: "AutomaticRepairsPolicy"
                }
            }, virtualMachineProfile: {
                serializedName: "properties.virtualMachineProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, overprovision: {
                serializedName: "properties.overprovision",
                type: {
                    name: "Boolean"
                }
            }, doNotRunExtensionsOnOverprovisionedVMs: {
                serializedName: "properties.doNotRunExtensionsOnOverprovisionedVMs",
                type: {
                    name: "Boolean"
                }
            }, uniqueId: {
                serializedName: "properties.uniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, singlePlacementGroup: {
                serializedName: "properties.singlePlacementGroup",
                type: {
                    name: "Boolean"
                }
            }, zoneBalance: {
                serializedName: "properties.zoneBalance",
                type: {
                    name: "Boolean"
                }
            }, platformFaultDomainCount: {
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostGroup: {
                serializedName: "properties.hostGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, scaleInPolicy: {
                serializedName: "properties.scaleInPolicy",
                type: {
                    name: "Composite",
                    className: "ScaleInPolicy"
                }
            }, orchestrationMode: {
                serializedName: "properties.orchestrationMode",
                type: {
                    name: "String"
                }
            }, spotRestorePolicy: {
                serializedName: "properties.spotRestorePolicy",
                type: {
                    name: "Composite",
                    className: "SpotRestorePolicy"
                }
            } })
    }
};
export const Image = {
    type: {
        name: "Composite",
        className: "Image",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, sourceVirtualMachine: {
                serializedName: "properties.sourceVirtualMachine",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "ImageStorageProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            } })
    }
};
export const RestorePointCollection = {
    type: {
        name: "Composite",
        className: "RestorePointCollection",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "RestorePointCollectionSourceProperties"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, restorePointCollectionId: {
                serializedName: "properties.restorePointCollectionId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, restorePoints: {
                serializedName: "properties.restorePoints",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePoint"
                        }
                    }
                }
            } })
    }
};
export const CapacityReservationGroup = {
    type: {
        name: "Composite",
        className: "CapacityReservationGroup",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, capacityReservations: {
                serializedName: "properties.capacityReservations",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, virtualMachinesAssociated: {
                serializedName: "properties.virtualMachinesAssociated",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationGroupInstanceView"
                }
            } })
    }
};
export const CapacityReservation = {
    type: {
        name: "Composite",
        className: "CapacityReservation",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, reservationId: {
                serializedName: "properties.reservationId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, virtualMachinesAssociated: {
                serializedName: "properties.virtualMachinesAssociated",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, provisioningTime: {
                serializedName: "properties.provisioningTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationInstanceView"
                }
            } })
    }
};
export const RollingUpgradeStatusInfo = {
    type: {
        name: "Composite",
        className: "RollingUpgradeStatusInfo",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { policy: {
                serializedName: "properties.policy",
                type: {
                    name: "Composite",
                    className: "RollingUpgradePolicy"
                }
            }, runningStatus: {
                serializedName: "properties.runningStatus",
                type: {
                    name: "Composite",
                    className: "RollingUpgradeRunningStatus"
                }
            }, progress: {
                serializedName: "properties.progress",
                type: {
                    name: "Composite",
                    className: "RollingUpgradeProgressInfo"
                }
            }, error: {
                serializedName: "properties.error",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            } })
    }
};
export const VirtualMachineScaleSetVM = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVM",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { instanceId: {
                serializedName: "instanceId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, resources: {
                serializedName: "resources",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineExtension"
                        }
                    }
                }
            }, zones: {
                serializedName: "zones",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, latestModelApplied: {
                serializedName: "properties.latestModelApplied",
                readOnly: true,
                type: {
                    name: "Boolean"
                }
            }, vmId: {
                serializedName: "properties.vmId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMInstanceView"
                }
            }, hardwareProfile: {
                serializedName: "properties.hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "StorageProfile"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, osProfile: {
                serializedName: "properties.osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            }, networkProfile: {
                serializedName: "properties.networkProfile",
                type: {
                    name: "Composite",
                    className: "NetworkProfile"
                }
            }, networkProfileConfiguration: {
                serializedName: "properties.networkProfileConfiguration",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMNetworkProfileConfiguration"
                }
            }, diagnosticsProfile: {
                serializedName: "properties.diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            }, availabilitySet: {
                serializedName: "properties.availabilitySet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "String"
                }
            }, modelDefinitionApplied: {
                serializedName: "properties.modelDefinitionApplied",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, protectionPolicy: {
                serializedName: "properties.protectionPolicy",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetVMProtectionPolicy"
                }
            }, userData: {
                serializedName: "properties.userData",
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineRunCommand = {
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommand",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandScriptSource"
                }
            }, parameters: {
                serializedName: "properties.parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, protectedParameters: {
                serializedName: "properties.protectedParameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, asyncExecution: {
                defaultValue: false,
                serializedName: "properties.asyncExecution",
                type: {
                    name: "Boolean"
                }
            }, runAsUser: {
                serializedName: "properties.runAsUser",
                type: {
                    name: "String"
                }
            }, runAsPassword: {
                serializedName: "properties.runAsPassword",
                type: {
                    name: "String"
                }
            }, timeoutInSeconds: {
                serializedName: "properties.timeoutInSeconds",
                type: {
                    name: "Number"
                }
            }, outputBlobUri: {
                serializedName: "properties.outputBlobUri",
                type: {
                    name: "String"
                }
            }, errorBlobUri: {
                serializedName: "properties.errorBlobUri",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandInstanceView"
                }
            } })
    }
};
export const Disk = {
    type: {
        name: "Composite",
        className: "Disk",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { managedBy: {
                serializedName: "managedBy",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, managedByExtended: {
                serializedName: "managedByExtended",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "DiskSku"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, timeCreated: {
                serializedName: "properties.timeCreated",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlanAutoGenerated"
                }
            }, supportedCapabilities: {
                serializedName: "properties.supportedCapabilities",
                type: {
                    name: "Composite",
                    className: "SupportedCapabilities"
                }
            }, creationData: {
                serializedName: "properties.creationData",
                type: {
                    name: "Composite",
                    className: "CreationData"
                }
            }, diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            }, diskSizeBytes: {
                serializedName: "properties.diskSizeBytes",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }, uniqueId: {
                serializedName: "properties.uniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, diskIopsReadWrite: {
                serializedName: "properties.diskIOPSReadWrite",
                type: {
                    name: "Number"
                }
            }, diskMBpsReadWrite: {
                serializedName: "properties.diskMBpsReadWrite",
                type: {
                    name: "Number"
                }
            }, diskIopsReadOnly: {
                serializedName: "properties.diskIOPSReadOnly",
                type: {
                    name: "Number"
                }
            }, diskMBpsReadOnly: {
                serializedName: "properties.diskMBpsReadOnly",
                type: {
                    name: "Number"
                }
            }, diskState: {
                serializedName: "properties.diskState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            }, maxShares: {
                serializedName: "properties.maxShares",
                type: {
                    name: "Number"
                }
            }, shareInfo: {
                serializedName: "properties.shareInfo",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ShareInfoElement"
                        }
                    }
                }
            }, networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            }, diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            }, tier: {
                serializedName: "properties.tier",
                type: {
                    name: "String"
                }
            }, burstingEnabled: {
                serializedName: "properties.burstingEnabled",
                type: {
                    name: "Boolean"
                }
            }, propertyUpdatesInProgress: {
                serializedName: "properties.propertyUpdatesInProgress",
                type: {
                    name: "Composite",
                    className: "PropertyUpdatesInProgress"
                }
            }, supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "DiskSecurityProfile"
                }
            }, completionPercent: {
                serializedName: "properties.completionPercent",
                type: {
                    name: "Number"
                }
            }, publicNetworkAccess: {
                serializedName: "properties.publicNetworkAccess",
                type: {
                    name: "String"
                }
            } })
    }
};
export const Snapshot = {
    type: {
        name: "Composite",
        className: "Snapshot",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { managedBy: {
                serializedName: "managedBy",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "SnapshotSku"
                }
            }, extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, timeCreated: {
                serializedName: "properties.timeCreated",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlanAutoGenerated"
                }
            }, supportedCapabilities: {
                serializedName: "properties.supportedCapabilities",
                type: {
                    name: "Composite",
                    className: "SupportedCapabilities"
                }
            }, creationData: {
                serializedName: "properties.creationData",
                type: {
                    name: "Composite",
                    className: "CreationData"
                }
            }, diskSizeGB: {
                serializedName: "properties.diskSizeGB",
                type: {
                    name: "Number"
                }
            }, diskSizeBytes: {
                serializedName: "properties.diskSizeBytes",
                readOnly: true,
                type: {
                    name: "Number"
                }
            }, diskState: {
                serializedName: "properties.diskState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, uniqueId: {
                serializedName: "properties.uniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, encryptionSettingsCollection: {
                serializedName: "properties.encryptionSettingsCollection",
                type: {
                    name: "Composite",
                    className: "EncryptionSettingsCollection"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, incremental: {
                serializedName: "properties.incremental",
                type: {
                    name: "Boolean"
                }
            }, encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            }, networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            }, diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            }, supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            }, publicNetworkAccess: {
                serializedName: "properties.publicNetworkAccess",
                type: {
                    name: "String"
                }
            }, completionPercent: {
                serializedName: "properties.completionPercent",
                type: {
                    name: "Number"
                }
            } })
    }
};
export const DiskEncryptionSet = {
    type: {
        name: "Composite",
        className: "DiskEncryptionSet",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "EncryptionSetIdentity"
                }
            }, encryptionType: {
                serializedName: "properties.encryptionType",
                type: {
                    name: "String"
                }
            }, activeKey: {
                serializedName: "properties.activeKey",
                type: {
                    name: "Composite",
                    className: "KeyForDiskEncryptionSet"
                }
            }, previousKeys: {
                serializedName: "properties.previousKeys",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "KeyForDiskEncryptionSet"
                        }
                    }
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, rotationToLatestKeyVersionEnabled: {
                serializedName: "properties.rotationToLatestKeyVersionEnabled",
                type: {
                    name: "Boolean"
                }
            }, lastKeyRotationTimestamp: {
                serializedName: "properties.lastKeyRotationTimestamp",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, autoKeyRotationError: {
                serializedName: "properties.autoKeyRotationError",
                type: {
                    name: "Composite",
                    className: "ApiError"
                }
            } })
    }
};
export const DiskAccess = {
    type: {
        name: "Composite",
        className: "DiskAccess",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { extendedLocation: {
                serializedName: "extendedLocation",
                type: {
                    name: "Composite",
                    className: "ExtendedLocation"
                }
            }, privateEndpointConnections: {
                serializedName: "properties.privateEndpointConnections",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "PrivateEndpointConnection"
                        }
                    }
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, timeCreated: {
                serializedName: "properties.timeCreated",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            } })
    }
};
export const Gallery = {
    type: {
        name: "Composite",
        className: "Gallery",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryIdentifier"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, sharingProfile: {
                serializedName: "properties.sharingProfile",
                type: {
                    name: "Composite",
                    className: "SharingProfile"
                }
            }, softDeletePolicy: {
                serializedName: "properties.softDeletePolicy",
                type: {
                    name: "Composite",
                    className: "SoftDeletePolicy"
                }
            } })
    }
};
export const GalleryImage = {
    type: {
        name: "Composite",
        className: "GalleryImage",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, osState: {
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: ["Generalized", "Specialized"]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            } })
    }
};
export const GalleryImageVersion = {
    type: {
        name: "Composite",
        className: "GalleryImageVersion",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { publishingProfile: {
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionPublishingProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionStorageProfile"
                }
            }, replicationStatus: {
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export const GalleryApplication = {
    type: {
        name: "Composite",
        className: "GalleryApplication",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, supportedOSType: {
                serializedName: "properties.supportedOSType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            } })
    }
};
export const GalleryApplicationVersion = {
    type: {
        name: "Composite",
        className: "GalleryApplicationVersion",
        modelProperties: Object.assign(Object.assign({}, Resource.type.modelProperties), { publishingProfile: {
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryApplicationVersionPublishingProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, replicationStatus: {
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export const AvailabilitySetUpdate = {
    type: {
        name: "Composite",
        className: "AvailabilitySetUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, platformUpdateDomainCount: {
                serializedName: "properties.platformUpdateDomainCount",
                type: {
                    name: "Number"
                }
            }, platformFaultDomainCount: {
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResource"
                        }
                    }
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, statuses: {
                serializedName: "properties.statuses",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "InstanceViewStatus"
                        }
                    }
                }
            } })
    }
};
export const ProximityPlacementGroupUpdate = {
    type: {
        name: "Composite",
        className: "ProximityPlacementGroupUpdate",
        modelProperties: Object.assign({}, UpdateResource.type.modelProperties)
    }
};
export const DedicatedHostGroupUpdate = {
    type: {
        name: "Composite",
        className: "DedicatedHostGroupUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, platformFaultDomainCount: {
                constraints: {
                    InclusiveMinimum: 1
                },
                serializedName: "properties.platformFaultDomainCount",
                type: {
                    name: "Number"
                }
            }, hosts: {
                serializedName: "properties.hosts",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostGroupInstanceView"
                }
            }, supportAutomaticPlacement: {
                serializedName: "properties.supportAutomaticPlacement",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const DedicatedHostUpdate = {
    type: {
        name: "Composite",
        className: "DedicatedHostUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { platformFaultDomain: {
                constraints: {
                    InclusiveMinimum: 0
                },
                serializedName: "properties.platformFaultDomain",
                type: {
                    name: "Number"
                }
            }, autoReplaceOnFailure: {
                serializedName: "properties.autoReplaceOnFailure",
                type: {
                    name: "Boolean"
                }
            }, hostId: {
                serializedName: "properties.hostId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, virtualMachines: {
                serializedName: "properties.virtualMachines",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "Enum",
                    allowedValues: [
                        "None",
                        "Windows_Server_Hybrid",
                        "Windows_Server_Perpetual"
                    ]
                }
            }, provisioningTime: {
                serializedName: "properties.provisioningTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "DedicatedHostInstanceView"
                }
            } })
    }
};
export const SshPublicKeyUpdateResource = {
    type: {
        name: "Composite",
        className: "SshPublicKeyUpdateResource",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { publicKey: {
                serializedName: "properties.publicKey",
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineExtensionUpdate = {
    type: {
        name: "Composite",
        className: "VirtualMachineExtensionUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, suppressFailures: {
                serializedName: "properties.suppressFailures",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const ImageUpdate = {
    type: {
        name: "Composite",
        className: "ImageUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { sourceVirtualMachine: {
                serializedName: "properties.sourceVirtualMachine",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "ImageStorageProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineUpdate = {
    type: {
        name: "Composite",
        className: "VirtualMachineUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineIdentity"
                }
            }, zones: {
                serializedName: "zones",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, hardwareProfile: {
                serializedName: "properties.hardwareProfile",
                type: {
                    name: "Composite",
                    className: "HardwareProfile"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "StorageProfile"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, osProfile: {
                serializedName: "properties.osProfile",
                type: {
                    name: "Composite",
                    className: "OSProfile"
                }
            }, networkProfile: {
                serializedName: "properties.networkProfile",
                type: {
                    name: "Composite",
                    className: "NetworkProfile"
                }
            }, securityProfile: {
                serializedName: "properties.securityProfile",
                type: {
                    name: "Composite",
                    className: "SecurityProfile"
                }
            }, diagnosticsProfile: {
                serializedName: "properties.diagnosticsProfile",
                type: {
                    name: "Composite",
                    className: "DiagnosticsProfile"
                }
            }, availabilitySet: {
                serializedName: "properties.availabilitySet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, virtualMachineScaleSet: {
                serializedName: "properties.virtualMachineScaleSet",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, priority: {
                serializedName: "properties.priority",
                type: {
                    name: "String"
                }
            }, evictionPolicy: {
                serializedName: "properties.evictionPolicy",
                type: {
                    name: "String"
                }
            }, billingProfile: {
                serializedName: "properties.billingProfile",
                type: {
                    name: "Composite",
                    className: "BillingProfile"
                }
            }, host: {
                serializedName: "properties.host",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, hostGroup: {
                serializedName: "properties.hostGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineInstanceView"
                }
            }, licenseType: {
                serializedName: "properties.licenseType",
                type: {
                    name: "String"
                }
            }, vmId: {
                serializedName: "properties.vmId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, extensionsTimeBudget: {
                serializedName: "properties.extensionsTimeBudget",
                type: {
                    name: "String"
                }
            }, platformFaultDomain: {
                serializedName: "properties.platformFaultDomain",
                type: {
                    name: "Number"
                }
            }, scheduledEventsProfile: {
                serializedName: "properties.scheduledEventsProfile",
                type: {
                    name: "Composite",
                    className: "ScheduledEventsProfile"
                }
            }, userData: {
                serializedName: "properties.userData",
                type: {
                    name: "String"
                }
            }, capacityReservation: {
                serializedName: "properties.capacityReservation",
                type: {
                    name: "Composite",
                    className: "CapacityReservationProfile"
                }
            }, applicationProfile: {
                serializedName: "properties.applicationProfile",
                type: {
                    name: "Composite",
                    className: "ApplicationProfile"
                }
            } })
    }
};
export const RestorePointCollectionUpdate = {
    type: {
        name: "Composite",
        className: "RestorePointCollectionUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "RestorePointCollectionSourceProperties"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, restorePointCollectionId: {
                serializedName: "properties.restorePointCollectionId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, restorePoints: {
                serializedName: "properties.restorePoints",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RestorePoint"
                        }
                    }
                }
            } })
    }
};
export const CapacityReservationGroupUpdate = {
    type: {
        name: "Composite",
        className: "CapacityReservationGroupUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { capacityReservations: {
                serializedName: "properties.capacityReservations",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, virtualMachinesAssociated: {
                serializedName: "properties.virtualMachinesAssociated",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationGroupInstanceView"
                }
            } })
    }
};
export const CapacityReservationUpdate = {
    type: {
        name: "Composite",
        className: "CapacityReservationUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, reservationId: {
                serializedName: "properties.reservationId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, virtualMachinesAssociated: {
                serializedName: "properties.virtualMachinesAssociated",
                readOnly: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "SubResourceReadOnly"
                        }
                    }
                }
            }, provisioningTime: {
                serializedName: "properties.provisioningTime",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "CapacityReservationInstanceView"
                }
            } })
    }
};
export const VirtualMachineScaleSetUpdate = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { sku: {
                serializedName: "sku",
                type: {
                    name: "Composite",
                    className: "Sku"
                }
            }, plan: {
                serializedName: "plan",
                type: {
                    name: "Composite",
                    className: "Plan"
                }
            }, identity: {
                serializedName: "identity",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetIdentity"
                }
            }, upgradePolicy: {
                serializedName: "properties.upgradePolicy",
                type: {
                    name: "Composite",
                    className: "UpgradePolicy"
                }
            }, automaticRepairsPolicy: {
                serializedName: "properties.automaticRepairsPolicy",
                type: {
                    name: "Composite",
                    className: "AutomaticRepairsPolicy"
                }
            }, virtualMachineProfile: {
                serializedName: "properties.virtualMachineProfile",
                type: {
                    name: "Composite",
                    className: "VirtualMachineScaleSetUpdateVMProfile"
                }
            }, overprovision: {
                serializedName: "properties.overprovision",
                type: {
                    name: "Boolean"
                }
            }, doNotRunExtensionsOnOverprovisionedVMs: {
                serializedName: "properties.doNotRunExtensionsOnOverprovisionedVMs",
                type: {
                    name: "Boolean"
                }
            }, singlePlacementGroup: {
                serializedName: "properties.singlePlacementGroup",
                type: {
                    name: "Boolean"
                }
            }, additionalCapabilities: {
                serializedName: "properties.additionalCapabilities",
                type: {
                    name: "Composite",
                    className: "AdditionalCapabilities"
                }
            }, scaleInPolicy: {
                serializedName: "properties.scaleInPolicy",
                type: {
                    name: "Composite",
                    className: "ScaleInPolicy"
                }
            }, proximityPlacementGroup: {
                serializedName: "properties.proximityPlacementGroup",
                type: {
                    name: "Composite",
                    className: "SubResource"
                }
            } })
    }
};
export const VirtualMachineRunCommandUpdate = {
    type: {
        name: "Composite",
        className: "VirtualMachineRunCommandUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResource.type.modelProperties), { source: {
                serializedName: "properties.source",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandScriptSource"
                }
            }, parameters: {
                serializedName: "properties.parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, protectedParameters: {
                serializedName: "properties.protectedParameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandInputParameter"
                        }
                    }
                }
            }, asyncExecution: {
                defaultValue: false,
                serializedName: "properties.asyncExecution",
                type: {
                    name: "Boolean"
                }
            }, runAsUser: {
                serializedName: "properties.runAsUser",
                type: {
                    name: "String"
                }
            }, runAsPassword: {
                serializedName: "properties.runAsPassword",
                type: {
                    name: "String"
                }
            }, timeoutInSeconds: {
                serializedName: "properties.timeoutInSeconds",
                type: {
                    name: "Number"
                }
            }, outputBlobUri: {
                serializedName: "properties.outputBlobUri",
                type: {
                    name: "String"
                }
            }, errorBlobUri: {
                serializedName: "properties.errorBlobUri",
                type: {
                    name: "String"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineRunCommandInstanceView"
                }
            } })
    }
};
export const VirtualMachineScaleSetExtension = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtension",
        modelProperties: Object.assign(Object.assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                serializedName: "name",
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, typePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, provisionAfterExtensions: {
                serializedName: "properties.provisionAfterExtensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, suppressFailures: {
                serializedName: "properties.suppressFailures",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const VirtualMachineScaleSetExtensionUpdate = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetExtensionUpdate",
        modelProperties: Object.assign(Object.assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, typePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, provisionAfterExtensions: {
                serializedName: "properties.provisionAfterExtensions",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, suppressFailures: {
                serializedName: "properties.suppressFailures",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const VirtualMachineScaleSetVMExtension = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtension",
        modelProperties: Object.assign(Object.assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, typePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, instanceView: {
                serializedName: "properties.instanceView",
                type: {
                    name: "Composite",
                    className: "VirtualMachineExtensionInstanceView"
                }
            }, suppressFailures: {
                serializedName: "properties.suppressFailures",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const VirtualMachineScaleSetVMExtensionUpdate = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMExtensionUpdate",
        modelProperties: Object.assign(Object.assign({}, SubResourceReadOnly.type.modelProperties), { name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, type: {
                serializedName: "type",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, forceUpdateTag: {
                serializedName: "properties.forceUpdateTag",
                type: {
                    name: "String"
                }
            }, publisher: {
                serializedName: "properties.publisher",
                type: {
                    name: "String"
                }
            }, typePropertiesType: {
                serializedName: "properties.type",
                type: {
                    name: "String"
                }
            }, typeHandlerVersion: {
                serializedName: "properties.typeHandlerVersion",
                type: {
                    name: "String"
                }
            }, autoUpgradeMinorVersion: {
                serializedName: "properties.autoUpgradeMinorVersion",
                type: {
                    name: "Boolean"
                }
            }, enableAutomaticUpgrade: {
                serializedName: "properties.enableAutomaticUpgrade",
                type: {
                    name: "Boolean"
                }
            }, settings: {
                serializedName: "properties.settings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, protectedSettings: {
                serializedName: "properties.protectedSettings",
                type: {
                    name: "Dictionary",
                    value: { type: { name: "any" } }
                }
            }, suppressFailures: {
                serializedName: "properties.suppressFailures",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const DedicatedHostInstanceViewWithName = {
    type: {
        name: "Composite",
        className: "DedicatedHostInstanceViewWithName",
        modelProperties: Object.assign(Object.assign({}, DedicatedHostInstanceView.type.modelProperties), { name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            } })
    }
};
export const ImageOSDisk = {
    type: {
        name: "Composite",
        className: "ImageOSDisk",
        modelProperties: Object.assign(Object.assign({}, ImageDisk.type.modelProperties), { osType: {
                serializedName: "osType",
                required: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, osState: {
                serializedName: "osState",
                required: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Generalized", "Specialized"]
                }
            } })
    }
};
export const ImageDataDisk = {
    type: {
        name: "Composite",
        className: "ImageDataDisk",
        modelProperties: Object.assign(Object.assign({}, ImageDisk.type.modelProperties), { lun: {
                serializedName: "lun",
                required: true,
                type: {
                    name: "Number"
                }
            } })
    }
};
export const RestorePoint = {
    type: {
        name: "Composite",
        className: "RestorePoint",
        modelProperties: Object.assign(Object.assign({}, ProxyResource.type.modelProperties), { excludeDisks: {
                serializedName: "properties.excludeDisks",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "ApiEntityReference"
                        }
                    }
                }
            }, sourceMetadata: {
                serializedName: "properties.sourceMetadata",
                type: {
                    name: "Composite",
                    className: "RestorePointSourceMetadata"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, consistencyMode: {
                serializedName: "properties.consistencyMode",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, timeCreated: {
                serializedName: "properties.timeCreated",
                type: {
                    name: "DateTime"
                }
            } })
    }
};
export const CapacityReservationInstanceViewWithName = {
    type: {
        name: "Composite",
        className: "CapacityReservationInstanceViewWithName",
        modelProperties: Object.assign(Object.assign({}, CapacityReservationInstanceView.type.modelProperties), { name: {
                serializedName: "name",
                readOnly: true,
                type: {
                    name: "String"
                }
            } })
    }
};
export const VirtualMachineScaleSetVMReimageParameters = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetVMReimageParameters",
        modelProperties: Object.assign({}, VirtualMachineReimageParameters.type.modelProperties)
    }
};
export const RequestRateByIntervalInput = {
    type: {
        name: "Composite",
        className: "RequestRateByIntervalInput",
        modelProperties: Object.assign(Object.assign({}, LogAnalyticsInputBase.type.modelProperties), { intervalLength: {
                serializedName: "intervalLength",
                required: true,
                type: {
                    name: "Enum",
                    allowedValues: ["ThreeMins", "FiveMins", "ThirtyMins", "SixtyMins"]
                }
            } })
    }
};
export const ThrottledRequestsInput = {
    type: {
        name: "Composite",
        className: "ThrottledRequestsInput",
        modelProperties: Object.assign({}, LogAnalyticsInputBase.type.modelProperties)
    }
};
export const RunCommandDocument = {
    type: {
        name: "Composite",
        className: "RunCommandDocument",
        modelProperties: Object.assign(Object.assign({}, RunCommandDocumentBase.type.modelProperties), { script: {
                serializedName: "script",
                required: true,
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }, parameters: {
                serializedName: "parameters",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "RunCommandParameterDefinition"
                        }
                    }
                }
            } })
    }
};
export const DiskRestorePoint = {
    type: {
        name: "Composite",
        className: "DiskRestorePoint",
        modelProperties: Object.assign(Object.assign({}, ProxyOnlyResource.type.modelProperties), { timeCreated: {
                serializedName: "properties.timeCreated",
                readOnly: true,
                type: {
                    name: "DateTime"
                }
            }, sourceResourceId: {
                serializedName: "properties.sourceResourceId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, osType: {
                serializedName: "properties.osType",
                readOnly: true,
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "PurchasePlanAutoGenerated"
                }
            }, supportedCapabilities: {
                serializedName: "properties.supportedCapabilities",
                type: {
                    name: "Composite",
                    className: "SupportedCapabilities"
                }
            }, familyId: {
                serializedName: "properties.familyId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, sourceUniqueId: {
                serializedName: "properties.sourceUniqueId",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, encryption: {
                serializedName: "properties.encryption",
                type: {
                    name: "Composite",
                    className: "Encryption"
                }
            }, supportsHibernation: {
                serializedName: "properties.supportsHibernation",
                type: {
                    name: "Boolean"
                }
            }, networkAccessPolicy: {
                serializedName: "properties.networkAccessPolicy",
                type: {
                    name: "String"
                }
            }, publicNetworkAccess: {
                serializedName: "properties.publicNetworkAccess",
                type: {
                    name: "String"
                }
            }, diskAccessId: {
                serializedName: "properties.diskAccessId",
                type: {
                    name: "String"
                }
            }, completionPercent: {
                serializedName: "properties.completionPercent",
                type: {
                    name: "Number"
                }
            } })
    }
};
export const GalleryUpdate = {
    type: {
        name: "Composite",
        className: "GalleryUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResourceDefinition.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryIdentifier"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, sharingProfile: {
                serializedName: "properties.sharingProfile",
                type: {
                    name: "Composite",
                    className: "SharingProfile"
                }
            }, softDeletePolicy: {
                serializedName: "properties.softDeletePolicy",
                type: {
                    name: "Composite",
                    className: "SoftDeletePolicy"
                }
            } })
    }
};
export const GalleryImageUpdate = {
    type: {
        name: "Composite",
        className: "GalleryImageUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResourceDefinition.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, osState: {
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: ["Generalized", "Specialized"]
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            } })
    }
};
export const GalleryImageVersionUpdate = {
    type: {
        name: "Composite",
        className: "GalleryImageVersionUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResourceDefinition.type.modelProperties), { publishingProfile: {
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionPublishingProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, storageProfile: {
                serializedName: "properties.storageProfile",
                type: {
                    name: "Composite",
                    className: "GalleryImageVersionStorageProfile"
                }
            }, replicationStatus: {
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export const GalleryApplicationUpdate = {
    type: {
        name: "Composite",
        className: "GalleryApplicationUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResourceDefinition.type.modelProperties), { description: {
                serializedName: "properties.description",
                type: {
                    name: "String"
                }
            }, eula: {
                serializedName: "properties.eula",
                type: {
                    name: "String"
                }
            }, privacyStatementUri: {
                serializedName: "properties.privacyStatementUri",
                type: {
                    name: "String"
                }
            }, releaseNoteUri: {
                serializedName: "properties.releaseNoteUri",
                type: {
                    name: "String"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, supportedOSType: {
                serializedName: "properties.supportedOSType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            } })
    }
};
export const GalleryApplicationVersionUpdate = {
    type: {
        name: "Composite",
        className: "GalleryApplicationVersionUpdate",
        modelProperties: Object.assign(Object.assign({}, UpdateResourceDefinition.type.modelProperties), { publishingProfile: {
                serializedName: "properties.publishingProfile",
                type: {
                    name: "Composite",
                    className: "GalleryApplicationVersionPublishingProfile"
                }
            }, provisioningState: {
                serializedName: "properties.provisioningState",
                readOnly: true,
                type: {
                    name: "String"
                }
            }, replicationStatus: {
                serializedName: "properties.replicationStatus",
                type: {
                    name: "Composite",
                    className: "ReplicationStatus"
                }
            } })
    }
};
export const GalleryImageVersionPublishingProfile = {
    type: {
        name: "Composite",
        className: "GalleryImageVersionPublishingProfile",
        modelProperties: Object.assign({}, GalleryArtifactPublishingProfileBase.type.modelProperties)
    }
};
export const GalleryApplicationVersionPublishingProfile = {
    type: {
        name: "Composite",
        className: "GalleryApplicationVersionPublishingProfile",
        modelProperties: Object.assign(Object.assign({}, GalleryArtifactPublishingProfileBase.type.modelProperties), { source: {
                serializedName: "source",
                type: {
                    name: "Composite",
                    className: "UserArtifactSource"
                }
            }, manageActions: {
                serializedName: "manageActions",
                type: {
                    name: "Composite",
                    className: "UserArtifactManage"
                }
            }, enableHealthCheck: {
                serializedName: "enableHealthCheck",
                type: {
                    name: "Boolean"
                }
            } })
    }
};
export const OSDiskImageEncryption = {
    type: {
        name: "Composite",
        className: "OSDiskImageEncryption",
        modelProperties: Object.assign({}, DiskImageEncryption.type.modelProperties)
    }
};
export const DataDiskImageEncryption = {
    type: {
        name: "Composite",
        className: "DataDiskImageEncryption",
        modelProperties: Object.assign(Object.assign({}, DiskImageEncryption.type.modelProperties), { lun: {
                serializedName: "lun",
                required: true,
                type: {
                    name: "Number"
                }
            } })
    }
};
export const GalleryOSDiskImage = {
    type: {
        name: "Composite",
        className: "GalleryOSDiskImage",
        modelProperties: Object.assign({}, GalleryDiskImage.type.modelProperties)
    }
};
export const GalleryDataDiskImage = {
    type: {
        name: "Composite",
        className: "GalleryDataDiskImage",
        modelProperties: Object.assign(Object.assign({}, GalleryDiskImage.type.modelProperties), { lun: {
                serializedName: "lun",
                required: true,
                type: {
                    name: "Number"
                }
            } })
    }
};
export const PirSharedGalleryResource = {
    type: {
        name: "Composite",
        className: "PirSharedGalleryResource",
        modelProperties: Object.assign(Object.assign({}, PirResource.type.modelProperties), { uniqueId: {
                serializedName: "identifier.uniqueId",
                type: {
                    name: "String"
                }
            } })
    }
};
export const CommunityGallery = {
    type: {
        name: "Composite",
        className: "CommunityGallery",
        modelProperties: Object.assign({}, PirCommunityGalleryResource.type.modelProperties)
    }
};
export const CommunityGalleryImage = {
    type: {
        name: "Composite",
        className: "CommunityGalleryImage",
        modelProperties: Object.assign(Object.assign({}, PirCommunityGalleryResource.type.modelProperties), { osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, osState: {
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: ["Generalized", "Specialized"]
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            } })
    }
};
export const CommunityGalleryImageVersion = {
    type: {
        name: "Composite",
        className: "CommunityGalleryImageVersion",
        modelProperties: Object.assign(Object.assign({}, PirCommunityGalleryResource.type.modelProperties), { publishedDate: {
                serializedName: "properties.publishedDate",
                type: {
                    name: "DateTime"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            } })
    }
};
export const VirtualMachineImage = {
    type: {
        name: "Composite",
        className: "VirtualMachineImage",
        modelProperties: Object.assign(Object.assign({}, VirtualMachineImageResource.type.modelProperties), { plan: {
                serializedName: "properties.plan",
                type: {
                    name: "Composite",
                    className: "PurchasePlan"
                }
            }, osDiskImage: {
                serializedName: "properties.osDiskImage",
                type: {
                    name: "Composite",
                    className: "OSDiskImage"
                }
            }, dataDiskImages: {
                serializedName: "properties.dataDiskImages",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "DataDiskImage"
                        }
                    }
                }
            }, automaticOSUpgradeProperties: {
                serializedName: "properties.automaticOSUpgradeProperties",
                type: {
                    name: "Composite",
                    className: "AutomaticOSUpgradeProperties"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "DisallowedConfiguration"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineImageFeature"
                        }
                    }
                }
            } })
    }
};
export const VirtualMachineScaleSetReimageParameters = {
    type: {
        name: "Composite",
        className: "VirtualMachineScaleSetReimageParameters",
        modelProperties: Object.assign(Object.assign({}, VirtualMachineScaleSetVMReimageParameters.type.modelProperties), { instanceIds: {
                serializedName: "instanceIds",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            } })
    }
};
export const SharedGallery = {
    type: {
        name: "Composite",
        className: "SharedGallery",
        modelProperties: Object.assign({}, PirSharedGalleryResource.type.modelProperties)
    }
};
export const SharedGalleryImage = {
    type: {
        name: "Composite",
        className: "SharedGalleryImage",
        modelProperties: Object.assign(Object.assign({}, PirSharedGalleryResource.type.modelProperties), { osType: {
                serializedName: "properties.osType",
                type: {
                    name: "Enum",
                    allowedValues: ["Windows", "Linux"]
                }
            }, osState: {
                serializedName: "properties.osState",
                type: {
                    name: "Enum",
                    allowedValues: ["Generalized", "Specialized"]
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            }, identifier: {
                serializedName: "properties.identifier",
                type: {
                    name: "Composite",
                    className: "GalleryImageIdentifier"
                }
            }, recommended: {
                serializedName: "properties.recommended",
                type: {
                    name: "Composite",
                    className: "RecommendedMachineConfiguration"
                }
            }, disallowed: {
                serializedName: "properties.disallowed",
                type: {
                    name: "Composite",
                    className: "Disallowed"
                }
            }, hyperVGeneration: {
                serializedName: "properties.hyperVGeneration",
                type: {
                    name: "String"
                }
            }, features: {
                serializedName: "properties.features",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "GalleryImageFeature"
                        }
                    }
                }
            }, purchasePlan: {
                serializedName: "properties.purchasePlan",
                type: {
                    name: "Composite",
                    className: "ImagePurchasePlan"
                }
            } })
    }
};
export const SharedGalleryImageVersion = {
    type: {
        name: "Composite",
        className: "SharedGalleryImageVersion",
        modelProperties: Object.assign(Object.assign({}, PirSharedGalleryResource.type.modelProperties), { publishedDate: {
                serializedName: "properties.publishedDate",
                type: {
                    name: "DateTime"
                }
            }, endOfLifeDate: {
                serializedName: "properties.endOfLifeDate",
                type: {
                    name: "DateTime"
                }
            } })
    }
};
//# sourceMappingURL=mappers.js.map