## API Report File for "@azure/arm-network"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import * as coreAuth from '@azure/core-auth';
import * as coreClient from '@azure/core-client';
import { PagedAsyncIterableIterator } from '@azure/core-paging';
import { PollerLike } from '@azure/core-lro';
import { PollOperationState } from '@azure/core-lro';

// @public
export interface AadAuthenticationParameters {
    aadAudience?: string;
    aadIssuer?: string;
    aadTenant?: string;
}

// @public
export type Access = string;

// @public
export interface AddressSpace {
    addressPrefixes?: string[];
}

// @public
export type ApplicationGateway = Resource & {
    readonly etag?: string;
    zones?: string[];
    identity?: ManagedServiceIdentity;
    sku?: ApplicationGatewaySku;
    sslPolicy?: ApplicationGatewaySslPolicy;
    readonly operationalState?: ApplicationGatewayOperationalState;
    gatewayIPConfigurations?: ApplicationGatewayIPConfiguration[];
    authenticationCertificates?: ApplicationGatewayAuthenticationCertificate[];
    trustedRootCertificates?: ApplicationGatewayTrustedRootCertificate[];
    trustedClientCertificates?: ApplicationGatewayTrustedClientCertificate[];
    sslCertificates?: ApplicationGatewaySslCertificate[];
    frontendIPConfigurations?: ApplicationGatewayFrontendIPConfiguration[];
    frontendPorts?: ApplicationGatewayFrontendPort[];
    probes?: ApplicationGatewayProbe[];
    backendAddressPools?: ApplicationGatewayBackendAddressPool[];
    backendHttpSettingsCollection?: ApplicationGatewayBackendHttpSettings[];
    httpListeners?: ApplicationGatewayHttpListener[];
    sslProfiles?: ApplicationGatewaySslProfile[];
    urlPathMaps?: ApplicationGatewayUrlPathMap[];
    requestRoutingRules?: ApplicationGatewayRequestRoutingRule[];
    rewriteRuleSets?: ApplicationGatewayRewriteRuleSet[];
    redirectConfigurations?: ApplicationGatewayRedirectConfiguration[];
    webApplicationFirewallConfiguration?: ApplicationGatewayWebApplicationFirewallConfiguration;
    firewallPolicy?: SubResource;
    enableHttp2?: boolean;
    enableFips?: boolean;
    autoscaleConfiguration?: ApplicationGatewayAutoscaleConfiguration;
    privateLinkConfigurations?: ApplicationGatewayPrivateLinkConfiguration[];
    readonly privateEndpointConnections?: ApplicationGatewayPrivateEndpointConnection[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    customErrorConfigurations?: ApplicationGatewayCustomError[];
    forceFirewallPolicyAssociation?: boolean;
    loadDistributionPolicies?: ApplicationGatewayLoadDistributionPolicy[];
    globalConfiguration?: ApplicationGatewayGlobalConfiguration;
};

// @public
export type ApplicationGatewayAuthenticationCertificate = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    data?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayAutoscaleConfiguration {
    maxCapacity?: number;
    minCapacity: number;
}

// @public
export type ApplicationGatewayAvailableSslOptions = Resource & {
    predefinedPolicies?: SubResource[];
    defaultPolicy?: ApplicationGatewaySslPolicyName;
    availableCipherSuites?: ApplicationGatewaySslCipherSuite[];
    availableProtocols?: ApplicationGatewaySslProtocol[];
};

// @public
export interface ApplicationGatewayAvailableSslPredefinedPolicies {
    nextLink?: string;
    value?: ApplicationGatewaySslPredefinedPolicy[];
}

// @public
export interface ApplicationGatewayAvailableWafRuleSetsResult {
    value?: ApplicationGatewayFirewallRuleSet[];
}

// @public
export interface ApplicationGatewayBackendAddress {
    fqdn?: string;
    ipAddress?: string;
}

// @public
export type ApplicationGatewayBackendAddressPool = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly backendIPConfigurations?: NetworkInterfaceIPConfiguration[];
    backendAddresses?: ApplicationGatewayBackendAddress[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayBackendHealth {
    backendAddressPools?: ApplicationGatewayBackendHealthPool[];
}

// @public
export interface ApplicationGatewayBackendHealthHttpSettings {
    backendHttpSettings?: ApplicationGatewayBackendHttpSettings;
    servers?: ApplicationGatewayBackendHealthServer[];
}

// @public
export interface ApplicationGatewayBackendHealthOnDemand {
    backendAddressPool?: ApplicationGatewayBackendAddressPool;
    backendHealthHttpSettings?: ApplicationGatewayBackendHealthHttpSettings;
}

// @public
export interface ApplicationGatewayBackendHealthPool {
    backendAddressPool?: ApplicationGatewayBackendAddressPool;
    backendHttpSettingsCollection?: ApplicationGatewayBackendHealthHttpSettings[];
}

// @public
export interface ApplicationGatewayBackendHealthServer {
    address?: string;
    health?: ApplicationGatewayBackendHealthServerHealth;
    healthProbeLog?: string;
    ipConfiguration?: NetworkInterfaceIPConfiguration;
}

// @public
export type ApplicationGatewayBackendHealthServerHealth = string;

// @public
export type ApplicationGatewayBackendHttpSettings = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    port?: number;
    protocol?: ApplicationGatewayProtocol;
    cookieBasedAffinity?: ApplicationGatewayCookieBasedAffinity;
    requestTimeout?: number;
    probe?: SubResource;
    authenticationCertificates?: SubResource[];
    trustedRootCertificates?: SubResource[];
    connectionDraining?: ApplicationGatewayConnectionDraining;
    hostName?: string;
    pickHostNameFromBackendAddress?: boolean;
    affinityCookieName?: string;
    probeEnabled?: boolean;
    path?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayClientAuthConfiguration {
    verifyClientCertIssuerDN?: boolean;
}

// @public
export interface ApplicationGatewayConnectionDraining {
    drainTimeoutInSec: number;
    enabled: boolean;
}

// @public
export type ApplicationGatewayCookieBasedAffinity = string;

// @public
export interface ApplicationGatewayCustomError {
    customErrorPageUrl?: string;
    statusCode?: ApplicationGatewayCustomErrorStatusCode;
}

// @public
export type ApplicationGatewayCustomErrorStatusCode = string;

// @public
export interface ApplicationGatewayFirewallDisabledRuleGroup {
    ruleGroupName: string;
    rules?: number[];
}

// @public
export interface ApplicationGatewayFirewallExclusion {
    matchVariable: string;
    selector: string;
    selectorMatchOperator: string;
}

// @public
export type ApplicationGatewayFirewallMode = string;

// @public
export interface ApplicationGatewayFirewallRule {
    description?: string;
    ruleId: number;
}

// @public
export interface ApplicationGatewayFirewallRuleGroup {
    description?: string;
    ruleGroupName: string;
    rules: ApplicationGatewayFirewallRule[];
}

// @public
export type ApplicationGatewayFirewallRuleSet = Resource & {
    readonly provisioningState?: ProvisioningState;
    ruleSetType?: string;
    ruleSetVersion?: string;
    ruleGroups?: ApplicationGatewayFirewallRuleGroup[];
};

// @public
export type ApplicationGatewayFrontendIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    subnet?: SubResource;
    publicIPAddress?: SubResource;
    privateLinkConfiguration?: SubResource;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewayFrontendPort = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    port?: number;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayGlobalConfiguration {
    enableRequestBuffering?: boolean;
    enableResponseBuffering?: boolean;
}

// @public
export interface ApplicationGatewayHeaderConfiguration {
    headerName?: string;
    headerValue?: string;
}

// @public
export type ApplicationGatewayHttpListener = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    frontendIPConfiguration?: SubResource;
    frontendPort?: SubResource;
    protocol?: ApplicationGatewayProtocol;
    hostName?: string;
    sslCertificate?: SubResource;
    sslProfile?: SubResource;
    requireServerNameIndication?: boolean;
    readonly provisioningState?: ProvisioningState;
    customErrorConfigurations?: ApplicationGatewayCustomError[];
    firewallPolicy?: SubResource;
    hostNames?: string[];
};

// @public
export type ApplicationGatewayIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    subnet?: SubResource;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayListResult {
    nextLink?: string;
    value?: ApplicationGateway[];
}

// @public
export type ApplicationGatewayLoadDistributionAlgorithm = string;

// @public
export type ApplicationGatewayLoadDistributionPolicy = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    loadDistributionTargets?: ApplicationGatewayLoadDistributionTarget[];
    loadDistributionAlgorithm?: ApplicationGatewayLoadDistributionAlgorithm;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewayLoadDistributionTarget = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    weightPerServer?: number;
    backendAddressPool?: SubResource;
};

// @public
export interface ApplicationGatewayOnDemandProbe {
    backendAddressPool?: SubResource;
    backendHttpSettings?: SubResource;
    host?: string;
    match?: ApplicationGatewayProbeHealthResponseMatch;
    path?: string;
    pickHostNameFromBackendHttpSettings?: boolean;
    protocol?: ApplicationGatewayProtocol;
    timeout?: number;
}

// @public
export type ApplicationGatewayOperationalState = string;

// @public
export type ApplicationGatewayPathRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    paths?: string[];
    backendAddressPool?: SubResource;
    backendHttpSettings?: SubResource;
    redirectConfiguration?: SubResource;
    rewriteRuleSet?: SubResource;
    loadDistributionPolicy?: SubResource;
    readonly provisioningState?: ProvisioningState;
    firewallPolicy?: SubResource;
};

// @public
export type ApplicationGatewayPrivateEndpointConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly privateEndpoint?: PrivateEndpoint;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
    readonly provisioningState?: ProvisioningState;
    readonly linkIdentifier?: string;
};

// @public
export interface ApplicationGatewayPrivateEndpointConnectionListResult {
    nextLink?: string;
    value?: ApplicationGatewayPrivateEndpointConnection[];
}

// @public
export interface ApplicationGatewayPrivateEndpointConnections {
    beginDelete(resourceGroupName: string, applicationGatewayName: string, connectionName: string, options?: ApplicationGatewayPrivateEndpointConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, applicationGatewayName: string, connectionName: string, options?: ApplicationGatewayPrivateEndpointConnectionsDeleteOptionalParams): Promise<void>;
    beginUpdate(resourceGroupName: string, applicationGatewayName: string, connectionName: string, parameters: ApplicationGatewayPrivateEndpointConnection, options?: ApplicationGatewayPrivateEndpointConnectionsUpdateOptionalParams): Promise<PollerLike<PollOperationState<ApplicationGatewayPrivateEndpointConnectionsUpdateResponse>, ApplicationGatewayPrivateEndpointConnectionsUpdateResponse>>;
    beginUpdateAndWait(resourceGroupName: string, applicationGatewayName: string, connectionName: string, parameters: ApplicationGatewayPrivateEndpointConnection, options?: ApplicationGatewayPrivateEndpointConnectionsUpdateOptionalParams): Promise<ApplicationGatewayPrivateEndpointConnectionsUpdateResponse>;
    get(resourceGroupName: string, applicationGatewayName: string, connectionName: string, options?: ApplicationGatewayPrivateEndpointConnectionsGetOptionalParams): Promise<ApplicationGatewayPrivateEndpointConnectionsGetResponse>;
    list(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewayPrivateEndpointConnectionsListOptionalParams): PagedAsyncIterableIterator<ApplicationGatewayPrivateEndpointConnection>;
}

// @public
export interface ApplicationGatewayPrivateEndpointConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ApplicationGatewayPrivateEndpointConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewayPrivateEndpointConnectionsGetResponse = ApplicationGatewayPrivateEndpointConnection;

// @public
export interface ApplicationGatewayPrivateEndpointConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewayPrivateEndpointConnectionsListNextResponse = ApplicationGatewayPrivateEndpointConnectionListResult;

// @public
export interface ApplicationGatewayPrivateEndpointConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewayPrivateEndpointConnectionsListResponse = ApplicationGatewayPrivateEndpointConnectionListResult;

// @public
export interface ApplicationGatewayPrivateEndpointConnectionsUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ApplicationGatewayPrivateEndpointConnectionsUpdateResponse = ApplicationGatewayPrivateEndpointConnection;

// @public
export type ApplicationGatewayPrivateLinkConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    ipConfigurations?: ApplicationGatewayPrivateLinkIpConfiguration[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewayPrivateLinkIpConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    subnet?: SubResource;
    primary?: boolean;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewayPrivateLinkResource = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly groupId?: string;
    readonly requiredMembers?: string[];
    requiredZoneNames?: string[];
};

// @public
export interface ApplicationGatewayPrivateLinkResourceListResult {
    nextLink?: string;
    value?: ApplicationGatewayPrivateLinkResource[];
}

// @public
export interface ApplicationGatewayPrivateLinkResources {
    list(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewayPrivateLinkResourcesListOptionalParams): PagedAsyncIterableIterator<ApplicationGatewayPrivateLinkResource>;
}

// @public
export interface ApplicationGatewayPrivateLinkResourcesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewayPrivateLinkResourcesListNextResponse = ApplicationGatewayPrivateLinkResourceListResult;

// @public
export interface ApplicationGatewayPrivateLinkResourcesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewayPrivateLinkResourcesListResponse = ApplicationGatewayPrivateLinkResourceListResult;

// @public
export type ApplicationGatewayProbe = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    protocol?: ApplicationGatewayProtocol;
    host?: string;
    path?: string;
    interval?: number;
    timeout?: number;
    unhealthyThreshold?: number;
    pickHostNameFromBackendHttpSettings?: boolean;
    minServers?: number;
    match?: ApplicationGatewayProbeHealthResponseMatch;
    readonly provisioningState?: ProvisioningState;
    port?: number;
};

// @public
export interface ApplicationGatewayProbeHealthResponseMatch {
    body?: string;
    statusCodes?: string[];
}

// @public
export type ApplicationGatewayProtocol = string;

// @public
export type ApplicationGatewayRedirectConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    redirectType?: ApplicationGatewayRedirectType;
    targetListener?: SubResource;
    targetUrl?: string;
    includePath?: boolean;
    includeQueryString?: boolean;
    requestRoutingRules?: SubResource[];
    urlPathMaps?: SubResource[];
    pathRules?: SubResource[];
};

// @public
export type ApplicationGatewayRedirectType = string;

// @public
export type ApplicationGatewayRequestRoutingRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    ruleType?: ApplicationGatewayRequestRoutingRuleType;
    priority?: number;
    backendAddressPool?: SubResource;
    backendHttpSettings?: SubResource;
    httpListener?: SubResource;
    urlPathMap?: SubResource;
    rewriteRuleSet?: SubResource;
    redirectConfiguration?: SubResource;
    loadDistributionPolicy?: SubResource;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewayRequestRoutingRuleType = string;

// @public
export interface ApplicationGatewayRewriteRule {
    actionSet?: ApplicationGatewayRewriteRuleActionSet;
    conditions?: ApplicationGatewayRewriteRuleCondition[];
    name?: string;
    ruleSequence?: number;
}

// @public
export interface ApplicationGatewayRewriteRuleActionSet {
    requestHeaderConfigurations?: ApplicationGatewayHeaderConfiguration[];
    responseHeaderConfigurations?: ApplicationGatewayHeaderConfiguration[];
    urlConfiguration?: ApplicationGatewayUrlConfiguration;
}

// @public
export interface ApplicationGatewayRewriteRuleCondition {
    ignoreCase?: boolean;
    negate?: boolean;
    pattern?: string;
    variable?: string;
}

// @public
export type ApplicationGatewayRewriteRuleSet = SubResource & {
    name?: string;
    readonly etag?: string;
    rewriteRules?: ApplicationGatewayRewriteRule[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGateways {
    beginBackendHealth(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysBackendHealthOptionalParams): Promise<PollerLike<PollOperationState<ApplicationGatewaysBackendHealthResponse>, ApplicationGatewaysBackendHealthResponse>>;
    beginBackendHealthAndWait(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysBackendHealthOptionalParams): Promise<ApplicationGatewaysBackendHealthResponse>;
    beginBackendHealthOnDemand(resourceGroupName: string, applicationGatewayName: string, probeRequest: ApplicationGatewayOnDemandProbe, options?: ApplicationGatewaysBackendHealthOnDemandOptionalParams): Promise<PollerLike<PollOperationState<ApplicationGatewaysBackendHealthOnDemandResponse>, ApplicationGatewaysBackendHealthOnDemandResponse>>;
    beginBackendHealthOnDemandAndWait(resourceGroupName: string, applicationGatewayName: string, probeRequest: ApplicationGatewayOnDemandProbe, options?: ApplicationGatewaysBackendHealthOnDemandOptionalParams): Promise<ApplicationGatewaysBackendHealthOnDemandResponse>;
    beginCreateOrUpdate(resourceGroupName: string, applicationGatewayName: string, parameters: ApplicationGateway, options?: ApplicationGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ApplicationGatewaysCreateOrUpdateResponse>, ApplicationGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, applicationGatewayName: string, parameters: ApplicationGateway, options?: ApplicationGatewaysCreateOrUpdateOptionalParams): Promise<ApplicationGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysDeleteOptionalParams): Promise<void>;
    beginStart(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysStartOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginStartAndWait(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysStartOptionalParams): Promise<void>;
    beginStop(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysStopOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginStopAndWait(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysStopOptionalParams): Promise<void>;
    get(resourceGroupName: string, applicationGatewayName: string, options?: ApplicationGatewaysGetOptionalParams): Promise<ApplicationGatewaysGetResponse>;
    getSslPredefinedPolicy(predefinedPolicyName: string, options?: ApplicationGatewaysGetSslPredefinedPolicyOptionalParams): Promise<ApplicationGatewaysGetSslPredefinedPolicyResponse>;
    list(resourceGroupName: string, options?: ApplicationGatewaysListOptionalParams): PagedAsyncIterableIterator<ApplicationGateway>;
    listAll(options?: ApplicationGatewaysListAllOptionalParams): PagedAsyncIterableIterator<ApplicationGateway>;
    listAvailableRequestHeaders(options?: ApplicationGatewaysListAvailableRequestHeadersOptionalParams): Promise<ApplicationGatewaysListAvailableRequestHeadersResponse>;
    listAvailableResponseHeaders(options?: ApplicationGatewaysListAvailableResponseHeadersOptionalParams): Promise<ApplicationGatewaysListAvailableResponseHeadersResponse>;
    listAvailableServerVariables(options?: ApplicationGatewaysListAvailableServerVariablesOptionalParams): Promise<ApplicationGatewaysListAvailableServerVariablesResponse>;
    listAvailableSslOptions(options?: ApplicationGatewaysListAvailableSslOptionsOptionalParams): Promise<ApplicationGatewaysListAvailableSslOptionsResponse>;
    listAvailableSslPredefinedPolicies(options?: ApplicationGatewaysListAvailableSslPredefinedPoliciesOptionalParams): PagedAsyncIterableIterator<ApplicationGatewaySslPredefinedPolicy>;
    listAvailableWafRuleSets(options?: ApplicationGatewaysListAvailableWafRuleSetsOptionalParams): Promise<ApplicationGatewaysListAvailableWafRuleSetsResponse>;
    updateTags(resourceGroupName: string, applicationGatewayName: string, parameters: TagsObject, options?: ApplicationGatewaysUpdateTagsOptionalParams): Promise<ApplicationGatewaysUpdateTagsResponse>;
}

// @public
export interface ApplicationGatewaysBackendHealthOnDemandOptionalParams extends coreClient.OperationOptions {
    expand?: string;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ApplicationGatewaysBackendHealthOnDemandResponse = ApplicationGatewayBackendHealthOnDemand;

// @public
export interface ApplicationGatewaysBackendHealthOptionalParams extends coreClient.OperationOptions {
    expand?: string;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ApplicationGatewaysBackendHealthResponse = ApplicationGatewayBackendHealth;

// @public
export interface ApplicationGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ApplicationGatewaysCreateOrUpdateResponse = ApplicationGateway;

// @public
export interface ApplicationGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ApplicationGatewaysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysGetResponse = ApplicationGateway;

// @public
export interface ApplicationGatewaysGetSslPredefinedPolicyOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysGetSslPredefinedPolicyResponse = ApplicationGatewaySslPredefinedPolicy;

// @public
export interface ApplicationGatewaySku {
    capacity?: number;
    name?: ApplicationGatewaySkuName;
    tier?: ApplicationGatewayTier;
}

// @public
export type ApplicationGatewaySkuName = string;

// @public
export interface ApplicationGatewaysListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAllNextResponse = ApplicationGatewayListResult;

// @public
export interface ApplicationGatewaysListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAllResponse = ApplicationGatewayListResult;

// @public
export interface ApplicationGatewaysListAvailableRequestHeadersOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableRequestHeadersResponse = {
    body: string[];
};

// @public
export interface ApplicationGatewaysListAvailableResponseHeadersOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableResponseHeadersResponse = {
    body: string[];
};

// @public
export interface ApplicationGatewaysListAvailableServerVariablesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableServerVariablesResponse = {
    body: string[];
};

// @public
export interface ApplicationGatewaysListAvailableSslOptionsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableSslOptionsResponse = ApplicationGatewayAvailableSslOptions;

// @public
export interface ApplicationGatewaysListAvailableSslPredefinedPoliciesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableSslPredefinedPoliciesNextResponse = ApplicationGatewayAvailableSslPredefinedPolicies;

// @public
export interface ApplicationGatewaysListAvailableSslPredefinedPoliciesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableSslPredefinedPoliciesResponse = ApplicationGatewayAvailableSslPredefinedPolicies;

// @public
export interface ApplicationGatewaysListAvailableWafRuleSetsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListAvailableWafRuleSetsResponse = ApplicationGatewayAvailableWafRuleSetsResult;

// @public
export interface ApplicationGatewaysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListNextResponse = ApplicationGatewayListResult;

// @public
export interface ApplicationGatewaysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysListResponse = ApplicationGatewayListResult;

// @public
export type ApplicationGatewaySslCertificate = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    data?: string;
    password?: string;
    readonly publicCertData?: string;
    keyVaultSecretId?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewaySslCipherSuite = string;

// @public
export interface ApplicationGatewaySslPolicy {
    cipherSuites?: ApplicationGatewaySslCipherSuite[];
    disabledSslProtocols?: ApplicationGatewaySslProtocol[];
    minProtocolVersion?: ApplicationGatewaySslProtocol;
    policyName?: ApplicationGatewaySslPolicyName;
    policyType?: ApplicationGatewaySslPolicyType;
}

// @public
export type ApplicationGatewaySslPolicyName = string;

// @public
export type ApplicationGatewaySslPolicyType = string;

// @public
export type ApplicationGatewaySslPredefinedPolicy = SubResource & {
    name?: string;
    cipherSuites?: ApplicationGatewaySslCipherSuite[];
    minProtocolVersion?: ApplicationGatewaySslProtocol;
};

// @public
export type ApplicationGatewaySslProfile = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    trustedClientCertificates?: SubResource[];
    sslPolicy?: ApplicationGatewaySslPolicy;
    clientAuthConfiguration?: ApplicationGatewayClientAuthConfiguration;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewaySslProtocol = string;

// @public
export interface ApplicationGatewaysStartOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ApplicationGatewaysStopOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ApplicationGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationGatewaysUpdateTagsResponse = ApplicationGateway;

// @public
export type ApplicationGatewayTier = string;

// @public
export type ApplicationGatewayTrustedClientCertificate = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    data?: string;
    readonly validatedCertData?: string;
    readonly clientCertIssuerDN?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ApplicationGatewayTrustedRootCertificate = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    data?: string;
    keyVaultSecretId?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayUrlConfiguration {
    modifiedPath?: string;
    modifiedQueryString?: string;
    reroute?: boolean;
}

// @public
export type ApplicationGatewayUrlPathMap = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    defaultBackendAddressPool?: SubResource;
    defaultBackendHttpSettings?: SubResource;
    defaultRewriteRuleSet?: SubResource;
    defaultRedirectConfiguration?: SubResource;
    defaultLoadDistributionPolicy?: SubResource;
    pathRules?: ApplicationGatewayPathRule[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationGatewayWebApplicationFirewallConfiguration {
    disabledRuleGroups?: ApplicationGatewayFirewallDisabledRuleGroup[];
    enabled: boolean;
    exclusions?: ApplicationGatewayFirewallExclusion[];
    fileUploadLimitInMb?: number;
    firewallMode: ApplicationGatewayFirewallMode;
    maxRequestBodySize?: number;
    maxRequestBodySizeInKb?: number;
    requestBodyCheck?: boolean;
    ruleSetType: string;
    ruleSetVersion: string;
}

// @public
export type ApplicationRule = FirewallPolicyRule & {
    ruleType: "ApplicationRule";
    sourceAddresses?: string[];
    destinationAddresses?: string[];
    protocols?: FirewallPolicyRuleApplicationProtocol[];
    targetFqdns?: string[];
    targetUrls?: string[];
    fqdnTags?: string[];
    sourceIpGroups?: string[];
    terminateTLS?: boolean;
    webCategories?: string[];
};

// @public
export type ApplicationSecurityGroup = Resource & {
    readonly etag?: string;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ApplicationSecurityGroupListResult {
    readonly nextLink?: string;
    value?: ApplicationSecurityGroup[];
}

// @public
export interface ApplicationSecurityGroups {
    beginCreateOrUpdate(resourceGroupName: string, applicationSecurityGroupName: string, parameters: ApplicationSecurityGroup, options?: ApplicationSecurityGroupsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ApplicationSecurityGroupsCreateOrUpdateResponse>, ApplicationSecurityGroupsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, applicationSecurityGroupName: string, parameters: ApplicationSecurityGroup, options?: ApplicationSecurityGroupsCreateOrUpdateOptionalParams): Promise<ApplicationSecurityGroupsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, applicationSecurityGroupName: string, options?: ApplicationSecurityGroupsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, applicationSecurityGroupName: string, options?: ApplicationSecurityGroupsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, applicationSecurityGroupName: string, options?: ApplicationSecurityGroupsGetOptionalParams): Promise<ApplicationSecurityGroupsGetResponse>;
    list(resourceGroupName: string, options?: ApplicationSecurityGroupsListOptionalParams): PagedAsyncIterableIterator<ApplicationSecurityGroup>;
    listAll(options?: ApplicationSecurityGroupsListAllOptionalParams): PagedAsyncIterableIterator<ApplicationSecurityGroup>;
    updateTags(resourceGroupName: string, applicationSecurityGroupName: string, parameters: TagsObject, options?: ApplicationSecurityGroupsUpdateTagsOptionalParams): Promise<ApplicationSecurityGroupsUpdateTagsResponse>;
}

// @public
export interface ApplicationSecurityGroupsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ApplicationSecurityGroupsCreateOrUpdateResponse = ApplicationSecurityGroup;

// @public
export interface ApplicationSecurityGroupsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ApplicationSecurityGroupsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationSecurityGroupsGetResponse = ApplicationSecurityGroup;

// @public
export interface ApplicationSecurityGroupsListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationSecurityGroupsListAllNextResponse = ApplicationSecurityGroupListResult;

// @public
export interface ApplicationSecurityGroupsListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationSecurityGroupsListAllResponse = ApplicationSecurityGroupListResult;

// @public
export interface ApplicationSecurityGroupsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationSecurityGroupsListNextResponse = ApplicationSecurityGroupListResult;

// @public
export interface ApplicationSecurityGroupsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationSecurityGroupsListResponse = ApplicationSecurityGroupListResult;

// @public
export interface ApplicationSecurityGroupsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ApplicationSecurityGroupsUpdateTagsResponse = ApplicationSecurityGroup;

// @public
export type AssociationType = string;

// @public
export type AuthenticationMethod = string;

// @public
export interface AuthorizationListResult {
    nextLink?: string;
    value?: ExpressRouteCircuitAuthorization[];
}

// @public
export type AuthorizationUseStatus = string;

// @public
export interface AutoApprovedPrivateLinkService {
    privateLinkService?: string;
}

// @public
export interface AutoApprovedPrivateLinkServicesResult {
    readonly nextLink?: string;
    value?: AutoApprovedPrivateLinkService[];
}

// @public
export interface Availability {
    blobDuration?: string;
    retention?: string;
    timeGrain?: string;
}

// @public
export interface AvailableDelegation {
    actions?: string[];
    id?: string;
    name?: string;
    serviceName?: string;
    type?: string;
}

// @public
export interface AvailableDelegations {
    list(location: string, options?: AvailableDelegationsListOptionalParams): PagedAsyncIterableIterator<AvailableDelegation>;
}

// @public
export interface AvailableDelegationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableDelegationsListNextResponse = AvailableDelegationsResult;

// @public
export interface AvailableDelegationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableDelegationsListResponse = AvailableDelegationsResult;

// @public
export interface AvailableDelegationsResult {
    readonly nextLink?: string;
    value?: AvailableDelegation[];
}

// @public
export interface AvailableEndpointServices {
    list(location: string, options?: AvailableEndpointServicesListOptionalParams): PagedAsyncIterableIterator<EndpointServiceResult>;
}

// @public
export interface AvailableEndpointServicesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableEndpointServicesListNextResponse = EndpointServicesListResult;

// @public
export interface AvailableEndpointServicesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableEndpointServicesListResponse = EndpointServicesListResult;

// @public
export interface AvailablePrivateEndpointType {
    displayName?: string;
    id?: string;
    name?: string;
    resourceName?: string;
    type?: string;
}

// @public
export interface AvailablePrivateEndpointTypes {
    list(location: string, options?: AvailablePrivateEndpointTypesListOptionalParams): PagedAsyncIterableIterator<AvailablePrivateEndpointType>;
    listByResourceGroup(location: string, resourceGroupName: string, options?: AvailablePrivateEndpointTypesListByResourceGroupOptionalParams): PagedAsyncIterableIterator<AvailablePrivateEndpointType>;
}

// @public
export interface AvailablePrivateEndpointTypesListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailablePrivateEndpointTypesListByResourceGroupNextResponse = AvailablePrivateEndpointTypesResult;

// @public
export interface AvailablePrivateEndpointTypesListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailablePrivateEndpointTypesListByResourceGroupResponse = AvailablePrivateEndpointTypesResult;

// @public
export interface AvailablePrivateEndpointTypesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailablePrivateEndpointTypesListNextResponse = AvailablePrivateEndpointTypesResult;

// @public
export interface AvailablePrivateEndpointTypesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailablePrivateEndpointTypesListResponse = AvailablePrivateEndpointTypesResult;

// @public
export interface AvailablePrivateEndpointTypesResult {
    readonly nextLink?: string;
    value?: AvailablePrivateEndpointType[];
}

// @public
export interface AvailableProvidersList {
    countries: AvailableProvidersListCountry[];
}

// @public
export interface AvailableProvidersListCity {
    cityName?: string;
    providers?: string[];
}

// @public
export interface AvailableProvidersListCountry {
    countryName?: string;
    providers?: string[];
    states?: AvailableProvidersListState[];
}

// @public
export interface AvailableProvidersListParameters {
    azureLocations?: string[];
    city?: string;
    country?: string;
    state?: string;
}

// @public
export interface AvailableProvidersListState {
    cities?: AvailableProvidersListCity[];
    providers?: string[];
    stateName?: string;
}

// @public
export interface AvailableResourceGroupDelegations {
    list(location: string, resourceGroupName: string, options?: AvailableResourceGroupDelegationsListOptionalParams): PagedAsyncIterableIterator<AvailableDelegation>;
}

// @public
export interface AvailableResourceGroupDelegationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableResourceGroupDelegationsListNextResponse = AvailableDelegationsResult;

// @public
export interface AvailableResourceGroupDelegationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableResourceGroupDelegationsListResponse = AvailableDelegationsResult;

// @public
export interface AvailableServiceAlias {
    id?: string;
    name?: string;
    resourceName?: string;
    type?: string;
}

// @public
export interface AvailableServiceAliases {
    list(location: string, options?: AvailableServiceAliasesListOptionalParams): PagedAsyncIterableIterator<AvailableServiceAlias>;
    listByResourceGroup(resourceGroupName: string, location: string, options?: AvailableServiceAliasesListByResourceGroupOptionalParams): PagedAsyncIterableIterator<AvailableServiceAlias>;
}

// @public
export interface AvailableServiceAliasesListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableServiceAliasesListByResourceGroupNextResponse = AvailableServiceAliasesResult;

// @public
export interface AvailableServiceAliasesListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableServiceAliasesListByResourceGroupResponse = AvailableServiceAliasesResult;

// @public
export interface AvailableServiceAliasesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableServiceAliasesListNextResponse = AvailableServiceAliasesResult;

// @public
export interface AvailableServiceAliasesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AvailableServiceAliasesListResponse = AvailableServiceAliasesResult;

// @public
export interface AvailableServiceAliasesResult {
    readonly nextLink?: string;
    value?: AvailableServiceAlias[];
}

// @public
export interface AzureAsyncOperationResult {
    error?: ErrorModel;
    status?: NetworkOperationStatus;
}

// @public
export type AzureFirewall = Resource & {
    zones?: string[];
    readonly etag?: string;
    applicationRuleCollections?: AzureFirewallApplicationRuleCollection[];
    natRuleCollections?: AzureFirewallNatRuleCollection[];
    networkRuleCollections?: AzureFirewallNetworkRuleCollection[];
    ipConfigurations?: AzureFirewallIPConfiguration[];
    managementIpConfiguration?: AzureFirewallIPConfiguration;
    readonly provisioningState?: ProvisioningState;
    threatIntelMode?: AzureFirewallThreatIntelMode;
    virtualHub?: SubResource;
    firewallPolicy?: SubResource;
    hubIPAddresses?: HubIPAddresses;
    readonly ipGroups?: AzureFirewallIpGroups[];
    sku?: AzureFirewallSku;
    additionalProperties?: {
        [propertyName: string]: string;
    };
};

// @public
export interface AzureFirewallApplicationRule {
    description?: string;
    fqdnTags?: string[];
    name?: string;
    protocols?: AzureFirewallApplicationRuleProtocol[];
    sourceAddresses?: string[];
    sourceIpGroups?: string[];
    targetFqdns?: string[];
}

// @public
export type AzureFirewallApplicationRuleCollection = SubResource & {
    name?: string;
    readonly etag?: string;
    priority?: number;
    action?: AzureFirewallRCAction;
    rules?: AzureFirewallApplicationRule[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface AzureFirewallApplicationRuleProtocol {
    port?: number;
    protocolType?: AzureFirewallApplicationRuleProtocolType;
}

// @public
export type AzureFirewallApplicationRuleProtocolType = string;

// @public
export type AzureFirewallFqdnTag = Resource & {
    readonly etag?: string;
    readonly provisioningState?: ProvisioningState;
    readonly fqdnTagName?: string;
};

// @public
export interface AzureFirewallFqdnTagListResult {
    nextLink?: string;
    value?: AzureFirewallFqdnTag[];
}

// @public
export interface AzureFirewallFqdnTags {
    listAll(options?: AzureFirewallFqdnTagsListAllOptionalParams): PagedAsyncIterableIterator<AzureFirewallFqdnTag>;
}

// @public
export interface AzureFirewallFqdnTagsListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallFqdnTagsListAllNextResponse = AzureFirewallFqdnTagListResult;

// @public
export interface AzureFirewallFqdnTagsListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallFqdnTagsListAllResponse = AzureFirewallFqdnTagListResult;

// @public
export type AzureFirewallIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly privateIPAddress?: string;
    subnet?: SubResource;
    publicIPAddress?: SubResource;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface AzureFirewallIpGroups {
    readonly changeNumber?: string;
    readonly id?: string;
}

// @public
export interface AzureFirewallListResult {
    nextLink?: string;
    value?: AzureFirewall[];
}

// @public
export interface AzureFirewallNatRCAction {
    type?: AzureFirewallNatRCActionType;
}

// @public
export type AzureFirewallNatRCActionType = string;

// @public
export interface AzureFirewallNatRule {
    description?: string;
    destinationAddresses?: string[];
    destinationPorts?: string[];
    name?: string;
    protocols?: AzureFirewallNetworkRuleProtocol[];
    sourceAddresses?: string[];
    sourceIpGroups?: string[];
    translatedAddress?: string;
    translatedFqdn?: string;
    translatedPort?: string;
}

// @public
export type AzureFirewallNatRuleCollection = SubResource & {
    name?: string;
    readonly etag?: string;
    priority?: number;
    action?: AzureFirewallNatRCAction;
    rules?: AzureFirewallNatRule[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface AzureFirewallNetworkRule {
    description?: string;
    destinationAddresses?: string[];
    destinationFqdns?: string[];
    destinationIpGroups?: string[];
    destinationPorts?: string[];
    name?: string;
    protocols?: AzureFirewallNetworkRuleProtocol[];
    sourceAddresses?: string[];
    sourceIpGroups?: string[];
}

// @public
export type AzureFirewallNetworkRuleCollection = SubResource & {
    name?: string;
    readonly etag?: string;
    priority?: number;
    action?: AzureFirewallRCAction;
    rules?: AzureFirewallNetworkRule[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export type AzureFirewallNetworkRuleProtocol = string;

// @public
export interface AzureFirewallPublicIPAddress {
    address?: string;
}

// @public
export interface AzureFirewallRCAction {
    type?: AzureFirewallRCActionType;
}

// @public
export type AzureFirewallRCActionType = string;

// @public
export interface AzureFirewalls {
    beginCreateOrUpdate(resourceGroupName: string, azureFirewallName: string, parameters: AzureFirewall, options?: AzureFirewallsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<AzureFirewallsCreateOrUpdateResponse>, AzureFirewallsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, azureFirewallName: string, parameters: AzureFirewall, options?: AzureFirewallsCreateOrUpdateOptionalParams): Promise<AzureFirewallsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, azureFirewallName: string, options?: AzureFirewallsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, azureFirewallName: string, options?: AzureFirewallsDeleteOptionalParams): Promise<void>;
    beginUpdateTags(resourceGroupName: string, azureFirewallName: string, parameters: TagsObject, options?: AzureFirewallsUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<AzureFirewallsUpdateTagsResponse>, AzureFirewallsUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, azureFirewallName: string, parameters: TagsObject, options?: AzureFirewallsUpdateTagsOptionalParams): Promise<AzureFirewallsUpdateTagsResponse>;
    get(resourceGroupName: string, azureFirewallName: string, options?: AzureFirewallsGetOptionalParams): Promise<AzureFirewallsGetResponse>;
    list(resourceGroupName: string, options?: AzureFirewallsListOptionalParams): PagedAsyncIterableIterator<AzureFirewall>;
    listAll(options?: AzureFirewallsListAllOptionalParams): PagedAsyncIterableIterator<AzureFirewall>;
}

// @public
export interface AzureFirewallsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type AzureFirewallsCreateOrUpdateResponse = AzureFirewall;

// @public
export interface AzureFirewallsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface AzureFirewallsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallsGetResponse = AzureFirewall;

// @public
export interface AzureFirewallSku {
    name?: AzureFirewallSkuName;
    tier?: AzureFirewallSkuTier;
}

// @public
export type AzureFirewallSkuName = string;

// @public
export type AzureFirewallSkuTier = string;

// @public
export interface AzureFirewallsListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallsListAllNextResponse = AzureFirewallListResult;

// @public
export interface AzureFirewallsListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallsListAllResponse = AzureFirewallListResult;

// @public
export interface AzureFirewallsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallsListNextResponse = AzureFirewallListResult;

// @public
export interface AzureFirewallsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type AzureFirewallsListResponse = AzureFirewallListResult;

// @public
export interface AzureFirewallsUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type AzureFirewallsUpdateTagsResponse = AzureFirewall;

// @public
export type AzureFirewallThreatIntelMode = string;

// @public
export interface AzureReachabilityReport {
    aggregationLevel: string;
    providerLocation: AzureReachabilityReportLocation;
    reachabilityReport: AzureReachabilityReportItem[];
}

// @public
export interface AzureReachabilityReportItem {
    azureLocation?: string;
    latencies?: AzureReachabilityReportLatencyInfo[];
    provider?: string;
}

// @public
export interface AzureReachabilityReportLatencyInfo {
    score?: number;
    timeStamp?: Date;
}

// @public
export interface AzureReachabilityReportLocation {
    city?: string;
    country: string;
    state?: string;
}

// @public
export interface AzureReachabilityReportParameters {
    azureLocations?: string[];
    endTime: Date;
    providerLocation: AzureReachabilityReportLocation;
    providers?: string[];
    startTime: Date;
}

// @public
export interface AzureWebCategory {
    readonly etag?: string;
    readonly group?: string;
    id?: string;
    readonly name?: string;
    readonly type?: string;
}

// @public
export interface AzureWebCategoryListResult {
    nextLink?: string;
    value?: AzureWebCategory[];
}

// @public
export interface BackendAddressInboundNatRulePortMappings {
    inboundNatRulePortMappings?: InboundNatRulePortMapping[];
}

// @public
export type BackendAddressPool = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    location?: string;
    tunnelInterfaces?: GatewayLoadBalancerTunnelInterface[];
    loadBalancerBackendAddresses?: LoadBalancerBackendAddress[];
    readonly backendIPConfigurations?: NetworkInterfaceIPConfiguration[];
    readonly loadBalancingRules?: SubResource[];
    readonly outboundRule?: SubResource;
    readonly outboundRules?: SubResource[];
    readonly inboundNatRules?: SubResource[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface BastionActiveSession {
    readonly protocol?: BastionConnectProtocol;
    readonly resourceType?: string;
    readonly sessionDurationInMins?: number;
    readonly sessionId?: string;
    readonly startTime?: Record<string, unknown>;
    readonly targetHostName?: string;
    readonly targetIpAddress?: string;
    readonly targetResourceGroup?: string;
    readonly targetResourceId?: string;
    readonly targetSubscriptionId?: string;
    readonly userName?: string;
}

// @public
export interface BastionActiveSessionListResult {
    nextLink?: string;
    value?: BastionActiveSession[];
}

// @public
export type BastionConnectProtocol = string;

// @public
export type BastionHost = Resource & {
    readonly etag?: string;
    sku?: Sku;
    ipConfigurations?: BastionHostIPConfiguration[];
    dnsName?: string;
    readonly provisioningState?: ProvisioningState;
    scaleUnits?: number;
    disableCopyPaste?: boolean;
    enableFileCopy?: boolean;
    enableIpConnect?: boolean;
    enableShareableLink?: boolean;
    enableTunneling?: boolean;
};

// @public
export type BastionHostIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    subnet?: SubResource;
    publicIPAddress?: SubResource;
    readonly provisioningState?: ProvisioningState;
    privateIPAllocationMethod?: IPAllocationMethod;
};

// @public
export interface BastionHostListResult {
    nextLink?: string;
    value?: BastionHost[];
}

// @public
export interface BastionHosts {
    beginCreateOrUpdate(resourceGroupName: string, bastionHostName: string, parameters: BastionHost, options?: BastionHostsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<BastionHostsCreateOrUpdateResponse>, BastionHostsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, bastionHostName: string, parameters: BastionHost, options?: BastionHostsCreateOrUpdateOptionalParams): Promise<BastionHostsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, bastionHostName: string, options?: BastionHostsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, bastionHostName: string, options?: BastionHostsDeleteOptionalParams): Promise<void>;
    beginUpdateTags(resourceGroupName: string, bastionHostName: string, parameters: TagsObject, options?: BastionHostsUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<BastionHostsUpdateTagsResponse>, BastionHostsUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, bastionHostName: string, parameters: TagsObject, options?: BastionHostsUpdateTagsOptionalParams): Promise<BastionHostsUpdateTagsResponse>;
    get(resourceGroupName: string, bastionHostName: string, options?: BastionHostsGetOptionalParams): Promise<BastionHostsGetResponse>;
    list(options?: BastionHostsListOptionalParams): PagedAsyncIterableIterator<BastionHost>;
    listByResourceGroup(resourceGroupName: string, options?: BastionHostsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<BastionHost>;
}

// @public
export interface BastionHostsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type BastionHostsCreateOrUpdateResponse = BastionHost;

// @public
export interface BastionHostsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface BastionHostsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BastionHostsGetResponse = BastionHost;

// @public
export type BastionHostSkuName = string;

// @public
export interface BastionHostsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BastionHostsListByResourceGroupNextResponse = BastionHostListResult;

// @public
export interface BastionHostsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BastionHostsListByResourceGroupResponse = BastionHostListResult;

// @public
export interface BastionHostsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BastionHostsListNextResponse = BastionHostListResult;

// @public
export interface BastionHostsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BastionHostsListResponse = BastionHostListResult;

// @public
export interface BastionHostsUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type BastionHostsUpdateTagsResponse = BastionHost;

// @public
export interface BastionSessionDeleteResult {
    nextLink?: string;
    value?: BastionSessionState[];
}

// @public
export interface BastionSessionState {
    readonly message?: string;
    readonly sessionId?: string;
    readonly state?: string;
}

// @public
export interface BastionShareableLink {
    readonly bsl?: string;
    readonly createdAt?: string;
    readonly message?: string;
    vm: Vm;
}

// @public
export interface BastionShareableLinkListRequest {
    vms?: BastionShareableLink[];
}

// @public
export interface BastionShareableLinkListResult {
    nextLink?: string;
    value?: BastionShareableLink[];
}

// @public
export interface BGPCommunity {
    communityName?: string;
    communityPrefixes?: string[];
    communityValue?: string;
    isAuthorizedToUse?: boolean;
    serviceGroup?: string;
    serviceSupportedRegion?: string;
}

// @public
export type BgpConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    peerAsn?: number;
    peerIp?: string;
    hubVirtualNetworkConnection?: SubResource;
    readonly provisioningState?: ProvisioningState;
    readonly connectionState?: HubBgpConnectionStatus;
};

// @public
export type BgpPeerState = string;

// @public
export interface BgpPeerStatus {
    readonly asn?: number;
    readonly connectedDuration?: string;
    readonly localAddress?: string;
    readonly messagesReceived?: number;
    readonly messagesSent?: number;
    readonly neighbor?: string;
    readonly routesReceived?: number;
    readonly state?: BgpPeerState;
}

// @public
export interface BgpPeerStatusListResult {
    value?: BgpPeerStatus[];
}

// @public
export interface BgpServiceCommunities {
    list(options?: BgpServiceCommunitiesListOptionalParams): PagedAsyncIterableIterator<BgpServiceCommunity>;
}

// @public
export interface BgpServiceCommunitiesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BgpServiceCommunitiesListNextResponse = BgpServiceCommunityListResult;

// @public
export interface BgpServiceCommunitiesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type BgpServiceCommunitiesListResponse = BgpServiceCommunityListResult;

// @public
export type BgpServiceCommunity = Resource & {
    serviceName?: string;
    bgpCommunities?: BGPCommunity[];
};

// @public
export interface BgpServiceCommunityListResult {
    nextLink?: string;
    value?: BgpServiceCommunity[];
}

// @public
export interface BgpSettings {
    asn?: number;
    bgpPeeringAddress?: string;
    bgpPeeringAddresses?: IPConfigurationBgpPeeringAddress[];
    peerWeight?: number;
}

// @public
export interface BreakOutCategoryPolicies {
    allow?: boolean;
    default?: boolean;
    optimize?: boolean;
}

// @public
export interface CheckDnsNameAvailabilityOptionalParams extends coreClient.OperationOptions {
}

// @public
export type CheckDnsNameAvailabilityResponse = DnsNameAvailabilityResult;

// @public
export interface CheckPrivateLinkServiceVisibilityRequest {
    privateLinkServiceAlias?: string;
}

// @public
export type CircuitConnectionStatus = string;

// @public
export interface CloudError {
    error?: CloudErrorBody;
}

// @public
export interface CloudErrorBody {
    code?: string;
    details?: CloudErrorBody[];
    message?: string;
    target?: string;
}

// @public
export type CommissionedState = string;

// @public (undocumented)
export interface Components1Jq1T4ISchemasManagedserviceidentityPropertiesUserassignedidentitiesAdditionalproperties {
    readonly clientId?: string;
    readonly principalId?: string;
}

// @public
export interface ConnectionMonitor {
    autoStart?: boolean;
    destination?: ConnectionMonitorDestination;
    endpoints?: ConnectionMonitorEndpoint[];
    location?: string;
    monitoringIntervalInSeconds?: number;
    notes?: string;
    outputs?: ConnectionMonitorOutput[];
    source?: ConnectionMonitorSource;
    tags?: {
        [propertyName: string]: string;
    };
    testConfigurations?: ConnectionMonitorTestConfiguration[];
    testGroups?: ConnectionMonitorTestGroup[];
}

// @public
export interface ConnectionMonitorDestination {
    address?: string;
    port?: number;
    resourceId?: string;
}

// @public
export interface ConnectionMonitorEndpoint {
    address?: string;
    coverageLevel?: CoverageLevel;
    filter?: ConnectionMonitorEndpointFilter;
    name: string;
    resourceId?: string;
    scope?: ConnectionMonitorEndpointScope;
    type?: EndpointType;
}

// @public
export interface ConnectionMonitorEndpointFilter {
    items?: ConnectionMonitorEndpointFilterItem[];
    type?: ConnectionMonitorEndpointFilterType;
}

// @public
export interface ConnectionMonitorEndpointFilterItem {
    address?: string;
    type?: ConnectionMonitorEndpointFilterItemType;
}

// @public
export type ConnectionMonitorEndpointFilterItemType = string;

// @public
export type ConnectionMonitorEndpointFilterType = string;

// @public
export interface ConnectionMonitorEndpointScope {
    exclude?: ConnectionMonitorEndpointScopeItem[];
    include?: ConnectionMonitorEndpointScopeItem[];
}

// @public
export interface ConnectionMonitorEndpointScopeItem {
    address?: string;
}

// @public
export interface ConnectionMonitorHttpConfiguration {
    method?: HttpConfigurationMethod;
    path?: string;
    port?: number;
    preferHttps?: boolean;
    requestHeaders?: HttpHeader[];
    validStatusCodeRanges?: string[];
}

// @public
export interface ConnectionMonitorIcmpConfiguration {
    disableTraceRoute?: boolean;
}

// @public
export interface ConnectionMonitorListResult {
    value?: ConnectionMonitorResult[];
}

// @public
export interface ConnectionMonitorOutput {
    type?: OutputType;
    workspaceSettings?: ConnectionMonitorWorkspaceSettings;
}

// @public
export interface ConnectionMonitorParameters {
    autoStart?: boolean;
    destination?: ConnectionMonitorDestination;
    endpoints?: ConnectionMonitorEndpoint[];
    monitoringIntervalInSeconds?: number;
    notes?: string;
    outputs?: ConnectionMonitorOutput[];
    source?: ConnectionMonitorSource;
    testConfigurations?: ConnectionMonitorTestConfiguration[];
    testGroups?: ConnectionMonitorTestGroup[];
}

// @public
export interface ConnectionMonitorQueryResult {
    sourceStatus?: ConnectionMonitorSourceStatus;
    states?: ConnectionStateSnapshot[];
}

// @public
export interface ConnectionMonitorResult {
    autoStart?: boolean;
    readonly connectionMonitorType?: ConnectionMonitorType;
    destination?: ConnectionMonitorDestination;
    endpoints?: ConnectionMonitorEndpoint[];
    readonly etag?: string;
    readonly id?: string;
    location?: string;
    monitoringIntervalInSeconds?: number;
    readonly monitoringStatus?: string;
    readonly name?: string;
    notes?: string;
    outputs?: ConnectionMonitorOutput[];
    readonly provisioningState?: ProvisioningState;
    source?: ConnectionMonitorSource;
    readonly startTime?: Date;
    tags?: {
        [propertyName: string]: string;
    };
    testConfigurations?: ConnectionMonitorTestConfiguration[];
    testGroups?: ConnectionMonitorTestGroup[];
    readonly type?: string;
}

// @public
export type ConnectionMonitorResultProperties = ConnectionMonitorParameters & {
    readonly provisioningState?: ProvisioningState;
    readonly startTime?: Date;
    readonly monitoringStatus?: string;
    readonly connectionMonitorType?: ConnectionMonitorType;
};

// @public
export interface ConnectionMonitors {
    beginCreateOrUpdate(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, parameters: ConnectionMonitor, options?: ConnectionMonitorsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ConnectionMonitorsCreateOrUpdateResponse>, ConnectionMonitorsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, parameters: ConnectionMonitor, options?: ConnectionMonitorsCreateOrUpdateOptionalParams): Promise<ConnectionMonitorsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsDeleteOptionalParams): Promise<void>;
    beginQuery(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsQueryOptionalParams): Promise<PollerLike<PollOperationState<ConnectionMonitorsQueryResponse>, ConnectionMonitorsQueryResponse>>;
    beginQueryAndWait(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsQueryOptionalParams): Promise<ConnectionMonitorsQueryResponse>;
    beginStart(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsStartOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginStartAndWait(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsStartOptionalParams): Promise<void>;
    beginStop(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsStopOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginStopAndWait(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsStopOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, options?: ConnectionMonitorsGetOptionalParams): Promise<ConnectionMonitorsGetResponse>;
    list(resourceGroupName: string, networkWatcherName: string, options?: ConnectionMonitorsListOptionalParams): PagedAsyncIterableIterator<ConnectionMonitorResult>;
    updateTags(resourceGroupName: string, networkWatcherName: string, connectionMonitorName: string, parameters: TagsObject, options?: ConnectionMonitorsUpdateTagsOptionalParams): Promise<ConnectionMonitorsUpdateTagsResponse>;
}

// @public
export interface ConnectionMonitorsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    migrate?: string;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ConnectionMonitorsCreateOrUpdateResponse = ConnectionMonitorResult;

// @public
export interface ConnectionMonitorsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ConnectionMonitorsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConnectionMonitorsGetResponse = ConnectionMonitorResult;

// @public
export interface ConnectionMonitorsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConnectionMonitorsListResponse = ConnectionMonitorListResult;

// @public
export interface ConnectionMonitorSource {
    port?: number;
    resourceId: string;
}

// @public
export type ConnectionMonitorSourceStatus = string;

// @public
export interface ConnectionMonitorsQueryOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ConnectionMonitorsQueryResponse = ConnectionMonitorQueryResult;

// @public
export interface ConnectionMonitorsStartOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ConnectionMonitorsStopOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ConnectionMonitorSuccessThreshold {
    checksFailedPercent?: number;
    roundTripTimeMs?: number;
}

// @public
export interface ConnectionMonitorsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ConnectionMonitorsUpdateTagsResponse = ConnectionMonitorResult;

// @public
export interface ConnectionMonitorTcpConfiguration {
    destinationPortBehavior?: DestinationPortBehavior;
    disableTraceRoute?: boolean;
    port?: number;
}

// @public
export interface ConnectionMonitorTestConfiguration {
    httpConfiguration?: ConnectionMonitorHttpConfiguration;
    icmpConfiguration?: ConnectionMonitorIcmpConfiguration;
    name: string;
    preferredIPVersion?: PreferredIPVersion;
    protocol: ConnectionMonitorTestConfigurationProtocol;
    successThreshold?: ConnectionMonitorSuccessThreshold;
    tcpConfiguration?: ConnectionMonitorTcpConfiguration;
    testFrequencySec?: number;
}

// @public
export type ConnectionMonitorTestConfigurationProtocol = string;

// @public
export interface ConnectionMonitorTestGroup {
    destinations: string[];
    disable?: boolean;
    name: string;
    sources: string[];
    testConfigurations: string[];
}

// @public
export type ConnectionMonitorType = string;

// @public
export interface ConnectionMonitorWorkspaceSettings {
    workspaceResourceId?: string;
}

// @public
export interface ConnectionResetSharedKey {
    keyLength: number;
}

// @public
export type ConnectionSharedKey = SubResource & {
    value: string;
};

// @public
export type ConnectionState = string;

// @public
export interface ConnectionStateSnapshot {
    avgLatencyInMs?: number;
    connectionState?: ConnectionState;
    endTime?: Date;
    evaluationState?: EvaluationState;
    readonly hops?: ConnectivityHop[];
    maxLatencyInMs?: number;
    minLatencyInMs?: number;
    probesFailed?: number;
    probesSent?: number;
    startTime?: Date;
}

// @public
export type ConnectionStatus = string;

// @public
export interface ConnectivityDestination {
    address?: string;
    port?: number;
    resourceId?: string;
}

// @public
export interface ConnectivityHop {
    readonly address?: string;
    readonly id?: string;
    readonly issues?: ConnectivityIssue[];
    readonly links?: HopLink[];
    readonly nextHopIds?: string[];
    readonly previousHopIds?: string[];
    readonly previousLinks?: HopLink[];
    readonly resourceId?: string;
    readonly type?: string;
}

// @public
export interface ConnectivityInformation {
    readonly avgLatencyInMs?: number;
    readonly connectionStatus?: ConnectionStatus;
    readonly hops?: ConnectivityHop[];
    readonly maxLatencyInMs?: number;
    readonly minLatencyInMs?: number;
    readonly probesFailed?: number;
    readonly probesSent?: number;
}

// @public
export interface ConnectivityIssue {
    readonly context?: {
        [propertyName: string]: string;
    }[];
    readonly origin?: Origin;
    readonly severity?: Severity;
    readonly type?: IssueType;
}

// @public
export interface ConnectivityParameters {
    destination: ConnectivityDestination;
    preferredIPVersion?: IPVersion;
    protocol?: Protocol;
    protocolConfiguration?: ProtocolConfiguration;
    source: ConnectivitySource;
}

// @public
export interface ConnectivitySource {
    port?: number;
    resourceId: string;
}

// @public
export type Container = SubResource & {};

// @public
export type ContainerNetworkInterface = SubResource & {
    name?: string;
    readonly type?: string;
    readonly etag?: string;
    readonly containerNetworkInterfaceConfiguration?: ContainerNetworkInterfaceConfiguration;
    container?: Container;
    readonly ipConfigurations?: ContainerNetworkInterfaceIpConfiguration[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ContainerNetworkInterfaceConfiguration = SubResource & {
    name?: string;
    readonly type?: string;
    readonly etag?: string;
    ipConfigurations?: IPConfigurationProfile[];
    containerNetworkInterfaces?: SubResource[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ContainerNetworkInterfaceIpConfiguration {
    readonly etag?: string;
    name?: string;
    readonly provisioningState?: ProvisioningState;
    readonly type?: string;
}

// @public
export type CoverageLevel = string;

// @public
export interface CustomDnsConfigPropertiesFormat {
    fqdn?: string;
    ipAddresses?: string[];
}

// @public
export type CustomIpPrefix = Resource & {
    extendedLocation?: ExtendedLocation;
    readonly etag?: string;
    zones?: string[];
    cidr?: string;
    signedMessage?: string;
    authorizationMessage?: string;
    customIpPrefixParent?: SubResource;
    readonly childCustomIpPrefixes?: SubResource[];
    commissionedState?: CommissionedState;
    readonly publicIpPrefixes?: SubResource[];
    readonly resourceGuid?: string;
    readonly failedReason?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface CustomIPPrefixes {
    beginCreateOrUpdate(resourceGroupName: string, customIpPrefixName: string, parameters: CustomIpPrefix, options?: CustomIPPrefixesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<CustomIPPrefixesCreateOrUpdateResponse>, CustomIPPrefixesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, customIpPrefixName: string, parameters: CustomIpPrefix, options?: CustomIPPrefixesCreateOrUpdateOptionalParams): Promise<CustomIPPrefixesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, customIpPrefixName: string, options?: CustomIPPrefixesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, customIpPrefixName: string, options?: CustomIPPrefixesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, customIpPrefixName: string, options?: CustomIPPrefixesGetOptionalParams): Promise<CustomIPPrefixesGetResponse>;
    list(resourceGroupName: string, options?: CustomIPPrefixesListOptionalParams): PagedAsyncIterableIterator<CustomIpPrefix>;
    listAll(options?: CustomIPPrefixesListAllOptionalParams): PagedAsyncIterableIterator<CustomIpPrefix>;
    updateTags(resourceGroupName: string, customIpPrefixName: string, parameters: TagsObject, options?: CustomIPPrefixesUpdateTagsOptionalParams): Promise<CustomIPPrefixesUpdateTagsResponse>;
}

// @public
export interface CustomIPPrefixesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type CustomIPPrefixesCreateOrUpdateResponse = CustomIpPrefix;

// @public
export interface CustomIPPrefixesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface CustomIPPrefixesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type CustomIPPrefixesGetResponse = CustomIpPrefix;

// @public
export interface CustomIPPrefixesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type CustomIPPrefixesListAllNextResponse = CustomIpPrefixListResult;

// @public
export interface CustomIPPrefixesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type CustomIPPrefixesListAllResponse = CustomIpPrefixListResult;

// @public
export interface CustomIPPrefixesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type CustomIPPrefixesListNextResponse = CustomIpPrefixListResult;

// @public
export interface CustomIPPrefixesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type CustomIPPrefixesListResponse = CustomIpPrefixListResult;

// @public
export interface CustomIPPrefixesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type CustomIPPrefixesUpdateTagsResponse = CustomIpPrefix;

// @public
export interface CustomIpPrefixListResult {
    nextLink?: string;
    value?: CustomIpPrefix[];
}

// @public
export interface DdosCustomPolicies {
    beginCreateOrUpdate(resourceGroupName: string, ddosCustomPolicyName: string, parameters: DdosCustomPolicy, options?: DdosCustomPoliciesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<DdosCustomPoliciesCreateOrUpdateResponse>, DdosCustomPoliciesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, ddosCustomPolicyName: string, parameters: DdosCustomPolicy, options?: DdosCustomPoliciesCreateOrUpdateOptionalParams): Promise<DdosCustomPoliciesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, ddosCustomPolicyName: string, options?: DdosCustomPoliciesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, ddosCustomPolicyName: string, options?: DdosCustomPoliciesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, ddosCustomPolicyName: string, options?: DdosCustomPoliciesGetOptionalParams): Promise<DdosCustomPoliciesGetResponse>;
    updateTags(resourceGroupName: string, ddosCustomPolicyName: string, parameters: TagsObject, options?: DdosCustomPoliciesUpdateTagsOptionalParams): Promise<DdosCustomPoliciesUpdateTagsResponse>;
}

// @public
export interface DdosCustomPoliciesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type DdosCustomPoliciesCreateOrUpdateResponse = DdosCustomPolicy;

// @public
export interface DdosCustomPoliciesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface DdosCustomPoliciesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosCustomPoliciesGetResponse = DdosCustomPolicy;

// @public
export interface DdosCustomPoliciesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosCustomPoliciesUpdateTagsResponse = DdosCustomPolicy;

// @public
export type DdosCustomPolicy = Resource & {
    readonly etag?: string;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    readonly publicIPAddresses?: SubResource[];
    protocolCustomSettings?: ProtocolCustomSettingsFormat[];
};

// @public
export type DdosCustomPolicyProtocol = string;

// @public
export type DdosCustomPolicyTriggerSensitivityOverride = string;

// @public
export interface DdosProtectionPlan {
    readonly etag?: string;
    readonly id?: string;
    location?: string;
    readonly name?: string;
    readonly provisioningState?: ProvisioningState;
    readonly resourceGuid?: string;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
    readonly virtualNetworks?: SubResource[];
}

// @public
export interface DdosProtectionPlanListResult {
    readonly nextLink?: string;
    value?: DdosProtectionPlan[];
}

// @public
export interface DdosProtectionPlans {
    beginCreateOrUpdate(resourceGroupName: string, ddosProtectionPlanName: string, parameters: DdosProtectionPlan, options?: DdosProtectionPlansCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<DdosProtectionPlansCreateOrUpdateResponse>, DdosProtectionPlansCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, ddosProtectionPlanName: string, parameters: DdosProtectionPlan, options?: DdosProtectionPlansCreateOrUpdateOptionalParams): Promise<DdosProtectionPlansCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, ddosProtectionPlanName: string, options?: DdosProtectionPlansDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, ddosProtectionPlanName: string, options?: DdosProtectionPlansDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, ddosProtectionPlanName: string, options?: DdosProtectionPlansGetOptionalParams): Promise<DdosProtectionPlansGetResponse>;
    list(options?: DdosProtectionPlansListOptionalParams): PagedAsyncIterableIterator<DdosProtectionPlan>;
    listByResourceGroup(resourceGroupName: string, options?: DdosProtectionPlansListByResourceGroupOptionalParams): PagedAsyncIterableIterator<DdosProtectionPlan>;
    updateTags(resourceGroupName: string, ddosProtectionPlanName: string, parameters: TagsObject, options?: DdosProtectionPlansUpdateTagsOptionalParams): Promise<DdosProtectionPlansUpdateTagsResponse>;
}

// @public
export interface DdosProtectionPlansCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type DdosProtectionPlansCreateOrUpdateResponse = DdosProtectionPlan;

// @public
export interface DdosProtectionPlansDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface DdosProtectionPlansGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosProtectionPlansGetResponse = DdosProtectionPlan;

// @public
export interface DdosProtectionPlansListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosProtectionPlansListByResourceGroupNextResponse = DdosProtectionPlanListResult;

// @public
export interface DdosProtectionPlansListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosProtectionPlansListByResourceGroupResponse = DdosProtectionPlanListResult;

// @public
export interface DdosProtectionPlansListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosProtectionPlansListNextResponse = DdosProtectionPlanListResult;

// @public
export interface DdosProtectionPlansListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosProtectionPlansListResponse = DdosProtectionPlanListResult;

// @public
export interface DdosProtectionPlansUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DdosProtectionPlansUpdateTagsResponse = DdosProtectionPlan;

// @public
export interface DdosSettings {
    ddosCustomPolicy?: SubResource;
    protectedIP?: boolean;
    protectionCoverage?: DdosSettingsProtectionCoverage;
}

// @public
export type DdosSettingsProtectionCoverage = string;

// @public
export interface DefaultSecurityRules {
    get(resourceGroupName: string, networkSecurityGroupName: string, defaultSecurityRuleName: string, options?: DefaultSecurityRulesGetOptionalParams): Promise<DefaultSecurityRulesGetResponse>;
    list(resourceGroupName: string, networkSecurityGroupName: string, options?: DefaultSecurityRulesListOptionalParams): PagedAsyncIterableIterator<SecurityRule>;
}

// @public
export interface DefaultSecurityRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DefaultSecurityRulesGetResponse = SecurityRule;

// @public
export interface DefaultSecurityRulesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DefaultSecurityRulesListNextResponse = SecurityRuleListResult;

// @public
export interface DefaultSecurityRulesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DefaultSecurityRulesListResponse = SecurityRuleListResult;

// @public
export type Delegation = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    serviceName?: string;
    readonly actions?: string[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface DeleteBastionShareableLinkOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type DeleteOptions = string;

// @public
export type DestinationPortBehavior = string;

// @public
export interface DeviceProperties {
    deviceModel?: string;
    deviceVendor?: string;
    linkSpeedInMbps?: number;
}

// @public
export interface DhcpOptions {
    dnsServers?: string[];
}

// @public
export type DhGroup = string;

// @public
export interface Dimension {
    displayName?: string;
    internalName?: string;
    name?: string;
}

// @public
export type Direction = string;

// @public
export interface DisconnectActiveSessionsNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DisconnectActiveSessionsNextResponse = BastionSessionDeleteResult;

// @public
export interface DisconnectActiveSessionsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DisconnectActiveSessionsResponse = BastionSessionDeleteResult;

// @public
export interface DnsNameAvailabilityResult {
    available?: boolean;
}

// @public
export interface DnsSettings {
    enableProxy?: boolean;
    requireProxyForNetworkRules?: boolean;
    servers?: string[];
}

// @public
export type DscpConfiguration = Resource & {
    readonly etag?: string;
    markings?: number[];
    sourceIpRanges?: QosIpRange[];
    destinationIpRanges?: QosIpRange[];
    sourcePortRanges?: QosPortRange[];
    destinationPortRanges?: QosPortRange[];
    protocol?: ProtocolType;
    qosDefinitionCollection?: QosDefinition[];
    readonly qosCollectionId?: string;
    readonly associatedNetworkInterfaces?: NetworkInterface[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface DscpConfigurationCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type DscpConfigurationCreateOrUpdateResponse = DscpConfiguration;

// @public
export interface DscpConfigurationDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface DscpConfigurationGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DscpConfigurationGetResponse = DscpConfiguration;

// @public
export interface DscpConfigurationListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DscpConfigurationListAllNextResponse = DscpConfigurationListResult;

// @public
export interface DscpConfigurationListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DscpConfigurationListAllResponse = DscpConfigurationListResult;

// @public
export interface DscpConfigurationListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DscpConfigurationListNextResponse = DscpConfigurationListResult;

// @public
export interface DscpConfigurationListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type DscpConfigurationListResponse = DscpConfigurationListResult;

// @public
export interface DscpConfigurationListResult {
    readonly nextLink?: string;
    value?: DscpConfiguration[];
}

// @public
export interface DscpConfigurationOperations {
    beginCreateOrUpdate(resourceGroupName: string, dscpConfigurationName: string, parameters: DscpConfiguration, options?: DscpConfigurationCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<DscpConfigurationCreateOrUpdateResponse>, DscpConfigurationCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, dscpConfigurationName: string, parameters: DscpConfiguration, options?: DscpConfigurationCreateOrUpdateOptionalParams): Promise<DscpConfigurationCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, dscpConfigurationName: string, options?: DscpConfigurationDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, dscpConfigurationName: string, options?: DscpConfigurationDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, dscpConfigurationName: string, options?: DscpConfigurationGetOptionalParams): Promise<DscpConfigurationGetResponse>;
    list(resourceGroupName: string, options?: DscpConfigurationListOptionalParams): PagedAsyncIterableIterator<DscpConfiguration>;
    listAll(options?: DscpConfigurationListAllOptionalParams): PagedAsyncIterableIterator<DscpConfiguration>;
}

// @public
export interface EffectiveNetworkSecurityGroup {
    association?: EffectiveNetworkSecurityGroupAssociation;
    effectiveSecurityRules?: EffectiveNetworkSecurityRule[];
    networkSecurityGroup?: SubResource;
    tagMap?: string;
}

// @public
export interface EffectiveNetworkSecurityGroupAssociation {
    networkInterface?: SubResource;
    networkManager?: SubResource;
    subnet?: SubResource;
}

// @public
export interface EffectiveNetworkSecurityGroupListResult {
    readonly nextLink?: string;
    value?: EffectiveNetworkSecurityGroup[];
}

// @public
export interface EffectiveNetworkSecurityRule {
    access?: SecurityRuleAccess;
    destinationAddressPrefix?: string;
    destinationAddressPrefixes?: string[];
    destinationPortRange?: string;
    destinationPortRanges?: string[];
    direction?: SecurityRuleDirection;
    expandedDestinationAddressPrefix?: string[];
    expandedSourceAddressPrefix?: string[];
    name?: string;
    priority?: number;
    protocol?: EffectiveSecurityRuleProtocol;
    sourceAddressPrefix?: string;
    sourceAddressPrefixes?: string[];
    sourcePortRange?: string;
    sourcePortRanges?: string[];
}

// @public
export interface EffectiveRoute {
    addressPrefix?: string[];
    disableBgpRoutePropagation?: boolean;
    name?: string;
    nextHopIpAddress?: string[];
    nextHopType?: RouteNextHopType;
    source?: EffectiveRouteSource;
    state?: EffectiveRouteState;
}

// @public
export interface EffectiveRouteListResult {
    readonly nextLink?: string;
    value?: EffectiveRoute[];
}

// @public
export type EffectiveRouteSource = string;

// @public
export interface EffectiveRoutesParameters {
    resourceId?: string;
    virtualWanResourceType?: string;
}

// @public
export type EffectiveRouteState = string;

// @public
export type EffectiveSecurityRuleProtocol = string;

// @public
export type EndpointServiceResult = SubResource & {
    readonly name?: string;
    readonly type?: string;
};

// @public
export interface EndpointServicesListResult {
    nextLink?: string;
    value?: EndpointServiceResult[];
}

// @public
export type EndpointType = string;

// @public
export type Enum69 = number;

// @public
export type Enum70 = number;

// @public
export type Enum71 = number;

// @public
export interface ErrorDetails {
    code?: string;
    message?: string;
    target?: string;
}

// @public
export interface ErrorModel {
    code?: string;
    details?: ErrorDetails[];
    innerError?: string;
    message?: string;
    target?: string;
}

// @public
export interface ErrorResponse {
    error?: ErrorDetails;
}

// @public
export interface EvaluatedNetworkSecurityGroup {
    appliedTo?: string;
    matchedRule?: MatchedRule;
    networkSecurityGroupId?: string;
    readonly rulesEvaluationResult?: NetworkSecurityRulesEvaluationResult[];
}

// @public
export type EvaluationState = string;

// @public
export interface ExclusionManagedRule {
    ruleId: string;
}

// @public
export interface ExclusionManagedRuleGroup {
    ruleGroupName: string;
    rules?: ExclusionManagedRule[];
}

// @public
export interface ExclusionManagedRuleSet {
    ruleGroups?: ExclusionManagedRuleGroup[];
    ruleSetType: string;
    ruleSetVersion: string;
}

// @public
export interface ExplicitProxySettings {
    enableExplicitProxy?: boolean;
    httpPort?: number;
    httpsPort?: number;
    pacFile?: string;
    pacFilePort?: number;
}

// @public
export type ExpressRouteCircuit = Resource & {
    sku?: ExpressRouteCircuitSku;
    readonly etag?: string;
    allowClassicOperations?: boolean;
    circuitProvisioningState?: string;
    serviceProviderProvisioningState?: ServiceProviderProvisioningState;
    authorizations?: ExpressRouteCircuitAuthorization[];
    peerings?: ExpressRouteCircuitPeering[];
    serviceKey?: string;
    serviceProviderNotes?: string;
    serviceProviderProperties?: ExpressRouteCircuitServiceProviderProperties;
    expressRoutePort?: SubResource;
    bandwidthInGbps?: number;
    readonly stag?: number;
    readonly provisioningState?: ProvisioningState;
    gatewayManagerEtag?: string;
    globalReachEnabled?: boolean;
};

// @public
export interface ExpressRouteCircuitArpTable {
    age?: number;
    interface?: string;
    ipAddress?: string;
    macAddress?: string;
}

// @public
export type ExpressRouteCircuitAuthorization = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    authorizationKey?: string;
    authorizationUseStatus?: AuthorizationUseStatus;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ExpressRouteCircuitAuthorizations {
    beginCreateOrUpdate(resourceGroupName: string, circuitName: string, authorizationName: string, authorizationParameters: ExpressRouteCircuitAuthorization, options?: ExpressRouteCircuitAuthorizationsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitAuthorizationsCreateOrUpdateResponse>, ExpressRouteCircuitAuthorizationsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, circuitName: string, authorizationName: string, authorizationParameters: ExpressRouteCircuitAuthorization, options?: ExpressRouteCircuitAuthorizationsCreateOrUpdateOptionalParams): Promise<ExpressRouteCircuitAuthorizationsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, circuitName: string, authorizationName: string, options?: ExpressRouteCircuitAuthorizationsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, circuitName: string, authorizationName: string, options?: ExpressRouteCircuitAuthorizationsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, circuitName: string, authorizationName: string, options?: ExpressRouteCircuitAuthorizationsGetOptionalParams): Promise<ExpressRouteCircuitAuthorizationsGetResponse>;
    list(resourceGroupName: string, circuitName: string, options?: ExpressRouteCircuitAuthorizationsListOptionalParams): PagedAsyncIterableIterator<ExpressRouteCircuitAuthorization>;
}

// @public
export interface ExpressRouteCircuitAuthorizationsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitAuthorizationsCreateOrUpdateResponse = ExpressRouteCircuitAuthorization;

// @public
export interface ExpressRouteCircuitAuthorizationsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteCircuitAuthorizationsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitAuthorizationsGetResponse = ExpressRouteCircuitAuthorization;

// @public
export interface ExpressRouteCircuitAuthorizationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitAuthorizationsListNextResponse = AuthorizationListResult;

// @public
export interface ExpressRouteCircuitAuthorizationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitAuthorizationsListResponse = AuthorizationListResult;

// @public
export type ExpressRouteCircuitConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    expressRouteCircuitPeering?: SubResource;
    peerExpressRouteCircuitPeering?: SubResource;
    addressPrefix?: string;
    authorizationKey?: string;
    ipv6CircuitConnectionConfig?: Ipv6CircuitConnectionConfig;
    readonly circuitConnectionStatus?: CircuitConnectionStatus;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ExpressRouteCircuitConnectionListResult {
    nextLink?: string;
    value?: ExpressRouteCircuitConnection[];
}

// @public
export interface ExpressRouteCircuitConnections {
    beginCreateOrUpdate(resourceGroupName: string, circuitName: string, peeringName: string, connectionName: string, expressRouteCircuitConnectionParameters: ExpressRouteCircuitConnection, options?: ExpressRouteCircuitConnectionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitConnectionsCreateOrUpdateResponse>, ExpressRouteCircuitConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, circuitName: string, peeringName: string, connectionName: string, expressRouteCircuitConnectionParameters: ExpressRouteCircuitConnection, options?: ExpressRouteCircuitConnectionsCreateOrUpdateOptionalParams): Promise<ExpressRouteCircuitConnectionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, circuitName: string, peeringName: string, connectionName: string, options?: ExpressRouteCircuitConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, circuitName: string, peeringName: string, connectionName: string, options?: ExpressRouteCircuitConnectionsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, circuitName: string, peeringName: string, connectionName: string, options?: ExpressRouteCircuitConnectionsGetOptionalParams): Promise<ExpressRouteCircuitConnectionsGetResponse>;
    list(resourceGroupName: string, circuitName: string, peeringName: string, options?: ExpressRouteCircuitConnectionsListOptionalParams): PagedAsyncIterableIterator<ExpressRouteCircuitConnection>;
}

// @public
export interface ExpressRouteCircuitConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitConnectionsCreateOrUpdateResponse = ExpressRouteCircuitConnection;

// @public
export interface ExpressRouteCircuitConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteCircuitConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitConnectionsGetResponse = ExpressRouteCircuitConnection;

// @public
export interface ExpressRouteCircuitConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitConnectionsListNextResponse = ExpressRouteCircuitConnectionListResult;

// @public
export interface ExpressRouteCircuitConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitConnectionsListResponse = ExpressRouteCircuitConnectionListResult;

// @public
export interface ExpressRouteCircuitListResult {
    nextLink?: string;
    value?: ExpressRouteCircuit[];
}

// @public
export type ExpressRouteCircuitPeering = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    peeringType?: ExpressRoutePeeringType;
    state?: ExpressRoutePeeringState;
    azureASN?: number;
    peerASN?: number;
    primaryPeerAddressPrefix?: string;
    secondaryPeerAddressPrefix?: string;
    primaryAzurePort?: string;
    secondaryAzurePort?: string;
    sharedKey?: string;
    vlanId?: number;
    microsoftPeeringConfig?: ExpressRouteCircuitPeeringConfig;
    stats?: ExpressRouteCircuitStats;
    readonly provisioningState?: ProvisioningState;
    gatewayManagerEtag?: string;
    readonly lastModifiedBy?: string;
    routeFilter?: SubResource;
    ipv6PeeringConfig?: Ipv6ExpressRouteCircuitPeeringConfig;
    expressRouteConnection?: ExpressRouteConnectionId;
    connections?: ExpressRouteCircuitConnection[];
    readonly peeredConnections?: PeerExpressRouteCircuitConnection[];
};

// @public
export type ExpressRouteCircuitPeeringAdvertisedPublicPrefixState = string;

// @public
export interface ExpressRouteCircuitPeeringConfig {
    advertisedCommunities?: string[];
    advertisedPublicPrefixes?: string[];
    readonly advertisedPublicPrefixesState?: ExpressRouteCircuitPeeringAdvertisedPublicPrefixState;
    customerASN?: number;
    legacyMode?: number;
    routingRegistryName?: string;
}

// @public
export interface ExpressRouteCircuitPeeringId {
    id?: string;
}

// @public
export interface ExpressRouteCircuitPeeringListResult {
    nextLink?: string;
    value?: ExpressRouteCircuitPeering[];
}

// @public
export interface ExpressRouteCircuitPeerings {
    beginCreateOrUpdate(resourceGroupName: string, circuitName: string, peeringName: string, peeringParameters: ExpressRouteCircuitPeering, options?: ExpressRouteCircuitPeeringsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitPeeringsCreateOrUpdateResponse>, ExpressRouteCircuitPeeringsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, circuitName: string, peeringName: string, peeringParameters: ExpressRouteCircuitPeering, options?: ExpressRouteCircuitPeeringsCreateOrUpdateOptionalParams): Promise<ExpressRouteCircuitPeeringsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, circuitName: string, peeringName: string, options?: ExpressRouteCircuitPeeringsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, circuitName: string, peeringName: string, options?: ExpressRouteCircuitPeeringsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, circuitName: string, peeringName: string, options?: ExpressRouteCircuitPeeringsGetOptionalParams): Promise<ExpressRouteCircuitPeeringsGetResponse>;
    list(resourceGroupName: string, circuitName: string, options?: ExpressRouteCircuitPeeringsListOptionalParams): PagedAsyncIterableIterator<ExpressRouteCircuitPeering>;
}

// @public
export interface ExpressRouteCircuitPeeringsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitPeeringsCreateOrUpdateResponse = ExpressRouteCircuitPeering;

// @public
export interface ExpressRouteCircuitPeeringsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteCircuitPeeringsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitPeeringsGetResponse = ExpressRouteCircuitPeering;

// @public
export interface ExpressRouteCircuitPeeringsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitPeeringsListNextResponse = ExpressRouteCircuitPeeringListResult;

// @public
export interface ExpressRouteCircuitPeeringsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitPeeringsListResponse = ExpressRouteCircuitPeeringListResult;

// @public
export type ExpressRouteCircuitPeeringState = string;

// @public
export interface ExpressRouteCircuitReference {
    id?: string;
}

// @public
export interface ExpressRouteCircuitRoutesTable {
    locPrf?: string;
    network?: string;
    nextHop?: string;
    path?: string;
    weight?: number;
}

// @public
export interface ExpressRouteCircuitRoutesTableSummary {
    as?: number;
    neighbor?: string;
    statePfxRcd?: string;
    upDown?: string;
    v?: number;
}

// @public
export interface ExpressRouteCircuits {
    beginCreateOrUpdate(resourceGroupName: string, circuitName: string, parameters: ExpressRouteCircuit, options?: ExpressRouteCircuitsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitsCreateOrUpdateResponse>, ExpressRouteCircuitsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, circuitName: string, parameters: ExpressRouteCircuit, options?: ExpressRouteCircuitsCreateOrUpdateOptionalParams): Promise<ExpressRouteCircuitsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, circuitName: string, options?: ExpressRouteCircuitsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, circuitName: string, options?: ExpressRouteCircuitsDeleteOptionalParams): Promise<void>;
    beginListArpTable(resourceGroupName: string, circuitName: string, peeringName: string, devicePath: string, options?: ExpressRouteCircuitsListArpTableOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitsListArpTableResponse>, ExpressRouteCircuitsListArpTableResponse>>;
    beginListArpTableAndWait(resourceGroupName: string, circuitName: string, peeringName: string, devicePath: string, options?: ExpressRouteCircuitsListArpTableOptionalParams): Promise<ExpressRouteCircuitsListArpTableResponse>;
    beginListRoutesTable(resourceGroupName: string, circuitName: string, peeringName: string, devicePath: string, options?: ExpressRouteCircuitsListRoutesTableOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitsListRoutesTableResponse>, ExpressRouteCircuitsListRoutesTableResponse>>;
    beginListRoutesTableAndWait(resourceGroupName: string, circuitName: string, peeringName: string, devicePath: string, options?: ExpressRouteCircuitsListRoutesTableOptionalParams): Promise<ExpressRouteCircuitsListRoutesTableResponse>;
    beginListRoutesTableSummary(resourceGroupName: string, circuitName: string, peeringName: string, devicePath: string, options?: ExpressRouteCircuitsListRoutesTableSummaryOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCircuitsListRoutesTableSummaryResponse>, ExpressRouteCircuitsListRoutesTableSummaryResponse>>;
    beginListRoutesTableSummaryAndWait(resourceGroupName: string, circuitName: string, peeringName: string, devicePath: string, options?: ExpressRouteCircuitsListRoutesTableSummaryOptionalParams): Promise<ExpressRouteCircuitsListRoutesTableSummaryResponse>;
    get(resourceGroupName: string, circuitName: string, options?: ExpressRouteCircuitsGetOptionalParams): Promise<ExpressRouteCircuitsGetResponse>;
    getPeeringStats(resourceGroupName: string, circuitName: string, peeringName: string, options?: ExpressRouteCircuitsGetPeeringStatsOptionalParams): Promise<ExpressRouteCircuitsGetPeeringStatsResponse>;
    getStats(resourceGroupName: string, circuitName: string, options?: ExpressRouteCircuitsGetStatsOptionalParams): Promise<ExpressRouteCircuitsGetStatsResponse>;
    list(resourceGroupName: string, options?: ExpressRouteCircuitsListOptionalParams): PagedAsyncIterableIterator<ExpressRouteCircuit>;
    listAll(options?: ExpressRouteCircuitsListAllOptionalParams): PagedAsyncIterableIterator<ExpressRouteCircuit>;
    updateTags(resourceGroupName: string, circuitName: string, parameters: TagsObject, options?: ExpressRouteCircuitsUpdateTagsOptionalParams): Promise<ExpressRouteCircuitsUpdateTagsResponse>;
}

// @public
export interface ExpressRouteCircuitsArpTableListResult {
    nextLink?: string;
    value?: ExpressRouteCircuitArpTable[];
}

// @public
export interface ExpressRouteCircuitsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitsCreateOrUpdateResponse = ExpressRouteCircuit;

// @public
export interface ExpressRouteCircuitsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteCircuitServiceProviderProperties {
    bandwidthInMbps?: number;
    peeringLocation?: string;
    serviceProviderName?: string;
}

// @public
export interface ExpressRouteCircuitsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export interface ExpressRouteCircuitsGetPeeringStatsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsGetPeeringStatsResponse = ExpressRouteCircuitStats;

// @public
export type ExpressRouteCircuitsGetResponse = ExpressRouteCircuit;

// @public
export interface ExpressRouteCircuitsGetStatsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsGetStatsResponse = ExpressRouteCircuitStats;

// @public
export interface ExpressRouteCircuitSku {
    family?: ExpressRouteCircuitSkuFamily;
    name?: string;
    tier?: ExpressRouteCircuitSkuTier;
}

// @public
export type ExpressRouteCircuitSkuFamily = string;

// @public
export type ExpressRouteCircuitSkuTier = string;

// @public
export interface ExpressRouteCircuitsListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsListAllNextResponse = ExpressRouteCircuitListResult;

// @public
export interface ExpressRouteCircuitsListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsListAllResponse = ExpressRouteCircuitListResult;

// @public
export interface ExpressRouteCircuitsListArpTableOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitsListArpTableResponse = ExpressRouteCircuitsArpTableListResult;

// @public
export interface ExpressRouteCircuitsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsListNextResponse = ExpressRouteCircuitListResult;

// @public
export interface ExpressRouteCircuitsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsListResponse = ExpressRouteCircuitListResult;

// @public
export interface ExpressRouteCircuitsListRoutesTableOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitsListRoutesTableResponse = ExpressRouteCircuitsRoutesTableListResult;

// @public
export interface ExpressRouteCircuitsListRoutesTableSummaryOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCircuitsListRoutesTableSummaryResponse = ExpressRouteCircuitsRoutesTableSummaryListResult;

// @public
export interface ExpressRouteCircuitsRoutesTableListResult {
    nextLink?: string;
    value?: ExpressRouteCircuitRoutesTable[];
}

// @public
export interface ExpressRouteCircuitsRoutesTableSummaryListResult {
    nextLink?: string;
    value?: ExpressRouteCircuitRoutesTableSummary[];
}

// @public
export interface ExpressRouteCircuitStats {
    primarybytesIn?: number;
    primarybytesOut?: number;
    secondarybytesIn?: number;
    secondarybytesOut?: number;
}

// @public
export interface ExpressRouteCircuitsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCircuitsUpdateTagsResponse = ExpressRouteCircuit;

// @public
export type ExpressRouteConnection = SubResource & {
    name: string;
    readonly provisioningState?: ProvisioningState;
    expressRouteCircuitPeering?: ExpressRouteCircuitPeeringId;
    authorizationKey?: string;
    routingWeight?: number;
    enableInternetSecurity?: boolean;
    expressRouteGatewayBypass?: boolean;
    routingConfiguration?: RoutingConfiguration;
};

// @public
export interface ExpressRouteConnectionId {
    readonly id?: string;
}

// @public
export interface ExpressRouteConnectionList {
    value?: ExpressRouteConnection[];
}

// @public
export interface ExpressRouteConnections {
    beginCreateOrUpdate(resourceGroupName: string, expressRouteGatewayName: string, connectionName: string, putExpressRouteConnectionParameters: ExpressRouteConnection, options?: ExpressRouteConnectionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteConnectionsCreateOrUpdateResponse>, ExpressRouteConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, expressRouteGatewayName: string, connectionName: string, putExpressRouteConnectionParameters: ExpressRouteConnection, options?: ExpressRouteConnectionsCreateOrUpdateOptionalParams): Promise<ExpressRouteConnectionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, expressRouteGatewayName: string, connectionName: string, options?: ExpressRouteConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, expressRouteGatewayName: string, connectionName: string, options?: ExpressRouteConnectionsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, expressRouteGatewayName: string, connectionName: string, options?: ExpressRouteConnectionsGetOptionalParams): Promise<ExpressRouteConnectionsGetResponse>;
    list(resourceGroupName: string, expressRouteGatewayName: string, options?: ExpressRouteConnectionsListOptionalParams): Promise<ExpressRouteConnectionsListResponse>;
}

// @public
export interface ExpressRouteConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteConnectionsCreateOrUpdateResponse = ExpressRouteConnection;

// @public
export interface ExpressRouteConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteConnectionsGetResponse = ExpressRouteConnection;

// @public
export interface ExpressRouteConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteConnectionsListResponse = ExpressRouteConnectionList;

// @public
export type ExpressRouteCrossConnection = Resource & {
    readonly etag?: string;
    readonly primaryAzurePort?: string;
    readonly secondaryAzurePort?: string;
    readonly sTag?: number;
    readonly peeringLocation?: string;
    readonly bandwidthInMbps?: number;
    expressRouteCircuit?: ExpressRouteCircuitReference;
    serviceProviderProvisioningState?: ServiceProviderProvisioningState;
    serviceProviderNotes?: string;
    readonly provisioningState?: ProvisioningState;
    peerings?: ExpressRouteCrossConnectionPeering[];
};

// @public
export interface ExpressRouteCrossConnectionListResult {
    readonly nextLink?: string;
    value?: ExpressRouteCrossConnection[];
}

// @public
export type ExpressRouteCrossConnectionPeering = SubResource & {
    name?: string;
    readonly etag?: string;
    peeringType?: ExpressRoutePeeringType;
    state?: ExpressRoutePeeringState;
    readonly azureASN?: number;
    peerASN?: number;
    primaryPeerAddressPrefix?: string;
    secondaryPeerAddressPrefix?: string;
    readonly primaryAzurePort?: string;
    readonly secondaryAzurePort?: string;
    sharedKey?: string;
    vlanId?: number;
    microsoftPeeringConfig?: ExpressRouteCircuitPeeringConfig;
    readonly provisioningState?: ProvisioningState;
    gatewayManagerEtag?: string;
    readonly lastModifiedBy?: string;
    ipv6PeeringConfig?: Ipv6ExpressRouteCircuitPeeringConfig;
};

// @public
export interface ExpressRouteCrossConnectionPeeringList {
    readonly nextLink?: string;
    value?: ExpressRouteCrossConnectionPeering[];
}

// @public
export interface ExpressRouteCrossConnectionPeerings {
    beginCreateOrUpdate(resourceGroupName: string, crossConnectionName: string, peeringName: string, peeringParameters: ExpressRouteCrossConnectionPeering, options?: ExpressRouteCrossConnectionPeeringsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCrossConnectionPeeringsCreateOrUpdateResponse>, ExpressRouteCrossConnectionPeeringsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, crossConnectionName: string, peeringName: string, peeringParameters: ExpressRouteCrossConnectionPeering, options?: ExpressRouteCrossConnectionPeeringsCreateOrUpdateOptionalParams): Promise<ExpressRouteCrossConnectionPeeringsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, crossConnectionName: string, peeringName: string, options?: ExpressRouteCrossConnectionPeeringsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, crossConnectionName: string, peeringName: string, options?: ExpressRouteCrossConnectionPeeringsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, crossConnectionName: string, peeringName: string, options?: ExpressRouteCrossConnectionPeeringsGetOptionalParams): Promise<ExpressRouteCrossConnectionPeeringsGetResponse>;
    list(resourceGroupName: string, crossConnectionName: string, options?: ExpressRouteCrossConnectionPeeringsListOptionalParams): PagedAsyncIterableIterator<ExpressRouteCrossConnectionPeering>;
}

// @public
export interface ExpressRouteCrossConnectionPeeringsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCrossConnectionPeeringsCreateOrUpdateResponse = ExpressRouteCrossConnectionPeering;

// @public
export interface ExpressRouteCrossConnectionPeeringsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteCrossConnectionPeeringsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionPeeringsGetResponse = ExpressRouteCrossConnectionPeering;

// @public
export interface ExpressRouteCrossConnectionPeeringsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionPeeringsListNextResponse = ExpressRouteCrossConnectionPeeringList;

// @public
export interface ExpressRouteCrossConnectionPeeringsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionPeeringsListResponse = ExpressRouteCrossConnectionPeeringList;

// @public
export interface ExpressRouteCrossConnectionRoutesTableSummary {
    asn?: number;
    neighbor?: string;
    stateOrPrefixesReceived?: string;
    upDown?: string;
}

// @public
export interface ExpressRouteCrossConnections {
    beginCreateOrUpdate(resourceGroupName: string, crossConnectionName: string, parameters: ExpressRouteCrossConnection, options?: ExpressRouteCrossConnectionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCrossConnectionsCreateOrUpdateResponse>, ExpressRouteCrossConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, crossConnectionName: string, parameters: ExpressRouteCrossConnection, options?: ExpressRouteCrossConnectionsCreateOrUpdateOptionalParams): Promise<ExpressRouteCrossConnectionsCreateOrUpdateResponse>;
    beginListArpTable(resourceGroupName: string, crossConnectionName: string, peeringName: string, devicePath: string, options?: ExpressRouteCrossConnectionsListArpTableOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCrossConnectionsListArpTableResponse>, ExpressRouteCrossConnectionsListArpTableResponse>>;
    beginListArpTableAndWait(resourceGroupName: string, crossConnectionName: string, peeringName: string, devicePath: string, options?: ExpressRouteCrossConnectionsListArpTableOptionalParams): Promise<ExpressRouteCrossConnectionsListArpTableResponse>;
    beginListRoutesTable(resourceGroupName: string, crossConnectionName: string, peeringName: string, devicePath: string, options?: ExpressRouteCrossConnectionsListRoutesTableOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCrossConnectionsListRoutesTableResponse>, ExpressRouteCrossConnectionsListRoutesTableResponse>>;
    beginListRoutesTableAndWait(resourceGroupName: string, crossConnectionName: string, peeringName: string, devicePath: string, options?: ExpressRouteCrossConnectionsListRoutesTableOptionalParams): Promise<ExpressRouteCrossConnectionsListRoutesTableResponse>;
    beginListRoutesTableSummary(resourceGroupName: string, crossConnectionName: string, peeringName: string, devicePath: string, options?: ExpressRouteCrossConnectionsListRoutesTableSummaryOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteCrossConnectionsListRoutesTableSummaryResponse>, ExpressRouteCrossConnectionsListRoutesTableSummaryResponse>>;
    beginListRoutesTableSummaryAndWait(resourceGroupName: string, crossConnectionName: string, peeringName: string, devicePath: string, options?: ExpressRouteCrossConnectionsListRoutesTableSummaryOptionalParams): Promise<ExpressRouteCrossConnectionsListRoutesTableSummaryResponse>;
    get(resourceGroupName: string, crossConnectionName: string, options?: ExpressRouteCrossConnectionsGetOptionalParams): Promise<ExpressRouteCrossConnectionsGetResponse>;
    list(options?: ExpressRouteCrossConnectionsListOptionalParams): PagedAsyncIterableIterator<ExpressRouteCrossConnection>;
    listByResourceGroup(resourceGroupName: string, options?: ExpressRouteCrossConnectionsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<ExpressRouteCrossConnection>;
    updateTags(resourceGroupName: string, crossConnectionName: string, crossConnectionParameters: TagsObject, options?: ExpressRouteCrossConnectionsUpdateTagsOptionalParams): Promise<ExpressRouteCrossConnectionsUpdateTagsResponse>;
}

// @public
export interface ExpressRouteCrossConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCrossConnectionsCreateOrUpdateResponse = ExpressRouteCrossConnection;

// @public
export interface ExpressRouteCrossConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionsGetResponse = ExpressRouteCrossConnection;

// @public
export interface ExpressRouteCrossConnectionsListArpTableOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCrossConnectionsListArpTableResponse = ExpressRouteCircuitsArpTableListResult;

// @public
export interface ExpressRouteCrossConnectionsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionsListByResourceGroupNextResponse = ExpressRouteCrossConnectionListResult;

// @public
export interface ExpressRouteCrossConnectionsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionsListByResourceGroupResponse = ExpressRouteCrossConnectionListResult;

// @public
export interface ExpressRouteCrossConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionsListNextResponse = ExpressRouteCrossConnectionListResult;

// @public
export interface ExpressRouteCrossConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionsListResponse = ExpressRouteCrossConnectionListResult;

// @public
export interface ExpressRouteCrossConnectionsListRoutesTableOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCrossConnectionsListRoutesTableResponse = ExpressRouteCircuitsRoutesTableListResult;

// @public
export interface ExpressRouteCrossConnectionsListRoutesTableSummaryOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteCrossConnectionsListRoutesTableSummaryResponse = ExpressRouteCrossConnectionsRoutesTableSummaryListResult;

// @public
export interface ExpressRouteCrossConnectionsRoutesTableSummaryListResult {
    readonly nextLink?: string;
    value?: ExpressRouteCrossConnectionRoutesTableSummary[];
}

// @public
export interface ExpressRouteCrossConnectionsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteCrossConnectionsUpdateTagsResponse = ExpressRouteCrossConnection;

// @public
export type ExpressRouteGateway = Resource & {
    readonly etag?: string;
    autoScaleConfiguration?: ExpressRouteGatewayPropertiesAutoScaleConfiguration;
    readonly expressRouteConnections?: ExpressRouteConnection[];
    readonly provisioningState?: ProvisioningState;
    virtualHub?: VirtualHubId;
};

// @public
export interface ExpressRouteGatewayList {
    value?: ExpressRouteGateway[];
}

// @public
export interface ExpressRouteGatewayPropertiesAutoScaleConfiguration {
    bounds?: ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds;
}

// @public
export interface ExpressRouteGatewayPropertiesAutoScaleConfigurationBounds {
    max?: number;
    min?: number;
}

// @public
export interface ExpressRouteGateways {
    beginCreateOrUpdate(resourceGroupName: string, expressRouteGatewayName: string, putExpressRouteGatewayParameters: ExpressRouteGateway, options?: ExpressRouteGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteGatewaysCreateOrUpdateResponse>, ExpressRouteGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, expressRouteGatewayName: string, putExpressRouteGatewayParameters: ExpressRouteGateway, options?: ExpressRouteGatewaysCreateOrUpdateOptionalParams): Promise<ExpressRouteGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, expressRouteGatewayName: string, options?: ExpressRouteGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, expressRouteGatewayName: string, options?: ExpressRouteGatewaysDeleteOptionalParams): Promise<void>;
    beginUpdateTags(resourceGroupName: string, expressRouteGatewayName: string, expressRouteGatewayParameters: TagsObject, options?: ExpressRouteGatewaysUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<ExpressRouteGatewaysUpdateTagsResponse>, ExpressRouteGatewaysUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, expressRouteGatewayName: string, expressRouteGatewayParameters: TagsObject, options?: ExpressRouteGatewaysUpdateTagsOptionalParams): Promise<ExpressRouteGatewaysUpdateTagsResponse>;
    get(resourceGroupName: string, expressRouteGatewayName: string, options?: ExpressRouteGatewaysGetOptionalParams): Promise<ExpressRouteGatewaysGetResponse>;
    listByResourceGroup(resourceGroupName: string, options?: ExpressRouteGatewaysListByResourceGroupOptionalParams): Promise<ExpressRouteGatewaysListByResourceGroupResponse>;
    listBySubscription(options?: ExpressRouteGatewaysListBySubscriptionOptionalParams): Promise<ExpressRouteGatewaysListBySubscriptionResponse>;
}

// @public
export interface ExpressRouteGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteGatewaysCreateOrUpdateResponse = ExpressRouteGateway;

// @public
export interface ExpressRouteGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ExpressRouteGatewaysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteGatewaysGetResponse = ExpressRouteGateway;

// @public
export interface ExpressRouteGatewaysListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteGatewaysListByResourceGroupResponse = ExpressRouteGatewayList;

// @public
export interface ExpressRouteGatewaysListBySubscriptionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteGatewaysListBySubscriptionResponse = ExpressRouteGatewayList;

// @public
export interface ExpressRouteGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRouteGatewaysUpdateTagsResponse = ExpressRouteGateway;

// @public
export type ExpressRouteLink = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly routerName?: string;
    readonly interfaceName?: string;
    readonly patchPanelId?: string;
    readonly rackId?: string;
    readonly connectorType?: ExpressRouteLinkConnectorType;
    adminState?: ExpressRouteLinkAdminState;
    readonly provisioningState?: ProvisioningState;
    macSecConfig?: ExpressRouteLinkMacSecConfig;
};

// @public
export type ExpressRouteLinkAdminState = string;

// @public
export type ExpressRouteLinkConnectorType = string;

// @public
export interface ExpressRouteLinkListResult {
    nextLink?: string;
    value?: ExpressRouteLink[];
}

// @public
export type ExpressRouteLinkMacSecCipher = string;

// @public
export interface ExpressRouteLinkMacSecConfig {
    cakSecretIdentifier?: string;
    cipher?: ExpressRouteLinkMacSecCipher;
    cknSecretIdentifier?: string;
    sciState?: ExpressRouteLinkMacSecSciState;
}

// @public
export type ExpressRouteLinkMacSecSciState = string;

// @public
export interface ExpressRouteLinks {
    get(resourceGroupName: string, expressRoutePortName: string, linkName: string, options?: ExpressRouteLinksGetOptionalParams): Promise<ExpressRouteLinksGetResponse>;
    list(resourceGroupName: string, expressRoutePortName: string, options?: ExpressRouteLinksListOptionalParams): PagedAsyncIterableIterator<ExpressRouteLink>;
}

// @public
export interface ExpressRouteLinksGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteLinksGetResponse = ExpressRouteLink;

// @public
export interface ExpressRouteLinksListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteLinksListNextResponse = ExpressRouteLinkListResult;

// @public
export interface ExpressRouteLinksListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteLinksListResponse = ExpressRouteLinkListResult;

// @public
export type ExpressRoutePeeringState = string;

// @public
export type ExpressRoutePeeringType = string;

// @public
export type ExpressRoutePort = Resource & {
    readonly etag?: string;
    identity?: ManagedServiceIdentity;
    peeringLocation?: string;
    bandwidthInGbps?: number;
    readonly provisionedBandwidthInGbps?: number;
    readonly mtu?: string;
    encapsulation?: ExpressRoutePortsEncapsulation;
    readonly etherType?: string;
    readonly allocationDate?: string;
    links?: ExpressRouteLink[];
    readonly circuits?: SubResource[];
    readonly provisioningState?: ProvisioningState;
    readonly resourceGuid?: string;
};

// @public
export interface ExpressRoutePortListResult {
    nextLink?: string;
    value?: ExpressRoutePort[];
}

// @public
export interface ExpressRoutePorts {
    beginCreateOrUpdate(resourceGroupName: string, expressRoutePortName: string, parameters: ExpressRoutePort, options?: ExpressRoutePortsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ExpressRoutePortsCreateOrUpdateResponse>, ExpressRoutePortsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, expressRoutePortName: string, parameters: ExpressRoutePort, options?: ExpressRoutePortsCreateOrUpdateOptionalParams): Promise<ExpressRoutePortsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, expressRoutePortName: string, options?: ExpressRoutePortsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, expressRoutePortName: string, options?: ExpressRoutePortsDeleteOptionalParams): Promise<void>;
    generateLOA(resourceGroupName: string, expressRoutePortName: string, request: GenerateExpressRoutePortsLOARequest, options?: ExpressRoutePortsGenerateLOAOptionalParams): Promise<ExpressRoutePortsGenerateLOAResponse>;
    get(resourceGroupName: string, expressRoutePortName: string, options?: ExpressRoutePortsGetOptionalParams): Promise<ExpressRoutePortsGetResponse>;
    list(options?: ExpressRoutePortsListOptionalParams): PagedAsyncIterableIterator<ExpressRoutePort>;
    listByResourceGroup(resourceGroupName: string, options?: ExpressRoutePortsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<ExpressRoutePort>;
    updateTags(resourceGroupName: string, expressRoutePortName: string, parameters: TagsObject, options?: ExpressRoutePortsUpdateTagsOptionalParams): Promise<ExpressRoutePortsUpdateTagsResponse>;
}

// @public
export interface ExpressRoutePortsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRoutePortsCreateOrUpdateResponse = ExpressRoutePort;

// @public
export interface ExpressRoutePortsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ExpressRoutePortsEncapsulation = string;

// @public
export interface ExpressRoutePortsGenerateLOAOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsGenerateLOAResponse = GenerateExpressRoutePortsLOAResult;

// @public
export interface ExpressRoutePortsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsGetResponse = ExpressRoutePort;

// @public
export interface ExpressRoutePortsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsListByResourceGroupNextResponse = ExpressRoutePortListResult;

// @public
export interface ExpressRoutePortsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsListByResourceGroupResponse = ExpressRoutePortListResult;

// @public
export interface ExpressRoutePortsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsListNextResponse = ExpressRoutePortListResult;

// @public
export interface ExpressRoutePortsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsListResponse = ExpressRoutePortListResult;

// @public
export type ExpressRoutePortsLocation = Resource & {
    readonly address?: string;
    readonly contact?: string;
    availableBandwidths?: ExpressRoutePortsLocationBandwidths[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ExpressRoutePortsLocationBandwidths {
    readonly offerName?: string;
    readonly valueInGbps?: number;
}

// @public
export interface ExpressRoutePortsLocationListResult {
    nextLink?: string;
    value?: ExpressRoutePortsLocation[];
}

// @public
export interface ExpressRoutePortsLocations {
    get(locationName: string, options?: ExpressRoutePortsLocationsGetOptionalParams): Promise<ExpressRoutePortsLocationsGetResponse>;
    list(options?: ExpressRoutePortsLocationsListOptionalParams): PagedAsyncIterableIterator<ExpressRoutePortsLocation>;
}

// @public
export interface ExpressRoutePortsLocationsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsLocationsGetResponse = ExpressRoutePortsLocation;

// @public
export interface ExpressRoutePortsLocationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsLocationsListNextResponse = ExpressRoutePortsLocationListResult;

// @public
export interface ExpressRoutePortsLocationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsLocationsListResponse = ExpressRoutePortsLocationListResult;

// @public
export interface ExpressRoutePortsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRoutePortsUpdateTagsResponse = ExpressRoutePort;

// @public
export type ExpressRouteServiceProvider = Resource & {
    peeringLocations?: string[];
    bandwidthsOffered?: ExpressRouteServiceProviderBandwidthsOffered[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ExpressRouteServiceProviderBandwidthsOffered {
    offerName?: string;
    valueInMbps?: number;
}

// @public
export interface ExpressRouteServiceProviderListResult {
    nextLink?: string;
    value?: ExpressRouteServiceProvider[];
}

// @public
export interface ExpressRouteServiceProviders {
    list(options?: ExpressRouteServiceProvidersListOptionalParams): PagedAsyncIterableIterator<ExpressRouteServiceProvider>;
}

// @public
export interface ExpressRouteServiceProvidersListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteServiceProvidersListNextResponse = ExpressRouteServiceProviderListResult;

// @public
export interface ExpressRouteServiceProvidersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ExpressRouteServiceProvidersListResponse = ExpressRouteServiceProviderListResult;

// @public
export interface ExtendedLocation {
    name?: string;
    type?: ExtendedLocationTypes;
}

// @public
export type ExtendedLocationTypes = string;

// @public
export interface FilterItems {
    field?: string;
    values?: string[];
}

// @public
export interface FirewallPolicies {
    beginCreateOrUpdate(resourceGroupName: string, firewallPolicyName: string, parameters: FirewallPolicy, options?: FirewallPoliciesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<FirewallPoliciesCreateOrUpdateResponse>, FirewallPoliciesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, firewallPolicyName: string, parameters: FirewallPolicy, options?: FirewallPoliciesCreateOrUpdateOptionalParams): Promise<FirewallPoliciesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, firewallPolicyName: string, options?: FirewallPoliciesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, firewallPolicyName: string, options?: FirewallPoliciesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, firewallPolicyName: string, options?: FirewallPoliciesGetOptionalParams): Promise<FirewallPoliciesGetResponse>;
    list(resourceGroupName: string, options?: FirewallPoliciesListOptionalParams): PagedAsyncIterableIterator<FirewallPolicy>;
    listAll(options?: FirewallPoliciesListAllOptionalParams): PagedAsyncIterableIterator<FirewallPolicy>;
}

// @public
export interface FirewallPoliciesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type FirewallPoliciesCreateOrUpdateResponse = FirewallPolicy;

// @public
export interface FirewallPoliciesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface FirewallPoliciesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type FirewallPoliciesGetResponse = FirewallPolicy;

// @public
export interface FirewallPoliciesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPoliciesListAllNextResponse = FirewallPolicyListResult;

// @public
export interface FirewallPoliciesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPoliciesListAllResponse = FirewallPolicyListResult;

// @public
export interface FirewallPoliciesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPoliciesListNextResponse = FirewallPolicyListResult;

// @public
export interface FirewallPoliciesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPoliciesListResponse = FirewallPolicyListResult;

// @public
export type FirewallPolicy = Resource & {
    readonly etag?: string;
    identity?: ManagedServiceIdentity;
    readonly ruleCollectionGroups?: SubResource[];
    readonly provisioningState?: ProvisioningState;
    basePolicy?: SubResource;
    readonly firewalls?: SubResource[];
    readonly childPolicies?: SubResource[];
    threatIntelMode?: AzureFirewallThreatIntelMode;
    threatIntelWhitelist?: FirewallPolicyThreatIntelWhitelist;
    insights?: FirewallPolicyInsights;
    snat?: FirewallPolicySnat;
    sql?: FirewallPolicySQL;
    dnsSettings?: DnsSettings;
    explicitProxySettings?: ExplicitProxySettings;
    intrusionDetection?: FirewallPolicyIntrusionDetection;
    transportSecurity?: FirewallPolicyTransportSecurity;
    sku?: FirewallPolicySku;
};

// @public
export interface FirewallPolicyCertificateAuthority {
    keyVaultSecretId?: string;
    name?: string;
}

// @public
export type FirewallPolicyFilterRuleCollection = FirewallPolicyRuleCollection & {
    ruleCollectionType: "FirewallPolicyFilterRuleCollection";
    action?: FirewallPolicyFilterRuleCollectionAction;
    rules?: FirewallPolicyRuleUnion[];
};

// @public
export interface FirewallPolicyFilterRuleCollectionAction {
    type?: FirewallPolicyFilterRuleCollectionActionType;
}

// @public
export type FirewallPolicyFilterRuleCollectionActionType = string;

// @public
export interface FirewallPolicyIdpsSignatures {
    list(resourceGroupName: string, firewallPolicyName: string, parameters: IdpsQueryObject, options?: FirewallPolicyIdpsSignaturesListOptionalParams): Promise<FirewallPolicyIdpsSignaturesListResponse>;
}

// @public
export interface FirewallPolicyIdpsSignaturesFilterValues {
    list(resourceGroupName: string, firewallPolicyName: string, parameters: SignatureOverridesFilterValuesQuery, options?: FirewallPolicyIdpsSignaturesFilterValuesListOptionalParams): Promise<FirewallPolicyIdpsSignaturesFilterValuesListResponse>;
}

// @public
export interface FirewallPolicyIdpsSignaturesFilterValuesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyIdpsSignaturesFilterValuesListResponse = SignatureOverridesFilterValuesResponse;

// @public
export interface FirewallPolicyIdpsSignaturesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyIdpsSignaturesListResponse = QueryResults;

// @public
export interface FirewallPolicyIdpsSignaturesOverrides {
    get(resourceGroupName: string, firewallPolicyName: string, options?: FirewallPolicyIdpsSignaturesOverridesGetOptionalParams): Promise<FirewallPolicyIdpsSignaturesOverridesGetResponse>;
    list(resourceGroupName: string, firewallPolicyName: string, options?: FirewallPolicyIdpsSignaturesOverridesListOptionalParams): Promise<FirewallPolicyIdpsSignaturesOverridesListResponse>;
    patch(resourceGroupName: string, firewallPolicyName: string, parameters: SignaturesOverrides, options?: FirewallPolicyIdpsSignaturesOverridesPatchOptionalParams): Promise<FirewallPolicyIdpsSignaturesOverridesPatchResponse>;
    put(resourceGroupName: string, firewallPolicyName: string, parameters: SignaturesOverrides, options?: FirewallPolicyIdpsSignaturesOverridesPutOptionalParams): Promise<FirewallPolicyIdpsSignaturesOverridesPutResponse>;
}

// @public
export interface FirewallPolicyIdpsSignaturesOverridesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyIdpsSignaturesOverridesGetResponse = SignaturesOverrides;

// @public
export interface FirewallPolicyIdpsSignaturesOverridesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyIdpsSignaturesOverridesListResponse = SignaturesOverridesList;

// @public
export interface FirewallPolicyIdpsSignaturesOverridesPatchOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyIdpsSignaturesOverridesPatchResponse = SignaturesOverrides;

// @public
export interface FirewallPolicyIdpsSignaturesOverridesPutOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyIdpsSignaturesOverridesPutResponse = SignaturesOverrides;

// @public
export interface FirewallPolicyInsights {
    isEnabled?: boolean;
    logAnalyticsResources?: FirewallPolicyLogAnalyticsResources;
    retentionDays?: number;
}

// @public
export interface FirewallPolicyIntrusionDetection {
    configuration?: FirewallPolicyIntrusionDetectionConfiguration;
    mode?: FirewallPolicyIntrusionDetectionStateType;
}

// @public
export interface FirewallPolicyIntrusionDetectionBypassTrafficSpecifications {
    description?: string;
    destinationAddresses?: string[];
    destinationIpGroups?: string[];
    destinationPorts?: string[];
    name?: string;
    protocol?: FirewallPolicyIntrusionDetectionProtocol;
    sourceAddresses?: string[];
    sourceIpGroups?: string[];
}

// @public
export interface FirewallPolicyIntrusionDetectionConfiguration {
    bypassTrafficSettings?: FirewallPolicyIntrusionDetectionBypassTrafficSpecifications[];
    signatureOverrides?: FirewallPolicyIntrusionDetectionSignatureSpecification[];
}

// @public
export type FirewallPolicyIntrusionDetectionProtocol = string;

// @public
export interface FirewallPolicyIntrusionDetectionSignatureSpecification {
    id?: string;
    mode?: FirewallPolicyIntrusionDetectionStateType;
}

// @public
export type FirewallPolicyIntrusionDetectionStateType = string;

// @public
export interface FirewallPolicyListResult {
    nextLink?: string;
    value?: FirewallPolicy[];
}

// @public
export interface FirewallPolicyLogAnalyticsResources {
    defaultWorkspaceId?: SubResource;
    workspaces?: FirewallPolicyLogAnalyticsWorkspace[];
}

// @public
export interface FirewallPolicyLogAnalyticsWorkspace {
    region?: string;
    workspaceId?: SubResource;
}

// @public
export type FirewallPolicyNatRuleCollection = FirewallPolicyRuleCollection & {
    ruleCollectionType: "FirewallPolicyNatRuleCollection";
    action?: FirewallPolicyNatRuleCollectionAction;
    rules?: FirewallPolicyRuleUnion[];
};

// @public
export interface FirewallPolicyNatRuleCollectionAction {
    type?: FirewallPolicyNatRuleCollectionActionType;
}

// @public
export type FirewallPolicyNatRuleCollectionActionType = string;

// @public
export interface FirewallPolicyRule {
    description?: string;
    name?: string;
    ruleType: "ApplicationRule" | "NatRule" | "NetworkRule";
}

// @public
export interface FirewallPolicyRuleApplicationProtocol {
    port?: number;
    protocolType?: FirewallPolicyRuleApplicationProtocolType;
}

// @public
export type FirewallPolicyRuleApplicationProtocolType = string;

// @public
export interface FirewallPolicyRuleCollection {
    name?: string;
    priority?: number;
    ruleCollectionType: "FirewallPolicyNatRuleCollection" | "FirewallPolicyFilterRuleCollection";
}

// @public
export type FirewallPolicyRuleCollectionGroup = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    priority?: number;
    ruleCollections?: FirewallPolicyRuleCollectionUnion[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface FirewallPolicyRuleCollectionGroupListResult {
    nextLink?: string;
    value?: FirewallPolicyRuleCollectionGroup[];
}

// @public
export interface FirewallPolicyRuleCollectionGroups {
    beginCreateOrUpdate(resourceGroupName: string, firewallPolicyName: string, ruleCollectionGroupName: string, parameters: FirewallPolicyRuleCollectionGroup, options?: FirewallPolicyRuleCollectionGroupsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<FirewallPolicyRuleCollectionGroupsCreateOrUpdateResponse>, FirewallPolicyRuleCollectionGroupsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, firewallPolicyName: string, ruleCollectionGroupName: string, parameters: FirewallPolicyRuleCollectionGroup, options?: FirewallPolicyRuleCollectionGroupsCreateOrUpdateOptionalParams): Promise<FirewallPolicyRuleCollectionGroupsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, firewallPolicyName: string, ruleCollectionGroupName: string, options?: FirewallPolicyRuleCollectionGroupsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, firewallPolicyName: string, ruleCollectionGroupName: string, options?: FirewallPolicyRuleCollectionGroupsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, firewallPolicyName: string, ruleCollectionGroupName: string, options?: FirewallPolicyRuleCollectionGroupsGetOptionalParams): Promise<FirewallPolicyRuleCollectionGroupsGetResponse>;
    list(resourceGroupName: string, firewallPolicyName: string, options?: FirewallPolicyRuleCollectionGroupsListOptionalParams): PagedAsyncIterableIterator<FirewallPolicyRuleCollectionGroup>;
}

// @public
export interface FirewallPolicyRuleCollectionGroupsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type FirewallPolicyRuleCollectionGroupsCreateOrUpdateResponse = FirewallPolicyRuleCollectionGroup;

// @public
export interface FirewallPolicyRuleCollectionGroupsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface FirewallPolicyRuleCollectionGroupsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyRuleCollectionGroupsGetResponse = FirewallPolicyRuleCollectionGroup;

// @public
export interface FirewallPolicyRuleCollectionGroupsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyRuleCollectionGroupsListNextResponse = FirewallPolicyRuleCollectionGroupListResult;

// @public
export interface FirewallPolicyRuleCollectionGroupsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FirewallPolicyRuleCollectionGroupsListResponse = FirewallPolicyRuleCollectionGroupListResult;

// @public
export type FirewallPolicyRuleCollectionType = string;

// @public (undocumented)
export type FirewallPolicyRuleCollectionUnion = FirewallPolicyRuleCollection | FirewallPolicyNatRuleCollection | FirewallPolicyFilterRuleCollection;

// @public
export type FirewallPolicyRuleNetworkProtocol = string;

// @public
export type FirewallPolicyRuleType = string;

// @public (undocumented)
export type FirewallPolicyRuleUnion = FirewallPolicyRule | ApplicationRule | NatRule | NetworkRule;

// @public
export interface FirewallPolicySku {
    tier?: FirewallPolicySkuTier;
}

// @public
export type FirewallPolicySkuTier = string;

// @public
export interface FirewallPolicySnat {
    privateRanges?: string[];
}

// @public
export interface FirewallPolicySQL {
    allowSqlRedirect?: boolean;
}

// @public
export interface FirewallPolicyThreatIntelWhitelist {
    fqdns?: string[];
    ipAddresses?: string[];
}

// @public
export interface FirewallPolicyTransportSecurity {
    certificateAuthority?: FirewallPolicyCertificateAuthority;
}

// @public
export type FlowLog = Resource & {
    readonly etag?: string;
    targetResourceId?: string;
    readonly targetResourceGuid?: string;
    storageId?: string;
    enabled?: boolean;
    retentionPolicy?: RetentionPolicyParameters;
    format?: FlowLogFormatParameters;
    flowAnalyticsConfiguration?: TrafficAnalyticsProperties;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface FlowLogFormatParameters {
    type?: FlowLogFormatType;
    version?: number;
}

// @public
export type FlowLogFormatType = string;

// @public
export interface FlowLogInformation {
    enabled: boolean;
    flowAnalyticsConfiguration?: TrafficAnalyticsProperties;
    format?: FlowLogFormatParameters;
    retentionPolicy?: RetentionPolicyParameters;
    storageId: string;
    targetResourceId: string;
}

// @public
export interface FlowLogListResult {
    readonly nextLink?: string;
    value?: FlowLog[];
}

// @public
export interface FlowLogs {
    beginCreateOrUpdate(resourceGroupName: string, networkWatcherName: string, flowLogName: string, parameters: FlowLog, options?: FlowLogsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<FlowLogsCreateOrUpdateResponse>, FlowLogsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkWatcherName: string, flowLogName: string, parameters: FlowLog, options?: FlowLogsCreateOrUpdateOptionalParams): Promise<FlowLogsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkWatcherName: string, flowLogName: string, options?: FlowLogsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkWatcherName: string, flowLogName: string, options?: FlowLogsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkWatcherName: string, flowLogName: string, options?: FlowLogsGetOptionalParams): Promise<FlowLogsGetResponse>;
    list(resourceGroupName: string, networkWatcherName: string, options?: FlowLogsListOptionalParams): PagedAsyncIterableIterator<FlowLog>;
    updateTags(resourceGroupName: string, networkWatcherName: string, flowLogName: string, parameters: TagsObject, options?: FlowLogsUpdateTagsOptionalParams): Promise<FlowLogsUpdateTagsResponse>;
}

// @public
export interface FlowLogsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type FlowLogsCreateOrUpdateResponse = FlowLog;

// @public
export interface FlowLogsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface FlowLogsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FlowLogsGetResponse = FlowLog;

// @public
export interface FlowLogsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FlowLogsListNextResponse = FlowLogListResult;

// @public
export interface FlowLogsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FlowLogsListResponse = FlowLogListResult;

// @public
export interface FlowLogStatusParameters {
    targetResourceId: string;
}

// @public
export interface FlowLogsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type FlowLogsUpdateTagsResponse = FlowLog;

// @public
export type FrontendIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    zones?: string[];
    readonly inboundNatRules?: SubResource[];
    readonly inboundNatPools?: SubResource[];
    readonly outboundRules?: SubResource[];
    readonly loadBalancingRules?: SubResource[];
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    privateIPAddressVersion?: IPVersion;
    subnet?: Subnet;
    publicIPAddress?: PublicIPAddress;
    publicIPPrefix?: SubResource;
    gatewayLoadBalancer?: SubResource;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface GatewayLoadBalancerTunnelInterface {
    identifier?: number;
    port?: number;
    protocol?: GatewayLoadBalancerTunnelProtocol;
    type?: GatewayLoadBalancerTunnelInterfaceType;
}

// @public
export type GatewayLoadBalancerTunnelInterfaceType = string;

// @public
export type GatewayLoadBalancerTunnelProtocol = string;

// @public
export interface GatewayRoute {
    readonly asPath?: string;
    readonly localAddress?: string;
    readonly network?: string;
    readonly nextHop?: string;
    readonly origin?: string;
    readonly sourcePeer?: string;
    readonly weight?: number;
}

// @public
export interface GatewayRouteListResult {
    value?: GatewayRoute[];
}

// @public
export interface GenerateExpressRoutePortsLOARequest {
    customerName: string;
}

// @public
export interface GenerateExpressRoutePortsLOAResult {
    encodedContent?: string;
}

// @public
export interface GeneratevirtualwanvpnserverconfigurationvpnprofileOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type GeneratevirtualwanvpnserverconfigurationvpnprofileResponse = VpnProfileResponse;

// @public
export interface GetActiveSessionsNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type GetActiveSessionsNextResponse = BastionActiveSessionListResult;

// @public
export interface GetActiveSessionsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type GetActiveSessionsResponse = BastionActiveSessionListResult;

// @public
export interface GetBastionShareableLinkNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type GetBastionShareableLinkNextResponse = BastionShareableLinkListResult;

// @public
export interface GetBastionShareableLinkOptionalParams extends coreClient.OperationOptions {
}

// @public
export type GetBastionShareableLinkResponse = BastionShareableLinkListResult;

// @public
export interface GetVpnSitesConfigurationRequest {
    outputBlobSasUrl: string;
    vpnSites?: string[];
}

// @public
export interface HopLink {
    readonly context?: {
        [propertyName: string]: string;
    };
    readonly issues?: ConnectivityIssue[];
    readonly linkType?: string;
    readonly nextHopId?: string;
    readonly resourceId?: string;
    readonly roundTripTimeAvg?: number;
    readonly roundTripTimeMax?: number;
    readonly roundTripTimeMin?: number;
}

// @public
export interface HttpConfiguration {
    headers?: HttpHeader[];
    method?: HttpMethod;
    validStatusCodes?: number[];
}

// @public
export type HttpConfigurationMethod = string;

// @public
export interface HttpHeader {
    name?: string;
    value?: string;
}

// @public
export type HttpMethod = string;

// @public
export type HubBgpConnectionStatus = string;

// @public
export interface HubIPAddresses {
    privateIPAddress?: string;
    publicIPs?: HubPublicIPAddresses;
}

// @public
export type HubIpConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    subnet?: Subnet;
    publicIPAddress?: PublicIPAddress;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface HubPublicIPAddresses {
    addresses?: AzureFirewallPublicIPAddress[];
    count?: number;
}

// @public
export interface HubRoute {
    destinations: string[];
    destinationType: string;
    name: string;
    nextHop: string;
    nextHopType: string;
}

// @public
export type HubRouteTable = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    routes?: HubRoute[];
    labels?: string[];
    readonly associatedConnections?: string[];
    readonly propagatingConnections?: string[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface HubRouteTables {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, routeTableName: string, routeTableParameters: HubRouteTable, options?: HubRouteTablesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<HubRouteTablesCreateOrUpdateResponse>, HubRouteTablesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, routeTableName: string, routeTableParameters: HubRouteTable, options?: HubRouteTablesCreateOrUpdateOptionalParams): Promise<HubRouteTablesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, routeTableName: string, options?: HubRouteTablesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, routeTableName: string, options?: HubRouteTablesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, routeTableName: string, options?: HubRouteTablesGetOptionalParams): Promise<HubRouteTablesGetResponse>;
    list(resourceGroupName: string, virtualHubName: string, options?: HubRouteTablesListOptionalParams): PagedAsyncIterableIterator<HubRouteTable>;
}

// @public
export interface HubRouteTablesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type HubRouteTablesCreateOrUpdateResponse = HubRouteTable;

// @public
export interface HubRouteTablesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface HubRouteTablesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type HubRouteTablesGetResponse = HubRouteTable;

// @public
export interface HubRouteTablesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type HubRouteTablesListNextResponse = ListHubRouteTablesResult;

// @public
export interface HubRouteTablesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type HubRouteTablesListResponse = ListHubRouteTablesResult;

// @public
export type HubVirtualNetworkConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    remoteVirtualNetwork?: SubResource;
    allowHubToRemoteVnetTransit?: boolean;
    allowRemoteVnetToUseHubVnetGateways?: boolean;
    enableInternetSecurity?: boolean;
    routingConfiguration?: RoutingConfiguration;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface HubVirtualNetworkConnections {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, connectionName: string, hubVirtualNetworkConnectionParameters: HubVirtualNetworkConnection, options?: HubVirtualNetworkConnectionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<HubVirtualNetworkConnectionsCreateOrUpdateResponse>, HubVirtualNetworkConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, connectionName: string, hubVirtualNetworkConnectionParameters: HubVirtualNetworkConnection, options?: HubVirtualNetworkConnectionsCreateOrUpdateOptionalParams): Promise<HubVirtualNetworkConnectionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, connectionName: string, options?: HubVirtualNetworkConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, connectionName: string, options?: HubVirtualNetworkConnectionsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, connectionName: string, options?: HubVirtualNetworkConnectionsGetOptionalParams): Promise<HubVirtualNetworkConnectionsGetResponse>;
    list(resourceGroupName: string, virtualHubName: string, options?: HubVirtualNetworkConnectionsListOptionalParams): PagedAsyncIterableIterator<HubVirtualNetworkConnection>;
}

// @public
export interface HubVirtualNetworkConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type HubVirtualNetworkConnectionsCreateOrUpdateResponse = HubVirtualNetworkConnection;

// @public
export interface HubVirtualNetworkConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface HubVirtualNetworkConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type HubVirtualNetworkConnectionsGetResponse = HubVirtualNetworkConnection;

// @public
export interface HubVirtualNetworkConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type HubVirtualNetworkConnectionsListNextResponse = ListHubVirtualNetworkConnectionsResult;

// @public
export interface HubVirtualNetworkConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type HubVirtualNetworkConnectionsListResponse = ListHubVirtualNetworkConnectionsResult;

// @public
export type HubVirtualNetworkConnectionStatus = string;

// @public
export interface IdpsQueryObject {
    filters?: FilterItems[];
    orderBy?: OrderBy;
    resultsPerPage?: number;
    search?: string;
    skip?: number;
}

// @public
export type IkeEncryption = string;

// @public
export type IkeIntegrity = string;

// @public
export type InboundNatPool = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    frontendIPConfiguration?: SubResource;
    protocol?: TransportProtocol;
    frontendPortRangeStart?: number;
    frontendPortRangeEnd?: number;
    backendPort?: number;
    idleTimeoutInMinutes?: number;
    enableFloatingIP?: boolean;
    enableTcpReset?: boolean;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type InboundNatRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    frontendIPConfiguration?: SubResource;
    readonly backendIPConfiguration?: NetworkInterfaceIPConfiguration;
    protocol?: TransportProtocol;
    frontendPort?: number;
    backendPort?: number;
    idleTimeoutInMinutes?: number;
    enableFloatingIP?: boolean;
    enableTcpReset?: boolean;
    frontendPortRangeStart?: number;
    frontendPortRangeEnd?: number;
    backendAddressPool?: SubResource;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface InboundNatRuleListResult {
    readonly nextLink?: string;
    value?: InboundNatRule[];
}

// @public
export interface InboundNatRulePortMapping {
    readonly backendPort?: number;
    readonly frontendPort?: number;
    readonly inboundNatRuleName?: string;
    readonly protocol?: TransportProtocol;
}

// @public
export interface InboundNatRules {
    beginCreateOrUpdate(resourceGroupName: string, loadBalancerName: string, inboundNatRuleName: string, inboundNatRuleParameters: InboundNatRule, options?: InboundNatRulesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<InboundNatRulesCreateOrUpdateResponse>, InboundNatRulesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, loadBalancerName: string, inboundNatRuleName: string, inboundNatRuleParameters: InboundNatRule, options?: InboundNatRulesCreateOrUpdateOptionalParams): Promise<InboundNatRulesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, loadBalancerName: string, inboundNatRuleName: string, options?: InboundNatRulesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, loadBalancerName: string, inboundNatRuleName: string, options?: InboundNatRulesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, loadBalancerName: string, inboundNatRuleName: string, options?: InboundNatRulesGetOptionalParams): Promise<InboundNatRulesGetResponse>;
    list(resourceGroupName: string, loadBalancerName: string, options?: InboundNatRulesListOptionalParams): PagedAsyncIterableIterator<InboundNatRule>;
}

// @public
export interface InboundNatRulesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type InboundNatRulesCreateOrUpdateResponse = InboundNatRule;

// @public
export interface InboundNatRulesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface InboundNatRulesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type InboundNatRulesGetResponse = InboundNatRule;

// @public
export interface InboundNatRulesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type InboundNatRulesListNextResponse = InboundNatRuleListResult;

// @public
export interface InboundNatRulesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type InboundNatRulesListResponse = InboundNatRuleListResult;

// @public
export type InboundSecurityRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    rules?: InboundSecurityRules[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface InboundSecurityRuleCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type InboundSecurityRuleCreateOrUpdateResponse = InboundSecurityRule;

// @public
export interface InboundSecurityRuleOperations {
    beginCreateOrUpdate(resourceGroupName: string, networkVirtualApplianceName: string, ruleCollectionName: string, parameters: InboundSecurityRule, options?: InboundSecurityRuleCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<InboundSecurityRuleCreateOrUpdateResponse>, InboundSecurityRuleCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkVirtualApplianceName: string, ruleCollectionName: string, parameters: InboundSecurityRule, options?: InboundSecurityRuleCreateOrUpdateOptionalParams): Promise<InboundSecurityRuleCreateOrUpdateResponse>;
}

// @public
export interface InboundSecurityRules {
    destinationPortRange?: number;
    protocol?: InboundSecurityRulesProtocol;
    sourceAddressPrefix?: string;
}

// @public
export type InboundSecurityRulesProtocol = string;

// @public
export interface IPAddressAvailabilityResult {
    available?: boolean;
    availableIPAddresses?: string[];
    isPlatformReserved?: boolean;
}

// @public
export type IpAllocation = Resource & {
    readonly etag?: string;
    readonly subnet?: SubResource;
    readonly virtualNetwork?: SubResource;
    typePropertiesType?: IpAllocationType;
    prefix?: string;
    prefixLength?: number;
    prefixType?: IPVersion;
    ipamAllocationId?: string;
    allocationTags?: {
        [propertyName: string]: string;
    };
};

// @public
export interface IpAllocationListResult {
    nextLink?: string;
    value?: IpAllocation[];
}

// @public
export type IPAllocationMethod = string;

// @public
export interface IpAllocations {
    beginCreateOrUpdate(resourceGroupName: string, ipAllocationName: string, parameters: IpAllocation, options?: IpAllocationsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<IpAllocationsCreateOrUpdateResponse>, IpAllocationsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, ipAllocationName: string, parameters: IpAllocation, options?: IpAllocationsCreateOrUpdateOptionalParams): Promise<IpAllocationsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, ipAllocationName: string, options?: IpAllocationsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, ipAllocationName: string, options?: IpAllocationsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, ipAllocationName: string, options?: IpAllocationsGetOptionalParams): Promise<IpAllocationsGetResponse>;
    list(options?: IpAllocationsListOptionalParams): PagedAsyncIterableIterator<IpAllocation>;
    listByResourceGroup(resourceGroupName: string, options?: IpAllocationsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<IpAllocation>;
    updateTags(resourceGroupName: string, ipAllocationName: string, parameters: TagsObject, options?: IpAllocationsUpdateTagsOptionalParams): Promise<IpAllocationsUpdateTagsResponse>;
}

// @public
export interface IpAllocationsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type IpAllocationsCreateOrUpdateResponse = IpAllocation;

// @public
export interface IpAllocationsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface IpAllocationsGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type IpAllocationsGetResponse = IpAllocation;

// @public
export interface IpAllocationsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpAllocationsListByResourceGroupNextResponse = IpAllocationListResult;

// @public
export interface IpAllocationsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpAllocationsListByResourceGroupResponse = IpAllocationListResult;

// @public
export interface IpAllocationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpAllocationsListNextResponse = IpAllocationListResult;

// @public
export interface IpAllocationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpAllocationsListResponse = IpAllocationListResult;

// @public
export interface IpAllocationsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpAllocationsUpdateTagsResponse = IpAllocation;

// @public
export type IpAllocationType = string;

// @public
export type IPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    subnet?: Subnet;
    publicIPAddress?: PublicIPAddress;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface IPConfigurationBgpPeeringAddress {
    customBgpIpAddresses?: string[];
    readonly defaultBgpIpAddresses?: string[];
    ipconfigurationId?: string;
    readonly tunnelIpAddresses?: string[];
}

// @public
export type IPConfigurationProfile = SubResource & {
    name?: string;
    readonly type?: string;
    readonly etag?: string;
    subnet?: Subnet;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type IpFlowProtocol = string;

// @public
export type IpGroup = Resource & {
    readonly etag?: string;
    readonly provisioningState?: ProvisioningState;
    ipAddresses?: string[];
    readonly firewalls?: SubResource[];
    readonly firewallPolicies?: SubResource[];
};

// @public
export interface IpGroupListResult {
    nextLink?: string;
    value?: IpGroup[];
}

// @public
export interface IpGroups {
    beginCreateOrUpdate(resourceGroupName: string, ipGroupsName: string, parameters: IpGroup, options?: IpGroupsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<IpGroupsCreateOrUpdateResponse>, IpGroupsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, ipGroupsName: string, parameters: IpGroup, options?: IpGroupsCreateOrUpdateOptionalParams): Promise<IpGroupsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, ipGroupsName: string, options?: IpGroupsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, ipGroupsName: string, options?: IpGroupsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, ipGroupsName: string, options?: IpGroupsGetOptionalParams): Promise<IpGroupsGetResponse>;
    list(options?: IpGroupsListOptionalParams): PagedAsyncIterableIterator<IpGroup>;
    listByResourceGroup(resourceGroupName: string, options?: IpGroupsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<IpGroup>;
    updateGroups(resourceGroupName: string, ipGroupsName: string, parameters: TagsObject, options?: IpGroupsUpdateGroupsOptionalParams): Promise<IpGroupsUpdateGroupsResponse>;
}

// @public
export interface IpGroupsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type IpGroupsCreateOrUpdateResponse = IpGroup;

// @public
export interface IpGroupsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface IpGroupsGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type IpGroupsGetResponse = IpGroup;

// @public
export interface IpGroupsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpGroupsListByResourceGroupNextResponse = IpGroupListResult;

// @public
export interface IpGroupsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpGroupsListByResourceGroupResponse = IpGroupListResult;

// @public
export interface IpGroupsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpGroupsListNextResponse = IpGroupListResult;

// @public
export interface IpGroupsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpGroupsListResponse = IpGroupListResult;

// @public
export interface IpGroupsUpdateGroupsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type IpGroupsUpdateGroupsResponse = IpGroup;

// @public
export type IpsecEncryption = string;

// @public
export type IpsecIntegrity = string;

// @public
export interface IpsecPolicy {
    dhGroup: DhGroup;
    ikeEncryption: IkeEncryption;
    ikeIntegrity: IkeIntegrity;
    ipsecEncryption: IpsecEncryption;
    ipsecIntegrity: IpsecIntegrity;
    pfsGroup: PfsGroup;
    saDataSizeKilobytes: number;
    saLifeTimeSeconds: number;
}

// @public
export interface IpTag {
    ipTagType?: string;
    tag?: string;
}

// @public
export interface Ipv6CircuitConnectionConfig {
    addressPrefix?: string;
    readonly circuitConnectionStatus?: CircuitConnectionStatus;
}

// @public
export interface Ipv6ExpressRouteCircuitPeeringConfig {
    microsoftPeeringConfig?: ExpressRouteCircuitPeeringConfig;
    primaryPeerAddressPrefix?: string;
    routeFilter?: SubResource;
    secondaryPeerAddressPrefix?: string;
    state?: ExpressRouteCircuitPeeringState;
}

// @public
export type IPVersion = string;

// @public
export type IssueType = string;

// @public
export enum KnownAccess {
    // (undocumented)
    Allow = "Allow",
    // (undocumented)
    Deny = "Deny"
}

// @public
export enum KnownApplicationGatewayBackendHealthServerHealth {
    // (undocumented)
    Down = "Down",
    // (undocumented)
    Draining = "Draining",
    // (undocumented)
    Partial = "Partial",
    // (undocumented)
    Unknown = "Unknown",
    // (undocumented)
    Up = "Up"
}

// @public
export enum KnownApplicationGatewayCookieBasedAffinity {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownApplicationGatewayCustomErrorStatusCode {
    // (undocumented)
    HttpStatus403 = "HttpStatus403",
    // (undocumented)
    HttpStatus502 = "HttpStatus502"
}

// @public
export enum KnownApplicationGatewayFirewallMode {
    // (undocumented)
    Detection = "Detection",
    // (undocumented)
    Prevention = "Prevention"
}

// @public
export enum KnownApplicationGatewayLoadDistributionAlgorithm {
    // (undocumented)
    IpHash = "IpHash",
    // (undocumented)
    LeastConnections = "LeastConnections",
    // (undocumented)
    RoundRobin = "RoundRobin"
}

// @public
export enum KnownApplicationGatewayOperationalState {
    // (undocumented)
    Running = "Running",
    // (undocumented)
    Starting = "Starting",
    // (undocumented)
    Stopped = "Stopped",
    // (undocumented)
    Stopping = "Stopping"
}

// @public
export enum KnownApplicationGatewayProtocol {
    // (undocumented)
    Http = "Http",
    // (undocumented)
    Https = "Https"
}

// @public
export enum KnownApplicationGatewayRedirectType {
    // (undocumented)
    Found = "Found",
    // (undocumented)
    Permanent = "Permanent",
    // (undocumented)
    SeeOther = "SeeOther",
    // (undocumented)
    Temporary = "Temporary"
}

// @public
export enum KnownApplicationGatewayRequestRoutingRuleType {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    PathBasedRouting = "PathBasedRouting"
}

// @public
export enum KnownApplicationGatewaySkuName {
    // (undocumented)
    StandardLarge = "Standard_Large",
    // (undocumented)
    StandardMedium = "Standard_Medium",
    // (undocumented)
    StandardSmall = "Standard_Small",
    // (undocumented)
    StandardV2 = "Standard_v2",
    // (undocumented)
    WAFLarge = "WAF_Large",
    // (undocumented)
    WAFMedium = "WAF_Medium",
    // (undocumented)
    WAFV2 = "WAF_v2"
}

// @public
export enum KnownApplicationGatewaySslCipherSuite {
    // (undocumented)
    TLSDHEDSSWith3DESEDECBCSHA = "TLS_DHE_DSS_WITH_3DES_EDE_CBC_SHA",
    // (undocumented)
    TLSDHEDSSWithAES128CBCSHA = "TLS_DHE_DSS_WITH_AES_128_CBC_SHA",
    // (undocumented)
    TLSDHEDSSWithAES128CBCSHA256 = "TLS_DHE_DSS_WITH_AES_128_CBC_SHA256",
    // (undocumented)
    TLSDHEDSSWithAES256CBCSHA = "TLS_DHE_DSS_WITH_AES_256_CBC_SHA",
    // (undocumented)
    TLSDHEDSSWithAES256CBCSHA256 = "TLS_DHE_DSS_WITH_AES_256_CBC_SHA256",
    // (undocumented)
    TLSDHERSAWithAES128CBCSHA = "TLS_DHE_RSA_WITH_AES_128_CBC_SHA",
    // (undocumented)
    TLSDHERSAWithAES128GCMSHA256 = "TLS_DHE_RSA_WITH_AES_128_GCM_SHA256",
    // (undocumented)
    TLSDHERSAWithAES256CBCSHA = "TLS_DHE_RSA_WITH_AES_256_CBC_SHA",
    // (undocumented)
    TLSDHERSAWithAES256GCMSHA384 = "TLS_DHE_RSA_WITH_AES_256_GCM_SHA384",
    // (undocumented)
    TLSEcdheEcdsaWithAES128CBCSHA = "TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA",
    // (undocumented)
    TLSEcdheEcdsaWithAES128CBCSHA256 = "TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256",
    // (undocumented)
    TLSEcdheEcdsaWithAES128GCMSHA256 = "TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256",
    // (undocumented)
    TLSEcdheEcdsaWithAES256CBCSHA = "TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA",
    // (undocumented)
    TLSEcdheEcdsaWithAES256CBCSHA384 = "TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA384",
    // (undocumented)
    TLSEcdheEcdsaWithAES256GCMSHA384 = "TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384",
    // (undocumented)
    TLSEcdheRSAWithAES128CBCSHA = "TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA",
    // (undocumented)
    TLSEcdheRSAWithAES128CBCSHA256 = "TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256",
    // (undocumented)
    TLSEcdheRSAWithAES128GCMSHA256 = "TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256",
    // (undocumented)
    TLSEcdheRSAWithAES256CBCSHA = "TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA",
    // (undocumented)
    TLSEcdheRSAWithAES256CBCSHA384 = "TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384",
    // (undocumented)
    TLSEcdheRSAWithAES256GCMSHA384 = "TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384",
    // (undocumented)
    TLSRSAWith3DESEDECBCSHA = "TLS_RSA_WITH_3DES_EDE_CBC_SHA",
    // (undocumented)
    TLSRSAWithAES128CBCSHA = "TLS_RSA_WITH_AES_128_CBC_SHA",
    // (undocumented)
    TLSRSAWithAES128CBCSHA256 = "TLS_RSA_WITH_AES_128_CBC_SHA256",
    // (undocumented)
    TLSRSAWithAES128GCMSHA256 = "TLS_RSA_WITH_AES_128_GCM_SHA256",
    // (undocumented)
    TLSRSAWithAES256CBCSHA = "TLS_RSA_WITH_AES_256_CBC_SHA",
    // (undocumented)
    TLSRSAWithAES256CBCSHA256 = "TLS_RSA_WITH_AES_256_CBC_SHA256",
    // (undocumented)
    TLSRSAWithAES256GCMSHA384 = "TLS_RSA_WITH_AES_256_GCM_SHA384"
}

// @public
export enum KnownApplicationGatewaySslPolicyName {
    // (undocumented)
    AppGwSslPolicy20150501 = "AppGwSslPolicy20150501",
    // (undocumented)
    AppGwSslPolicy20170401 = "AppGwSslPolicy20170401",
    // (undocumented)
    AppGwSslPolicy20170401S = "AppGwSslPolicy20170401S"
}

// @public
export enum KnownApplicationGatewaySslPolicyType {
    // (undocumented)
    Custom = "Custom",
    // (undocumented)
    Predefined = "Predefined"
}

// @public
export enum KnownApplicationGatewaySslProtocol {
    // (undocumented)
    TLSv10 = "TLSv1_0",
    // (undocumented)
    TLSv11 = "TLSv1_1",
    // (undocumented)
    TLSv12 = "TLSv1_2"
}

// @public
export enum KnownApplicationGatewayTier {
    // (undocumented)
    Standard = "Standard",
    // (undocumented)
    StandardV2 = "Standard_v2",
    // (undocumented)
    WAF = "WAF",
    // (undocumented)
    WAFV2 = "WAF_v2"
}

// @public
export enum KnownAssociationType {
    // (undocumented)
    Associated = "Associated",
    // (undocumented)
    Contains = "Contains"
}

// @public
export enum KnownAuthenticationMethod {
    // (undocumented)
    EapmschaPv2 = "EAPMSCHAPv2",
    // (undocumented)
    Eaptls = "EAPTLS"
}

// @public
export enum KnownAuthorizationUseStatus {
    // (undocumented)
    Available = "Available",
    // (undocumented)
    InUse = "InUse"
}

// @public
export enum KnownAzureFirewallApplicationRuleProtocolType {
    // (undocumented)
    Http = "Http",
    // (undocumented)
    Https = "Https",
    // (undocumented)
    Mssql = "Mssql"
}

// @public
export enum KnownAzureFirewallNatRCActionType {
    // (undocumented)
    Dnat = "Dnat",
    // (undocumented)
    Snat = "Snat"
}

// @public
export enum KnownAzureFirewallNetworkRuleProtocol {
    // (undocumented)
    Any = "Any",
    // (undocumented)
    Icmp = "ICMP",
    // (undocumented)
    TCP = "TCP",
    // (undocumented)
    UDP = "UDP"
}

// @public
export enum KnownAzureFirewallRCActionType {
    // (undocumented)
    Allow = "Allow",
    // (undocumented)
    Deny = "Deny"
}

// @public
export enum KnownAzureFirewallSkuName {
    // (undocumented)
    AzfwHub = "AZFW_Hub",
    // (undocumented)
    AzfwVnet = "AZFW_VNet"
}

// @public
export enum KnownAzureFirewallSkuTier {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Premium = "Premium",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownAzureFirewallThreatIntelMode {
    // (undocumented)
    Alert = "Alert",
    // (undocumented)
    Deny = "Deny",
    // (undocumented)
    Off = "Off"
}

// @public
export enum KnownBastionConnectProtocol {
    // (undocumented)
    RDP = "RDP",
    // (undocumented)
    SSH = "SSH"
}

// @public
export enum KnownBastionHostSkuName {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownBgpPeerState {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    Idle = "Idle",
    // (undocumented)
    Stopped = "Stopped",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownCircuitConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    Disconnected = "Disconnected"
}

// @public
export enum KnownCommissionedState {
    // (undocumented)
    Commissioned = "Commissioned",
    // (undocumented)
    Commissioning = "Commissioning",
    // (undocumented)
    Decommissioning = "Decommissioning",
    // (undocumented)
    Deprovisioning = "Deprovisioning",
    // (undocumented)
    Provisioned = "Provisioned",
    // (undocumented)
    Provisioning = "Provisioning"
}

// @public
export enum KnownConnectionMonitorEndpointFilterItemType {
    // (undocumented)
    AgentAddress = "AgentAddress"
}

// @public
export enum KnownConnectionMonitorEndpointFilterType {
    // (undocumented)
    Include = "Include"
}

// @public
export enum KnownConnectionMonitorSourceStatus {
    // (undocumented)
    Active = "Active",
    // (undocumented)
    Inactive = "Inactive",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownConnectionMonitorTestConfigurationProtocol {
    // (undocumented)
    Http = "Http",
    // (undocumented)
    Icmp = "Icmp",
    // (undocumented)
    Tcp = "Tcp"
}

// @public
export enum KnownConnectionMonitorType {
    // (undocumented)
    MultiEndpoint = "MultiEndpoint",
    // (undocumented)
    SingleSourceDestination = "SingleSourceDestination"
}

// @public
export enum KnownConnectionState {
    // (undocumented)
    Reachable = "Reachable",
    // (undocumented)
    Unknown = "Unknown",
    // (undocumented)
    Unreachable = "Unreachable"
}

// @public
export enum KnownConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Degraded = "Degraded",
    // (undocumented)
    Disconnected = "Disconnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownCoverageLevel {
    // (undocumented)
    AboveAverage = "AboveAverage",
    // (undocumented)
    Average = "Average",
    // (undocumented)
    BelowAverage = "BelowAverage",
    // (undocumented)
    Default = "Default",
    // (undocumented)
    Full = "Full",
    // (undocumented)
    Low = "Low"
}

// @public
export enum KnownDdosCustomPolicyProtocol {
    // (undocumented)
    Syn = "Syn",
    // (undocumented)
    Tcp = "Tcp",
    // (undocumented)
    Udp = "Udp"
}

// @public
export enum KnownDdosCustomPolicyTriggerSensitivityOverride {
    // (undocumented)
    Default = "Default",
    // (undocumented)
    High = "High",
    // (undocumented)
    Low = "Low",
    // (undocumented)
    Relaxed = "Relaxed"
}

// @public
export enum KnownDdosSettingsProtectionCoverage {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownDeleteOptions {
    // (undocumented)
    Delete = "Delete",
    // (undocumented)
    Detach = "Detach"
}

// @public
export enum KnownDestinationPortBehavior {
    // (undocumented)
    ListenIfAvailable = "ListenIfAvailable",
    // (undocumented)
    None = "None"
}

// @public
export enum KnownDhGroup {
    // (undocumented)
    DHGroup1 = "DHGroup1",
    // (undocumented)
    DHGroup14 = "DHGroup14",
    // (undocumented)
    DHGroup2 = "DHGroup2",
    // (undocumented)
    DHGroup2048 = "DHGroup2048",
    // (undocumented)
    DHGroup24 = "DHGroup24",
    // (undocumented)
    ECP256 = "ECP256",
    // (undocumented)
    ECP384 = "ECP384",
    // (undocumented)
    None = "None"
}

// @public
export enum KnownDirection {
    // (undocumented)
    Inbound = "Inbound",
    // (undocumented)
    Outbound = "Outbound"
}

// @public
export enum KnownEffectiveRouteSource {
    // (undocumented)
    Default = "Default",
    // (undocumented)
    Unknown = "Unknown",
    // (undocumented)
    User = "User",
    // (undocumented)
    VirtualNetworkGateway = "VirtualNetworkGateway"
}

// @public
export enum KnownEffectiveRouteState {
    // (undocumented)
    Active = "Active",
    // (undocumented)
    Invalid = "Invalid"
}

// @public
export enum KnownEffectiveSecurityRuleProtocol {
    // (undocumented)
    All = "All",
    // (undocumented)
    Tcp = "Tcp",
    // (undocumented)
    Udp = "Udp"
}

// @public
export enum KnownEndpointType {
    // (undocumented)
    AzureSubnet = "AzureSubnet",
    // (undocumented)
    AzureVM = "AzureVM",
    // (undocumented)
    AzureVNet = "AzureVNet",
    // (undocumented)
    ExternalAddress = "ExternalAddress",
    // (undocumented)
    MMAWorkspaceMachine = "MMAWorkspaceMachine",
    // (undocumented)
    MMAWorkspaceNetwork = "MMAWorkspaceNetwork"
}

// @public
export enum KnownEnum69 {
    // (undocumented)
    One = 1,
    // (undocumented)
    Two = 2,
    // (undocumented)
    Zero = 0
}

// @public
export enum KnownEnum70 {
    // (undocumented)
    One = 1,
    // (undocumented)
    Three = 3,
    // (undocumented)
    Two = 2
}

// @public
export enum KnownEnum71 {
    // (undocumented)
    One = 1,
    // (undocumented)
    Two = 2,
    // (undocumented)
    Zero = 0
}

// @public
export enum KnownEvaluationState {
    // (undocumented)
    Completed = "Completed",
    // (undocumented)
    InProgress = "InProgress",
    // (undocumented)
    NotStarted = "NotStarted"
}

// @public
export enum KnownExpressRouteCircuitPeeringAdvertisedPublicPrefixState {
    // (undocumented)
    Configured = "Configured",
    // (undocumented)
    Configuring = "Configuring",
    // (undocumented)
    NotConfigured = "NotConfigured",
    // (undocumented)
    ValidationNeeded = "ValidationNeeded"
}

// @public
export enum KnownExpressRouteCircuitPeeringState {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownExpressRouteCircuitSkuFamily {
    // (undocumented)
    MeteredData = "MeteredData",
    // (undocumented)
    UnlimitedData = "UnlimitedData"
}

// @public
export enum KnownExpressRouteCircuitSkuTier {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Local = "Local",
    // (undocumented)
    Premium = "Premium",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownExpressRouteLinkAdminState {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownExpressRouteLinkConnectorType {
    // (undocumented)
    LC = "LC",
    // (undocumented)
    SC = "SC"
}

// @public
export enum KnownExpressRouteLinkMacSecCipher {
    // (undocumented)
    GcmAes128 = "GcmAes128",
    // (undocumented)
    GcmAes256 = "GcmAes256",
    // (undocumented)
    GcmAesXpn128 = "GcmAesXpn128",
    // (undocumented)
    GcmAesXpn256 = "GcmAesXpn256"
}

// @public
export enum KnownExpressRouteLinkMacSecSciState {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownExpressRoutePeeringState {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownExpressRoutePeeringType {
    // (undocumented)
    AzurePrivatePeering = "AzurePrivatePeering",
    // (undocumented)
    AzurePublicPeering = "AzurePublicPeering",
    // (undocumented)
    MicrosoftPeering = "MicrosoftPeering"
}

// @public
export enum KnownExpressRoutePortsEncapsulation {
    // (undocumented)
    Dot1Q = "Dot1Q",
    // (undocumented)
    QinQ = "QinQ"
}

// @public
export enum KnownExtendedLocationTypes {
    // (undocumented)
    EdgeZone = "EdgeZone"
}

// @public
export enum KnownFirewallPolicyFilterRuleCollectionActionType {
    // (undocumented)
    Allow = "Allow",
    // (undocumented)
    Deny = "Deny"
}

// @public
export enum KnownFirewallPolicyIntrusionDetectionProtocol {
    // (undocumented)
    ANY = "ANY",
    // (undocumented)
    Icmp = "ICMP",
    // (undocumented)
    TCP = "TCP",
    // (undocumented)
    UDP = "UDP"
}

// @public
export enum KnownFirewallPolicyIntrusionDetectionStateType {
    // (undocumented)
    Alert = "Alert",
    // (undocumented)
    Deny = "Deny",
    // (undocumented)
    Off = "Off"
}

// @public
export enum KnownFirewallPolicyNatRuleCollectionActionType {
    // (undocumented)
    Dnat = "DNAT"
}

// @public
export enum KnownFirewallPolicyRuleApplicationProtocolType {
    // (undocumented)
    Http = "Http",
    // (undocumented)
    Https = "Https"
}

// @public
export enum KnownFirewallPolicyRuleCollectionType {
    // (undocumented)
    FirewallPolicyFilterRuleCollection = "FirewallPolicyFilterRuleCollection",
    // (undocumented)
    FirewallPolicyNatRuleCollection = "FirewallPolicyNatRuleCollection"
}

// @public
export enum KnownFirewallPolicyRuleNetworkProtocol {
    // (undocumented)
    Any = "Any",
    // (undocumented)
    Icmp = "ICMP",
    // (undocumented)
    TCP = "TCP",
    // (undocumented)
    UDP = "UDP"
}

// @public
export enum KnownFirewallPolicyRuleType {
    // (undocumented)
    ApplicationRule = "ApplicationRule",
    // (undocumented)
    NatRule = "NatRule",
    // (undocumented)
    NetworkRule = "NetworkRule"
}

// @public
export enum KnownFirewallPolicySkuTier {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Premium = "Premium",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownFlowLogFormatType {
    // (undocumented)
    Json = "JSON"
}

// @public
export enum KnownGatewayLoadBalancerTunnelInterfaceType {
    // (undocumented)
    External = "External",
    // (undocumented)
    Internal = "Internal",
    // (undocumented)
    None = "None"
}

// @public
export enum KnownGatewayLoadBalancerTunnelProtocol {
    // (undocumented)
    Native = "Native",
    // (undocumented)
    None = "None",
    // (undocumented)
    Vxlan = "VXLAN"
}

// @public
export enum KnownHttpConfigurationMethod {
    // (undocumented)
    Get = "Get",
    // (undocumented)
    Post = "Post"
}

// @public
export enum KnownHttpMethod {
    // (undocumented)
    Get = "Get"
}

// @public
export enum KnownHubBgpConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    NotConnected = "NotConnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownHubVirtualNetworkConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    NotConnected = "NotConnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownIkeEncryption {
    // (undocumented)
    AES128 = "AES128",
    // (undocumented)
    AES192 = "AES192",
    // (undocumented)
    AES256 = "AES256",
    // (undocumented)
    DES = "DES",
    // (undocumented)
    DES3 = "DES3",
    // (undocumented)
    Gcmaes128 = "GCMAES128",
    // (undocumented)
    Gcmaes256 = "GCMAES256"
}

// @public
export enum KnownIkeIntegrity {
    // (undocumented)
    Gcmaes128 = "GCMAES128",
    // (undocumented)
    Gcmaes256 = "GCMAES256",
    // (undocumented)
    MD5 = "MD5",
    // (undocumented)
    SHA1 = "SHA1",
    // (undocumented)
    SHA256 = "SHA256",
    // (undocumented)
    SHA384 = "SHA384"
}

// @public
export enum KnownInboundSecurityRulesProtocol {
    // (undocumented)
    TCP = "TCP",
    // (undocumented)
    UDP = "UDP"
}

// @public
export enum KnownIPAllocationMethod {
    // (undocumented)
    Dynamic = "Dynamic",
    // (undocumented)
    Static = "Static"
}

// @public
export enum KnownIpAllocationType {
    // (undocumented)
    Hypernet = "Hypernet",
    // (undocumented)
    Undefined = "Undefined"
}

// @public
export enum KnownIpFlowProtocol {
    // (undocumented)
    TCP = "TCP",
    // (undocumented)
    UDP = "UDP"
}

// @public
export enum KnownIpsecEncryption {
    // (undocumented)
    AES128 = "AES128",
    // (undocumented)
    AES192 = "AES192",
    // (undocumented)
    AES256 = "AES256",
    // (undocumented)
    DES = "DES",
    // (undocumented)
    DES3 = "DES3",
    // (undocumented)
    Gcmaes128 = "GCMAES128",
    // (undocumented)
    Gcmaes192 = "GCMAES192",
    // (undocumented)
    Gcmaes256 = "GCMAES256",
    // (undocumented)
    None = "None"
}

// @public
export enum KnownIpsecIntegrity {
    // (undocumented)
    Gcmaes128 = "GCMAES128",
    // (undocumented)
    Gcmaes192 = "GCMAES192",
    // (undocumented)
    Gcmaes256 = "GCMAES256",
    // (undocumented)
    MD5 = "MD5",
    // (undocumented)
    SHA1 = "SHA1",
    // (undocumented)
    SHA256 = "SHA256"
}

// @public
export enum KnownIPVersion {
    // (undocumented)
    IPv4 = "IPv4",
    // (undocumented)
    IPv6 = "IPv6"
}

// @public
export enum KnownIssueType {
    // (undocumented)
    AgentStopped = "AgentStopped",
    // (undocumented)
    DnsResolution = "DnsResolution",
    // (undocumented)
    GuestFirewall = "GuestFirewall",
    // (undocumented)
    NetworkSecurityRule = "NetworkSecurityRule",
    // (undocumented)
    Platform = "Platform",
    // (undocumented)
    PortThrottled = "PortThrottled",
    // (undocumented)
    SocketBind = "SocketBind",
    // (undocumented)
    Unknown = "Unknown",
    // (undocumented)
    UserDefinedRoute = "UserDefinedRoute"
}

// @public
export enum KnownLoadBalancerOutboundRuleProtocol {
    // (undocumented)
    All = "All",
    // (undocumented)
    Tcp = "Tcp",
    // (undocumented)
    Udp = "Udp"
}

// @public
export enum KnownLoadBalancerSkuName {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Gateway = "Gateway",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownLoadBalancerSkuTier {
    // (undocumented)
    Global = "Global",
    // (undocumented)
    Regional = "Regional"
}

// @public
export enum KnownLoadDistribution {
    // (undocumented)
    Default = "Default",
    // (undocumented)
    SourceIP = "SourceIP",
    // (undocumented)
    SourceIPProtocol = "SourceIPProtocol"
}

// @public
export enum KnownManagedRuleEnabledState {
    // (undocumented)
    Disabled = "Disabled"
}

// @public
export enum KnownNatGatewaySkuName {
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownNetworkInterfaceMigrationPhase {
    // (undocumented)
    Abort = "Abort",
    // (undocumented)
    Commit = "Commit",
    // (undocumented)
    Committed = "Committed",
    // (undocumented)
    None = "None",
    // (undocumented)
    Prepare = "Prepare"
}

// @public
export enum KnownNetworkInterfaceNicType {
    // (undocumented)
    Elastic = "Elastic",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownNetworkOperationStatus {
    // (undocumented)
    Failed = "Failed",
    // (undocumented)
    InProgress = "InProgress",
    // (undocumented)
    Succeeded = "Succeeded"
}

// @public
export enum KnownNextHopType {
    // (undocumented)
    HyperNetGateway = "HyperNetGateway",
    // (undocumented)
    Internet = "Internet",
    // (undocumented)
    None = "None",
    // (undocumented)
    VirtualAppliance = "VirtualAppliance",
    // (undocumented)
    VirtualNetworkGateway = "VirtualNetworkGateway",
    // (undocumented)
    VnetLocal = "VnetLocal"
}

// @public
export enum KnownOfficeTrafficCategory {
    // (undocumented)
    All = "All",
    // (undocumented)
    None = "None",
    // (undocumented)
    Optimize = "Optimize",
    // (undocumented)
    OptimizeAndAllow = "OptimizeAndAllow"
}

// @public
export enum KnownOrderByOrder {
    // (undocumented)
    Ascending = "Ascending",
    // (undocumented)
    Descending = "Descending"
}

// @public
export enum KnownOrigin {
    // (undocumented)
    Inbound = "Inbound",
    // (undocumented)
    Local = "Local",
    // (undocumented)
    Outbound = "Outbound"
}

// @public
export enum KnownOutputType {
    // (undocumented)
    Workspace = "Workspace"
}

// @public
export enum KnownOwaspCrsExclusionEntryMatchVariable {
    // (undocumented)
    RequestArgKeys = "RequestArgKeys",
    // (undocumented)
    RequestArgNames = "RequestArgNames",
    // (undocumented)
    RequestArgValues = "RequestArgValues",
    // (undocumented)
    RequestCookieKeys = "RequestCookieKeys",
    // (undocumented)
    RequestCookieNames = "RequestCookieNames",
    // (undocumented)
    RequestCookieValues = "RequestCookieValues",
    // (undocumented)
    RequestHeaderKeys = "RequestHeaderKeys",
    // (undocumented)
    RequestHeaderNames = "RequestHeaderNames",
    // (undocumented)
    RequestHeaderValues = "RequestHeaderValues"
}

// @public
export enum KnownOwaspCrsExclusionEntrySelectorMatchOperator {
    // (undocumented)
    Contains = "Contains",
    // (undocumented)
    EndsWith = "EndsWith",
    // (undocumented)
    Equals = "Equals",
    // (undocumented)
    EqualsAny = "EqualsAny",
    // (undocumented)
    StartsWith = "StartsWith"
}

// @public
export enum KnownPcError {
    // (undocumented)
    AgentStopped = "AgentStopped",
    // (undocumented)
    CaptureFailed = "CaptureFailed",
    // (undocumented)
    InternalError = "InternalError",
    // (undocumented)
    LocalFileFailed = "LocalFileFailed",
    // (undocumented)
    StorageFailed = "StorageFailed"
}

// @public
export enum KnownPcProtocol {
    // (undocumented)
    Any = "Any",
    // (undocumented)
    TCP = "TCP",
    // (undocumented)
    UDP = "UDP"
}

// @public
export enum KnownPcStatus {
    // (undocumented)
    Error = "Error",
    // (undocumented)
    NotStarted = "NotStarted",
    // (undocumented)
    Running = "Running",
    // (undocumented)
    Stopped = "Stopped",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownPfsGroup {
    // (undocumented)
    ECP256 = "ECP256",
    // (undocumented)
    ECP384 = "ECP384",
    // (undocumented)
    None = "None",
    // (undocumented)
    PFS1 = "PFS1",
    // (undocumented)
    PFS14 = "PFS14",
    // (undocumented)
    PFS2 = "PFS2",
    // (undocumented)
    PFS2048 = "PFS2048",
    // (undocumented)
    PFS24 = "PFS24",
    // (undocumented)
    Pfsmm = "PFSMM"
}

// @public
export enum KnownPreferredIPVersion {
    // (undocumented)
    IPv4 = "IPv4",
    // (undocumented)
    IPv6 = "IPv6"
}

// @public
export enum KnownPreferredRoutingGateway {
    // (undocumented)
    ExpressRoute = "ExpressRoute",
    // (undocumented)
    None = "None",
    // (undocumented)
    VpnGateway = "VpnGateway"
}

// @public
export enum KnownProbeProtocol {
    // (undocumented)
    Http = "Http",
    // (undocumented)
    Https = "Https",
    // (undocumented)
    Tcp = "Tcp"
}

// @public
export enum KnownProcessorArchitecture {
    // (undocumented)
    Amd64 = "Amd64",
    // (undocumented)
    X86 = "X86"
}

// @public
export enum KnownProtocol {
    // (undocumented)
    Http = "Http",
    // (undocumented)
    Https = "Https",
    // (undocumented)
    Icmp = "Icmp",
    // (undocumented)
    Tcp = "Tcp"
}

// @public
export enum KnownProtocolType {
    // (undocumented)
    Ah = "Ah",
    // (undocumented)
    All = "All",
    // (undocumented)
    DoNotUse = "DoNotUse",
    // (undocumented)
    Esp = "Esp",
    // (undocumented)
    Gre = "Gre",
    // (undocumented)
    Icmp = "Icmp",
    // (undocumented)
    Tcp = "Tcp",
    // (undocumented)
    Udp = "Udp",
    // (undocumented)
    Vxlan = "Vxlan"
}

// @public
export enum KnownProvisioningState {
    // (undocumented)
    Deleting = "Deleting",
    // (undocumented)
    Failed = "Failed",
    // (undocumented)
    Succeeded = "Succeeded",
    // (undocumented)
    Updating = "Updating"
}

// @public
export enum KnownPublicIPAddressMigrationPhase {
    // (undocumented)
    Abort = "Abort",
    // (undocumented)
    Commit = "Commit",
    // (undocumented)
    Committed = "Committed",
    // (undocumented)
    None = "None",
    // (undocumented)
    Prepare = "Prepare"
}

// @public
export enum KnownPublicIPAddressSkuName {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownPublicIPAddressSkuTier {
    // (undocumented)
    Global = "Global",
    // (undocumented)
    Regional = "Regional"
}

// @public
export enum KnownPublicIPPrefixSkuName {
    // (undocumented)
    Standard = "Standard"
}

// @public
export enum KnownPublicIPPrefixSkuTier {
    // (undocumented)
    Global = "Global",
    // (undocumented)
    Regional = "Regional"
}

// @public
export enum KnownRouteFilterRuleType {
    // (undocumented)
    Community = "Community"
}

// @public
export enum KnownRouteNextHopType {
    // (undocumented)
    Internet = "Internet",
    // (undocumented)
    None = "None",
    // (undocumented)
    VirtualAppliance = "VirtualAppliance",
    // (undocumented)
    VirtualNetworkGateway = "VirtualNetworkGateway",
    // (undocumented)
    VnetLocal = "VnetLocal"
}

// @public
export enum KnownRoutingState {
    // (undocumented)
    Failed = "Failed",
    // (undocumented)
    None = "None",
    // (undocumented)
    Provisioned = "Provisioned",
    // (undocumented)
    Provisioning = "Provisioning"
}

// @public
export enum KnownSecurityPartnerProviderConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    NotConnected = "NotConnected",
    // (undocumented)
    PartiallyConnected = "PartiallyConnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownSecurityProviderName {
    // (undocumented)
    Checkpoint = "Checkpoint",
    // (undocumented)
    IBoss = "IBoss",
    // (undocumented)
    ZScaler = "ZScaler"
}

// @public
export enum KnownSecurityRuleAccess {
    // (undocumented)
    Allow = "Allow",
    // (undocumented)
    Deny = "Deny"
}

// @public
export enum KnownSecurityRuleDirection {
    // (undocumented)
    Inbound = "Inbound",
    // (undocumented)
    Outbound = "Outbound"
}

// @public
export enum KnownSecurityRuleProtocol {
    // (undocumented)
    Ah = "Ah",
    // (undocumented)
    Asterisk = "*",
    // (undocumented)
    Esp = "Esp",
    // (undocumented)
    Icmp = "Icmp",
    // (undocumented)
    Tcp = "Tcp",
    // (undocumented)
    Udp = "Udp"
}

// @public
export enum KnownServiceProviderProvisioningState {
    // (undocumented)
    Deprovisioning = "Deprovisioning",
    // (undocumented)
    NotProvisioned = "NotProvisioned",
    // (undocumented)
    Provisioned = "Provisioned",
    // (undocumented)
    Provisioning = "Provisioning"
}

// @public
export enum KnownSeverity {
    // (undocumented)
    Error = "Error",
    // (undocumented)
    Warning = "Warning"
}

// @public
export enum KnownSyncRemoteAddressSpace {
    // (undocumented)
    True = "true"
}

// @public
export enum KnownTransportProtocol {
    // (undocumented)
    All = "All",
    // (undocumented)
    Tcp = "Tcp",
    // (undocumented)
    Udp = "Udp"
}

// @public
export enum KnownTunnelConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    NotConnected = "NotConnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownUsageUnit {
    // (undocumented)
    Count = "Count"
}

// @public
export enum KnownVerbosityLevel {
    // (undocumented)
    Full = "Full",
    // (undocumented)
    Minimum = "Minimum",
    // (undocumented)
    Normal = "Normal"
}

// @public
export enum KnownVirtualNetworkEncryptionEnforcement {
    // (undocumented)
    AllowUnencrypted = "AllowUnencrypted",
    // (undocumented)
    DropUnencrypted = "DropUnencrypted"
}

// @public
export enum KnownVirtualNetworkGatewayConnectionMode {
    // (undocumented)
    Default = "Default",
    // (undocumented)
    InitiatorOnly = "InitiatorOnly",
    // (undocumented)
    ResponderOnly = "ResponderOnly"
}

// @public
export enum KnownVirtualNetworkGatewayConnectionProtocol {
    // (undocumented)
    IKEv1 = "IKEv1",
    // (undocumented)
    IKEv2 = "IKEv2"
}

// @public
export enum KnownVirtualNetworkGatewayConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    NotConnected = "NotConnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownVirtualNetworkGatewayConnectionType {
    // (undocumented)
    ExpressRoute = "ExpressRoute",
    // (undocumented)
    IPsec = "IPsec",
    // (undocumented)
    Vnet2Vnet = "Vnet2Vnet",
    // (undocumented)
    VPNClient = "VPNClient"
}

// @public
export enum KnownVirtualNetworkGatewaySkuName {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    ErGw1AZ = "ErGw1AZ",
    // (undocumented)
    ErGw2AZ = "ErGw2AZ",
    // (undocumented)
    ErGw3AZ = "ErGw3AZ",
    // (undocumented)
    HighPerformance = "HighPerformance",
    // (undocumented)
    Standard = "Standard",
    // (undocumented)
    UltraPerformance = "UltraPerformance",
    // (undocumented)
    VpnGw1 = "VpnGw1",
    // (undocumented)
    VpnGw1AZ = "VpnGw1AZ",
    // (undocumented)
    VpnGw2 = "VpnGw2",
    // (undocumented)
    VpnGw2AZ = "VpnGw2AZ",
    // (undocumented)
    VpnGw3 = "VpnGw3",
    // (undocumented)
    VpnGw3AZ = "VpnGw3AZ",
    // (undocumented)
    VpnGw4 = "VpnGw4",
    // (undocumented)
    VpnGw4AZ = "VpnGw4AZ",
    // (undocumented)
    VpnGw5 = "VpnGw5",
    // (undocumented)
    VpnGw5AZ = "VpnGw5AZ"
}

// @public
export enum KnownVirtualNetworkGatewaySkuTier {
    // (undocumented)
    Basic = "Basic",
    // (undocumented)
    ErGw1AZ = "ErGw1AZ",
    // (undocumented)
    ErGw2AZ = "ErGw2AZ",
    // (undocumented)
    ErGw3AZ = "ErGw3AZ",
    // (undocumented)
    HighPerformance = "HighPerformance",
    // (undocumented)
    Standard = "Standard",
    // (undocumented)
    UltraPerformance = "UltraPerformance",
    // (undocumented)
    VpnGw1 = "VpnGw1",
    // (undocumented)
    VpnGw1AZ = "VpnGw1AZ",
    // (undocumented)
    VpnGw2 = "VpnGw2",
    // (undocumented)
    VpnGw2AZ = "VpnGw2AZ",
    // (undocumented)
    VpnGw3 = "VpnGw3",
    // (undocumented)
    VpnGw3AZ = "VpnGw3AZ",
    // (undocumented)
    VpnGw4 = "VpnGw4",
    // (undocumented)
    VpnGw4AZ = "VpnGw4AZ",
    // (undocumented)
    VpnGw5 = "VpnGw5",
    // (undocumented)
    VpnGw5AZ = "VpnGw5AZ"
}

// @public
export enum KnownVirtualNetworkGatewayType {
    // (undocumented)
    ExpressRoute = "ExpressRoute",
    // (undocumented)
    LocalGateway = "LocalGateway",
    // (undocumented)
    Vpn = "Vpn"
}

// @public
export enum KnownVirtualNetworkPeeringLevel {
    // (undocumented)
    FullyInSync = "FullyInSync",
    // (undocumented)
    LocalAndRemoteNotInSync = "LocalAndRemoteNotInSync",
    // (undocumented)
    LocalNotInSync = "LocalNotInSync",
    // (undocumented)
    RemoteNotInSync = "RemoteNotInSync"
}

// @public
export enum KnownVirtualNetworkPeeringState {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Disconnected = "Disconnected",
    // (undocumented)
    Initiated = "Initiated"
}

// @public
export enum KnownVirtualNetworkPrivateEndpointNetworkPolicies {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownVirtualNetworkPrivateLinkServiceNetworkPolicies {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownVirtualWanSecurityProviderType {
    // (undocumented)
    External = "External",
    // (undocumented)
    Native = "Native"
}

// @public
export enum KnownVpnAuthenticationType {
    // (undocumented)
    AAD = "AAD",
    // (undocumented)
    Certificate = "Certificate",
    // (undocumented)
    Radius = "Radius"
}

// @public
export enum KnownVpnClientProtocol {
    // (undocumented)
    IkeV2 = "IkeV2",
    // (undocumented)
    OpenVPN = "OpenVPN",
    // (undocumented)
    Sstp = "SSTP"
}

// @public
export enum KnownVpnConnectionStatus {
    // (undocumented)
    Connected = "Connected",
    // (undocumented)
    Connecting = "Connecting",
    // (undocumented)
    NotConnected = "NotConnected",
    // (undocumented)
    Unknown = "Unknown"
}

// @public
export enum KnownVpnGatewayGeneration {
    // (undocumented)
    Generation1 = "Generation1",
    // (undocumented)
    Generation2 = "Generation2",
    // (undocumented)
    None = "None"
}

// @public
export enum KnownVpnGatewayTunnelingProtocol {
    // (undocumented)
    IkeV2 = "IkeV2",
    // (undocumented)
    OpenVPN = "OpenVPN"
}

// @public
export enum KnownVpnLinkConnectionMode {
    // (undocumented)
    Default = "Default",
    // (undocumented)
    InitiatorOnly = "InitiatorOnly",
    // (undocumented)
    ResponderOnly = "ResponderOnly"
}

// @public
export enum KnownVpnNatRuleMode {
    // (undocumented)
    EgressSnat = "EgressSnat",
    // (undocumented)
    IngressSnat = "IngressSnat"
}

// @public
export enum KnownVpnNatRuleType {
    // (undocumented)
    Dynamic = "Dynamic",
    // (undocumented)
    Static = "Static"
}

// @public
export enum KnownVpnType {
    // (undocumented)
    PolicyBased = "PolicyBased",
    // (undocumented)
    RouteBased = "RouteBased"
}

// @public
export enum KnownWebApplicationFirewallAction {
    // (undocumented)
    Allow = "Allow",
    // (undocumented)
    Block = "Block",
    // (undocumented)
    Log = "Log"
}

// @public
export enum KnownWebApplicationFirewallEnabledState {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownWebApplicationFirewallMatchVariable {
    // (undocumented)
    PostArgs = "PostArgs",
    // (undocumented)
    QueryString = "QueryString",
    // (undocumented)
    RemoteAddr = "RemoteAddr",
    // (undocumented)
    RequestBody = "RequestBody",
    // (undocumented)
    RequestCookies = "RequestCookies",
    // (undocumented)
    RequestHeaders = "RequestHeaders",
    // (undocumented)
    RequestMethod = "RequestMethod",
    // (undocumented)
    RequestUri = "RequestUri"
}

// @public
export enum KnownWebApplicationFirewallMode {
    // (undocumented)
    Detection = "Detection",
    // (undocumented)
    Prevention = "Prevention"
}

// @public
export enum KnownWebApplicationFirewallOperator {
    // (undocumented)
    BeginsWith = "BeginsWith",
    // (undocumented)
    Contains = "Contains",
    // (undocumented)
    EndsWith = "EndsWith",
    // (undocumented)
    Equal = "Equal",
    // (undocumented)
    GeoMatch = "GeoMatch",
    // (undocumented)
    GreaterThan = "GreaterThan",
    // (undocumented)
    GreaterThanOrEqual = "GreaterThanOrEqual",
    // (undocumented)
    IPMatch = "IPMatch",
    // (undocumented)
    LessThan = "LessThan",
    // (undocumented)
    LessThanOrEqual = "LessThanOrEqual",
    // (undocumented)
    Regex = "Regex"
}

// @public
export enum KnownWebApplicationFirewallPolicyResourceState {
    // (undocumented)
    Creating = "Creating",
    // (undocumented)
    Deleting = "Deleting",
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Disabling = "Disabling",
    // (undocumented)
    Enabled = "Enabled",
    // (undocumented)
    Enabling = "Enabling"
}

// @public
export enum KnownWebApplicationFirewallRuleType {
    // (undocumented)
    Invalid = "Invalid",
    // (undocumented)
    MatchRule = "MatchRule"
}

// @public
export enum KnownWebApplicationFirewallTransform {
    // (undocumented)
    HtmlEntityDecode = "HtmlEntityDecode",
    // (undocumented)
    Lowercase = "Lowercase",
    // (undocumented)
    RemoveNulls = "RemoveNulls",
    // (undocumented)
    Trim = "Trim",
    // (undocumented)
    UrlDecode = "UrlDecode",
    // (undocumented)
    UrlEncode = "UrlEncode"
}

// @public
export interface ListHubRouteTablesResult {
    nextLink?: string;
    value?: HubRouteTable[];
}

// @public
export interface ListHubVirtualNetworkConnectionsResult {
    nextLink?: string;
    value?: HubVirtualNetworkConnection[];
}

// @public
export interface ListP2SVpnGatewaysResult {
    nextLink?: string;
    value?: P2SVpnGateway[];
}

// @public
export interface ListRoutingIntentResult {
    nextLink?: string;
    value?: RoutingIntent[];
}

// @public
export interface ListVirtualHubBgpConnectionResults {
    nextLink?: string;
    value?: BgpConnection[];
}

// @public
export interface ListVirtualHubIpConfigurationResults {
    nextLink?: string;
    value?: HubIpConfiguration[];
}

// @public
export interface ListVirtualHubRouteTableV2SResult {
    nextLink?: string;
    value?: VirtualHubRouteTableV2[];
}

// @public
export interface ListVirtualHubsResult {
    nextLink?: string;
    value?: VirtualHub[];
}

// @public
export interface ListVirtualNetworkGatewayNatRulesResult {
    nextLink?: string;
    value?: VirtualNetworkGatewayNatRule[];
}

// @public
export interface ListVirtualWANsResult {
    nextLink?: string;
    value?: VirtualWAN[];
}

// @public
export interface ListVpnConnectionsResult {
    nextLink?: string;
    value?: VpnConnection[];
}

// @public
export interface ListVpnGatewayNatRulesResult {
    nextLink?: string;
    value?: VpnGatewayNatRule[];
}

// @public
export interface ListVpnGatewaysResult {
    nextLink?: string;
    value?: VpnGateway[];
}

// @public
export interface ListVpnServerConfigurationsResult {
    nextLink?: string;
    value?: VpnServerConfiguration[];
}

// @public
export interface ListVpnSiteLinkConnectionsResult {
    nextLink?: string;
    value?: VpnSiteLinkConnection[];
}

// @public
export interface ListVpnSiteLinksResult {
    nextLink?: string;
    value?: VpnSiteLink[];
}

// @public
export interface ListVpnSitesResult {
    nextLink?: string;
    value?: VpnSite[];
}

// @public
export type LoadBalancer = Resource & {
    extendedLocation?: ExtendedLocation;
    sku?: LoadBalancerSku;
    readonly etag?: string;
    frontendIPConfigurations?: FrontendIPConfiguration[];
    backendAddressPools?: BackendAddressPool[];
    loadBalancingRules?: LoadBalancingRule[];
    probes?: Probe[];
    inboundNatRules?: InboundNatRule[];
    inboundNatPools?: InboundNatPool[];
    outboundRules?: OutboundRule[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface LoadBalancerBackendAddress {
    readonly inboundNatRulesPortMapping?: NatRulePortMapping[];
    ipAddress?: string;
    loadBalancerFrontendIPConfiguration?: SubResource;
    name?: string;
    readonly networkInterfaceIPConfiguration?: SubResource;
    subnet?: SubResource;
    virtualNetwork?: SubResource;
}

// @public
export interface LoadBalancerBackendAddressPoolListResult {
    readonly nextLink?: string;
    value?: BackendAddressPool[];
}

// @public
export interface LoadBalancerBackendAddressPools {
    beginCreateOrUpdate(resourceGroupName: string, loadBalancerName: string, backendAddressPoolName: string, parameters: BackendAddressPool, options?: LoadBalancerBackendAddressPoolsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<LoadBalancerBackendAddressPoolsCreateOrUpdateResponse>, LoadBalancerBackendAddressPoolsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, loadBalancerName: string, backendAddressPoolName: string, parameters: BackendAddressPool, options?: LoadBalancerBackendAddressPoolsCreateOrUpdateOptionalParams): Promise<LoadBalancerBackendAddressPoolsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, loadBalancerName: string, backendAddressPoolName: string, options?: LoadBalancerBackendAddressPoolsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, loadBalancerName: string, backendAddressPoolName: string, options?: LoadBalancerBackendAddressPoolsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, loadBalancerName: string, backendAddressPoolName: string, options?: LoadBalancerBackendAddressPoolsGetOptionalParams): Promise<LoadBalancerBackendAddressPoolsGetResponse>;
    list(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancerBackendAddressPoolsListOptionalParams): PagedAsyncIterableIterator<BackendAddressPool>;
}

// @public
export interface LoadBalancerBackendAddressPoolsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type LoadBalancerBackendAddressPoolsCreateOrUpdateResponse = BackendAddressPool;

// @public
export interface LoadBalancerBackendAddressPoolsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface LoadBalancerBackendAddressPoolsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerBackendAddressPoolsGetResponse = BackendAddressPool;

// @public
export interface LoadBalancerBackendAddressPoolsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerBackendAddressPoolsListNextResponse = LoadBalancerBackendAddressPoolListResult;

// @public
export interface LoadBalancerBackendAddressPoolsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerBackendAddressPoolsListResponse = LoadBalancerBackendAddressPoolListResult;

// @public
export interface LoadBalancerFrontendIPConfigurationListResult {
    readonly nextLink?: string;
    value?: FrontendIPConfiguration[];
}

// @public
export interface LoadBalancerFrontendIPConfigurations {
    get(resourceGroupName: string, loadBalancerName: string, frontendIPConfigurationName: string, options?: LoadBalancerFrontendIPConfigurationsGetOptionalParams): Promise<LoadBalancerFrontendIPConfigurationsGetResponse>;
    list(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancerFrontendIPConfigurationsListOptionalParams): PagedAsyncIterableIterator<FrontendIPConfiguration>;
}

// @public
export interface LoadBalancerFrontendIPConfigurationsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerFrontendIPConfigurationsGetResponse = FrontendIPConfiguration;

// @public
export interface LoadBalancerFrontendIPConfigurationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerFrontendIPConfigurationsListNextResponse = LoadBalancerFrontendIPConfigurationListResult;

// @public
export interface LoadBalancerFrontendIPConfigurationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerFrontendIPConfigurationsListResponse = LoadBalancerFrontendIPConfigurationListResult;

// @public
export interface LoadBalancerListResult {
    readonly nextLink?: string;
    value?: LoadBalancer[];
}

// @public
export interface LoadBalancerLoadBalancingRuleListResult {
    readonly nextLink?: string;
    value?: LoadBalancingRule[];
}

// @public
export interface LoadBalancerLoadBalancingRules {
    get(resourceGroupName: string, loadBalancerName: string, loadBalancingRuleName: string, options?: LoadBalancerLoadBalancingRulesGetOptionalParams): Promise<LoadBalancerLoadBalancingRulesGetResponse>;
    list(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancerLoadBalancingRulesListOptionalParams): PagedAsyncIterableIterator<LoadBalancingRule>;
}

// @public
export interface LoadBalancerLoadBalancingRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerLoadBalancingRulesGetResponse = LoadBalancingRule;

// @public
export interface LoadBalancerLoadBalancingRulesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerLoadBalancingRulesListNextResponse = LoadBalancerLoadBalancingRuleListResult;

// @public
export interface LoadBalancerLoadBalancingRulesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerLoadBalancingRulesListResponse = LoadBalancerLoadBalancingRuleListResult;

// @public
export interface LoadBalancerNetworkInterfaces {
    list(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancerNetworkInterfacesListOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
}

// @public
export interface LoadBalancerNetworkInterfacesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerNetworkInterfacesListNextResponse = NetworkInterfaceListResult;

// @public
export interface LoadBalancerNetworkInterfacesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerNetworkInterfacesListResponse = NetworkInterfaceListResult;

// @public
export interface LoadBalancerOutboundRuleListResult {
    readonly nextLink?: string;
    value?: OutboundRule[];
}

// @public
export type LoadBalancerOutboundRuleProtocol = string;

// @public
export interface LoadBalancerOutboundRules {
    get(resourceGroupName: string, loadBalancerName: string, outboundRuleName: string, options?: LoadBalancerOutboundRulesGetOptionalParams): Promise<LoadBalancerOutboundRulesGetResponse>;
    list(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancerOutboundRulesListOptionalParams): PagedAsyncIterableIterator<OutboundRule>;
}

// @public
export interface LoadBalancerOutboundRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerOutboundRulesGetResponse = OutboundRule;

// @public
export interface LoadBalancerOutboundRulesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerOutboundRulesListNextResponse = LoadBalancerOutboundRuleListResult;

// @public
export interface LoadBalancerOutboundRulesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerOutboundRulesListResponse = LoadBalancerOutboundRuleListResult;

// @public
export interface LoadBalancerProbeListResult {
    readonly nextLink?: string;
    value?: Probe[];
}

// @public
export interface LoadBalancerProbes {
    get(resourceGroupName: string, loadBalancerName: string, probeName: string, options?: LoadBalancerProbesGetOptionalParams): Promise<LoadBalancerProbesGetResponse>;
    list(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancerProbesListOptionalParams): PagedAsyncIterableIterator<Probe>;
}

// @public
export interface LoadBalancerProbesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerProbesGetResponse = Probe;

// @public
export interface LoadBalancerProbesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerProbesListNextResponse = LoadBalancerProbeListResult;

// @public
export interface LoadBalancerProbesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancerProbesListResponse = LoadBalancerProbeListResult;

// @public
export interface LoadBalancers {
    beginCreateOrUpdate(resourceGroupName: string, loadBalancerName: string, parameters: LoadBalancer, options?: LoadBalancersCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<LoadBalancersCreateOrUpdateResponse>, LoadBalancersCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, loadBalancerName: string, parameters: LoadBalancer, options?: LoadBalancersCreateOrUpdateOptionalParams): Promise<LoadBalancersCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancersDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancersDeleteOptionalParams): Promise<void>;
    beginListInboundNatRulePortMappings(groupName: string, loadBalancerName: string, backendPoolName: string, parameters: QueryInboundNatRulePortMappingRequest, options?: LoadBalancersListInboundNatRulePortMappingsOptionalParams): Promise<PollerLike<PollOperationState<LoadBalancersListInboundNatRulePortMappingsResponse>, LoadBalancersListInboundNatRulePortMappingsResponse>>;
    beginListInboundNatRulePortMappingsAndWait(groupName: string, loadBalancerName: string, backendPoolName: string, parameters: QueryInboundNatRulePortMappingRequest, options?: LoadBalancersListInboundNatRulePortMappingsOptionalParams): Promise<LoadBalancersListInboundNatRulePortMappingsResponse>;
    beginSwapPublicIpAddresses(location: string, parameters: LoadBalancerVipSwapRequest, options?: LoadBalancersSwapPublicIpAddressesOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginSwapPublicIpAddressesAndWait(location: string, parameters: LoadBalancerVipSwapRequest, options?: LoadBalancersSwapPublicIpAddressesOptionalParams): Promise<void>;
    get(resourceGroupName: string, loadBalancerName: string, options?: LoadBalancersGetOptionalParams): Promise<LoadBalancersGetResponse>;
    list(resourceGroupName: string, options?: LoadBalancersListOptionalParams): PagedAsyncIterableIterator<LoadBalancer>;
    listAll(options?: LoadBalancersListAllOptionalParams): PagedAsyncIterableIterator<LoadBalancer>;
    updateTags(resourceGroupName: string, loadBalancerName: string, parameters: TagsObject, options?: LoadBalancersUpdateTagsOptionalParams): Promise<LoadBalancersUpdateTagsResponse>;
}

// @public
export interface LoadBalancersCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type LoadBalancersCreateOrUpdateResponse = LoadBalancer;

// @public
export interface LoadBalancersDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface LoadBalancersGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type LoadBalancersGetResponse = LoadBalancer;

// @public
export interface LoadBalancerSku {
    name?: LoadBalancerSkuName;
    tier?: LoadBalancerSkuTier;
}

// @public
export type LoadBalancerSkuName = string;

// @public
export type LoadBalancerSkuTier = string;

// @public
export interface LoadBalancersListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancersListAllNextResponse = LoadBalancerListResult;

// @public
export interface LoadBalancersListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancersListAllResponse = LoadBalancerListResult;

// @public
export interface LoadBalancersListInboundNatRulePortMappingsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type LoadBalancersListInboundNatRulePortMappingsResponse = BackendAddressInboundNatRulePortMappings;

// @public
export interface LoadBalancersListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancersListNextResponse = LoadBalancerListResult;

// @public
export interface LoadBalancersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancersListResponse = LoadBalancerListResult;

// @public
export interface LoadBalancersSwapPublicIpAddressesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface LoadBalancersUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LoadBalancersUpdateTagsResponse = LoadBalancer;

// @public
export interface LoadBalancerVipSwapRequest {
    frontendIPConfigurations?: LoadBalancerVipSwapRequestFrontendIPConfiguration[];
}

// @public
export interface LoadBalancerVipSwapRequestFrontendIPConfiguration {
    id?: string;
    publicIPAddress?: SubResource;
}

// @public
export type LoadBalancingRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    frontendIPConfiguration?: SubResource;
    backendAddressPool?: SubResource;
    backendAddressPools?: SubResource[];
    probe?: SubResource;
    protocol?: TransportProtocol;
    loadDistribution?: LoadDistribution;
    frontendPort?: number;
    backendPort?: number;
    idleTimeoutInMinutes?: number;
    enableFloatingIP?: boolean;
    enableTcpReset?: boolean;
    disableOutboundSnat?: boolean;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type LoadDistribution = string;

// @public
export type LocalNetworkGateway = Resource & {
    readonly etag?: string;
    localNetworkAddressSpace?: AddressSpace;
    gatewayIpAddress?: string;
    fqdn?: string;
    bgpSettings?: BgpSettings;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface LocalNetworkGatewayListResult {
    readonly nextLink?: string;
    value?: LocalNetworkGateway[];
}

// @public
export interface LocalNetworkGateways {
    beginCreateOrUpdate(resourceGroupName: string, localNetworkGatewayName: string, parameters: LocalNetworkGateway, options?: LocalNetworkGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<LocalNetworkGatewaysCreateOrUpdateResponse>, LocalNetworkGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, localNetworkGatewayName: string, parameters: LocalNetworkGateway, options?: LocalNetworkGatewaysCreateOrUpdateOptionalParams): Promise<LocalNetworkGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, localNetworkGatewayName: string, options?: LocalNetworkGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, localNetworkGatewayName: string, options?: LocalNetworkGatewaysDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, localNetworkGatewayName: string, options?: LocalNetworkGatewaysGetOptionalParams): Promise<LocalNetworkGatewaysGetResponse>;
    list(resourceGroupName: string, options?: LocalNetworkGatewaysListOptionalParams): PagedAsyncIterableIterator<LocalNetworkGateway>;
    updateTags(resourceGroupName: string, localNetworkGatewayName: string, parameters: TagsObject, options?: LocalNetworkGatewaysUpdateTagsOptionalParams): Promise<LocalNetworkGatewaysUpdateTagsResponse>;
}

// @public
export interface LocalNetworkGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type LocalNetworkGatewaysCreateOrUpdateResponse = LocalNetworkGateway;

// @public
export interface LocalNetworkGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface LocalNetworkGatewaysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LocalNetworkGatewaysGetResponse = LocalNetworkGateway;

// @public
export interface LocalNetworkGatewaysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LocalNetworkGatewaysListNextResponse = LocalNetworkGatewayListResult;

// @public
export interface LocalNetworkGatewaysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LocalNetworkGatewaysListResponse = LocalNetworkGatewayListResult;

// @public
export interface LocalNetworkGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type LocalNetworkGatewaysUpdateTagsResponse = LocalNetworkGateway;

// @public
export interface LogSpecification {
    blobDuration?: string;
    displayName?: string;
    name?: string;
}

// @public
export type ManagedRuleEnabledState = string;

// @public
export interface ManagedRuleGroupOverride {
    ruleGroupName: string;
    rules?: ManagedRuleOverride[];
}

// @public
export interface ManagedRuleOverride {
    ruleId: string;
    state?: ManagedRuleEnabledState;
}

// @public
export interface ManagedRulesDefinition {
    exclusions?: OwaspCrsExclusionEntry[];
    managedRuleSets: ManagedRuleSet[];
}

// @public
export interface ManagedRuleSet {
    ruleGroupOverrides?: ManagedRuleGroupOverride[];
    ruleSetType: string;
    ruleSetVersion: string;
}

// @public
export interface ManagedServiceIdentity {
    readonly principalId?: string;
    readonly tenantId?: string;
    type?: ResourceIdentityType;
    userAssignedIdentities?: {
        [propertyName: string]: Components1Jq1T4ISchemasManagedserviceidentityPropertiesUserassignedidentitiesAdditionalproperties;
    };
}

// @public
export interface MatchCondition {
    matchValues: string[];
    matchVariables: MatchVariable[];
    negationConditon?: boolean;
    operator: WebApplicationFirewallOperator;
    transforms?: WebApplicationFirewallTransform[];
}

// @public
export interface MatchedRule {
    action?: string;
    ruleName?: string;
}

// @public
export interface MatchVariable {
    selector?: string;
    variableName: WebApplicationFirewallMatchVariable;
}

// @public
export interface MetricSpecification {
    aggregationType?: string;
    availabilities?: Availability[];
    dimensions?: Dimension[];
    displayDescription?: string;
    displayName?: string;
    enableRegionalMdmAccount?: boolean;
    fillGapWithZero?: boolean;
    isInternal?: boolean;
    metricFilterPattern?: string;
    name?: string;
    resourceIdDimensionNameOverride?: string;
    sourceMdmAccount?: string;
    sourceMdmNamespace?: string;
    unit?: string;
}

// @public
export type NatGateway = Resource & {
    sku?: NatGatewaySku;
    zones?: string[];
    readonly etag?: string;
    idleTimeoutInMinutes?: number;
    publicIpAddresses?: SubResource[];
    publicIpPrefixes?: SubResource[];
    readonly subnets?: SubResource[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface NatGatewayListResult {
    nextLink?: string;
    value?: NatGateway[];
}

// @public
export interface NatGateways {
    beginCreateOrUpdate(resourceGroupName: string, natGatewayName: string, parameters: NatGateway, options?: NatGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<NatGatewaysCreateOrUpdateResponse>, NatGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, natGatewayName: string, parameters: NatGateway, options?: NatGatewaysCreateOrUpdateOptionalParams): Promise<NatGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, natGatewayName: string, options?: NatGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, natGatewayName: string, options?: NatGatewaysDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, natGatewayName: string, options?: NatGatewaysGetOptionalParams): Promise<NatGatewaysGetResponse>;
    list(resourceGroupName: string, options?: NatGatewaysListOptionalParams): PagedAsyncIterableIterator<NatGateway>;
    listAll(options?: NatGatewaysListAllOptionalParams): PagedAsyncIterableIterator<NatGateway>;
    updateTags(resourceGroupName: string, natGatewayName: string, parameters: TagsObject, options?: NatGatewaysUpdateTagsOptionalParams): Promise<NatGatewaysUpdateTagsResponse>;
}

// @public
export interface NatGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NatGatewaysCreateOrUpdateResponse = NatGateway;

// @public
export interface NatGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NatGatewaysGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NatGatewaysGetResponse = NatGateway;

// @public
export interface NatGatewaySku {
    name?: NatGatewaySkuName;
}

// @public
export type NatGatewaySkuName = string;

// @public
export interface NatGatewaysListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatGatewaysListAllNextResponse = NatGatewayListResult;

// @public
export interface NatGatewaysListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatGatewaysListAllResponse = NatGatewayListResult;

// @public
export interface NatGatewaysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatGatewaysListNextResponse = NatGatewayListResult;

// @public
export interface NatGatewaysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatGatewaysListResponse = NatGatewayListResult;

// @public
export interface NatGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatGatewaysUpdateTagsResponse = NatGateway;

// @public
export type NatRule = FirewallPolicyRule & {
    ruleType: "NatRule";
    ipProtocols?: FirewallPolicyRuleNetworkProtocol[];
    sourceAddresses?: string[];
    destinationAddresses?: string[];
    destinationPorts?: string[];
    translatedAddress?: string;
    translatedPort?: string;
    sourceIpGroups?: string[];
    translatedFqdn?: string;
};

// @public
export interface NatRulePortMapping {
    backendPort?: number;
    frontendPort?: number;
    inboundNatRuleName?: string;
}

// @public
export interface NatRules {
    beginCreateOrUpdate(resourceGroupName: string, gatewayName: string, natRuleName: string, natRuleParameters: VpnGatewayNatRule, options?: NatRulesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<NatRulesCreateOrUpdateResponse>, NatRulesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, gatewayName: string, natRuleName: string, natRuleParameters: VpnGatewayNatRule, options?: NatRulesCreateOrUpdateOptionalParams): Promise<NatRulesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, gatewayName: string, natRuleName: string, options?: NatRulesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, gatewayName: string, natRuleName: string, options?: NatRulesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, gatewayName: string, natRuleName: string, options?: NatRulesGetOptionalParams): Promise<NatRulesGetResponse>;
    listByVpnGateway(resourceGroupName: string, gatewayName: string, options?: NatRulesListByVpnGatewayOptionalParams): PagedAsyncIterableIterator<VpnGatewayNatRule>;
}

// @public
export interface NatRulesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NatRulesCreateOrUpdateResponse = VpnGatewayNatRule;

// @public
export interface NatRulesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NatRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatRulesGetResponse = VpnGatewayNatRule;

// @public
export interface NatRulesListByVpnGatewayNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatRulesListByVpnGatewayNextResponse = ListVpnGatewayNatRulesResult;

// @public
export interface NatRulesListByVpnGatewayOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NatRulesListByVpnGatewayResponse = ListVpnGatewayNatRulesResult;

// @public
export interface NetworkConfigurationDiagnosticParameters {
    profiles: NetworkConfigurationDiagnosticProfile[];
    targetResourceId: string;
    verbosityLevel?: VerbosityLevel;
}

// @public
export interface NetworkConfigurationDiagnosticProfile {
    destination: string;
    destinationPort: string;
    direction: Direction;
    protocol: string;
    source: string;
}

// @public
export interface NetworkConfigurationDiagnosticResponse {
    readonly results?: NetworkConfigurationDiagnosticResult[];
}

// @public
export interface NetworkConfigurationDiagnosticResult {
    networkSecurityGroupResult?: NetworkSecurityGroupResult;
    profile?: NetworkConfigurationDiagnosticProfile;
}

// @public
export type NetworkIntentPolicy = Resource & {
    readonly etag?: string;
};

// @public
export interface NetworkIntentPolicyConfiguration {
    networkIntentPolicyName?: string;
    sourceNetworkIntentPolicy?: NetworkIntentPolicy;
}

// @public
export type NetworkInterface = Resource & {
    extendedLocation?: ExtendedLocation;
    readonly etag?: string;
    readonly virtualMachine?: SubResource;
    networkSecurityGroup?: NetworkSecurityGroup;
    readonly privateEndpoint?: PrivateEndpoint;
    ipConfigurations?: NetworkInterfaceIPConfiguration[];
    readonly tapConfigurations?: NetworkInterfaceTapConfiguration[];
    dnsSettings?: NetworkInterfaceDnsSettings;
    readonly macAddress?: string;
    readonly primary?: boolean;
    readonly vnetEncryptionSupported?: boolean;
    enableAcceleratedNetworking?: boolean;
    enableIPForwarding?: boolean;
    readonly hostedWorkloads?: string[];
    readonly dscpConfiguration?: SubResource;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    workloadType?: string;
    nicType?: NetworkInterfaceNicType;
    privateLinkService?: PrivateLinkService;
    migrationPhase?: NetworkInterfaceMigrationPhase;
};

// @public
export interface NetworkInterfaceAssociation {
    readonly id?: string;
    securityRules?: SecurityRule[];
}

// @public
export interface NetworkInterfaceDnsSettings {
    readonly appliedDnsServers?: string[];
    dnsServers?: string[];
    internalDnsNameLabel?: string;
    readonly internalDomainNameSuffix?: string;
    readonly internalFqdn?: string;
}

// @public
export type NetworkInterfaceIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    gatewayLoadBalancer?: SubResource;
    virtualNetworkTaps?: VirtualNetworkTap[];
    applicationGatewayBackendAddressPools?: ApplicationGatewayBackendAddressPool[];
    loadBalancerBackendAddressPools?: BackendAddressPool[];
    loadBalancerInboundNatRules?: InboundNatRule[];
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    privateIPAddressVersion?: IPVersion;
    subnet?: Subnet;
    primary?: boolean;
    publicIPAddress?: PublicIPAddress;
    applicationSecurityGroups?: ApplicationSecurityGroup[];
    readonly provisioningState?: ProvisioningState;
    readonly privateLinkConnectionProperties?: NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties;
};

// @public
export interface NetworkInterfaceIPConfigurationListResult {
    readonly nextLink?: string;
    value?: NetworkInterfaceIPConfiguration[];
}

// @public
export interface NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties {
    readonly fqdns?: string[];
    readonly groupId?: string;
    readonly requiredMemberName?: string;
}

// @public
export interface NetworkInterfaceIPConfigurations {
    get(resourceGroupName: string, networkInterfaceName: string, ipConfigurationName: string, options?: NetworkInterfaceIPConfigurationsGetOptionalParams): Promise<NetworkInterfaceIPConfigurationsGetResponse>;
    list(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfaceIPConfigurationsListOptionalParams): PagedAsyncIterableIterator<NetworkInterfaceIPConfiguration>;
}

// @public
export interface NetworkInterfaceIPConfigurationsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceIPConfigurationsGetResponse = NetworkInterfaceIPConfiguration;

// @public
export interface NetworkInterfaceIPConfigurationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceIPConfigurationsListNextResponse = NetworkInterfaceIPConfigurationListResult;

// @public
export interface NetworkInterfaceIPConfigurationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceIPConfigurationsListResponse = NetworkInterfaceIPConfigurationListResult;

// @public
export interface NetworkInterfaceListResult {
    readonly nextLink?: string;
    value?: NetworkInterface[];
}

// @public
export interface NetworkInterfaceLoadBalancerListResult {
    readonly nextLink?: string;
    value?: LoadBalancer[];
}

// @public
export interface NetworkInterfaceLoadBalancers {
    list(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfaceLoadBalancersListOptionalParams): PagedAsyncIterableIterator<LoadBalancer>;
}

// @public
export interface NetworkInterfaceLoadBalancersListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceLoadBalancersListNextResponse = NetworkInterfaceLoadBalancerListResult;

// @public
export interface NetworkInterfaceLoadBalancersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceLoadBalancersListResponse = NetworkInterfaceLoadBalancerListResult;

// @public
export type NetworkInterfaceMigrationPhase = string;

// @public
export type NetworkInterfaceNicType = string;

// @public
export interface NetworkInterfaces {
    beginCreateOrUpdate(resourceGroupName: string, networkInterfaceName: string, parameters: NetworkInterface, options?: NetworkInterfacesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<NetworkInterfacesCreateOrUpdateResponse>, NetworkInterfacesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkInterfaceName: string, parameters: NetworkInterface, options?: NetworkInterfacesCreateOrUpdateOptionalParams): Promise<NetworkInterfacesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesDeleteOptionalParams): Promise<void>;
    beginGetEffectiveRouteTable(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesGetEffectiveRouteTableOptionalParams): Promise<PollerLike<PollOperationState<NetworkInterfacesGetEffectiveRouteTableResponse>, NetworkInterfacesGetEffectiveRouteTableResponse>>;
    beginGetEffectiveRouteTableAndWait(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesGetEffectiveRouteTableOptionalParams): Promise<NetworkInterfacesGetEffectiveRouteTableResponse>;
    beginListEffectiveNetworkSecurityGroups(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesListEffectiveNetworkSecurityGroupsOptionalParams): Promise<PollerLike<PollOperationState<NetworkInterfacesListEffectiveNetworkSecurityGroupsResponse>, NetworkInterfacesListEffectiveNetworkSecurityGroupsResponse>>;
    beginListEffectiveNetworkSecurityGroupsAndWait(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesListEffectiveNetworkSecurityGroupsOptionalParams): Promise<NetworkInterfacesListEffectiveNetworkSecurityGroupsResponse>;
    get(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfacesGetOptionalParams): Promise<NetworkInterfacesGetResponse>;
    getCloudServiceNetworkInterface(resourceGroupName: string, cloudServiceName: string, roleInstanceName: string, networkInterfaceName: string, options?: NetworkInterfacesGetCloudServiceNetworkInterfaceOptionalParams): Promise<NetworkInterfacesGetCloudServiceNetworkInterfaceResponse>;
    getVirtualMachineScaleSetIpConfiguration(resourceGroupName: string, virtualMachineScaleSetName: string, virtualmachineIndex: string, networkInterfaceName: string, ipConfigurationName: string, options?: NetworkInterfacesGetVirtualMachineScaleSetIpConfigurationOptionalParams): Promise<NetworkInterfacesGetVirtualMachineScaleSetIpConfigurationResponse>;
    getVirtualMachineScaleSetNetworkInterface(resourceGroupName: string, virtualMachineScaleSetName: string, virtualmachineIndex: string, networkInterfaceName: string, options?: NetworkInterfacesGetVirtualMachineScaleSetNetworkInterfaceOptionalParams): Promise<NetworkInterfacesGetVirtualMachineScaleSetNetworkInterfaceResponse>;
    list(resourceGroupName: string, options?: NetworkInterfacesListOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
    listAll(options?: NetworkInterfacesListAllOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
    listCloudServiceNetworkInterfaces(resourceGroupName: string, cloudServiceName: string, options?: NetworkInterfacesListCloudServiceNetworkInterfacesOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
    listCloudServiceRoleInstanceNetworkInterfaces(resourceGroupName: string, cloudServiceName: string, roleInstanceName: string, options?: NetworkInterfacesListCloudServiceRoleInstanceNetworkInterfacesOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
    listVirtualMachineScaleSetIpConfigurations(resourceGroupName: string, virtualMachineScaleSetName: string, virtualmachineIndex: string, networkInterfaceName: string, options?: NetworkInterfacesListVirtualMachineScaleSetIpConfigurationsOptionalParams): PagedAsyncIterableIterator<NetworkInterfaceIPConfiguration>;
    listVirtualMachineScaleSetNetworkInterfaces(resourceGroupName: string, virtualMachineScaleSetName: string, options?: NetworkInterfacesListVirtualMachineScaleSetNetworkInterfacesOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
    listVirtualMachineScaleSetVMNetworkInterfaces(resourceGroupName: string, virtualMachineScaleSetName: string, virtualmachineIndex: string, options?: NetworkInterfacesListVirtualMachineScaleSetVMNetworkInterfacesOptionalParams): PagedAsyncIterableIterator<NetworkInterface>;
    updateTags(resourceGroupName: string, networkInterfaceName: string, parameters: TagsObject, options?: NetworkInterfacesUpdateTagsOptionalParams): Promise<NetworkInterfacesUpdateTagsResponse>;
}

// @public
export interface NetworkInterfacesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkInterfacesCreateOrUpdateResponse = NetworkInterface;

// @public
export interface NetworkInterfacesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NetworkInterfacesGetCloudServiceNetworkInterfaceOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkInterfacesGetCloudServiceNetworkInterfaceResponse = NetworkInterface;

// @public
export interface NetworkInterfacesGetEffectiveRouteTableOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkInterfacesGetEffectiveRouteTableResponse = EffectiveRouteListResult;

// @public
export interface NetworkInterfacesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkInterfacesGetResponse = NetworkInterface;

// @public
export interface NetworkInterfacesGetVirtualMachineScaleSetIpConfigurationOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkInterfacesGetVirtualMachineScaleSetIpConfigurationResponse = NetworkInterfaceIPConfiguration;

// @public
export interface NetworkInterfacesGetVirtualMachineScaleSetNetworkInterfaceOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkInterfacesGetVirtualMachineScaleSetNetworkInterfaceResponse = NetworkInterface;

// @public
export interface NetworkInterfacesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListAllNextResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListAllResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListCloudServiceNetworkInterfacesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListCloudServiceNetworkInterfacesNextResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListCloudServiceNetworkInterfacesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListCloudServiceNetworkInterfacesResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListCloudServiceRoleInstanceNetworkInterfacesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListCloudServiceRoleInstanceNetworkInterfacesNextResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListCloudServiceRoleInstanceNetworkInterfacesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListCloudServiceRoleInstanceNetworkInterfacesResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListEffectiveNetworkSecurityGroupsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkInterfacesListEffectiveNetworkSecurityGroupsResponse = EffectiveNetworkSecurityGroupListResult;

// @public
export interface NetworkInterfacesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListNextResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListVirtualMachineScaleSetIpConfigurationsNextOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkInterfacesListVirtualMachineScaleSetIpConfigurationsNextResponse = NetworkInterfaceIPConfigurationListResult;

// @public
export interface NetworkInterfacesListVirtualMachineScaleSetIpConfigurationsOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkInterfacesListVirtualMachineScaleSetIpConfigurationsResponse = NetworkInterfaceIPConfigurationListResult;

// @public
export interface NetworkInterfacesListVirtualMachineScaleSetNetworkInterfacesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListVirtualMachineScaleSetNetworkInterfacesNextResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListVirtualMachineScaleSetNetworkInterfacesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListVirtualMachineScaleSetNetworkInterfacesResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListVirtualMachineScaleSetVMNetworkInterfacesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListVirtualMachineScaleSetVMNetworkInterfacesNextResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesListVirtualMachineScaleSetVMNetworkInterfacesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesListVirtualMachineScaleSetVMNetworkInterfacesResponse = NetworkInterfaceListResult;

// @public
export interface NetworkInterfacesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfacesUpdateTagsResponse = NetworkInterface;

// @public
export type NetworkInterfaceTapConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    virtualNetworkTap?: VirtualNetworkTap;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface NetworkInterfaceTapConfigurationListResult {
    readonly nextLink?: string;
    value?: NetworkInterfaceTapConfiguration[];
}

// @public
export interface NetworkInterfaceTapConfigurations {
    beginCreateOrUpdate(resourceGroupName: string, networkInterfaceName: string, tapConfigurationName: string, tapConfigurationParameters: NetworkInterfaceTapConfiguration, options?: NetworkInterfaceTapConfigurationsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<NetworkInterfaceTapConfigurationsCreateOrUpdateResponse>, NetworkInterfaceTapConfigurationsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkInterfaceName: string, tapConfigurationName: string, tapConfigurationParameters: NetworkInterfaceTapConfiguration, options?: NetworkInterfaceTapConfigurationsCreateOrUpdateOptionalParams): Promise<NetworkInterfaceTapConfigurationsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkInterfaceName: string, tapConfigurationName: string, options?: NetworkInterfaceTapConfigurationsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkInterfaceName: string, tapConfigurationName: string, options?: NetworkInterfaceTapConfigurationsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkInterfaceName: string, tapConfigurationName: string, options?: NetworkInterfaceTapConfigurationsGetOptionalParams): Promise<NetworkInterfaceTapConfigurationsGetResponse>;
    list(resourceGroupName: string, networkInterfaceName: string, options?: NetworkInterfaceTapConfigurationsListOptionalParams): PagedAsyncIterableIterator<NetworkInterfaceTapConfiguration>;
}

// @public
export interface NetworkInterfaceTapConfigurationsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkInterfaceTapConfigurationsCreateOrUpdateResponse = NetworkInterfaceTapConfiguration;

// @public
export interface NetworkInterfaceTapConfigurationsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NetworkInterfaceTapConfigurationsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceTapConfigurationsGetResponse = NetworkInterfaceTapConfiguration;

// @public
export interface NetworkInterfaceTapConfigurationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceTapConfigurationsListNextResponse = NetworkInterfaceTapConfigurationListResult;

// @public
export interface NetworkInterfaceTapConfigurationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkInterfaceTapConfigurationsListResponse = NetworkInterfaceTapConfigurationListResult;

// @public (undocumented)
export class NetworkManagementClient extends coreClient.ServiceClient {
    // (undocumented)
    $host: string;
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: NetworkManagementClientOptionalParams);
    // (undocumented)
    applicationGatewayPrivateEndpointConnections: ApplicationGatewayPrivateEndpointConnections;
    // (undocumented)
    applicationGatewayPrivateLinkResources: ApplicationGatewayPrivateLinkResources;
    // (undocumented)
    applicationGateways: ApplicationGateways;
    // (undocumented)
    applicationSecurityGroups: ApplicationSecurityGroups;
    // (undocumented)
    availableDelegations: AvailableDelegations;
    // (undocumented)
    availableEndpointServices: AvailableEndpointServices;
    // (undocumented)
    availablePrivateEndpointTypes: AvailablePrivateEndpointTypes;
    // (undocumented)
    availableResourceGroupDelegations: AvailableResourceGroupDelegations;
    // (undocumented)
    availableServiceAliases: AvailableServiceAliases;
    // (undocumented)
    azureFirewallFqdnTags: AzureFirewallFqdnTags;
    // (undocumented)
    azureFirewalls: AzureFirewalls;
    // (undocumented)
    bastionHosts: BastionHosts;
    beginDeleteBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: BastionShareableLinkListRequest, options?: DeleteBastionShareableLinkOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteBastionShareableLinkAndWait(resourceGroupName: string, bastionHostName: string, bslRequest: BastionShareableLinkListRequest, options?: DeleteBastionShareableLinkOptionalParams): Promise<void>;
    beginGeneratevirtualwanvpnserverconfigurationvpnprofile(resourceGroupName: string, virtualWANName: string, vpnClientParams: VirtualWanVpnProfileParameters, options?: GeneratevirtualwanvpnserverconfigurationvpnprofileOptionalParams): Promise<PollerLike<PollOperationState<GeneratevirtualwanvpnserverconfigurationvpnprofileResponse>, GeneratevirtualwanvpnserverconfigurationvpnprofileResponse>>;
    beginGeneratevirtualwanvpnserverconfigurationvpnprofileAndWait(resourceGroupName: string, virtualWANName: string, vpnClientParams: VirtualWanVpnProfileParameters, options?: GeneratevirtualwanvpnserverconfigurationvpnprofileOptionalParams): Promise<GeneratevirtualwanvpnserverconfigurationvpnprofileResponse>;
    beginListActiveSessionsAndWait(resourceGroupName: string, bastionHostName: string, options?: GetActiveSessionsOptionalParams): PagedAsyncIterableIterator<BastionActiveSession>;
    beginListPutBastionShareableLinkAndWait(resourceGroupName: string, bastionHostName: string, bslRequest: BastionShareableLinkListRequest, options?: PutBastionShareableLinkOptionalParams): PagedAsyncIterableIterator<BastionShareableLink>;
    // (undocumented)
    bgpServiceCommunities: BgpServiceCommunities;
    checkDnsNameAvailability(location: string, domainNameLabel: string, options?: CheckDnsNameAvailabilityOptionalParams): Promise<CheckDnsNameAvailabilityResponse>;
    // (undocumented)
    connectionMonitors: ConnectionMonitors;
    // (undocumented)
    customIPPrefixes: CustomIPPrefixes;
    // (undocumented)
    ddosCustomPolicies: DdosCustomPolicies;
    // (undocumented)
    ddosProtectionPlans: DdosProtectionPlans;
    // (undocumented)
    defaultSecurityRules: DefaultSecurityRules;
    // (undocumented)
    dscpConfigurationOperations: DscpConfigurationOperations;
    // (undocumented)
    expressRouteCircuitAuthorizations: ExpressRouteCircuitAuthorizations;
    // (undocumented)
    expressRouteCircuitConnections: ExpressRouteCircuitConnections;
    // (undocumented)
    expressRouteCircuitPeerings: ExpressRouteCircuitPeerings;
    // (undocumented)
    expressRouteCircuits: ExpressRouteCircuits;
    // (undocumented)
    expressRouteConnections: ExpressRouteConnections;
    // (undocumented)
    expressRouteCrossConnectionPeerings: ExpressRouteCrossConnectionPeerings;
    // (undocumented)
    expressRouteCrossConnections: ExpressRouteCrossConnections;
    // (undocumented)
    expressRouteGateways: ExpressRouteGateways;
    // (undocumented)
    expressRouteLinks: ExpressRouteLinks;
    // (undocumented)
    expressRoutePorts: ExpressRoutePorts;
    // (undocumented)
    expressRoutePortsLocations: ExpressRoutePortsLocations;
    // (undocumented)
    expressRouteServiceProviders: ExpressRouteServiceProviders;
    // (undocumented)
    firewallPolicies: FirewallPolicies;
    // (undocumented)
    firewallPolicyIdpsSignatures: FirewallPolicyIdpsSignatures;
    // (undocumented)
    firewallPolicyIdpsSignaturesFilterValues: FirewallPolicyIdpsSignaturesFilterValues;
    // (undocumented)
    firewallPolicyIdpsSignaturesOverrides: FirewallPolicyIdpsSignaturesOverrides;
    // (undocumented)
    firewallPolicyRuleCollectionGroups: FirewallPolicyRuleCollectionGroups;
    // (undocumented)
    flowLogs: FlowLogs;
    // (undocumented)
    hubRouteTables: HubRouteTables;
    // (undocumented)
    hubVirtualNetworkConnections: HubVirtualNetworkConnections;
    // (undocumented)
    inboundNatRules: InboundNatRules;
    // (undocumented)
    inboundSecurityRuleOperations: InboundSecurityRuleOperations;
    // (undocumented)
    ipAllocations: IpAllocations;
    // (undocumented)
    ipGroups: IpGroups;
    listBastionShareableLink(resourceGroupName: string, bastionHostName: string, bslRequest: BastionShareableLinkListRequest, options?: GetBastionShareableLinkOptionalParams): PagedAsyncIterableIterator<BastionShareableLink>;
    listDisconnectActiveSessions(resourceGroupName: string, bastionHostName: string, sessionIds: SessionIds, options?: DisconnectActiveSessionsOptionalParams): PagedAsyncIterableIterator<BastionSessionState>;
    // (undocumented)
    loadBalancerBackendAddressPools: LoadBalancerBackendAddressPools;
    // (undocumented)
    loadBalancerFrontendIPConfigurations: LoadBalancerFrontendIPConfigurations;
    // (undocumented)
    loadBalancerLoadBalancingRules: LoadBalancerLoadBalancingRules;
    // (undocumented)
    loadBalancerNetworkInterfaces: LoadBalancerNetworkInterfaces;
    // (undocumented)
    loadBalancerOutboundRules: LoadBalancerOutboundRules;
    // (undocumented)
    loadBalancerProbes: LoadBalancerProbes;
    // (undocumented)
    loadBalancers: LoadBalancers;
    // (undocumented)
    localNetworkGateways: LocalNetworkGateways;
    // (undocumented)
    natGateways: NatGateways;
    // (undocumented)
    natRules: NatRules;
    // (undocumented)
    networkInterfaceIPConfigurations: NetworkInterfaceIPConfigurations;
    // (undocumented)
    networkInterfaceLoadBalancers: NetworkInterfaceLoadBalancers;
    // (undocumented)
    networkInterfaces: NetworkInterfaces;
    // (undocumented)
    networkInterfaceTapConfigurations: NetworkInterfaceTapConfigurations;
    // (undocumented)
    networkProfiles: NetworkProfiles;
    // (undocumented)
    networkSecurityGroups: NetworkSecurityGroups;
    // (undocumented)
    networkVirtualAppliances: NetworkVirtualAppliances;
    // (undocumented)
    networkWatchers: NetworkWatchers;
    // (undocumented)
    operations: Operations;
    // (undocumented)
    p2SVpnGateways: P2SVpnGateways;
    // (undocumented)
    packetCaptures: PacketCaptures;
    // (undocumented)
    peerExpressRouteCircuitConnections: PeerExpressRouteCircuitConnections;
    // (undocumented)
    privateDnsZoneGroups: PrivateDnsZoneGroups;
    // (undocumented)
    privateEndpoints: PrivateEndpoints;
    // (undocumented)
    privateLinkServices: PrivateLinkServices;
    // (undocumented)
    publicIPAddresses: PublicIPAddresses;
    // (undocumented)
    publicIPPrefixes: PublicIPPrefixes;
    // (undocumented)
    resourceNavigationLinks: ResourceNavigationLinks;
    // (undocumented)
    routeFilterRules: RouteFilterRules;
    // (undocumented)
    routeFilters: RouteFilters;
    // (undocumented)
    routes: Routes;
    // (undocumented)
    routeTables: RouteTables;
    // (undocumented)
    routingIntentOperations: RoutingIntentOperations;
    // (undocumented)
    securityPartnerProviders: SecurityPartnerProviders;
    // (undocumented)
    securityRules: SecurityRules;
    // (undocumented)
    serviceAssociationLinks: ServiceAssociationLinks;
    // (undocumented)
    serviceEndpointPolicies: ServiceEndpointPolicies;
    // (undocumented)
    serviceEndpointPolicyDefinitions: ServiceEndpointPolicyDefinitions;
    // (undocumented)
    serviceTagInformationOperations: ServiceTagInformationOperations;
    // (undocumented)
    serviceTags: ServiceTags;
    // (undocumented)
    subnets: Subnets;
    // (undocumented)
    subscriptionId: string;
    supportedSecurityProviders(resourceGroupName: string, virtualWANName: string, options?: SupportedSecurityProvidersOptionalParams): Promise<SupportedSecurityProvidersResponse>;
    // (undocumented)
    usages: Usages;
    // (undocumented)
    virtualApplianceSites: VirtualApplianceSites;
    // (undocumented)
    virtualApplianceSkus: VirtualApplianceSkus;
    // (undocumented)
    virtualHubBgpConnection: VirtualHubBgpConnection;
    // (undocumented)
    virtualHubBgpConnections: VirtualHubBgpConnections;
    // (undocumented)
    virtualHubIpConfiguration: VirtualHubIpConfiguration;
    // (undocumented)
    virtualHubRouteTableV2S: VirtualHubRouteTableV2S;
    // (undocumented)
    virtualHubs: VirtualHubs;
    // (undocumented)
    virtualNetworkGatewayConnections: VirtualNetworkGatewayConnections;
    // (undocumented)
    virtualNetworkGatewayNatRules: VirtualNetworkGatewayNatRules;
    // (undocumented)
    virtualNetworkGateways: VirtualNetworkGateways;
    // (undocumented)
    virtualNetworkPeerings: VirtualNetworkPeerings;
    // (undocumented)
    virtualNetworks: VirtualNetworks;
    // (undocumented)
    virtualNetworkTaps: VirtualNetworkTaps;
    // (undocumented)
    virtualRouterPeerings: VirtualRouterPeerings;
    // (undocumented)
    virtualRouters: VirtualRouters;
    // (undocumented)
    virtualWans: VirtualWans;
    // (undocumented)
    vpnConnections: VpnConnections;
    // (undocumented)
    vpnGateways: VpnGateways;
    // (undocumented)
    vpnLinkConnections: VpnLinkConnections;
    // (undocumented)
    vpnServerConfigurations: VpnServerConfigurations;
    // (undocumented)
    vpnServerConfigurationsAssociatedWithVirtualWan: VpnServerConfigurationsAssociatedWithVirtualWan;
    // (undocumented)
    vpnSiteLinkConnections: VpnSiteLinkConnections;
    // (undocumented)
    vpnSiteLinks: VpnSiteLinks;
    // (undocumented)
    vpnSites: VpnSites;
    // (undocumented)
    vpnSitesConfiguration: VpnSitesConfiguration;
    // (undocumented)
    webApplicationFirewallPolicies: WebApplicationFirewallPolicies;
    // (undocumented)
    webCategories: WebCategories;
}

// @public
export interface NetworkManagementClientOptionalParams extends coreClient.ServiceClientOptions {
    $host?: string;
    endpoint?: string;
}

// @public
export type NetworkOperationStatus = string;

// @public
export type NetworkProfile = Resource & {
    readonly etag?: string;
    readonly containerNetworkInterfaces?: ContainerNetworkInterface[];
    containerNetworkInterfaceConfigurations?: ContainerNetworkInterfaceConfiguration[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface NetworkProfileListResult {
    nextLink?: string;
    value?: NetworkProfile[];
}

// @public
export interface NetworkProfiles {
    beginDelete(resourceGroupName: string, networkProfileName: string, options?: NetworkProfilesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkProfileName: string, options?: NetworkProfilesDeleteOptionalParams): Promise<void>;
    createOrUpdate(resourceGroupName: string, networkProfileName: string, parameters: NetworkProfile, options?: NetworkProfilesCreateOrUpdateOptionalParams): Promise<NetworkProfilesCreateOrUpdateResponse>;
    get(resourceGroupName: string, networkProfileName: string, options?: NetworkProfilesGetOptionalParams): Promise<NetworkProfilesGetResponse>;
    list(resourceGroupName: string, options?: NetworkProfilesListOptionalParams): PagedAsyncIterableIterator<NetworkProfile>;
    listAll(options?: NetworkProfilesListAllOptionalParams): PagedAsyncIterableIterator<NetworkProfile>;
    updateTags(resourceGroupName: string, networkProfileName: string, parameters: TagsObject, options?: NetworkProfilesUpdateTagsOptionalParams): Promise<NetworkProfilesUpdateTagsResponse>;
}

// @public
export interface NetworkProfilesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkProfilesCreateOrUpdateResponse = NetworkProfile;

// @public
export interface NetworkProfilesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NetworkProfilesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkProfilesGetResponse = NetworkProfile;

// @public
export interface NetworkProfilesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkProfilesListAllNextResponse = NetworkProfileListResult;

// @public
export interface NetworkProfilesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkProfilesListAllResponse = NetworkProfileListResult;

// @public
export interface NetworkProfilesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkProfilesListNextResponse = NetworkProfileListResult;

// @public
export interface NetworkProfilesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkProfilesListResponse = NetworkProfileListResult;

// @public
export interface NetworkProfilesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkProfilesUpdateTagsResponse = NetworkProfile;

// @public
export type NetworkRule = FirewallPolicyRule & {
    ruleType: "NetworkRule";
    ipProtocols?: FirewallPolicyRuleNetworkProtocol[];
    sourceAddresses?: string[];
    destinationAddresses?: string[];
    destinationPorts?: string[];
    sourceIpGroups?: string[];
    destinationIpGroups?: string[];
    destinationFqdns?: string[];
};

// @public
export type NetworkSecurityGroup = Resource & {
    readonly etag?: string;
    securityRules?: SecurityRule[];
    readonly defaultSecurityRules?: SecurityRule[];
    readonly networkInterfaces?: NetworkInterface[];
    readonly subnets?: Subnet[];
    readonly flowLogs?: FlowLog[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface NetworkSecurityGroupListResult {
    nextLink?: string;
    value?: NetworkSecurityGroup[];
}

// @public
export interface NetworkSecurityGroupResult {
    readonly evaluatedNetworkSecurityGroups?: EvaluatedNetworkSecurityGroup[];
    securityRuleAccessResult?: SecurityRuleAccess;
}

// @public
export interface NetworkSecurityGroups {
    beginCreateOrUpdate(resourceGroupName: string, networkSecurityGroupName: string, parameters: NetworkSecurityGroup, options?: NetworkSecurityGroupsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<NetworkSecurityGroupsCreateOrUpdateResponse>, NetworkSecurityGroupsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkSecurityGroupName: string, parameters: NetworkSecurityGroup, options?: NetworkSecurityGroupsCreateOrUpdateOptionalParams): Promise<NetworkSecurityGroupsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkSecurityGroupName: string, options?: NetworkSecurityGroupsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkSecurityGroupName: string, options?: NetworkSecurityGroupsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkSecurityGroupName: string, options?: NetworkSecurityGroupsGetOptionalParams): Promise<NetworkSecurityGroupsGetResponse>;
    list(resourceGroupName: string, options?: NetworkSecurityGroupsListOptionalParams): PagedAsyncIterableIterator<NetworkSecurityGroup>;
    listAll(options?: NetworkSecurityGroupsListAllOptionalParams): PagedAsyncIterableIterator<NetworkSecurityGroup>;
    updateTags(resourceGroupName: string, networkSecurityGroupName: string, parameters: TagsObject, options?: NetworkSecurityGroupsUpdateTagsOptionalParams): Promise<NetworkSecurityGroupsUpdateTagsResponse>;
}

// @public
export interface NetworkSecurityGroupsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkSecurityGroupsCreateOrUpdateResponse = NetworkSecurityGroup;

// @public
export interface NetworkSecurityGroupsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NetworkSecurityGroupsGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkSecurityGroupsGetResponse = NetworkSecurityGroup;

// @public
export interface NetworkSecurityGroupsListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkSecurityGroupsListAllNextResponse = NetworkSecurityGroupListResult;

// @public
export interface NetworkSecurityGroupsListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkSecurityGroupsListAllResponse = NetworkSecurityGroupListResult;

// @public
export interface NetworkSecurityGroupsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkSecurityGroupsListNextResponse = NetworkSecurityGroupListResult;

// @public
export interface NetworkSecurityGroupsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkSecurityGroupsListResponse = NetworkSecurityGroupListResult;

// @public
export interface NetworkSecurityGroupsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkSecurityGroupsUpdateTagsResponse = NetworkSecurityGroup;

// @public
export interface NetworkSecurityRulesEvaluationResult {
    destinationMatched?: boolean;
    destinationPortMatched?: boolean;
    name?: string;
    protocolMatched?: boolean;
    sourceMatched?: boolean;
    sourcePortMatched?: boolean;
}

// @public
export type NetworkVirtualAppliance = Resource & {
    identity?: ManagedServiceIdentity;
    readonly etag?: string;
    nvaSku?: VirtualApplianceSkuProperties;
    readonly addressPrefix?: string;
    bootStrapConfigurationBlobs?: string[];
    virtualHub?: SubResource;
    cloudInitConfigurationBlobs?: string[];
    cloudInitConfiguration?: string;
    virtualApplianceAsn?: number;
    sshPublicKey?: string;
    readonly virtualApplianceNics?: VirtualApplianceNicProperties[];
    readonly virtualApplianceSites?: SubResource[];
    readonly inboundSecurityRules?: SubResource[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface NetworkVirtualApplianceListResult {
    nextLink?: string;
    value?: NetworkVirtualAppliance[];
}

// @public
export interface NetworkVirtualAppliances {
    beginCreateOrUpdate(resourceGroupName: string, networkVirtualApplianceName: string, parameters: NetworkVirtualAppliance, options?: NetworkVirtualAppliancesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<NetworkVirtualAppliancesCreateOrUpdateResponse>, NetworkVirtualAppliancesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkVirtualApplianceName: string, parameters: NetworkVirtualAppliance, options?: NetworkVirtualAppliancesCreateOrUpdateOptionalParams): Promise<NetworkVirtualAppliancesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkVirtualApplianceName: string, options?: NetworkVirtualAppliancesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkVirtualApplianceName: string, options?: NetworkVirtualAppliancesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkVirtualApplianceName: string, options?: NetworkVirtualAppliancesGetOptionalParams): Promise<NetworkVirtualAppliancesGetResponse>;
    list(options?: NetworkVirtualAppliancesListOptionalParams): PagedAsyncIterableIterator<NetworkVirtualAppliance>;
    listByResourceGroup(resourceGroupName: string, options?: NetworkVirtualAppliancesListByResourceGroupOptionalParams): PagedAsyncIterableIterator<NetworkVirtualAppliance>;
    updateTags(resourceGroupName: string, networkVirtualApplianceName: string, parameters: TagsObject, options?: NetworkVirtualAppliancesUpdateTagsOptionalParams): Promise<NetworkVirtualAppliancesUpdateTagsResponse>;
}

// @public
export interface NetworkVirtualAppliancesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkVirtualAppliancesCreateOrUpdateResponse = NetworkVirtualAppliance;

// @public
export interface NetworkVirtualAppliancesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NetworkVirtualAppliancesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type NetworkVirtualAppliancesGetResponse = NetworkVirtualAppliance;

// @public
export interface NetworkVirtualApplianceSiteListResult {
    nextLink?: string;
    value?: VirtualApplianceSite[];
}

// @public
export type NetworkVirtualApplianceSku = Resource & {
    readonly etag?: string;
    readonly vendor?: string;
    readonly availableVersions?: string[];
    availableScaleUnits?: NetworkVirtualApplianceSkuInstances[];
};

// @public
export interface NetworkVirtualApplianceSkuInstances {
    readonly instanceCount?: number;
    readonly scaleUnit?: string;
}

// @public
export interface NetworkVirtualApplianceSkuListResult {
    nextLink?: string;
    value?: NetworkVirtualApplianceSku[];
}

// @public
export interface NetworkVirtualAppliancesListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkVirtualAppliancesListByResourceGroupNextResponse = NetworkVirtualApplianceListResult;

// @public
export interface NetworkVirtualAppliancesListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkVirtualAppliancesListByResourceGroupResponse = NetworkVirtualApplianceListResult;

// @public
export interface NetworkVirtualAppliancesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkVirtualAppliancesListNextResponse = NetworkVirtualApplianceListResult;

// @public
export interface NetworkVirtualAppliancesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkVirtualAppliancesListResponse = NetworkVirtualApplianceListResult;

// @public
export interface NetworkVirtualAppliancesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkVirtualAppliancesUpdateTagsResponse = NetworkVirtualAppliance;

// @public
export type NetworkWatcher = Resource & {
    readonly etag?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface NetworkWatcherListResult {
    value?: NetworkWatcher[];
}

// @public
export interface NetworkWatchers {
    beginCheckConnectivity(resourceGroupName: string, networkWatcherName: string, parameters: ConnectivityParameters, options?: NetworkWatchersCheckConnectivityOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersCheckConnectivityResponse>, NetworkWatchersCheckConnectivityResponse>>;
    beginCheckConnectivityAndWait(resourceGroupName: string, networkWatcherName: string, parameters: ConnectivityParameters, options?: NetworkWatchersCheckConnectivityOptionalParams): Promise<NetworkWatchersCheckConnectivityResponse>;
    beginDelete(resourceGroupName: string, networkWatcherName: string, options?: NetworkWatchersDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkWatcherName: string, options?: NetworkWatchersDeleteOptionalParams): Promise<void>;
    beginGetAzureReachabilityReport(resourceGroupName: string, networkWatcherName: string, parameters: AzureReachabilityReportParameters, options?: NetworkWatchersGetAzureReachabilityReportOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetAzureReachabilityReportResponse>, NetworkWatchersGetAzureReachabilityReportResponse>>;
    beginGetAzureReachabilityReportAndWait(resourceGroupName: string, networkWatcherName: string, parameters: AzureReachabilityReportParameters, options?: NetworkWatchersGetAzureReachabilityReportOptionalParams): Promise<NetworkWatchersGetAzureReachabilityReportResponse>;
    beginGetFlowLogStatus(resourceGroupName: string, networkWatcherName: string, parameters: FlowLogStatusParameters, options?: NetworkWatchersGetFlowLogStatusOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetFlowLogStatusResponse>, NetworkWatchersGetFlowLogStatusResponse>>;
    beginGetFlowLogStatusAndWait(resourceGroupName: string, networkWatcherName: string, parameters: FlowLogStatusParameters, options?: NetworkWatchersGetFlowLogStatusOptionalParams): Promise<NetworkWatchersGetFlowLogStatusResponse>;
    beginGetNetworkConfigurationDiagnostic(resourceGroupName: string, networkWatcherName: string, parameters: NetworkConfigurationDiagnosticParameters, options?: NetworkWatchersGetNetworkConfigurationDiagnosticOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetNetworkConfigurationDiagnosticResponse>, NetworkWatchersGetNetworkConfigurationDiagnosticResponse>>;
    beginGetNetworkConfigurationDiagnosticAndWait(resourceGroupName: string, networkWatcherName: string, parameters: NetworkConfigurationDiagnosticParameters, options?: NetworkWatchersGetNetworkConfigurationDiagnosticOptionalParams): Promise<NetworkWatchersGetNetworkConfigurationDiagnosticResponse>;
    beginGetNextHop(resourceGroupName: string, networkWatcherName: string, parameters: NextHopParameters, options?: NetworkWatchersGetNextHopOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetNextHopResponse>, NetworkWatchersGetNextHopResponse>>;
    beginGetNextHopAndWait(resourceGroupName: string, networkWatcherName: string, parameters: NextHopParameters, options?: NetworkWatchersGetNextHopOptionalParams): Promise<NetworkWatchersGetNextHopResponse>;
    beginGetTroubleshooting(resourceGroupName: string, networkWatcherName: string, parameters: TroubleshootingParameters, options?: NetworkWatchersGetTroubleshootingOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetTroubleshootingResponse>, NetworkWatchersGetTroubleshootingResponse>>;
    beginGetTroubleshootingAndWait(resourceGroupName: string, networkWatcherName: string, parameters: TroubleshootingParameters, options?: NetworkWatchersGetTroubleshootingOptionalParams): Promise<NetworkWatchersGetTroubleshootingResponse>;
    beginGetTroubleshootingResult(resourceGroupName: string, networkWatcherName: string, parameters: QueryTroubleshootingParameters, options?: NetworkWatchersGetTroubleshootingResultOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetTroubleshootingResultResponse>, NetworkWatchersGetTroubleshootingResultResponse>>;
    beginGetTroubleshootingResultAndWait(resourceGroupName: string, networkWatcherName: string, parameters: QueryTroubleshootingParameters, options?: NetworkWatchersGetTroubleshootingResultOptionalParams): Promise<NetworkWatchersGetTroubleshootingResultResponse>;
    beginGetVMSecurityRules(resourceGroupName: string, networkWatcherName: string, parameters: SecurityGroupViewParameters, options?: NetworkWatchersGetVMSecurityRulesOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersGetVMSecurityRulesResponse>, NetworkWatchersGetVMSecurityRulesResponse>>;
    beginGetVMSecurityRulesAndWait(resourceGroupName: string, networkWatcherName: string, parameters: SecurityGroupViewParameters, options?: NetworkWatchersGetVMSecurityRulesOptionalParams): Promise<NetworkWatchersGetVMSecurityRulesResponse>;
    beginListAvailableProviders(resourceGroupName: string, networkWatcherName: string, parameters: AvailableProvidersListParameters, options?: NetworkWatchersListAvailableProvidersOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersListAvailableProvidersResponse>, NetworkWatchersListAvailableProvidersResponse>>;
    beginListAvailableProvidersAndWait(resourceGroupName: string, networkWatcherName: string, parameters: AvailableProvidersListParameters, options?: NetworkWatchersListAvailableProvidersOptionalParams): Promise<NetworkWatchersListAvailableProvidersResponse>;
    beginSetFlowLogConfiguration(resourceGroupName: string, networkWatcherName: string, parameters: FlowLogInformation, options?: NetworkWatchersSetFlowLogConfigurationOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersSetFlowLogConfigurationResponse>, NetworkWatchersSetFlowLogConfigurationResponse>>;
    beginSetFlowLogConfigurationAndWait(resourceGroupName: string, networkWatcherName: string, parameters: FlowLogInformation, options?: NetworkWatchersSetFlowLogConfigurationOptionalParams): Promise<NetworkWatchersSetFlowLogConfigurationResponse>;
    beginVerifyIPFlow(resourceGroupName: string, networkWatcherName: string, parameters: VerificationIPFlowParameters, options?: NetworkWatchersVerifyIPFlowOptionalParams): Promise<PollerLike<PollOperationState<NetworkWatchersVerifyIPFlowResponse>, NetworkWatchersVerifyIPFlowResponse>>;
    beginVerifyIPFlowAndWait(resourceGroupName: string, networkWatcherName: string, parameters: VerificationIPFlowParameters, options?: NetworkWatchersVerifyIPFlowOptionalParams): Promise<NetworkWatchersVerifyIPFlowResponse>;
    createOrUpdate(resourceGroupName: string, networkWatcherName: string, parameters: NetworkWatcher, options?: NetworkWatchersCreateOrUpdateOptionalParams): Promise<NetworkWatchersCreateOrUpdateResponse>;
    get(resourceGroupName: string, networkWatcherName: string, options?: NetworkWatchersGetOptionalParams): Promise<NetworkWatchersGetResponse>;
    getTopology(resourceGroupName: string, networkWatcherName: string, parameters: TopologyParameters, options?: NetworkWatchersGetTopologyOptionalParams): Promise<NetworkWatchersGetTopologyResponse>;
    list(resourceGroupName: string, options?: NetworkWatchersListOptionalParams): PagedAsyncIterableIterator<NetworkWatcher>;
    listAll(options?: NetworkWatchersListAllOptionalParams): PagedAsyncIterableIterator<NetworkWatcher>;
    updateTags(resourceGroupName: string, networkWatcherName: string, parameters: TagsObject, options?: NetworkWatchersUpdateTagsOptionalParams): Promise<NetworkWatchersUpdateTagsResponse>;
}

// @public
export interface NetworkWatchersCheckConnectivityOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersCheckConnectivityResponse = ConnectivityInformation;

// @public
export interface NetworkWatchersCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkWatchersCreateOrUpdateResponse = NetworkWatcher;

// @public
export interface NetworkWatchersDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface NetworkWatchersGetAzureReachabilityReportOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetAzureReachabilityReportResponse = AzureReachabilityReport;

// @public
export interface NetworkWatchersGetFlowLogStatusOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetFlowLogStatusResponse = FlowLogInformation;

// @public
export interface NetworkWatchersGetNetworkConfigurationDiagnosticOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetNetworkConfigurationDiagnosticResponse = NetworkConfigurationDiagnosticResponse;

// @public
export interface NetworkWatchersGetNextHopOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetNextHopResponse = NextHopResult;

// @public
export interface NetworkWatchersGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkWatchersGetResponse = NetworkWatcher;

// @public
export interface NetworkWatchersGetTopologyOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkWatchersGetTopologyResponse = Topology;

// @public
export interface NetworkWatchersGetTroubleshootingOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetTroubleshootingResponse = TroubleshootingResult;

// @public
export interface NetworkWatchersGetTroubleshootingResultOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetTroubleshootingResultResponse = TroubleshootingResult;

// @public
export interface NetworkWatchersGetVMSecurityRulesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersGetVMSecurityRulesResponse = SecurityGroupViewResult;

// @public
export interface NetworkWatchersListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkWatchersListAllResponse = NetworkWatcherListResult;

// @public
export interface NetworkWatchersListAvailableProvidersOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersListAvailableProvidersResponse = AvailableProvidersList;

// @public
export interface NetworkWatchersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkWatchersListResponse = NetworkWatcherListResult;

// @public
export interface NetworkWatchersSetFlowLogConfigurationOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersSetFlowLogConfigurationResponse = FlowLogInformation;

// @public
export interface NetworkWatchersUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type NetworkWatchersUpdateTagsResponse = NetworkWatcher;

// @public
export interface NetworkWatchersVerifyIPFlowOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type NetworkWatchersVerifyIPFlowResponse = VerificationIPFlowResult;

// @public
export interface NextHopParameters {
    destinationIPAddress: string;
    sourceIPAddress: string;
    targetNicResourceId?: string;
    targetResourceId: string;
}

// @public
export interface NextHopResult {
    nextHopIpAddress?: string;
    nextHopType?: NextHopType;
    routeTableId?: string;
}

// @public
export type NextHopType = string;

// @public
export interface O365BreakOutCategoryPolicies {
    allow?: boolean;
    default?: boolean;
    optimize?: boolean;
}

// @public
export interface O365PolicyProperties {
    breakOutCategories?: O365BreakOutCategoryPolicies;
}

// @public
export interface Office365PolicyProperties {
    breakOutCategories?: BreakOutCategoryPolicies;
}

// @public
export type OfficeTrafficCategory = string;

// @public
export interface Operation {
    display?: OperationDisplay;
    name?: string;
    origin?: string;
    serviceSpecification?: OperationPropertiesFormatServiceSpecification;
}

// @public
export interface OperationDisplay {
    description?: string;
    operation?: string;
    provider?: string;
    resource?: string;
}

// @public
export interface OperationListResult {
    nextLink?: string;
    value?: Operation[];
}

// @public
export interface OperationPropertiesFormatServiceSpecification {
    logSpecifications?: LogSpecification[];
    metricSpecifications?: MetricSpecification[];
}

// @public
export interface Operations {
    list(options?: OperationsListOptionalParams): PagedAsyncIterableIterator<Operation>;
}

// @public
export interface OperationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsListNextResponse = OperationListResult;

// @public
export interface OperationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsListResponse = OperationListResult;

// @public
export interface OrderBy {
    field?: string;
    order?: OrderByOrder;
}

// @public
export type OrderByOrder = string;

// @public
export type Origin = string;

// @public
export type OutboundRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    allocatedOutboundPorts?: number;
    frontendIPConfigurations?: SubResource[];
    backendAddressPool?: SubResource;
    readonly provisioningState?: ProvisioningState;
    protocol?: LoadBalancerOutboundRuleProtocol;
    enableTcpReset?: boolean;
    idleTimeoutInMinutes?: number;
};

// @public
export type OutputType = string;

// @public
export interface OwaspCrsExclusionEntry {
    exclusionManagedRuleSets?: ExclusionManagedRuleSet[];
    matchVariable: OwaspCrsExclusionEntryMatchVariable;
    selector: string;
    selectorMatchOperator: OwaspCrsExclusionEntrySelectorMatchOperator;
}

// @public
export type OwaspCrsExclusionEntryMatchVariable = string;

// @public
export type OwaspCrsExclusionEntrySelectorMatchOperator = string;

// @public
export type P2SConnectionConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    vpnClientAddressPool?: AddressSpace;
    routingConfiguration?: RoutingConfiguration;
    enableInternetSecurity?: boolean;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface P2SVpnConnectionHealth {
    sasUrl?: string;
}

// @public
export interface P2SVpnConnectionHealthRequest {
    outputBlobSasUrl?: string;
    vpnUserNamesFilter?: string[];
}

// @public
export interface P2SVpnConnectionRequest {
    vpnConnectionIds?: string[];
}

// @public
export type P2SVpnGateway = Resource & {
    readonly etag?: string;
    virtualHub?: SubResource;
    p2SConnectionConfigurations?: P2SConnectionConfiguration[];
    readonly provisioningState?: ProvisioningState;
    vpnGatewayScaleUnit?: number;
    vpnServerConfiguration?: SubResource;
    readonly vpnClientConnectionHealth?: VpnClientConnectionHealth;
    customDnsServers?: string[];
    isRoutingPreferenceInternet?: boolean;
};

// @public
export interface P2SVpnGateways {
    beginCreateOrUpdate(resourceGroupName: string, gatewayName: string, p2SVpnGatewayParameters: P2SVpnGateway, options?: P2SVpnGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<P2SVpnGatewaysCreateOrUpdateResponse>, P2SVpnGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, gatewayName: string, p2SVpnGatewayParameters: P2SVpnGateway, options?: P2SVpnGatewaysCreateOrUpdateOptionalParams): Promise<P2SVpnGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysDeleteOptionalParams): Promise<void>;
    beginDisconnectP2SVpnConnections(resourceGroupName: string, p2SVpnGatewayName: string, request: P2SVpnConnectionRequest, options?: P2SVpnGatewaysDisconnectP2SVpnConnectionsOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDisconnectP2SVpnConnectionsAndWait(resourceGroupName: string, p2SVpnGatewayName: string, request: P2SVpnConnectionRequest, options?: P2SVpnGatewaysDisconnectP2SVpnConnectionsOptionalParams): Promise<void>;
    beginGenerateVpnProfile(resourceGroupName: string, gatewayName: string, parameters: P2SVpnProfileParameters, options?: P2SVpnGatewaysGenerateVpnProfileOptionalParams): Promise<PollerLike<PollOperationState<P2SVpnGatewaysGenerateVpnProfileResponse>, P2SVpnGatewaysGenerateVpnProfileResponse>>;
    beginGenerateVpnProfileAndWait(resourceGroupName: string, gatewayName: string, parameters: P2SVpnProfileParameters, options?: P2SVpnGatewaysGenerateVpnProfileOptionalParams): Promise<P2SVpnGatewaysGenerateVpnProfileResponse>;
    beginGetP2SVpnConnectionHealth(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysGetP2SVpnConnectionHealthOptionalParams): Promise<PollerLike<PollOperationState<P2SVpnGatewaysGetP2SVpnConnectionHealthResponse>, P2SVpnGatewaysGetP2SVpnConnectionHealthResponse>>;
    beginGetP2SVpnConnectionHealthAndWait(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysGetP2SVpnConnectionHealthOptionalParams): Promise<P2SVpnGatewaysGetP2SVpnConnectionHealthResponse>;
    beginGetP2SVpnConnectionHealthDetailed(resourceGroupName: string, gatewayName: string, request: P2SVpnConnectionHealthRequest, options?: P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedOptionalParams): Promise<PollerLike<PollOperationState<P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedResponse>, P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedResponse>>;
    beginGetP2SVpnConnectionHealthDetailedAndWait(resourceGroupName: string, gatewayName: string, request: P2SVpnConnectionHealthRequest, options?: P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedOptionalParams): Promise<P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedResponse>;
    beginReset(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysResetOptionalParams): Promise<PollerLike<PollOperationState<P2SVpnGatewaysResetResponse>, P2SVpnGatewaysResetResponse>>;
    beginResetAndWait(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysResetOptionalParams): Promise<P2SVpnGatewaysResetResponse>;
    beginUpdateTags(resourceGroupName: string, gatewayName: string, p2SVpnGatewayParameters: TagsObject, options?: P2SVpnGatewaysUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<P2SVpnGatewaysUpdateTagsResponse>, P2SVpnGatewaysUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, gatewayName: string, p2SVpnGatewayParameters: TagsObject, options?: P2SVpnGatewaysUpdateTagsOptionalParams): Promise<P2SVpnGatewaysUpdateTagsResponse>;
    get(resourceGroupName: string, gatewayName: string, options?: P2SVpnGatewaysGetOptionalParams): Promise<P2SVpnGatewaysGetResponse>;
    list(options?: P2SVpnGatewaysListOptionalParams): PagedAsyncIterableIterator<P2SVpnGateway>;
    listByResourceGroup(resourceGroupName: string, options?: P2SVpnGatewaysListByResourceGroupOptionalParams): PagedAsyncIterableIterator<P2SVpnGateway>;
}

// @public
export interface P2SVpnGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type P2SVpnGatewaysCreateOrUpdateResponse = P2SVpnGateway;

// @public
export interface P2SVpnGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface P2SVpnGatewaysDisconnectP2SVpnConnectionsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface P2SVpnGatewaysGenerateVpnProfileOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type P2SVpnGatewaysGenerateVpnProfileResponse = VpnProfileResponse;

// @public
export interface P2SVpnGatewaysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export interface P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type P2SVpnGatewaysGetP2SVpnConnectionHealthDetailedResponse = P2SVpnConnectionHealth;

// @public
export interface P2SVpnGatewaysGetP2SVpnConnectionHealthOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type P2SVpnGatewaysGetP2SVpnConnectionHealthResponse = P2SVpnGateway;

// @public
export type P2SVpnGatewaysGetResponse = P2SVpnGateway;

// @public
export interface P2SVpnGatewaysListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type P2SVpnGatewaysListByResourceGroupNextResponse = ListP2SVpnGatewaysResult;

// @public
export interface P2SVpnGatewaysListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type P2SVpnGatewaysListByResourceGroupResponse = ListP2SVpnGatewaysResult;

// @public
export interface P2SVpnGatewaysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type P2SVpnGatewaysListNextResponse = ListP2SVpnGatewaysResult;

// @public
export interface P2SVpnGatewaysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type P2SVpnGatewaysListResponse = ListP2SVpnGatewaysResult;

// @public
export interface P2SVpnGatewaysResetOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type P2SVpnGatewaysResetResponse = P2SVpnGateway;

// @public
export interface P2SVpnGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type P2SVpnGatewaysUpdateTagsResponse = P2SVpnGateway;

// @public
export interface P2SVpnProfileParameters {
    authenticationMethod?: AuthenticationMethod;
}

// @public
export interface PacketCapture {
    bytesToCapturePerPacket?: number;
    filters?: PacketCaptureFilter[];
    storageLocation: PacketCaptureStorageLocation;
    target: string;
    timeLimitInSeconds?: number;
    totalBytesPerSession?: number;
}

// @public
export interface PacketCaptureFilter {
    localIPAddress?: string;
    localPort?: string;
    protocol?: PcProtocol;
    remoteIPAddress?: string;
    remotePort?: string;
}

// @public
export interface PacketCaptureListResult {
    value?: PacketCaptureResult[];
}

// @public
export interface PacketCaptureParameters {
    bytesToCapturePerPacket?: number;
    filters?: PacketCaptureFilter[];
    storageLocation: PacketCaptureStorageLocation;
    target: string;
    timeLimitInSeconds?: number;
    totalBytesPerSession?: number;
}

// @public
export interface PacketCaptureQueryStatusResult {
    captureStartTime?: Date;
    id?: string;
    name?: string;
    packetCaptureError?: PcError[];
    packetCaptureStatus?: PcStatus;
    stopReason?: string;
}

// @public
export interface PacketCaptureResult {
    bytesToCapturePerPacket?: number;
    readonly etag?: string;
    filters?: PacketCaptureFilter[];
    readonly id?: string;
    readonly name?: string;
    readonly provisioningState?: ProvisioningState;
    storageLocation?: PacketCaptureStorageLocation;
    target?: string;
    timeLimitInSeconds?: number;
    totalBytesPerSession?: number;
}

// @public
export type PacketCaptureResultProperties = PacketCaptureParameters & {
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface PacketCaptures {
    beginCreate(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, parameters: PacketCapture, options?: PacketCapturesCreateOptionalParams): Promise<PollerLike<PollOperationState<PacketCapturesCreateResponse>, PacketCapturesCreateResponse>>;
    beginCreateAndWait(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, parameters: PacketCapture, options?: PacketCapturesCreateOptionalParams): Promise<PacketCapturesCreateResponse>;
    beginDelete(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesDeleteOptionalParams): Promise<void>;
    beginGetStatus(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesGetStatusOptionalParams): Promise<PollerLike<PollOperationState<PacketCapturesGetStatusResponse>, PacketCapturesGetStatusResponse>>;
    beginGetStatusAndWait(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesGetStatusOptionalParams): Promise<PacketCapturesGetStatusResponse>;
    beginStop(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesStopOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginStopAndWait(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesStopOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkWatcherName: string, packetCaptureName: string, options?: PacketCapturesGetOptionalParams): Promise<PacketCapturesGetResponse>;
    list(resourceGroupName: string, networkWatcherName: string, options?: PacketCapturesListOptionalParams): PagedAsyncIterableIterator<PacketCaptureResult>;
}

// @public
export interface PacketCapturesCreateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PacketCapturesCreateResponse = PacketCaptureResult;

// @public
export interface PacketCapturesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PacketCapturesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PacketCapturesGetResponse = PacketCaptureResult;

// @public
export interface PacketCapturesGetStatusOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PacketCapturesGetStatusResponse = PacketCaptureQueryStatusResult;

// @public
export interface PacketCapturesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PacketCapturesListResponse = PacketCaptureListResult;

// @public
export interface PacketCapturesStopOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PacketCaptureStorageLocation {
    filePath?: string;
    storageId?: string;
    storagePath?: string;
}

// @public
export type PatchRouteFilter = SubResource & {
    readonly name?: string;
    readonly etag?: string;
    readonly type?: string;
    tags?: {
        [propertyName: string]: string;
    };
    rules?: RouteFilterRule[];
    readonly peerings?: ExpressRouteCircuitPeering[];
    readonly ipv6Peerings?: ExpressRouteCircuitPeering[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export type PatchRouteFilterRule = SubResource & {
    readonly name?: string;
    readonly etag?: string;
    access?: Access;
    routeFilterRuleType?: RouteFilterRuleType;
    communities?: string[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export type PcError = string;

// @public
export type PcProtocol = string;

// @public
export type PcStatus = string;

// @public
export type PeerExpressRouteCircuitConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    expressRouteCircuitPeering?: SubResource;
    peerExpressRouteCircuitPeering?: SubResource;
    addressPrefix?: string;
    readonly circuitConnectionStatus?: CircuitConnectionStatus;
    connectionName?: string;
    authResourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface PeerExpressRouteCircuitConnectionListResult {
    nextLink?: string;
    value?: PeerExpressRouteCircuitConnection[];
}

// @public
export interface PeerExpressRouteCircuitConnections {
    get(resourceGroupName: string, circuitName: string, peeringName: string, connectionName: string, options?: PeerExpressRouteCircuitConnectionsGetOptionalParams): Promise<PeerExpressRouteCircuitConnectionsGetResponse>;
    list(resourceGroupName: string, circuitName: string, peeringName: string, options?: PeerExpressRouteCircuitConnectionsListOptionalParams): PagedAsyncIterableIterator<PeerExpressRouteCircuitConnection>;
}

// @public
export interface PeerExpressRouteCircuitConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PeerExpressRouteCircuitConnectionsGetResponse = PeerExpressRouteCircuitConnection;

// @public
export interface PeerExpressRouteCircuitConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PeerExpressRouteCircuitConnectionsListNextResponse = PeerExpressRouteCircuitConnectionListResult;

// @public
export interface PeerExpressRouteCircuitConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PeerExpressRouteCircuitConnectionsListResponse = PeerExpressRouteCircuitConnectionListResult;

// @public
export interface PeerRoute {
    readonly asPath?: string;
    readonly localAddress?: string;
    readonly network?: string;
    readonly nextHop?: string;
    readonly origin?: string;
    readonly sourcePeer?: string;
    readonly weight?: number;
}

// @public
export interface PeerRouteList {
    value?: PeerRoute[];
}

// @public
export type PfsGroup = string;

// @public
export interface PolicySettings {
    fileUploadLimitInMb?: number;
    maxRequestBodySizeInKb?: number;
    mode?: WebApplicationFirewallMode;
    requestBodyCheck?: boolean;
    state?: WebApplicationFirewallEnabledState;
}

// @public
export type PreferredIPVersion = string;

// @public
export type PreferredRoutingGateway = string;

// @public
export interface PrepareNetworkPoliciesRequest {
    networkIntentPolicyConfigurations?: NetworkIntentPolicyConfiguration[];
    serviceName?: string;
}

// @public
export interface PrivateDnsZoneConfig {
    name?: string;
    privateDnsZoneId?: string;
    readonly recordSets?: RecordSet[];
}

// @public
export type PrivateDnsZoneGroup = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly provisioningState?: ProvisioningState;
    privateDnsZoneConfigs?: PrivateDnsZoneConfig[];
};

// @public
export interface PrivateDnsZoneGroupListResult {
    readonly nextLink?: string;
    value?: PrivateDnsZoneGroup[];
}

// @public
export interface PrivateDnsZoneGroups {
    beginCreateOrUpdate(resourceGroupName: string, privateEndpointName: string, privateDnsZoneGroupName: string, parameters: PrivateDnsZoneGroup, options?: PrivateDnsZoneGroupsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<PrivateDnsZoneGroupsCreateOrUpdateResponse>, PrivateDnsZoneGroupsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, privateEndpointName: string, privateDnsZoneGroupName: string, parameters: PrivateDnsZoneGroup, options?: PrivateDnsZoneGroupsCreateOrUpdateOptionalParams): Promise<PrivateDnsZoneGroupsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, privateEndpointName: string, privateDnsZoneGroupName: string, options?: PrivateDnsZoneGroupsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, privateEndpointName: string, privateDnsZoneGroupName: string, options?: PrivateDnsZoneGroupsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, privateEndpointName: string, privateDnsZoneGroupName: string, options?: PrivateDnsZoneGroupsGetOptionalParams): Promise<PrivateDnsZoneGroupsGetResponse>;
    list(privateEndpointName: string, resourceGroupName: string, options?: PrivateDnsZoneGroupsListOptionalParams): PagedAsyncIterableIterator<PrivateDnsZoneGroup>;
}

// @public
export interface PrivateDnsZoneGroupsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateDnsZoneGroupsCreateOrUpdateResponse = PrivateDnsZoneGroup;

// @public
export interface PrivateDnsZoneGroupsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PrivateDnsZoneGroupsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateDnsZoneGroupsGetResponse = PrivateDnsZoneGroup;

// @public
export interface PrivateDnsZoneGroupsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateDnsZoneGroupsListNextResponse = PrivateDnsZoneGroupListResult;

// @public
export interface PrivateDnsZoneGroupsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateDnsZoneGroupsListResponse = PrivateDnsZoneGroupListResult;

// @public
export type PrivateEndpoint = Resource & {
    extendedLocation?: ExtendedLocation;
    readonly etag?: string;
    subnet?: Subnet;
    readonly networkInterfaces?: NetworkInterface[];
    readonly provisioningState?: ProvisioningState;
    privateLinkServiceConnections?: PrivateLinkServiceConnection[];
    manualPrivateLinkServiceConnections?: PrivateLinkServiceConnection[];
    customDnsConfigs?: CustomDnsConfigPropertiesFormat[];
    applicationSecurityGroups?: ApplicationSecurityGroup[];
    ipConfigurations?: PrivateEndpointIPConfiguration[];
    customNetworkInterfaceName?: string;
};

// @public
export type PrivateEndpointConnection = SubResource & {
    name?: string;
    readonly type?: string;
    readonly etag?: string;
    readonly privateEndpoint?: PrivateEndpoint;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
    readonly provisioningState?: ProvisioningState;
    readonly linkIdentifier?: string;
};

// @public
export interface PrivateEndpointConnectionListResult {
    readonly nextLink?: string;
    value?: PrivateEndpointConnection[];
}

// @public
export interface PrivateEndpointIPConfiguration {
    readonly etag?: string;
    groupId?: string;
    memberName?: string;
    name?: string;
    privateIPAddress?: string;
    readonly type?: string;
}

// @public
export interface PrivateEndpointListResult {
    readonly nextLink?: string;
    value?: PrivateEndpoint[];
}

// @public
export interface PrivateEndpoints {
    beginCreateOrUpdate(resourceGroupName: string, privateEndpointName: string, parameters: PrivateEndpoint, options?: PrivateEndpointsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<PrivateEndpointsCreateOrUpdateResponse>, PrivateEndpointsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, privateEndpointName: string, parameters: PrivateEndpoint, options?: PrivateEndpointsCreateOrUpdateOptionalParams): Promise<PrivateEndpointsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, privateEndpointName: string, options?: PrivateEndpointsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, privateEndpointName: string, options?: PrivateEndpointsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, privateEndpointName: string, options?: PrivateEndpointsGetOptionalParams): Promise<PrivateEndpointsGetResponse>;
    list(resourceGroupName: string, options?: PrivateEndpointsListOptionalParams): PagedAsyncIterableIterator<PrivateEndpoint>;
    listBySubscription(options?: PrivateEndpointsListBySubscriptionOptionalParams): PagedAsyncIterableIterator<PrivateEndpoint>;
}

// @public
export interface PrivateEndpointsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateEndpointsCreateOrUpdateResponse = PrivateEndpoint;

// @public
export interface PrivateEndpointsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PrivateEndpointsGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type PrivateEndpointsGetResponse = PrivateEndpoint;

// @public
export interface PrivateEndpointsListBySubscriptionNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointsListBySubscriptionNextResponse = PrivateEndpointListResult;

// @public
export interface PrivateEndpointsListBySubscriptionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointsListBySubscriptionResponse = PrivateEndpointListResult;

// @public
export interface PrivateEndpointsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointsListNextResponse = PrivateEndpointListResult;

// @public
export interface PrivateEndpointsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointsListResponse = PrivateEndpointListResult;

// @public
export type PrivateLinkService = Resource & {
    extendedLocation?: ExtendedLocation;
    readonly etag?: string;
    loadBalancerFrontendIpConfigurations?: FrontendIPConfiguration[];
    ipConfigurations?: PrivateLinkServiceIpConfiguration[];
    readonly networkInterfaces?: NetworkInterface[];
    readonly provisioningState?: ProvisioningState;
    readonly privateEndpointConnections?: PrivateEndpointConnection[];
    visibility?: PrivateLinkServicePropertiesVisibility;
    autoApproval?: PrivateLinkServicePropertiesAutoApproval;
    fqdns?: string[];
    readonly alias?: string;
    enableProxyProtocol?: boolean;
};

// @public
export type PrivateLinkServiceConnection = SubResource & {
    name?: string;
    readonly type?: string;
    readonly etag?: string;
    readonly provisioningState?: ProvisioningState;
    privateLinkServiceId?: string;
    groupIds?: string[];
    requestMessage?: string;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
};

// @public
export interface PrivateLinkServiceConnectionState {
    actionsRequired?: string;
    description?: string;
    status?: string;
}

// @public
export type PrivateLinkServiceIpConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    privateIPAddress?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    subnet?: Subnet;
    primary?: boolean;
    readonly provisioningState?: ProvisioningState;
    privateIPAddressVersion?: IPVersion;
};

// @public
export interface PrivateLinkServiceListResult {
    readonly nextLink?: string;
    value?: PrivateLinkService[];
}

// @public
export type PrivateLinkServicePropertiesAutoApproval = ResourceSet & {};

// @public
export type PrivateLinkServicePropertiesVisibility = ResourceSet & {};

// @public
export interface PrivateLinkServices {
    beginCheckPrivateLinkServiceVisibility(location: string, parameters: CheckPrivateLinkServiceVisibilityRequest, options?: PrivateLinkServicesCheckPrivateLinkServiceVisibilityOptionalParams): Promise<PollerLike<PollOperationState<PrivateLinkServicesCheckPrivateLinkServiceVisibilityResponse>, PrivateLinkServicesCheckPrivateLinkServiceVisibilityResponse>>;
    beginCheckPrivateLinkServiceVisibilityAndWait(location: string, parameters: CheckPrivateLinkServiceVisibilityRequest, options?: PrivateLinkServicesCheckPrivateLinkServiceVisibilityOptionalParams): Promise<PrivateLinkServicesCheckPrivateLinkServiceVisibilityResponse>;
    beginCheckPrivateLinkServiceVisibilityByResourceGroup(location: string, resourceGroupName: string, parameters: CheckPrivateLinkServiceVisibilityRequest, options?: PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupOptionalParams): Promise<PollerLike<PollOperationState<PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupResponse>, PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupResponse>>;
    beginCheckPrivateLinkServiceVisibilityByResourceGroupAndWait(location: string, resourceGroupName: string, parameters: CheckPrivateLinkServiceVisibilityRequest, options?: PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupOptionalParams): Promise<PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupResponse>;
    beginCreateOrUpdate(resourceGroupName: string, serviceName: string, parameters: PrivateLinkService, options?: PrivateLinkServicesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<PrivateLinkServicesCreateOrUpdateResponse>, PrivateLinkServicesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, serviceName: string, parameters: PrivateLinkService, options?: PrivateLinkServicesCreateOrUpdateOptionalParams): Promise<PrivateLinkServicesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, serviceName: string, options?: PrivateLinkServicesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, serviceName: string, options?: PrivateLinkServicesDeleteOptionalParams): Promise<void>;
    beginDeletePrivateEndpointConnection(resourceGroupName: string, serviceName: string, peConnectionName: string, options?: PrivateLinkServicesDeletePrivateEndpointConnectionOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeletePrivateEndpointConnectionAndWait(resourceGroupName: string, serviceName: string, peConnectionName: string, options?: PrivateLinkServicesDeletePrivateEndpointConnectionOptionalParams): Promise<void>;
    get(resourceGroupName: string, serviceName: string, options?: PrivateLinkServicesGetOptionalParams): Promise<PrivateLinkServicesGetResponse>;
    getPrivateEndpointConnection(resourceGroupName: string, serviceName: string, peConnectionName: string, options?: PrivateLinkServicesGetPrivateEndpointConnectionOptionalParams): Promise<PrivateLinkServicesGetPrivateEndpointConnectionResponse>;
    list(resourceGroupName: string, options?: PrivateLinkServicesListOptionalParams): PagedAsyncIterableIterator<PrivateLinkService>;
    listAutoApprovedPrivateLinkServices(location: string, options?: PrivateLinkServicesListAutoApprovedPrivateLinkServicesOptionalParams): PagedAsyncIterableIterator<AutoApprovedPrivateLinkService>;
    listAutoApprovedPrivateLinkServicesByResourceGroup(location: string, resourceGroupName: string, options?: PrivateLinkServicesListAutoApprovedPrivateLinkServicesByResourceGroupOptionalParams): PagedAsyncIterableIterator<AutoApprovedPrivateLinkService>;
    listBySubscription(options?: PrivateLinkServicesListBySubscriptionOptionalParams): PagedAsyncIterableIterator<PrivateLinkService>;
    listPrivateEndpointConnections(resourceGroupName: string, serviceName: string, options?: PrivateLinkServicesListPrivateEndpointConnectionsOptionalParams): PagedAsyncIterableIterator<PrivateEndpointConnection>;
    updatePrivateEndpointConnection(resourceGroupName: string, serviceName: string, peConnectionName: string, parameters: PrivateEndpointConnection, options?: PrivateLinkServicesUpdatePrivateEndpointConnectionOptionalParams): Promise<PrivateLinkServicesUpdatePrivateEndpointConnectionResponse>;
}

// @public
export interface PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateLinkServicesCheckPrivateLinkServiceVisibilityByResourceGroupResponse = PrivateLinkServiceVisibility;

// @public
export interface PrivateLinkServicesCheckPrivateLinkServiceVisibilityOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateLinkServicesCheckPrivateLinkServiceVisibilityResponse = PrivateLinkServiceVisibility;

// @public
export interface PrivateLinkServicesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateLinkServicesCreateOrUpdateResponse = PrivateLinkService;

// @public
export interface PrivateLinkServicesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PrivateLinkServicesDeletePrivateEndpointConnectionOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PrivateLinkServicesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export interface PrivateLinkServicesGetPrivateEndpointConnectionOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type PrivateLinkServicesGetPrivateEndpointConnectionResponse = PrivateEndpointConnection;

// @public
export type PrivateLinkServicesGetResponse = PrivateLinkService;

// @public
export interface PrivateLinkServicesListAutoApprovedPrivateLinkServicesByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListAutoApprovedPrivateLinkServicesByResourceGroupNextResponse = AutoApprovedPrivateLinkServicesResult;

// @public
export interface PrivateLinkServicesListAutoApprovedPrivateLinkServicesByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListAutoApprovedPrivateLinkServicesByResourceGroupResponse = AutoApprovedPrivateLinkServicesResult;

// @public
export interface PrivateLinkServicesListAutoApprovedPrivateLinkServicesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListAutoApprovedPrivateLinkServicesNextResponse = AutoApprovedPrivateLinkServicesResult;

// @public
export interface PrivateLinkServicesListAutoApprovedPrivateLinkServicesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListAutoApprovedPrivateLinkServicesResponse = AutoApprovedPrivateLinkServicesResult;

// @public
export interface PrivateLinkServicesListBySubscriptionNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListBySubscriptionNextResponse = PrivateLinkServiceListResult;

// @public
export interface PrivateLinkServicesListBySubscriptionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListBySubscriptionResponse = PrivateLinkServiceListResult;

// @public
export interface PrivateLinkServicesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListNextResponse = PrivateLinkServiceListResult;

// @public
export interface PrivateLinkServicesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export interface PrivateLinkServicesListPrivateEndpointConnectionsNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListPrivateEndpointConnectionsNextResponse = PrivateEndpointConnectionListResult;

// @public
export interface PrivateLinkServicesListPrivateEndpointConnectionsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesListPrivateEndpointConnectionsResponse = PrivateEndpointConnectionListResult;

// @public
export type PrivateLinkServicesListResponse = PrivateLinkServiceListResult;

// @public
export interface PrivateLinkServicesUpdatePrivateEndpointConnectionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkServicesUpdatePrivateEndpointConnectionResponse = PrivateEndpointConnection;

// @public
export interface PrivateLinkServiceVisibility {
    visible?: boolean;
}

// @public
export type Probe = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly loadBalancingRules?: SubResource[];
    protocol?: ProbeProtocol;
    port?: number;
    intervalInSeconds?: number;
    numberOfProbes?: number;
    requestPath?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type ProbeProtocol = string;

// @public
export type ProcessorArchitecture = string;

// @public
export interface PropagatedRouteTable {
    ids?: SubResource[];
    labels?: string[];
}

// @public
export type Protocol = string;

// @public
export interface ProtocolConfiguration {
    httpConfiguration?: HttpConfiguration;
}

// @public
export interface ProtocolCustomSettingsFormat {
    protocol?: DdosCustomPolicyProtocol;
    sourceRateOverride?: string;
    triggerRateOverride?: string;
    triggerSensitivityOverride?: DdosCustomPolicyTriggerSensitivityOverride;
}

// @public
export type ProtocolType = string;

// @public
export type ProvisioningState = string;

// @public
export type PublicIPAddress = Resource & {
    extendedLocation?: ExtendedLocation;
    sku?: PublicIPAddressSku;
    readonly etag?: string;
    zones?: string[];
    publicIPAllocationMethod?: IPAllocationMethod;
    publicIPAddressVersion?: IPVersion;
    readonly ipConfiguration?: IPConfiguration;
    dnsSettings?: PublicIPAddressDnsSettings;
    ddosSettings?: DdosSettings;
    ipTags?: IpTag[];
    ipAddress?: string;
    publicIPPrefix?: SubResource;
    idleTimeoutInMinutes?: number;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    servicePublicIPAddress?: PublicIPAddress;
    natGateway?: NatGateway;
    migrationPhase?: PublicIPAddressMigrationPhase;
    linkedPublicIPAddress?: PublicIPAddress;
    deleteOption?: DeleteOptions;
};

// @public
export interface PublicIPAddressDnsSettings {
    domainNameLabel?: string;
    fqdn?: string;
    reverseFqdn?: string;
}

// @public
export interface PublicIPAddresses {
    beginCreateOrUpdate(resourceGroupName: string, publicIpAddressName: string, parameters: PublicIPAddress, options?: PublicIPAddressesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<PublicIPAddressesCreateOrUpdateResponse>, PublicIPAddressesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, publicIpAddressName: string, parameters: PublicIPAddress, options?: PublicIPAddressesCreateOrUpdateOptionalParams): Promise<PublicIPAddressesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, publicIpAddressName: string, options?: PublicIPAddressesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, publicIpAddressName: string, options?: PublicIPAddressesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, publicIpAddressName: string, options?: PublicIPAddressesGetOptionalParams): Promise<PublicIPAddressesGetResponse>;
    getCloudServicePublicIPAddress(resourceGroupName: string, cloudServiceName: string, roleInstanceName: string, networkInterfaceName: string, ipConfigurationName: string, publicIpAddressName: string, options?: PublicIPAddressesGetCloudServicePublicIPAddressOptionalParams): Promise<PublicIPAddressesGetCloudServicePublicIPAddressResponse>;
    getVirtualMachineScaleSetPublicIPAddress(resourceGroupName: string, virtualMachineScaleSetName: string, virtualmachineIndex: string, networkInterfaceName: string, ipConfigurationName: string, publicIpAddressName: string, options?: PublicIPAddressesGetVirtualMachineScaleSetPublicIPAddressOptionalParams): Promise<PublicIPAddressesGetVirtualMachineScaleSetPublicIPAddressResponse>;
    list(resourceGroupName: string, options?: PublicIPAddressesListOptionalParams): PagedAsyncIterableIterator<PublicIPAddress>;
    listAll(options?: PublicIPAddressesListAllOptionalParams): PagedAsyncIterableIterator<PublicIPAddress>;
    listCloudServicePublicIPAddresses(resourceGroupName: string, cloudServiceName: string, options?: PublicIPAddressesListCloudServicePublicIPAddressesOptionalParams): PagedAsyncIterableIterator<PublicIPAddress>;
    listCloudServiceRoleInstancePublicIPAddresses(resourceGroupName: string, cloudServiceName: string, roleInstanceName: string, networkInterfaceName: string, ipConfigurationName: string, options?: PublicIPAddressesListCloudServiceRoleInstancePublicIPAddressesOptionalParams): PagedAsyncIterableIterator<PublicIPAddress>;
    listVirtualMachineScaleSetPublicIPAddresses(resourceGroupName: string, virtualMachineScaleSetName: string, options?: PublicIPAddressesListVirtualMachineScaleSetPublicIPAddressesOptionalParams): PagedAsyncIterableIterator<PublicIPAddress>;
    listVirtualMachineScaleSetVMPublicIPAddresses(resourceGroupName: string, virtualMachineScaleSetName: string, virtualmachineIndex: string, networkInterfaceName: string, ipConfigurationName: string, options?: PublicIPAddressesListVirtualMachineScaleSetVMPublicIPAddressesOptionalParams): PagedAsyncIterableIterator<PublicIPAddress>;
    updateTags(resourceGroupName: string, publicIpAddressName: string, parameters: TagsObject, options?: PublicIPAddressesUpdateTagsOptionalParams): Promise<PublicIPAddressesUpdateTagsResponse>;
}

// @public
export interface PublicIPAddressesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PublicIPAddressesCreateOrUpdateResponse = PublicIPAddress;

// @public
export interface PublicIPAddressesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PublicIPAddressesGetCloudServicePublicIPAddressOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type PublicIPAddressesGetCloudServicePublicIPAddressResponse = PublicIPAddress;

// @public
export interface PublicIPAddressesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type PublicIPAddressesGetResponse = PublicIPAddress;

// @public
export interface PublicIPAddressesGetVirtualMachineScaleSetPublicIPAddressOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type PublicIPAddressesGetVirtualMachineScaleSetPublicIPAddressResponse = PublicIPAddress;

// @public
export interface PublicIPAddressesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListAllNextResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListAllResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListCloudServicePublicIPAddressesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListCloudServicePublicIPAddressesNextResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListCloudServicePublicIPAddressesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListCloudServicePublicIPAddressesResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListCloudServiceRoleInstancePublicIPAddressesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListCloudServiceRoleInstancePublicIPAddressesNextResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListCloudServiceRoleInstancePublicIPAddressesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListCloudServiceRoleInstancePublicIPAddressesResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListNextResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListVirtualMachineScaleSetPublicIPAddressesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListVirtualMachineScaleSetPublicIPAddressesNextResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListVirtualMachineScaleSetPublicIPAddressesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListVirtualMachineScaleSetPublicIPAddressesResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListVirtualMachineScaleSetVMPublicIPAddressesNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListVirtualMachineScaleSetVMPublicIPAddressesNextResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesListVirtualMachineScaleSetVMPublicIPAddressesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesListVirtualMachineScaleSetVMPublicIPAddressesResponse = PublicIPAddressListResult;

// @public
export interface PublicIPAddressesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPAddressesUpdateTagsResponse = PublicIPAddress;

// @public
export interface PublicIPAddressListResult {
    nextLink?: string;
    value?: PublicIPAddress[];
}

// @public
export type PublicIPAddressMigrationPhase = string;

// @public
export interface PublicIPAddressSku {
    name?: PublicIPAddressSkuName;
    tier?: PublicIPAddressSkuTier;
}

// @public
export type PublicIPAddressSkuName = string;

// @public
export type PublicIPAddressSkuTier = string;

// @public
export type PublicIPPrefix = Resource & {
    extendedLocation?: ExtendedLocation;
    sku?: PublicIPPrefixSku;
    readonly etag?: string;
    zones?: string[];
    publicIPAddressVersion?: IPVersion;
    ipTags?: IpTag[];
    prefixLength?: number;
    readonly ipPrefix?: string;
    readonly publicIPAddresses?: ReferencedPublicIpAddress[];
    readonly loadBalancerFrontendIpConfiguration?: SubResource;
    customIPPrefix?: SubResource;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    natGateway?: NatGateway;
};

// @public
export interface PublicIPPrefixes {
    beginCreateOrUpdate(resourceGroupName: string, publicIpPrefixName: string, parameters: PublicIPPrefix, options?: PublicIPPrefixesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<PublicIPPrefixesCreateOrUpdateResponse>, PublicIPPrefixesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, publicIpPrefixName: string, parameters: PublicIPPrefix, options?: PublicIPPrefixesCreateOrUpdateOptionalParams): Promise<PublicIPPrefixesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, publicIpPrefixName: string, options?: PublicIPPrefixesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, publicIpPrefixName: string, options?: PublicIPPrefixesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, publicIpPrefixName: string, options?: PublicIPPrefixesGetOptionalParams): Promise<PublicIPPrefixesGetResponse>;
    list(resourceGroupName: string, options?: PublicIPPrefixesListOptionalParams): PagedAsyncIterableIterator<PublicIPPrefix>;
    listAll(options?: PublicIPPrefixesListAllOptionalParams): PagedAsyncIterableIterator<PublicIPPrefix>;
    updateTags(resourceGroupName: string, publicIpPrefixName: string, parameters: TagsObject, options?: PublicIPPrefixesUpdateTagsOptionalParams): Promise<PublicIPPrefixesUpdateTagsResponse>;
}

// @public
export interface PublicIPPrefixesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PublicIPPrefixesCreateOrUpdateResponse = PublicIPPrefix;

// @public
export interface PublicIPPrefixesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface PublicIPPrefixesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type PublicIPPrefixesGetResponse = PublicIPPrefix;

// @public
export interface PublicIPPrefixesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPPrefixesListAllNextResponse = PublicIPPrefixListResult;

// @public
export interface PublicIPPrefixesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPPrefixesListAllResponse = PublicIPPrefixListResult;

// @public
export interface PublicIPPrefixesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPPrefixesListNextResponse = PublicIPPrefixListResult;

// @public
export interface PublicIPPrefixesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPPrefixesListResponse = PublicIPPrefixListResult;

// @public
export interface PublicIPPrefixesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PublicIPPrefixesUpdateTagsResponse = PublicIPPrefix;

// @public
export interface PublicIPPrefixListResult {
    nextLink?: string;
    value?: PublicIPPrefix[];
}

// @public
export interface PublicIPPrefixSku {
    name?: PublicIPPrefixSkuName;
    tier?: PublicIPPrefixSkuTier;
}

// @public
export type PublicIPPrefixSkuName = string;

// @public
export type PublicIPPrefixSkuTier = string;

// @public
export interface PutBastionShareableLinkNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PutBastionShareableLinkNextResponse = BastionShareableLinkListResult;

// @public
export interface PutBastionShareableLinkOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PutBastionShareableLinkResponse = BastionShareableLinkListResult;

// @public
export interface QosDefinition {
    destinationIpRanges?: QosIpRange[];
    destinationPortRanges?: QosPortRange[];
    markings?: number[];
    protocol?: ProtocolType;
    sourceIpRanges?: QosIpRange[];
    sourcePortRanges?: QosPortRange[];
}

// @public
export interface QosIpRange {
    endIP?: string;
    startIP?: string;
}

// @public
export interface QosPortRange {
    end?: number;
    start?: number;
}

// @public
export interface QueryInboundNatRulePortMappingRequest {
    ipAddress?: string;
    ipConfiguration?: SubResource;
}

// @public
export interface QueryResults {
    matchingRecordsCount?: number;
    signatures?: SingleQueryResult[];
}

// @public
export interface QueryTroubleshootingParameters {
    targetResourceId: string;
}

// @public
export interface RadiusServer {
    radiusServerAddress: string;
    radiusServerScore?: number;
    radiusServerSecret?: string;
}

// @public
export interface RecordSet {
    fqdn?: string;
    ipAddresses?: string[];
    readonly provisioningState?: ProvisioningState;
    recordSetName?: string;
    recordType?: string;
    ttl?: number;
}

// @public
export interface ReferencedPublicIpAddress {
    id?: string;
}

// @public
export interface Resource {
    id?: string;
    location?: string;
    readonly name?: string;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export type ResourceIdentityType = "SystemAssigned" | "UserAssigned" | "SystemAssigned, UserAssigned" | "None";

// @public
export type ResourceNavigationLink = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    linkedResourceType?: string;
    link?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ResourceNavigationLinks {
    list(resourceGroupName: string, virtualNetworkName: string, subnetName: string, options?: ResourceNavigationLinksListOptionalParams): Promise<ResourceNavigationLinksListResponse>;
}

// @public
export interface ResourceNavigationLinksListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ResourceNavigationLinksListResponse = ResourceNavigationLinksListResult;

// @public
export interface ResourceNavigationLinksListResult {
    readonly nextLink?: string;
    value?: ResourceNavigationLink[];
}

// @public
export interface ResourceSet {
    subscriptions?: string[];
}

// @public
export interface RetentionPolicyParameters {
    days?: number;
    enabled?: boolean;
}

// @public
export type Route = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    addressPrefix?: string;
    nextHopType?: RouteNextHopType;
    nextHopIpAddress?: string;
    readonly provisioningState?: ProvisioningState;
    hasBgpOverride?: boolean;
};

// @public
export type RouteFilter = Resource & {
    readonly etag?: string;
    rules?: RouteFilterRule[];
    readonly peerings?: ExpressRouteCircuitPeering[];
    readonly ipv6Peerings?: ExpressRouteCircuitPeering[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface RouteFilterListResult {
    nextLink?: string;
    value?: RouteFilter[];
}

// @public
export type RouteFilterRule = SubResource & {
    name?: string;
    location?: string;
    readonly etag?: string;
    access?: Access;
    routeFilterRuleType?: RouteFilterRuleType;
    communities?: string[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface RouteFilterRuleListResult {
    nextLink?: string;
    value?: RouteFilterRule[];
}

// @public
export interface RouteFilterRules {
    beginCreateOrUpdate(resourceGroupName: string, routeFilterName: string, ruleName: string, routeFilterRuleParameters: RouteFilterRule, options?: RouteFilterRulesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<RouteFilterRulesCreateOrUpdateResponse>, RouteFilterRulesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, routeFilterName: string, ruleName: string, routeFilterRuleParameters: RouteFilterRule, options?: RouteFilterRulesCreateOrUpdateOptionalParams): Promise<RouteFilterRulesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, routeFilterName: string, ruleName: string, options?: RouteFilterRulesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, routeFilterName: string, ruleName: string, options?: RouteFilterRulesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, routeFilterName: string, ruleName: string, options?: RouteFilterRulesGetOptionalParams): Promise<RouteFilterRulesGetResponse>;
    listByRouteFilter(resourceGroupName: string, routeFilterName: string, options?: RouteFilterRulesListByRouteFilterOptionalParams): PagedAsyncIterableIterator<RouteFilterRule>;
}

// @public
export interface RouteFilterRulesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type RouteFilterRulesCreateOrUpdateResponse = RouteFilterRule;

// @public
export interface RouteFilterRulesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface RouteFilterRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFilterRulesGetResponse = RouteFilterRule;

// @public
export interface RouteFilterRulesListByRouteFilterNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFilterRulesListByRouteFilterNextResponse = RouteFilterRuleListResult;

// @public
export interface RouteFilterRulesListByRouteFilterOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFilterRulesListByRouteFilterResponse = RouteFilterRuleListResult;

// @public
export type RouteFilterRuleType = string;

// @public
export interface RouteFilters {
    beginCreateOrUpdate(resourceGroupName: string, routeFilterName: string, routeFilterParameters: RouteFilter, options?: RouteFiltersCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<RouteFiltersCreateOrUpdateResponse>, RouteFiltersCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, routeFilterName: string, routeFilterParameters: RouteFilter, options?: RouteFiltersCreateOrUpdateOptionalParams): Promise<RouteFiltersCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, routeFilterName: string, options?: RouteFiltersDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, routeFilterName: string, options?: RouteFiltersDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, routeFilterName: string, options?: RouteFiltersGetOptionalParams): Promise<RouteFiltersGetResponse>;
    list(options?: RouteFiltersListOptionalParams): PagedAsyncIterableIterator<RouteFilter>;
    listByResourceGroup(resourceGroupName: string, options?: RouteFiltersListByResourceGroupOptionalParams): PagedAsyncIterableIterator<RouteFilter>;
    updateTags(resourceGroupName: string, routeFilterName: string, parameters: TagsObject, options?: RouteFiltersUpdateTagsOptionalParams): Promise<RouteFiltersUpdateTagsResponse>;
}

// @public
export interface RouteFiltersCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type RouteFiltersCreateOrUpdateResponse = RouteFilter;

// @public
export interface RouteFiltersDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface RouteFiltersGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type RouteFiltersGetResponse = RouteFilter;

// @public
export interface RouteFiltersListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFiltersListByResourceGroupNextResponse = RouteFilterListResult;

// @public
export interface RouteFiltersListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFiltersListByResourceGroupResponse = RouteFilterListResult;

// @public
export interface RouteFiltersListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFiltersListNextResponse = RouteFilterListResult;

// @public
export interface RouteFiltersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFiltersListResponse = RouteFilterListResult;

// @public
export interface RouteFiltersUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteFiltersUpdateTagsResponse = RouteFilter;

// @public
export interface RouteListResult {
    nextLink?: string;
    value?: Route[];
}

// @public
export type RouteNextHopType = string;

// @public
export interface Routes {
    beginCreateOrUpdate(resourceGroupName: string, routeTableName: string, routeName: string, routeParameters: Route, options?: RoutesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<RoutesCreateOrUpdateResponse>, RoutesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, routeTableName: string, routeName: string, routeParameters: Route, options?: RoutesCreateOrUpdateOptionalParams): Promise<RoutesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, routeTableName: string, routeName: string, options?: RoutesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, routeTableName: string, routeName: string, options?: RoutesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, routeTableName: string, routeName: string, options?: RoutesGetOptionalParams): Promise<RoutesGetResponse>;
    list(resourceGroupName: string, routeTableName: string, options?: RoutesListOptionalParams): PagedAsyncIterableIterator<Route>;
}

// @public
export interface RoutesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type RoutesCreateOrUpdateResponse = Route;

// @public
export interface RoutesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface RoutesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RoutesGetResponse = Route;

// @public
export interface RoutesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RoutesListNextResponse = RouteListResult;

// @public
export interface RoutesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RoutesListResponse = RouteListResult;

// @public
export type RouteTable = Resource & {
    readonly etag?: string;
    routes?: Route[];
    readonly subnets?: Subnet[];
    disableBgpRoutePropagation?: boolean;
    readonly provisioningState?: ProvisioningState;
    readonly resourceGuid?: string;
};

// @public
export interface RouteTableListResult {
    nextLink?: string;
    value?: RouteTable[];
}

// @public
export interface RouteTables {
    beginCreateOrUpdate(resourceGroupName: string, routeTableName: string, parameters: RouteTable, options?: RouteTablesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<RouteTablesCreateOrUpdateResponse>, RouteTablesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, routeTableName: string, parameters: RouteTable, options?: RouteTablesCreateOrUpdateOptionalParams): Promise<RouteTablesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, routeTableName: string, options?: RouteTablesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, routeTableName: string, options?: RouteTablesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, routeTableName: string, options?: RouteTablesGetOptionalParams): Promise<RouteTablesGetResponse>;
    list(resourceGroupName: string, options?: RouteTablesListOptionalParams): PagedAsyncIterableIterator<RouteTable>;
    listAll(options?: RouteTablesListAllOptionalParams): PagedAsyncIterableIterator<RouteTable>;
    updateTags(resourceGroupName: string, routeTableName: string, parameters: TagsObject, options?: RouteTablesUpdateTagsOptionalParams): Promise<RouteTablesUpdateTagsResponse>;
}

// @public
export interface RouteTablesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type RouteTablesCreateOrUpdateResponse = RouteTable;

// @public
export interface RouteTablesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface RouteTablesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type RouteTablesGetResponse = RouteTable;

// @public
export interface RouteTablesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteTablesListAllNextResponse = RouteTableListResult;

// @public
export interface RouteTablesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteTablesListAllResponse = RouteTableListResult;

// @public
export interface RouteTablesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteTablesListNextResponse = RouteTableListResult;

// @public
export interface RouteTablesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteTablesListResponse = RouteTableListResult;

// @public
export interface RouteTablesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RouteTablesUpdateTagsResponse = RouteTable;

// @public
export interface RoutingConfiguration {
    associatedRouteTable?: SubResource;
    propagatedRouteTables?: PropagatedRouteTable;
    vnetRoutes?: VnetRoute;
}

// @public
export type RoutingIntent = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    routingPolicies?: RoutingPolicy[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface RoutingIntentCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type RoutingIntentCreateOrUpdateResponse = RoutingIntent;

// @public
export interface RoutingIntentDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface RoutingIntentGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RoutingIntentGetResponse = RoutingIntent;

// @public
export interface RoutingIntentListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RoutingIntentListNextResponse = ListRoutingIntentResult;

// @public
export interface RoutingIntentListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type RoutingIntentListResponse = ListRoutingIntentResult;

// @public
export interface RoutingIntentOperations {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, routingIntentName: string, routingIntentParameters: RoutingIntent, options?: RoutingIntentCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<RoutingIntentCreateOrUpdateResponse>, RoutingIntentCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, routingIntentName: string, routingIntentParameters: RoutingIntent, options?: RoutingIntentCreateOrUpdateOptionalParams): Promise<RoutingIntentCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, routingIntentName: string, options?: RoutingIntentDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, routingIntentName: string, options?: RoutingIntentDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, routingIntentName: string, options?: RoutingIntentGetOptionalParams): Promise<RoutingIntentGetResponse>;
    list(resourceGroupName: string, virtualHubName: string, options?: RoutingIntentListOptionalParams): PagedAsyncIterableIterator<RoutingIntent>;
}

// @public
export interface RoutingPolicy {
    destinations: string[];
    name: string;
    nextHop: string;
}

// @public
export type RoutingState = string;

// @public
export interface SecurityGroupNetworkInterface {
    id?: string;
    securityRuleAssociations?: SecurityRuleAssociations;
}

// @public
export interface SecurityGroupViewParameters {
    targetResourceId: string;
}

// @public
export interface SecurityGroupViewResult {
    networkInterfaces?: SecurityGroupNetworkInterface[];
}

// @public
export type SecurityPartnerProvider = Resource & {
    readonly etag?: string;
    readonly provisioningState?: ProvisioningState;
    securityProviderName?: SecurityProviderName;
    readonly connectionStatus?: SecurityPartnerProviderConnectionStatus;
    virtualHub?: SubResource;
};

// @public
export type SecurityPartnerProviderConnectionStatus = string;

// @public
export interface SecurityPartnerProviderListResult {
    nextLink?: string;
    value?: SecurityPartnerProvider[];
}

// @public
export interface SecurityPartnerProviders {
    beginCreateOrUpdate(resourceGroupName: string, securityPartnerProviderName: string, parameters: SecurityPartnerProvider, options?: SecurityPartnerProvidersCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<SecurityPartnerProvidersCreateOrUpdateResponse>, SecurityPartnerProvidersCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, securityPartnerProviderName: string, parameters: SecurityPartnerProvider, options?: SecurityPartnerProvidersCreateOrUpdateOptionalParams): Promise<SecurityPartnerProvidersCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, securityPartnerProviderName: string, options?: SecurityPartnerProvidersDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, securityPartnerProviderName: string, options?: SecurityPartnerProvidersDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, securityPartnerProviderName: string, options?: SecurityPartnerProvidersGetOptionalParams): Promise<SecurityPartnerProvidersGetResponse>;
    list(options?: SecurityPartnerProvidersListOptionalParams): PagedAsyncIterableIterator<SecurityPartnerProvider>;
    listByResourceGroup(resourceGroupName: string, options?: SecurityPartnerProvidersListByResourceGroupOptionalParams): PagedAsyncIterableIterator<SecurityPartnerProvider>;
    updateTags(resourceGroupName: string, securityPartnerProviderName: string, parameters: TagsObject, options?: SecurityPartnerProvidersUpdateTagsOptionalParams): Promise<SecurityPartnerProvidersUpdateTagsResponse>;
}

// @public
export interface SecurityPartnerProvidersCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type SecurityPartnerProvidersCreateOrUpdateResponse = SecurityPartnerProvider;

// @public
export interface SecurityPartnerProvidersDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface SecurityPartnerProvidersGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityPartnerProvidersGetResponse = SecurityPartnerProvider;

// @public
export interface SecurityPartnerProvidersListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityPartnerProvidersListByResourceGroupNextResponse = SecurityPartnerProviderListResult;

// @public
export interface SecurityPartnerProvidersListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityPartnerProvidersListByResourceGroupResponse = SecurityPartnerProviderListResult;

// @public
export interface SecurityPartnerProvidersListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityPartnerProvidersListNextResponse = SecurityPartnerProviderListResult;

// @public
export interface SecurityPartnerProvidersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityPartnerProvidersListResponse = SecurityPartnerProviderListResult;

// @public
export interface SecurityPartnerProvidersUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityPartnerProvidersUpdateTagsResponse = SecurityPartnerProvider;

// @public
export type SecurityProviderName = string;

// @public
export type SecurityRule = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    description?: string;
    protocol?: SecurityRuleProtocol;
    sourcePortRange?: string;
    destinationPortRange?: string;
    sourceAddressPrefix?: string;
    sourceAddressPrefixes?: string[];
    sourceApplicationSecurityGroups?: ApplicationSecurityGroup[];
    destinationAddressPrefix?: string;
    destinationAddressPrefixes?: string[];
    destinationApplicationSecurityGroups?: ApplicationSecurityGroup[];
    sourcePortRanges?: string[];
    destinationPortRanges?: string[];
    access?: SecurityRuleAccess;
    priority?: number;
    direction?: SecurityRuleDirection;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type SecurityRuleAccess = string;

// @public
export interface SecurityRuleAssociations {
    defaultSecurityRules?: SecurityRule[];
    effectiveSecurityRules?: EffectiveNetworkSecurityRule[];
    networkInterfaceAssociation?: NetworkInterfaceAssociation;
    subnetAssociation?: SubnetAssociation;
}

// @public
export type SecurityRuleDirection = string;

// @public
export interface SecurityRuleListResult {
    nextLink?: string;
    value?: SecurityRule[];
}

// @public
export type SecurityRuleProtocol = string;

// @public
export interface SecurityRules {
    beginCreateOrUpdate(resourceGroupName: string, networkSecurityGroupName: string, securityRuleName: string, securityRuleParameters: SecurityRule, options?: SecurityRulesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<SecurityRulesCreateOrUpdateResponse>, SecurityRulesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkSecurityGroupName: string, securityRuleName: string, securityRuleParameters: SecurityRule, options?: SecurityRulesCreateOrUpdateOptionalParams): Promise<SecurityRulesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkSecurityGroupName: string, securityRuleName: string, options?: SecurityRulesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkSecurityGroupName: string, securityRuleName: string, options?: SecurityRulesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkSecurityGroupName: string, securityRuleName: string, options?: SecurityRulesGetOptionalParams): Promise<SecurityRulesGetResponse>;
    list(resourceGroupName: string, networkSecurityGroupName: string, options?: SecurityRulesListOptionalParams): PagedAsyncIterableIterator<SecurityRule>;
}

// @public
export interface SecurityRulesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type SecurityRulesCreateOrUpdateResponse = SecurityRule;

// @public
export interface SecurityRulesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface SecurityRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityRulesGetResponse = SecurityRule;

// @public
export interface SecurityRulesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityRulesListNextResponse = SecurityRuleListResult;

// @public
export interface SecurityRulesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecurityRulesListResponse = SecurityRuleListResult;

// @public
export type ServiceAssociationLink = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    linkedResourceType?: string;
    link?: string;
    readonly provisioningState?: ProvisioningState;
    allowDelete?: boolean;
    locations?: string[];
};

// @public
export interface ServiceAssociationLinks {
    list(resourceGroupName: string, virtualNetworkName: string, subnetName: string, options?: ServiceAssociationLinksListOptionalParams): Promise<ServiceAssociationLinksListResponse>;
}

// @public
export interface ServiceAssociationLinksListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceAssociationLinksListResponse = ServiceAssociationLinksListResult;

// @public
export interface ServiceAssociationLinksListResult {
    readonly nextLink?: string;
    value?: ServiceAssociationLink[];
}

// @public
export interface ServiceEndpointPolicies {
    beginCreateOrUpdate(resourceGroupName: string, serviceEndpointPolicyName: string, parameters: ServiceEndpointPolicy, options?: ServiceEndpointPoliciesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ServiceEndpointPoliciesCreateOrUpdateResponse>, ServiceEndpointPoliciesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, serviceEndpointPolicyName: string, parameters: ServiceEndpointPolicy, options?: ServiceEndpointPoliciesCreateOrUpdateOptionalParams): Promise<ServiceEndpointPoliciesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, serviceEndpointPolicyName: string, options?: ServiceEndpointPoliciesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, serviceEndpointPolicyName: string, options?: ServiceEndpointPoliciesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, serviceEndpointPolicyName: string, options?: ServiceEndpointPoliciesGetOptionalParams): Promise<ServiceEndpointPoliciesGetResponse>;
    list(options?: ServiceEndpointPoliciesListOptionalParams): PagedAsyncIterableIterator<ServiceEndpointPolicy>;
    listByResourceGroup(resourceGroupName: string, options?: ServiceEndpointPoliciesListByResourceGroupOptionalParams): PagedAsyncIterableIterator<ServiceEndpointPolicy>;
    updateTags(resourceGroupName: string, serviceEndpointPolicyName: string, parameters: TagsObject, options?: ServiceEndpointPoliciesUpdateTagsOptionalParams): Promise<ServiceEndpointPoliciesUpdateTagsResponse>;
}

// @public
export interface ServiceEndpointPoliciesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ServiceEndpointPoliciesCreateOrUpdateResponse = ServiceEndpointPolicy;

// @public
export interface ServiceEndpointPoliciesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ServiceEndpointPoliciesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type ServiceEndpointPoliciesGetResponse = ServiceEndpointPolicy;

// @public
export interface ServiceEndpointPoliciesListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPoliciesListByResourceGroupNextResponse = ServiceEndpointPolicyListResult;

// @public
export interface ServiceEndpointPoliciesListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPoliciesListByResourceGroupResponse = ServiceEndpointPolicyListResult;

// @public
export interface ServiceEndpointPoliciesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPoliciesListNextResponse = ServiceEndpointPolicyListResult;

// @public
export interface ServiceEndpointPoliciesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPoliciesListResponse = ServiceEndpointPolicyListResult;

// @public
export interface ServiceEndpointPoliciesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPoliciesUpdateTagsResponse = ServiceEndpointPolicy;

// @public
export type ServiceEndpointPolicy = Resource & {
    readonly etag?: string;
    readonly kind?: string;
    serviceEndpointPolicyDefinitions?: ServiceEndpointPolicyDefinition[];
    readonly subnets?: Subnet[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    serviceAlias?: string;
    contextualServiceEndpointPolicies?: string[];
};

// @public
export type ServiceEndpointPolicyDefinition = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    description?: string;
    service?: string;
    serviceResources?: string[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface ServiceEndpointPolicyDefinitionListResult {
    nextLink?: string;
    value?: ServiceEndpointPolicyDefinition[];
}

// @public
export interface ServiceEndpointPolicyDefinitions {
    beginCreateOrUpdate(resourceGroupName: string, serviceEndpointPolicyName: string, serviceEndpointPolicyDefinitionName: string, serviceEndpointPolicyDefinitions: ServiceEndpointPolicyDefinition, options?: ServiceEndpointPolicyDefinitionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ServiceEndpointPolicyDefinitionsCreateOrUpdateResponse>, ServiceEndpointPolicyDefinitionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, serviceEndpointPolicyName: string, serviceEndpointPolicyDefinitionName: string, serviceEndpointPolicyDefinitions: ServiceEndpointPolicyDefinition, options?: ServiceEndpointPolicyDefinitionsCreateOrUpdateOptionalParams): Promise<ServiceEndpointPolicyDefinitionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, serviceEndpointPolicyName: string, serviceEndpointPolicyDefinitionName: string, options?: ServiceEndpointPolicyDefinitionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, serviceEndpointPolicyName: string, serviceEndpointPolicyDefinitionName: string, options?: ServiceEndpointPolicyDefinitionsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, serviceEndpointPolicyName: string, serviceEndpointPolicyDefinitionName: string, options?: ServiceEndpointPolicyDefinitionsGetOptionalParams): Promise<ServiceEndpointPolicyDefinitionsGetResponse>;
    listByResourceGroup(resourceGroupName: string, serviceEndpointPolicyName: string, options?: ServiceEndpointPolicyDefinitionsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<ServiceEndpointPolicyDefinition>;
}

// @public
export interface ServiceEndpointPolicyDefinitionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ServiceEndpointPolicyDefinitionsCreateOrUpdateResponse = ServiceEndpointPolicyDefinition;

// @public
export interface ServiceEndpointPolicyDefinitionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ServiceEndpointPolicyDefinitionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPolicyDefinitionsGetResponse = ServiceEndpointPolicyDefinition;

// @public
export interface ServiceEndpointPolicyDefinitionsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPolicyDefinitionsListByResourceGroupNextResponse = ServiceEndpointPolicyDefinitionListResult;

// @public
export interface ServiceEndpointPolicyDefinitionsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceEndpointPolicyDefinitionsListByResourceGroupResponse = ServiceEndpointPolicyDefinitionListResult;

// @public
export interface ServiceEndpointPolicyListResult {
    readonly nextLink?: string;
    value?: ServiceEndpointPolicy[];
}

// @public
export interface ServiceEndpointPropertiesFormat {
    locations?: string[];
    readonly provisioningState?: ProvisioningState;
    service?: string;
}

// @public
export type ServiceProviderProvisioningState = string;

// @public
export interface ServiceTagInformation {
    readonly id?: string;
    readonly name?: string;
    readonly properties?: ServiceTagInformationPropertiesFormat;
    readonly serviceTagChangeNumber?: string;
}

// @public
export interface ServiceTagInformationListNextOptionalParams extends coreClient.OperationOptions {
    noAddressPrefixes?: boolean;
    tagName?: string;
}

// @public
export type ServiceTagInformationListNextResponse = ServiceTagInformationListResult;

// @public
export interface ServiceTagInformationListOptionalParams extends coreClient.OperationOptions {
    noAddressPrefixes?: boolean;
    tagName?: string;
}

// @public
export type ServiceTagInformationListResponse = ServiceTagInformationListResult;

// @public
export interface ServiceTagInformationListResult {
    readonly nextLink?: string;
    value?: ServiceTagInformation[];
}

// @public
export interface ServiceTagInformationOperations {
    list(location: string, options?: ServiceTagInformationListOptionalParams): PagedAsyncIterableIterator<ServiceTagInformation>;
}

// @public
export interface ServiceTagInformationPropertiesFormat {
    readonly addressPrefixes?: string[];
    readonly changeNumber?: string;
    readonly region?: string;
    readonly state?: string;
    readonly systemService?: string;
}

// @public
export interface ServiceTags {
    list(location: string, options?: ServiceTagsListOptionalParams): Promise<ServiceTagsListResponse>;
}

// @public
export interface ServiceTagsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ServiceTagsListResponse = ServiceTagsListResult;

// @public
export interface ServiceTagsListResult {
    readonly changeNumber?: string;
    readonly cloud?: string;
    readonly id?: string;
    readonly name?: string;
    readonly nextLink?: string;
    readonly type?: string;
    readonly values?: ServiceTagInformation[];
}

// @public
export interface SessionIds {
    sessionIds?: string[];
}

// @public
export type Severity = string;

// @public
export interface SignatureOverridesFilterValuesQuery {
    filterName?: string;
}

// @public
export interface SignatureOverridesFilterValuesResponse {
    filterValues?: string[];
}

// @public
export interface SignaturesOverrides {
    id?: string;
    name?: string;
    properties?: SignaturesOverridesProperties;
    type?: string;
}

// @public
export interface SignaturesOverridesList {
    value?: SignaturesOverrides[];
}

// @public
export interface SignaturesOverridesProperties {
    signatures?: {
        [propertyName: string]: string;
    };
}

// @public (undocumented)
export interface SingleQueryResult {
    description?: string;
    destinationPorts?: string[];
    direction?: Enum71;
    group?: string;
    inheritedFromParentPolicy?: boolean;
    lastUpdated?: string;
    mode?: Enum69;
    protocol?: string;
    severity?: Enum70;
    signatureId?: number;
    sourcePorts?: string[];
}

// @public
export interface Sku {
    name?: BastionHostSkuName;
}

// @public
export interface StaticRoute {
    addressPrefixes?: string[];
    name?: string;
    nextHopIpAddress?: string;
}

// @public
export type Subnet = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    addressPrefix?: string;
    addressPrefixes?: string[];
    networkSecurityGroup?: NetworkSecurityGroup;
    routeTable?: RouteTable;
    natGateway?: SubResource;
    serviceEndpoints?: ServiceEndpointPropertiesFormat[];
    serviceEndpointPolicies?: ServiceEndpointPolicy[];
    readonly privateEndpoints?: PrivateEndpoint[];
    readonly ipConfigurations?: IPConfiguration[];
    readonly ipConfigurationProfiles?: IPConfigurationProfile[];
    ipAllocations?: SubResource[];
    readonly resourceNavigationLinks?: ResourceNavigationLink[];
    readonly serviceAssociationLinks?: ServiceAssociationLink[];
    delegations?: Delegation[];
    readonly purpose?: string;
    readonly provisioningState?: ProvisioningState;
    privateEndpointNetworkPolicies?: VirtualNetworkPrivateEndpointNetworkPolicies;
    privateLinkServiceNetworkPolicies?: VirtualNetworkPrivateLinkServiceNetworkPolicies;
    applicationGatewayIpConfigurations?: ApplicationGatewayIPConfiguration[];
};

// @public
export interface SubnetAssociation {
    readonly id?: string;
    securityRules?: SecurityRule[];
}

// @public
export interface SubnetListResult {
    nextLink?: string;
    value?: Subnet[];
}

// @public
export interface Subnets {
    beginCreateOrUpdate(resourceGroupName: string, virtualNetworkName: string, subnetName: string, subnetParameters: Subnet, options?: SubnetsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<SubnetsCreateOrUpdateResponse>, SubnetsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualNetworkName: string, subnetName: string, subnetParameters: Subnet, options?: SubnetsCreateOrUpdateOptionalParams): Promise<SubnetsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualNetworkName: string, subnetName: string, options?: SubnetsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualNetworkName: string, subnetName: string, options?: SubnetsDeleteOptionalParams): Promise<void>;
    beginPrepareNetworkPolicies(resourceGroupName: string, virtualNetworkName: string, subnetName: string, prepareNetworkPoliciesRequestParameters: PrepareNetworkPoliciesRequest, options?: SubnetsPrepareNetworkPoliciesOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginPrepareNetworkPoliciesAndWait(resourceGroupName: string, virtualNetworkName: string, subnetName: string, prepareNetworkPoliciesRequestParameters: PrepareNetworkPoliciesRequest, options?: SubnetsPrepareNetworkPoliciesOptionalParams): Promise<void>;
    beginUnprepareNetworkPolicies(resourceGroupName: string, virtualNetworkName: string, subnetName: string, unprepareNetworkPoliciesRequestParameters: UnprepareNetworkPoliciesRequest, options?: SubnetsUnprepareNetworkPoliciesOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginUnprepareNetworkPoliciesAndWait(resourceGroupName: string, virtualNetworkName: string, subnetName: string, unprepareNetworkPoliciesRequestParameters: UnprepareNetworkPoliciesRequest, options?: SubnetsUnprepareNetworkPoliciesOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualNetworkName: string, subnetName: string, options?: SubnetsGetOptionalParams): Promise<SubnetsGetResponse>;
    list(resourceGroupName: string, virtualNetworkName: string, options?: SubnetsListOptionalParams): PagedAsyncIterableIterator<Subnet>;
}

// @public
export interface SubnetsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type SubnetsCreateOrUpdateResponse = Subnet;

// @public
export interface SubnetsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface SubnetsGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type SubnetsGetResponse = Subnet;

// @public
export interface SubnetsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SubnetsListNextResponse = SubnetListResult;

// @public
export interface SubnetsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SubnetsListResponse = SubnetListResult;

// @public
export interface SubnetsPrepareNetworkPoliciesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface SubnetsUnprepareNetworkPoliciesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface SubResource {
    id?: string;
}

// @public
export interface SupportedSecurityProvidersOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SupportedSecurityProvidersResponse = VirtualWanSecurityProviders;

// @public
export type SyncRemoteAddressSpace = string;

// @public
export interface TagsObject {
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface Topology {
    readonly createdDateTime?: Date;
    readonly id?: string;
    readonly lastModified?: Date;
    resources?: TopologyResource[];
}

// @public
export interface TopologyAssociation {
    associationType?: AssociationType;
    name?: string;
    resourceId?: string;
}

// @public
export interface TopologyParameters {
    targetResourceGroupName?: string;
    targetSubnet?: SubResource;
    targetVirtualNetwork?: SubResource;
}

// @public
export interface TopologyResource {
    associations?: TopologyAssociation[];
    id?: string;
    location?: string;
    name?: string;
}

// @public
export interface TrafficAnalyticsConfigurationProperties {
    enabled?: boolean;
    trafficAnalyticsInterval?: number;
    workspaceId?: string;
    workspaceRegion?: string;
    workspaceResourceId?: string;
}

// @public
export interface TrafficAnalyticsProperties {
    networkWatcherFlowAnalyticsConfiguration?: TrafficAnalyticsConfigurationProperties;
}

// @public
export interface TrafficSelectorPolicy {
    localAddressRanges: string[];
    remoteAddressRanges: string[];
}

// @public
export type TransportProtocol = string;

// @public
export interface TroubleshootingDetails {
    detail?: string;
    id?: string;
    reasonType?: string;
    recommendedActions?: TroubleshootingRecommendedActions[];
    summary?: string;
}

// @public
export interface TroubleshootingParameters {
    storageId: string;
    storagePath: string;
    targetResourceId: string;
}

// @public
export interface TroubleshootingRecommendedActions {
    actionId?: string;
    actionText?: string;
    actionUri?: string;
    actionUriText?: string;
}

// @public
export interface TroubleshootingResult {
    code?: string;
    endTime?: Date;
    results?: TroubleshootingDetails[];
    startTime?: Date;
}

// @public
export interface TunnelConnectionHealth {
    readonly connectionStatus?: VirtualNetworkGatewayConnectionStatus;
    readonly egressBytesTransferred?: number;
    readonly ingressBytesTransferred?: number;
    readonly lastConnectionEstablishedUtcTime?: string;
    readonly tunnel?: string;
}

// @public
export type TunnelConnectionStatus = string;

// @public
export interface UnprepareNetworkPoliciesRequest {
    serviceName?: string;
}

// @public
export interface Usage {
    currentValue: number;
    readonly id?: string;
    limit: number;
    name: UsageName;
    unit: UsageUnit;
}

// @public
export interface UsageName {
    localizedValue?: string;
    value?: string;
}

// @public
export interface Usages {
    list(location: string, options?: UsagesListOptionalParams): PagedAsyncIterableIterator<Usage>;
}

// @public
export interface UsagesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type UsagesListNextResponse = UsagesListResult;

// @public
export interface UsagesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type UsagesListResponse = UsagesListResult;

// @public
export interface UsagesListResult {
    nextLink?: string;
    value?: Usage[];
}

// @public
export type UsageUnit = string;

// @public
export type VerbosityLevel = string;

// @public
export interface VerificationIPFlowParameters {
    direction: Direction;
    localIPAddress: string;
    localPort: string;
    protocol: IpFlowProtocol;
    remoteIPAddress: string;
    remotePort: string;
    targetNicResourceId?: string;
    targetResourceId: string;
}

// @public
export interface VerificationIPFlowResult {
    access?: Access;
    ruleName?: string;
}

// @public
export interface VirtualApplianceNicProperties {
    readonly name?: string;
    readonly privateIpAddress?: string;
    readonly publicIpAddress?: string;
}

// @public
export type VirtualApplianceSite = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    addressPrefix?: string;
    o365Policy?: Office365PolicyProperties;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface VirtualApplianceSites {
    beginCreateOrUpdate(resourceGroupName: string, networkVirtualApplianceName: string, siteName: string, parameters: VirtualApplianceSite, options?: VirtualApplianceSitesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualApplianceSitesCreateOrUpdateResponse>, VirtualApplianceSitesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, networkVirtualApplianceName: string, siteName: string, parameters: VirtualApplianceSite, options?: VirtualApplianceSitesCreateOrUpdateOptionalParams): Promise<VirtualApplianceSitesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, networkVirtualApplianceName: string, siteName: string, options?: VirtualApplianceSitesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, networkVirtualApplianceName: string, siteName: string, options?: VirtualApplianceSitesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, networkVirtualApplianceName: string, siteName: string, options?: VirtualApplianceSitesGetOptionalParams): Promise<VirtualApplianceSitesGetResponse>;
    list(resourceGroupName: string, networkVirtualApplianceName: string, options?: VirtualApplianceSitesListOptionalParams): PagedAsyncIterableIterator<VirtualApplianceSite>;
}

// @public
export interface VirtualApplianceSitesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualApplianceSitesCreateOrUpdateResponse = VirtualApplianceSite;

// @public
export interface VirtualApplianceSitesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualApplianceSitesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualApplianceSitesGetResponse = VirtualApplianceSite;

// @public
export interface VirtualApplianceSitesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualApplianceSitesListNextResponse = NetworkVirtualApplianceSiteListResult;

// @public
export interface VirtualApplianceSitesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualApplianceSitesListResponse = NetworkVirtualApplianceSiteListResult;

// @public
export interface VirtualApplianceSkuProperties {
    bundledScaleUnit?: string;
    marketPlaceVersion?: string;
    vendor?: string;
}

// @public
export interface VirtualApplianceSkus {
    get(skuName: string, options?: VirtualApplianceSkusGetOptionalParams): Promise<VirtualApplianceSkusGetResponse>;
    list(options?: VirtualApplianceSkusListOptionalParams): PagedAsyncIterableIterator<NetworkVirtualApplianceSku>;
}

// @public
export interface VirtualApplianceSkusGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualApplianceSkusGetResponse = NetworkVirtualApplianceSku;

// @public
export interface VirtualApplianceSkusListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualApplianceSkusListNextResponse = NetworkVirtualApplianceSkuListResult;

// @public
export interface VirtualApplianceSkusListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualApplianceSkusListResponse = NetworkVirtualApplianceSkuListResult;

// @public
export type VirtualHub = Resource & {
    readonly etag?: string;
    readonly kind?: string;
    virtualWan?: SubResource;
    vpnGateway?: SubResource;
    p2SVpnGateway?: SubResource;
    expressRouteGateway?: SubResource;
    azureFirewall?: SubResource;
    securityPartnerProvider?: SubResource;
    addressPrefix?: string;
    routeTable?: VirtualHubRouteTable;
    readonly provisioningState?: ProvisioningState;
    securityProviderName?: string;
    virtualHubRouteTableV2S?: VirtualHubRouteTableV2[];
    sku?: string;
    readonly routingState?: RoutingState;
    readonly bgpConnections?: SubResource[];
    readonly ipConfigurations?: SubResource[];
    virtualRouterAsn?: number;
    virtualRouterIps?: string[];
    allowBranchToBranchTraffic?: boolean;
    preferredRoutingGateway?: PreferredRoutingGateway;
};

// @public
export interface VirtualHubBgpConnection {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, connectionName: string, parameters: BgpConnection, options?: VirtualHubBgpConnectionCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualHubBgpConnectionCreateOrUpdateResponse>, VirtualHubBgpConnectionCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, connectionName: string, parameters: BgpConnection, options?: VirtualHubBgpConnectionCreateOrUpdateOptionalParams): Promise<VirtualHubBgpConnectionCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, connectionName: string, options?: VirtualHubBgpConnectionDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, connectionName: string, options?: VirtualHubBgpConnectionDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, connectionName: string, options?: VirtualHubBgpConnectionGetOptionalParams): Promise<VirtualHubBgpConnectionGetResponse>;
}

// @public
export interface VirtualHubBgpConnectionCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualHubBgpConnectionCreateOrUpdateResponse = BgpConnection;

// @public
export interface VirtualHubBgpConnectionDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualHubBgpConnectionGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubBgpConnectionGetResponse = BgpConnection;

// @public
export interface VirtualHubBgpConnections {
    beginListAdvertisedRoutes(resourceGroupName: string, hubName: string, connectionName: string, options?: VirtualHubBgpConnectionsListAdvertisedRoutesOptionalParams): Promise<PollerLike<PollOperationState<VirtualHubBgpConnectionsListAdvertisedRoutesResponse>, VirtualHubBgpConnectionsListAdvertisedRoutesResponse>>;
    beginListAdvertisedRoutesAndWait(resourceGroupName: string, hubName: string, connectionName: string, options?: VirtualHubBgpConnectionsListAdvertisedRoutesOptionalParams): Promise<VirtualHubBgpConnectionsListAdvertisedRoutesResponse>;
    beginListLearnedRoutes(resourceGroupName: string, hubName: string, connectionName: string, options?: VirtualHubBgpConnectionsListLearnedRoutesOptionalParams): Promise<PollerLike<PollOperationState<VirtualHubBgpConnectionsListLearnedRoutesResponse>, VirtualHubBgpConnectionsListLearnedRoutesResponse>>;
    beginListLearnedRoutesAndWait(resourceGroupName: string, hubName: string, connectionName: string, options?: VirtualHubBgpConnectionsListLearnedRoutesOptionalParams): Promise<VirtualHubBgpConnectionsListLearnedRoutesResponse>;
    list(resourceGroupName: string, virtualHubName: string, options?: VirtualHubBgpConnectionsListOptionalParams): PagedAsyncIterableIterator<BgpConnection>;
}

// @public
export interface VirtualHubBgpConnectionsListAdvertisedRoutesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualHubBgpConnectionsListAdvertisedRoutesResponse = PeerRouteList;

// @public
export interface VirtualHubBgpConnectionsListLearnedRoutesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualHubBgpConnectionsListLearnedRoutesResponse = PeerRouteList;

// @public
export interface VirtualHubBgpConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubBgpConnectionsListNextResponse = ListVirtualHubBgpConnectionResults;

// @public
export interface VirtualHubBgpConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubBgpConnectionsListResponse = ListVirtualHubBgpConnectionResults;

// @public
export interface VirtualHubEffectiveRoute {
    addressPrefixes?: string[];
    asPath?: string;
    nextHops?: string[];
    nextHopType?: string;
    routeOrigin?: string;
}

// @public
export interface VirtualHubEffectiveRouteList {
    value?: VirtualHubEffectiveRoute[];
}

// @public
export interface VirtualHubId {
    id?: string;
}

// @public
export interface VirtualHubIpConfiguration {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, ipConfigName: string, parameters: HubIpConfiguration, options?: VirtualHubIpConfigurationCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualHubIpConfigurationCreateOrUpdateResponse>, VirtualHubIpConfigurationCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, ipConfigName: string, parameters: HubIpConfiguration, options?: VirtualHubIpConfigurationCreateOrUpdateOptionalParams): Promise<VirtualHubIpConfigurationCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, ipConfigName: string, options?: VirtualHubIpConfigurationDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, ipConfigName: string, options?: VirtualHubIpConfigurationDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, ipConfigName: string, options?: VirtualHubIpConfigurationGetOptionalParams): Promise<VirtualHubIpConfigurationGetResponse>;
    list(resourceGroupName: string, virtualHubName: string, options?: VirtualHubIpConfigurationListOptionalParams): PagedAsyncIterableIterator<HubIpConfiguration>;
}

// @public
export interface VirtualHubIpConfigurationCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualHubIpConfigurationCreateOrUpdateResponse = HubIpConfiguration;

// @public
export interface VirtualHubIpConfigurationDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualHubIpConfigurationGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubIpConfigurationGetResponse = HubIpConfiguration;

// @public
export interface VirtualHubIpConfigurationListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubIpConfigurationListNextResponse = ListVirtualHubIpConfigurationResults;

// @public
export interface VirtualHubIpConfigurationListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubIpConfigurationListResponse = ListVirtualHubIpConfigurationResults;

// @public
export interface VirtualHubRoute {
    addressPrefixes?: string[];
    nextHopIpAddress?: string;
}

// @public
export interface VirtualHubRouteTable {
    routes?: VirtualHubRoute[];
}

// @public
export type VirtualHubRouteTableV2 = SubResource & {
    name?: string;
    readonly etag?: string;
    routes?: VirtualHubRouteV2[];
    attachedConnections?: string[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface VirtualHubRouteTableV2S {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, routeTableName: string, virtualHubRouteTableV2Parameters: VirtualHubRouteTableV2, options?: VirtualHubRouteTableV2SCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualHubRouteTableV2SCreateOrUpdateResponse>, VirtualHubRouteTableV2SCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, routeTableName: string, virtualHubRouteTableV2Parameters: VirtualHubRouteTableV2, options?: VirtualHubRouteTableV2SCreateOrUpdateOptionalParams): Promise<VirtualHubRouteTableV2SCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, routeTableName: string, options?: VirtualHubRouteTableV2SDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, routeTableName: string, options?: VirtualHubRouteTableV2SDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, routeTableName: string, options?: VirtualHubRouteTableV2SGetOptionalParams): Promise<VirtualHubRouteTableV2SGetResponse>;
    list(resourceGroupName: string, virtualHubName: string, options?: VirtualHubRouteTableV2SListOptionalParams): PagedAsyncIterableIterator<VirtualHubRouteTableV2>;
}

// @public
export interface VirtualHubRouteTableV2SCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualHubRouteTableV2SCreateOrUpdateResponse = VirtualHubRouteTableV2;

// @public
export interface VirtualHubRouteTableV2SDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualHubRouteTableV2SGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubRouteTableV2SGetResponse = VirtualHubRouteTableV2;

// @public
export interface VirtualHubRouteTableV2SListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubRouteTableV2SListNextResponse = ListVirtualHubRouteTableV2SResult;

// @public
export interface VirtualHubRouteTableV2SListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubRouteTableV2SListResponse = ListVirtualHubRouteTableV2SResult;

// @public
export interface VirtualHubRouteV2 {
    destinations?: string[];
    destinationType?: string;
    nextHops?: string[];
    nextHopType?: string;
}

// @public
export interface VirtualHubs {
    beginCreateOrUpdate(resourceGroupName: string, virtualHubName: string, virtualHubParameters: VirtualHub, options?: VirtualHubsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualHubsCreateOrUpdateResponse>, VirtualHubsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualHubName: string, virtualHubParameters: VirtualHub, options?: VirtualHubsCreateOrUpdateOptionalParams): Promise<VirtualHubsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualHubName: string, options?: VirtualHubsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualHubName: string, options?: VirtualHubsDeleteOptionalParams): Promise<void>;
    beginGetEffectiveVirtualHubRoutes(resourceGroupName: string, virtualHubName: string, options?: VirtualHubsGetEffectiveVirtualHubRoutesOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginGetEffectiveVirtualHubRoutesAndWait(resourceGroupName: string, virtualHubName: string, options?: VirtualHubsGetEffectiveVirtualHubRoutesOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualHubName: string, options?: VirtualHubsGetOptionalParams): Promise<VirtualHubsGetResponse>;
    list(options?: VirtualHubsListOptionalParams): PagedAsyncIterableIterator<VirtualHub>;
    listByResourceGroup(resourceGroupName: string, options?: VirtualHubsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VirtualHub>;
    updateTags(resourceGroupName: string, virtualHubName: string, virtualHubParameters: TagsObject, options?: VirtualHubsUpdateTagsOptionalParams): Promise<VirtualHubsUpdateTagsResponse>;
}

// @public
export interface VirtualHubsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualHubsCreateOrUpdateResponse = VirtualHub;

// @public
export interface VirtualHubsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualHubsGetEffectiveVirtualHubRoutesOptionalParams extends coreClient.OperationOptions {
    effectiveRoutesParameters?: EffectiveRoutesParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualHubsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubsGetResponse = VirtualHub;

// @public
export interface VirtualHubsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubsListByResourceGroupNextResponse = ListVirtualHubsResult;

// @public
export interface VirtualHubsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubsListByResourceGroupResponse = ListVirtualHubsResult;

// @public
export interface VirtualHubsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubsListNextResponse = ListVirtualHubsResult;

// @public
export interface VirtualHubsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubsListResponse = ListVirtualHubsResult;

// @public
export interface VirtualHubsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualHubsUpdateTagsResponse = VirtualHub;

// @public
export type VirtualNetwork = Resource & {
    extendedLocation?: ExtendedLocation;
    readonly etag?: string;
    addressSpace?: AddressSpace;
    dhcpOptions?: DhcpOptions;
    flowTimeoutInMinutes?: number;
    subnets?: Subnet[];
    virtualNetworkPeerings?: VirtualNetworkPeering[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    enableDdosProtection?: boolean;
    enableVmProtection?: boolean;
    ddosProtectionPlan?: SubResource;
    bgpCommunities?: VirtualNetworkBgpCommunities;
    encryption?: VirtualNetworkEncryption;
    ipAllocations?: SubResource[];
};

// @public
export interface VirtualNetworkBgpCommunities {
    readonly regionalCommunity?: string;
    virtualNetworkCommunity: string;
}

// @public
export interface VirtualNetworkConnectionGatewayReference {
    id: string;
}

// @public
export interface VirtualNetworkEncryption {
    enabled: boolean;
    enforcement?: VirtualNetworkEncryptionEnforcement;
}

// @public
export type VirtualNetworkEncryptionEnforcement = string;

// @public
export type VirtualNetworkGateway = Resource & {
    extendedLocation?: ExtendedLocation;
    readonly etag?: string;
    ipConfigurations?: VirtualNetworkGatewayIPConfiguration[];
    gatewayType?: VirtualNetworkGatewayType;
    vpnType?: VpnType;
    vpnGatewayGeneration?: VpnGatewayGeneration;
    enableBgp?: boolean;
    enablePrivateIpAddress?: boolean;
    active?: boolean;
    disableIPSecReplayProtection?: boolean;
    gatewayDefaultSite?: SubResource;
    sku?: VirtualNetworkGatewaySku;
    vpnClientConfiguration?: VpnClientConfiguration;
    bgpSettings?: BgpSettings;
    customRoutes?: AddressSpace;
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    enableDnsForwarding?: boolean;
    readonly inboundDnsForwardingEndpoint?: string;
    vNetExtendedLocationResourceId?: string;
    natRules?: VirtualNetworkGatewayNatRule[];
    enableBgpRouteTranslationForNat?: boolean;
};

// @public
export type VirtualNetworkGatewayConnection = Resource & {
    readonly etag?: string;
    authorizationKey?: string;
    virtualNetworkGateway1: VirtualNetworkGateway;
    virtualNetworkGateway2?: VirtualNetworkGateway;
    localNetworkGateway2?: LocalNetworkGateway;
    ingressNatRules?: SubResource[];
    egressNatRules?: SubResource[];
    connectionType: VirtualNetworkGatewayConnectionType;
    connectionProtocol?: VirtualNetworkGatewayConnectionProtocol;
    routingWeight?: number;
    dpdTimeoutSeconds?: number;
    connectionMode?: VirtualNetworkGatewayConnectionMode;
    sharedKey?: string;
    readonly connectionStatus?: VirtualNetworkGatewayConnectionStatus;
    readonly tunnelConnectionStatus?: TunnelConnectionHealth[];
    readonly egressBytesTransferred?: number;
    readonly ingressBytesTransferred?: number;
    peer?: SubResource;
    enableBgp?: boolean;
    useLocalAzureIpAddress?: boolean;
    usePolicyBasedTrafficSelectors?: boolean;
    ipsecPolicies?: IpsecPolicy[];
    trafficSelectorPolicies?: TrafficSelectorPolicy[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    expressRouteGatewayBypass?: boolean;
};

// @public
export type VirtualNetworkGatewayConnectionListEntity = Resource & {
    readonly etag?: string;
    authorizationKey?: string;
    virtualNetworkGateway1: VirtualNetworkConnectionGatewayReference;
    virtualNetworkGateway2?: VirtualNetworkConnectionGatewayReference;
    localNetworkGateway2?: VirtualNetworkConnectionGatewayReference;
    connectionType: VirtualNetworkGatewayConnectionType;
    connectionProtocol?: VirtualNetworkGatewayConnectionProtocol;
    routingWeight?: number;
    connectionMode?: VirtualNetworkGatewayConnectionMode;
    sharedKey?: string;
    readonly connectionStatus?: VirtualNetworkGatewayConnectionStatus;
    readonly tunnelConnectionStatus?: TunnelConnectionHealth[];
    readonly egressBytesTransferred?: number;
    readonly ingressBytesTransferred?: number;
    peer?: SubResource;
    enableBgp?: boolean;
    usePolicyBasedTrafficSelectors?: boolean;
    ipsecPolicies?: IpsecPolicy[];
    trafficSelectorPolicies?: TrafficSelectorPolicy[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    expressRouteGatewayBypass?: boolean;
};

// @public
export interface VirtualNetworkGatewayConnectionListResult {
    readonly nextLink?: string;
    value?: VirtualNetworkGatewayConnection[];
}

// @public
export type VirtualNetworkGatewayConnectionMode = string;

// @public
export type VirtualNetworkGatewayConnectionProtocol = string;

// @public
export interface VirtualNetworkGatewayConnections {
    beginCreateOrUpdate(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: VirtualNetworkGatewayConnection, options?: VirtualNetworkGatewayConnectionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsCreateOrUpdateResponse>, VirtualNetworkGatewayConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: VirtualNetworkGatewayConnection, options?: VirtualNetworkGatewayConnectionsCreateOrUpdateOptionalParams): Promise<VirtualNetworkGatewayConnectionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsDeleteOptionalParams): Promise<void>;
    beginGetIkeSas(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsGetIkeSasOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsGetIkeSasResponse>, VirtualNetworkGatewayConnectionsGetIkeSasResponse>>;
    beginGetIkeSasAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsGetIkeSasOptionalParams): Promise<VirtualNetworkGatewayConnectionsGetIkeSasResponse>;
    beginResetConnection(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsResetConnectionOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginResetConnectionAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsResetConnectionOptionalParams): Promise<void>;
    beginResetSharedKey(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: ConnectionResetSharedKey, options?: VirtualNetworkGatewayConnectionsResetSharedKeyOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsResetSharedKeyResponse>, VirtualNetworkGatewayConnectionsResetSharedKeyResponse>>;
    beginResetSharedKeyAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: ConnectionResetSharedKey, options?: VirtualNetworkGatewayConnectionsResetSharedKeyOptionalParams): Promise<VirtualNetworkGatewayConnectionsResetSharedKeyResponse>;
    beginSetSharedKey(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: ConnectionSharedKey, options?: VirtualNetworkGatewayConnectionsSetSharedKeyOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsSetSharedKeyResponse>, VirtualNetworkGatewayConnectionsSetSharedKeyResponse>>;
    beginSetSharedKeyAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: ConnectionSharedKey, options?: VirtualNetworkGatewayConnectionsSetSharedKeyOptionalParams): Promise<VirtualNetworkGatewayConnectionsSetSharedKeyResponse>;
    beginStartPacketCapture(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsStartPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsStartPacketCaptureResponse>, VirtualNetworkGatewayConnectionsStartPacketCaptureResponse>>;
    beginStartPacketCaptureAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsStartPacketCaptureOptionalParams): Promise<VirtualNetworkGatewayConnectionsStartPacketCaptureResponse>;
    beginStopPacketCapture(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: VpnPacketCaptureStopParameters, options?: VirtualNetworkGatewayConnectionsStopPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsStopPacketCaptureResponse>, VirtualNetworkGatewayConnectionsStopPacketCaptureResponse>>;
    beginStopPacketCaptureAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: VpnPacketCaptureStopParameters, options?: VirtualNetworkGatewayConnectionsStopPacketCaptureOptionalParams): Promise<VirtualNetworkGatewayConnectionsStopPacketCaptureResponse>;
    beginUpdateTags(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: TagsObject, options?: VirtualNetworkGatewayConnectionsUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayConnectionsUpdateTagsResponse>, VirtualNetworkGatewayConnectionsUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: TagsObject, options?: VirtualNetworkGatewayConnectionsUpdateTagsOptionalParams): Promise<VirtualNetworkGatewayConnectionsUpdateTagsResponse>;
    get(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsGetOptionalParams): Promise<VirtualNetworkGatewayConnectionsGetResponse>;
    getSharedKey(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, options?: VirtualNetworkGatewayConnectionsGetSharedKeyOptionalParams): Promise<VirtualNetworkGatewayConnectionsGetSharedKeyResponse>;
    list(resourceGroupName: string, options?: VirtualNetworkGatewayConnectionsListOptionalParams): PagedAsyncIterableIterator<VirtualNetworkGatewayConnection>;
}

// @public
export interface VirtualNetworkGatewayConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsCreateOrUpdateResponse = VirtualNetworkGatewayConnection;

// @public
export interface VirtualNetworkGatewayConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkGatewayConnectionsGetIkeSasOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsGetIkeSasResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewayConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayConnectionsGetResponse = VirtualNetworkGatewayConnection;

// @public
export interface VirtualNetworkGatewayConnectionsGetSharedKeyOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayConnectionsGetSharedKeyResponse = ConnectionSharedKey;

// @public
export interface VirtualNetworkGatewayConnectionsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayConnectionsListNextResponse = VirtualNetworkGatewayConnectionListResult;

// @public
export interface VirtualNetworkGatewayConnectionsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayConnectionsListResponse = VirtualNetworkGatewayConnectionListResult;

// @public
export interface VirtualNetworkGatewayConnectionsResetConnectionOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkGatewayConnectionsResetSharedKeyOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsResetSharedKeyResponse = ConnectionResetSharedKey;

// @public
export interface VirtualNetworkGatewayConnectionsSetSharedKeyOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsSetSharedKeyResponse = ConnectionSharedKey;

// @public
export interface VirtualNetworkGatewayConnectionsStartPacketCaptureOptionalParams extends coreClient.OperationOptions {
    parameters?: VpnPacketCaptureStartParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsStartPacketCaptureResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewayConnectionsStopPacketCaptureOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsStopPacketCaptureResponse = {
    body: string;
};

// @public
export type VirtualNetworkGatewayConnectionStatus = string;

// @public
export interface VirtualNetworkGatewayConnectionsUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayConnectionsUpdateTagsResponse = VirtualNetworkGatewayConnection;

// @public
export type VirtualNetworkGatewayConnectionType = string;

// @public
export type VirtualNetworkGatewayIPConfiguration = SubResource & {
    name?: string;
    readonly etag?: string;
    privateIPAllocationMethod?: IPAllocationMethod;
    subnet?: SubResource;
    publicIPAddress?: SubResource;
    readonly privateIPAddress?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface VirtualNetworkGatewayListConnectionsResult {
    readonly nextLink?: string;
    value?: VirtualNetworkGatewayConnectionListEntity[];
}

// @public
export interface VirtualNetworkGatewayListResult {
    readonly nextLink?: string;
    value?: VirtualNetworkGateway[];
}

// @public
export type VirtualNetworkGatewayNatRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly provisioningState?: ProvisioningState;
    typePropertiesType?: VpnNatRuleType;
    mode?: VpnNatRuleMode;
    internalMappings?: VpnNatRuleMapping[];
    externalMappings?: VpnNatRuleMapping[];
    ipConfigurationId?: string;
};

// @public
export interface VirtualNetworkGatewayNatRules {
    beginCreateOrUpdate(resourceGroupName: string, virtualNetworkGatewayName: string, natRuleName: string, natRuleParameters: VirtualNetworkGatewayNatRule, options?: VirtualNetworkGatewayNatRulesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewayNatRulesCreateOrUpdateResponse>, VirtualNetworkGatewayNatRulesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, natRuleName: string, natRuleParameters: VirtualNetworkGatewayNatRule, options?: VirtualNetworkGatewayNatRulesCreateOrUpdateOptionalParams): Promise<VirtualNetworkGatewayNatRulesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualNetworkGatewayName: string, natRuleName: string, options?: VirtualNetworkGatewayNatRulesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, natRuleName: string, options?: VirtualNetworkGatewayNatRulesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualNetworkGatewayName: string, natRuleName: string, options?: VirtualNetworkGatewayNatRulesGetOptionalParams): Promise<VirtualNetworkGatewayNatRulesGetResponse>;
    listByVirtualNetworkGateway(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewayNatRulesListByVirtualNetworkGatewayOptionalParams): PagedAsyncIterableIterator<VirtualNetworkGatewayNatRule>;
}

// @public
export interface VirtualNetworkGatewayNatRulesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewayNatRulesCreateOrUpdateResponse = VirtualNetworkGatewayNatRule;

// @public
export interface VirtualNetworkGatewayNatRulesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkGatewayNatRulesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayNatRulesGetResponse = VirtualNetworkGatewayNatRule;

// @public
export interface VirtualNetworkGatewayNatRulesListByVirtualNetworkGatewayNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayNatRulesListByVirtualNetworkGatewayNextResponse = ListVirtualNetworkGatewayNatRulesResult;

// @public
export interface VirtualNetworkGatewayNatRulesListByVirtualNetworkGatewayOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewayNatRulesListByVirtualNetworkGatewayResponse = ListVirtualNetworkGatewayNatRulesResult;

// @public
export interface VirtualNetworkGateways {
    beginCreateOrUpdate(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VirtualNetworkGateway, options?: VirtualNetworkGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysCreateOrUpdateResponse>, VirtualNetworkGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VirtualNetworkGateway, options?: VirtualNetworkGatewaysCreateOrUpdateOptionalParams): Promise<VirtualNetworkGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysDeleteOptionalParams): Promise<void>;
    beginDisconnectVirtualNetworkGatewayVpnConnections(resourceGroupName: string, virtualNetworkGatewayName: string, request: P2SVpnConnectionRequest, options?: VirtualNetworkGatewaysDisconnectVirtualNetworkGatewayVpnConnectionsOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDisconnectVirtualNetworkGatewayVpnConnectionsAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, request: P2SVpnConnectionRequest, options?: VirtualNetworkGatewaysDisconnectVirtualNetworkGatewayVpnConnectionsOptionalParams): Promise<void>;
    beginGeneratevpnclientpackage(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VpnClientParameters, options?: VirtualNetworkGatewaysGeneratevpnclientpackageOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGeneratevpnclientpackageResponse>, VirtualNetworkGatewaysGeneratevpnclientpackageResponse>>;
    beginGeneratevpnclientpackageAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VpnClientParameters, options?: VirtualNetworkGatewaysGeneratevpnclientpackageOptionalParams): Promise<VirtualNetworkGatewaysGeneratevpnclientpackageResponse>;
    beginGenerateVpnProfile(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VpnClientParameters, options?: VirtualNetworkGatewaysGenerateVpnProfileOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGenerateVpnProfileResponse>, VirtualNetworkGatewaysGenerateVpnProfileResponse>>;
    beginGenerateVpnProfileAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VpnClientParameters, options?: VirtualNetworkGatewaysGenerateVpnProfileOptionalParams): Promise<VirtualNetworkGatewaysGenerateVpnProfileResponse>;
    beginGetAdvertisedRoutes(resourceGroupName: string, virtualNetworkGatewayName: string, peer: string, options?: VirtualNetworkGatewaysGetAdvertisedRoutesOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGetAdvertisedRoutesResponse>, VirtualNetworkGatewaysGetAdvertisedRoutesResponse>>;
    beginGetAdvertisedRoutesAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, peer: string, options?: VirtualNetworkGatewaysGetAdvertisedRoutesOptionalParams): Promise<VirtualNetworkGatewaysGetAdvertisedRoutesResponse>;
    beginGetBgpPeerStatus(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetBgpPeerStatusOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGetBgpPeerStatusResponse>, VirtualNetworkGatewaysGetBgpPeerStatusResponse>>;
    beginGetBgpPeerStatusAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetBgpPeerStatusOptionalParams): Promise<VirtualNetworkGatewaysGetBgpPeerStatusResponse>;
    beginGetLearnedRoutes(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetLearnedRoutesOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGetLearnedRoutesResponse>, VirtualNetworkGatewaysGetLearnedRoutesResponse>>;
    beginGetLearnedRoutesAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetLearnedRoutesOptionalParams): Promise<VirtualNetworkGatewaysGetLearnedRoutesResponse>;
    beginGetVpnclientConnectionHealth(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetVpnclientConnectionHealthOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGetVpnclientConnectionHealthResponse>, VirtualNetworkGatewaysGetVpnclientConnectionHealthResponse>>;
    beginGetVpnclientConnectionHealthAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetVpnclientConnectionHealthOptionalParams): Promise<VirtualNetworkGatewaysGetVpnclientConnectionHealthResponse>;
    beginGetVpnclientIpsecParameters(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetVpnclientIpsecParametersOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGetVpnclientIpsecParametersResponse>, VirtualNetworkGatewaysGetVpnclientIpsecParametersResponse>>;
    beginGetVpnclientIpsecParametersAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetVpnclientIpsecParametersOptionalParams): Promise<VirtualNetworkGatewaysGetVpnclientIpsecParametersResponse>;
    beginGetVpnProfilePackageUrl(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetVpnProfilePackageUrlOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysGetVpnProfilePackageUrlResponse>, VirtualNetworkGatewaysGetVpnProfilePackageUrlResponse>>;
    beginGetVpnProfilePackageUrlAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetVpnProfilePackageUrlOptionalParams): Promise<VirtualNetworkGatewaysGetVpnProfilePackageUrlResponse>;
    beginReset(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysResetOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysResetResponse>, VirtualNetworkGatewaysResetResponse>>;
    beginResetAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysResetOptionalParams): Promise<VirtualNetworkGatewaysResetResponse>;
    beginResetVpnClientSharedKey(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysResetVpnClientSharedKeyOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginResetVpnClientSharedKeyAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysResetVpnClientSharedKeyOptionalParams): Promise<void>;
    beginSetVpnclientIpsecParameters(resourceGroupName: string, virtualNetworkGatewayName: string, vpnclientIpsecParams: VpnClientIPsecParameters, options?: VirtualNetworkGatewaysSetVpnclientIpsecParametersOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysSetVpnclientIpsecParametersResponse>, VirtualNetworkGatewaysSetVpnclientIpsecParametersResponse>>;
    beginSetVpnclientIpsecParametersAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, vpnclientIpsecParams: VpnClientIPsecParameters, options?: VirtualNetworkGatewaysSetVpnclientIpsecParametersOptionalParams): Promise<VirtualNetworkGatewaysSetVpnclientIpsecParametersResponse>;
    beginStartPacketCapture(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysStartPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysStartPacketCaptureResponse>, VirtualNetworkGatewaysStartPacketCaptureResponse>>;
    beginStartPacketCaptureAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysStartPacketCaptureOptionalParams): Promise<VirtualNetworkGatewaysStartPacketCaptureResponse>;
    beginStopPacketCapture(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VpnPacketCaptureStopParameters, options?: VirtualNetworkGatewaysStopPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysStopPacketCaptureResponse>, VirtualNetworkGatewaysStopPacketCaptureResponse>>;
    beginStopPacketCaptureAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: VpnPacketCaptureStopParameters, options?: VirtualNetworkGatewaysStopPacketCaptureOptionalParams): Promise<VirtualNetworkGatewaysStopPacketCaptureResponse>;
    beginUpdateTags(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: TagsObject, options?: VirtualNetworkGatewaysUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkGatewaysUpdateTagsResponse>, VirtualNetworkGatewaysUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, virtualNetworkGatewayName: string, parameters: TagsObject, options?: VirtualNetworkGatewaysUpdateTagsOptionalParams): Promise<VirtualNetworkGatewaysUpdateTagsResponse>;
    get(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysGetOptionalParams): Promise<VirtualNetworkGatewaysGetResponse>;
    list(resourceGroupName: string, options?: VirtualNetworkGatewaysListOptionalParams): PagedAsyncIterableIterator<VirtualNetworkGateway>;
    listConnections(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysListConnectionsOptionalParams): PagedAsyncIterableIterator<VirtualNetworkGatewayConnectionListEntity>;
    supportedVpnDevices(resourceGroupName: string, virtualNetworkGatewayName: string, options?: VirtualNetworkGatewaysSupportedVpnDevicesOptionalParams): Promise<VirtualNetworkGatewaysSupportedVpnDevicesResponse>;
    vpnDeviceConfigurationScript(resourceGroupName: string, virtualNetworkGatewayConnectionName: string, parameters: VpnDeviceScriptParameters, options?: VirtualNetworkGatewaysVpnDeviceConfigurationScriptOptionalParams): Promise<VirtualNetworkGatewaysVpnDeviceConfigurationScriptResponse>;
}

// @public
export interface VirtualNetworkGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysCreateOrUpdateResponse = VirtualNetworkGateway;

// @public
export interface VirtualNetworkGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkGatewaysDisconnectVirtualNetworkGatewayVpnConnectionsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkGatewaysGeneratevpnclientpackageOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGeneratevpnclientpackageResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewaysGenerateVpnProfileOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGenerateVpnProfileResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewaysGetAdvertisedRoutesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGetAdvertisedRoutesResponse = GatewayRouteListResult;

// @public
export interface VirtualNetworkGatewaysGetBgpPeerStatusOptionalParams extends coreClient.OperationOptions {
    peer?: string;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGetBgpPeerStatusResponse = BgpPeerStatusListResult;

// @public
export interface VirtualNetworkGatewaysGetLearnedRoutesOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGetLearnedRoutesResponse = GatewayRouteListResult;

// @public
export interface VirtualNetworkGatewaysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysGetResponse = VirtualNetworkGateway;

// @public
export interface VirtualNetworkGatewaysGetVpnclientConnectionHealthOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGetVpnclientConnectionHealthResponse = VpnClientConnectionHealthDetailListResult;

// @public
export interface VirtualNetworkGatewaysGetVpnclientIpsecParametersOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGetVpnclientIpsecParametersResponse = VpnClientIPsecParameters;

// @public
export interface VirtualNetworkGatewaysGetVpnProfilePackageUrlOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysGetVpnProfilePackageUrlResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewaySku {
    readonly capacity?: number;
    name?: VirtualNetworkGatewaySkuName;
    tier?: VirtualNetworkGatewaySkuTier;
}

// @public
export type VirtualNetworkGatewaySkuName = string;

// @public
export type VirtualNetworkGatewaySkuTier = string;

// @public
export interface VirtualNetworkGatewaysListConnectionsNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysListConnectionsNextResponse = VirtualNetworkGatewayListConnectionsResult;

// @public
export interface VirtualNetworkGatewaysListConnectionsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysListConnectionsResponse = VirtualNetworkGatewayListConnectionsResult;

// @public
export interface VirtualNetworkGatewaysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysListNextResponse = VirtualNetworkGatewayListResult;

// @public
export interface VirtualNetworkGatewaysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysListResponse = VirtualNetworkGatewayListResult;

// @public
export interface VirtualNetworkGatewaysResetOptionalParams extends coreClient.OperationOptions {
    gatewayVip?: string;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysResetResponse = VirtualNetworkGateway;

// @public
export interface VirtualNetworkGatewaysResetVpnClientSharedKeyOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkGatewaysSetVpnclientIpsecParametersOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysSetVpnclientIpsecParametersResponse = VpnClientIPsecParameters;

// @public
export interface VirtualNetworkGatewaysStartPacketCaptureOptionalParams extends coreClient.OperationOptions {
    parameters?: VpnPacketCaptureStartParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysStartPacketCaptureResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewaysStopPacketCaptureOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysStopPacketCaptureResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewaysSupportedVpnDevicesOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysSupportedVpnDevicesResponse = {
    body: string;
};

// @public
export interface VirtualNetworkGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkGatewaysUpdateTagsResponse = VirtualNetworkGateway;

// @public
export interface VirtualNetworkGatewaysVpnDeviceConfigurationScriptOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkGatewaysVpnDeviceConfigurationScriptResponse = {
    body: string;
};

// @public
export type VirtualNetworkGatewayType = string;

// @public
export interface VirtualNetworkListResult {
    nextLink?: string;
    value?: VirtualNetwork[];
}

// @public
export interface VirtualNetworkListUsageResult {
    nextLink?: string;
    readonly value?: VirtualNetworkUsage[];
}

// @public
export type VirtualNetworkPeering = SubResource & {
    name?: string;
    readonly etag?: string;
    type?: string;
    allowVirtualNetworkAccess?: boolean;
    allowForwardedTraffic?: boolean;
    allowGatewayTransit?: boolean;
    useRemoteGateways?: boolean;
    remoteVirtualNetwork?: SubResource;
    remoteAddressSpace?: AddressSpace;
    remoteVirtualNetworkAddressSpace?: AddressSpace;
    remoteBgpCommunities?: VirtualNetworkBgpCommunities;
    readonly remoteVirtualNetworkEncryption?: VirtualNetworkEncryption;
    peeringState?: VirtualNetworkPeeringState;
    peeringSyncLevel?: VirtualNetworkPeeringLevel;
    readonly provisioningState?: ProvisioningState;
    doNotVerifyRemoteGateways?: boolean;
    readonly resourceGuid?: string;
};

// @public
export type VirtualNetworkPeeringLevel = string;

// @public
export interface VirtualNetworkPeeringListResult {
    nextLink?: string;
    value?: VirtualNetworkPeering[];
}

// @public
export interface VirtualNetworkPeerings {
    beginCreateOrUpdate(resourceGroupName: string, virtualNetworkName: string, virtualNetworkPeeringName: string, virtualNetworkPeeringParameters: VirtualNetworkPeering, options?: VirtualNetworkPeeringsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkPeeringsCreateOrUpdateResponse>, VirtualNetworkPeeringsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualNetworkName: string, virtualNetworkPeeringName: string, virtualNetworkPeeringParameters: VirtualNetworkPeering, options?: VirtualNetworkPeeringsCreateOrUpdateOptionalParams): Promise<VirtualNetworkPeeringsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualNetworkName: string, virtualNetworkPeeringName: string, options?: VirtualNetworkPeeringsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualNetworkName: string, virtualNetworkPeeringName: string, options?: VirtualNetworkPeeringsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualNetworkName: string, virtualNetworkPeeringName: string, options?: VirtualNetworkPeeringsGetOptionalParams): Promise<VirtualNetworkPeeringsGetResponse>;
    list(resourceGroupName: string, virtualNetworkName: string, options?: VirtualNetworkPeeringsListOptionalParams): PagedAsyncIterableIterator<VirtualNetworkPeering>;
}

// @public
export interface VirtualNetworkPeeringsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    syncRemoteAddressSpace?: SyncRemoteAddressSpace;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkPeeringsCreateOrUpdateResponse = VirtualNetworkPeering;

// @public
export interface VirtualNetworkPeeringsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkPeeringsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkPeeringsGetResponse = VirtualNetworkPeering;

// @public
export interface VirtualNetworkPeeringsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkPeeringsListNextResponse = VirtualNetworkPeeringListResult;

// @public
export interface VirtualNetworkPeeringsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkPeeringsListResponse = VirtualNetworkPeeringListResult;

// @public
export type VirtualNetworkPeeringState = string;

// @public
export type VirtualNetworkPrivateEndpointNetworkPolicies = string;

// @public
export type VirtualNetworkPrivateLinkServiceNetworkPolicies = string;

// @public
export interface VirtualNetworks {
    beginCreateOrUpdate(resourceGroupName: string, virtualNetworkName: string, parameters: VirtualNetwork, options?: VirtualNetworksCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworksCreateOrUpdateResponse>, VirtualNetworksCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualNetworkName: string, parameters: VirtualNetwork, options?: VirtualNetworksCreateOrUpdateOptionalParams): Promise<VirtualNetworksCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualNetworkName: string, options?: VirtualNetworksDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualNetworkName: string, options?: VirtualNetworksDeleteOptionalParams): Promise<void>;
    checkIPAddressAvailability(resourceGroupName: string, virtualNetworkName: string, ipAddress: string, options?: VirtualNetworksCheckIPAddressAvailabilityOptionalParams): Promise<VirtualNetworksCheckIPAddressAvailabilityResponse>;
    get(resourceGroupName: string, virtualNetworkName: string, options?: VirtualNetworksGetOptionalParams): Promise<VirtualNetworksGetResponse>;
    list(resourceGroupName: string, options?: VirtualNetworksListOptionalParams): PagedAsyncIterableIterator<VirtualNetwork>;
    listAll(options?: VirtualNetworksListAllOptionalParams): PagedAsyncIterableIterator<VirtualNetwork>;
    listUsage(resourceGroupName: string, virtualNetworkName: string, options?: VirtualNetworksListUsageOptionalParams): PagedAsyncIterableIterator<VirtualNetworkUsage>;
    updateTags(resourceGroupName: string, virtualNetworkName: string, parameters: TagsObject, options?: VirtualNetworksUpdateTagsOptionalParams): Promise<VirtualNetworksUpdateTagsResponse>;
}

// @public
export interface VirtualNetworksCheckIPAddressAvailabilityOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksCheckIPAddressAvailabilityResponse = IPAddressAvailabilityResult;

// @public
export interface VirtualNetworksCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworksCreateOrUpdateResponse = VirtualNetwork;

// @public
export interface VirtualNetworksDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworksGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type VirtualNetworksGetResponse = VirtualNetwork;

// @public
export interface VirtualNetworksListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksListAllNextResponse = VirtualNetworkListResult;

// @public
export interface VirtualNetworksListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksListAllResponse = VirtualNetworkListResult;

// @public
export interface VirtualNetworksListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksListNextResponse = VirtualNetworkListResult;

// @public
export interface VirtualNetworksListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksListResponse = VirtualNetworkListResult;

// @public
export interface VirtualNetworksListUsageNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksListUsageNextResponse = VirtualNetworkListUsageResult;

// @public
export interface VirtualNetworksListUsageOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksListUsageResponse = VirtualNetworkListUsageResult;

// @public
export interface VirtualNetworksUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworksUpdateTagsResponse = VirtualNetwork;

// @public
export type VirtualNetworkTap = Resource & {
    readonly etag?: string;
    readonly networkInterfaceTapConfigurations?: NetworkInterfaceTapConfiguration[];
    readonly resourceGuid?: string;
    readonly provisioningState?: ProvisioningState;
    destinationNetworkInterfaceIPConfiguration?: NetworkInterfaceIPConfiguration;
    destinationLoadBalancerFrontEndIPConfiguration?: FrontendIPConfiguration;
    destinationPort?: number;
};

// @public
export interface VirtualNetworkTapListResult {
    nextLink?: string;
    value?: VirtualNetworkTap[];
}

// @public
export interface VirtualNetworkTaps {
    beginCreateOrUpdate(resourceGroupName: string, tapName: string, parameters: VirtualNetworkTap, options?: VirtualNetworkTapsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualNetworkTapsCreateOrUpdateResponse>, VirtualNetworkTapsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, tapName: string, parameters: VirtualNetworkTap, options?: VirtualNetworkTapsCreateOrUpdateOptionalParams): Promise<VirtualNetworkTapsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, tapName: string, options?: VirtualNetworkTapsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, tapName: string, options?: VirtualNetworkTapsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, tapName: string, options?: VirtualNetworkTapsGetOptionalParams): Promise<VirtualNetworkTapsGetResponse>;
    listAll(options?: VirtualNetworkTapsListAllOptionalParams): PagedAsyncIterableIterator<VirtualNetworkTap>;
    listByResourceGroup(resourceGroupName: string, options?: VirtualNetworkTapsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VirtualNetworkTap>;
    updateTags(resourceGroupName: string, tapName: string, tapParameters: TagsObject, options?: VirtualNetworkTapsUpdateTagsOptionalParams): Promise<VirtualNetworkTapsUpdateTagsResponse>;
}

// @public
export interface VirtualNetworkTapsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualNetworkTapsCreateOrUpdateResponse = VirtualNetworkTap;

// @public
export interface VirtualNetworkTapsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualNetworkTapsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkTapsGetResponse = VirtualNetworkTap;

// @public
export interface VirtualNetworkTapsListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkTapsListAllNextResponse = VirtualNetworkTapListResult;

// @public
export interface VirtualNetworkTapsListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkTapsListAllResponse = VirtualNetworkTapListResult;

// @public
export interface VirtualNetworkTapsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkTapsListByResourceGroupNextResponse = VirtualNetworkTapListResult;

// @public
export interface VirtualNetworkTapsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkTapsListByResourceGroupResponse = VirtualNetworkTapListResult;

// @public
export interface VirtualNetworkTapsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualNetworkTapsUpdateTagsResponse = VirtualNetworkTap;

// @public
export interface VirtualNetworkUsage {
    readonly currentValue?: number;
    readonly id?: string;
    readonly limit?: number;
    readonly name?: VirtualNetworkUsageName;
    readonly unit?: string;
}

// @public
export interface VirtualNetworkUsageName {
    readonly localizedValue?: string;
    readonly value?: string;
}

// @public
export type VirtualRouter = Resource & {
    readonly etag?: string;
    virtualRouterAsn?: number;
    virtualRouterIps?: string[];
    hostedSubnet?: SubResource;
    hostedGateway?: SubResource;
    readonly peerings?: SubResource[];
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface VirtualRouterListResult {
    nextLink?: string;
    value?: VirtualRouter[];
}

// @public
export type VirtualRouterPeering = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    peerAsn?: number;
    peerIp?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export interface VirtualRouterPeeringListResult {
    nextLink?: string;
    value?: VirtualRouterPeering[];
}

// @public
export interface VirtualRouterPeerings {
    beginCreateOrUpdate(resourceGroupName: string, virtualRouterName: string, peeringName: string, parameters: VirtualRouterPeering, options?: VirtualRouterPeeringsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualRouterPeeringsCreateOrUpdateResponse>, VirtualRouterPeeringsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualRouterName: string, peeringName: string, parameters: VirtualRouterPeering, options?: VirtualRouterPeeringsCreateOrUpdateOptionalParams): Promise<VirtualRouterPeeringsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualRouterName: string, peeringName: string, options?: VirtualRouterPeeringsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualRouterName: string, peeringName: string, options?: VirtualRouterPeeringsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualRouterName: string, peeringName: string, options?: VirtualRouterPeeringsGetOptionalParams): Promise<VirtualRouterPeeringsGetResponse>;
    list(resourceGroupName: string, virtualRouterName: string, options?: VirtualRouterPeeringsListOptionalParams): PagedAsyncIterableIterator<VirtualRouterPeering>;
}

// @public
export interface VirtualRouterPeeringsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualRouterPeeringsCreateOrUpdateResponse = VirtualRouterPeering;

// @public
export interface VirtualRouterPeeringsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualRouterPeeringsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRouterPeeringsGetResponse = VirtualRouterPeering;

// @public
export interface VirtualRouterPeeringsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRouterPeeringsListNextResponse = VirtualRouterPeeringListResult;

// @public
export interface VirtualRouterPeeringsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRouterPeeringsListResponse = VirtualRouterPeeringListResult;

// @public
export interface VirtualRouters {
    beginCreateOrUpdate(resourceGroupName: string, virtualRouterName: string, parameters: VirtualRouter, options?: VirtualRoutersCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualRoutersCreateOrUpdateResponse>, VirtualRoutersCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualRouterName: string, parameters: VirtualRouter, options?: VirtualRoutersCreateOrUpdateOptionalParams): Promise<VirtualRoutersCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualRouterName: string, options?: VirtualRoutersDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualRouterName: string, options?: VirtualRoutersDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualRouterName: string, options?: VirtualRoutersGetOptionalParams): Promise<VirtualRoutersGetResponse>;
    list(options?: VirtualRoutersListOptionalParams): PagedAsyncIterableIterator<VirtualRouter>;
    listByResourceGroup(resourceGroupName: string, options?: VirtualRoutersListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VirtualRouter>;
}

// @public
export interface VirtualRoutersCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualRoutersCreateOrUpdateResponse = VirtualRouter;

// @public
export interface VirtualRoutersDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualRoutersGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type VirtualRoutersGetResponse = VirtualRouter;

// @public
export interface VirtualRoutersListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRoutersListByResourceGroupNextResponse = VirtualRouterListResult;

// @public
export interface VirtualRoutersListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRoutersListByResourceGroupResponse = VirtualRouterListResult;

// @public
export interface VirtualRoutersListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRoutersListNextResponse = VirtualRouterListResult;

// @public
export interface VirtualRoutersListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualRoutersListResponse = VirtualRouterListResult;

// @public
export type VirtualWAN = Resource & {
    readonly etag?: string;
    disableVpnEncryption?: boolean;
    readonly virtualHubs?: SubResource[];
    readonly vpnSites?: SubResource[];
    allowBranchToBranchTraffic?: boolean;
    allowVnetToVnetTraffic?: boolean;
    readonly office365LocalBreakoutCategory?: OfficeTrafficCategory;
    readonly provisioningState?: ProvisioningState;
    typePropertiesType?: string;
};

// @public
export interface VirtualWans {
    beginCreateOrUpdate(resourceGroupName: string, virtualWANName: string, wANParameters: VirtualWAN, options?: VirtualWansCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VirtualWansCreateOrUpdateResponse>, VirtualWansCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, virtualWANName: string, wANParameters: VirtualWAN, options?: VirtualWansCreateOrUpdateOptionalParams): Promise<VirtualWansCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, virtualWANName: string, options?: VirtualWansDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, virtualWANName: string, options?: VirtualWansDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, virtualWANName: string, options?: VirtualWansGetOptionalParams): Promise<VirtualWansGetResponse>;
    list(options?: VirtualWansListOptionalParams): PagedAsyncIterableIterator<VirtualWAN>;
    listByResourceGroup(resourceGroupName: string, options?: VirtualWansListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VirtualWAN>;
    updateTags(resourceGroupName: string, virtualWANName: string, wANParameters: TagsObject, options?: VirtualWansUpdateTagsOptionalParams): Promise<VirtualWansUpdateTagsResponse>;
}

// @public
export interface VirtualWansCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VirtualWansCreateOrUpdateResponse = VirtualWAN;

// @public
export interface VirtualWansDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VirtualWanSecurityProvider {
    name?: string;
    readonly type?: VirtualWanSecurityProviderType;
    url?: string;
}

// @public
export interface VirtualWanSecurityProviders {
    supportedProviders?: VirtualWanSecurityProvider[];
}

// @public
export type VirtualWanSecurityProviderType = string;

// @public
export interface VirtualWansGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualWansGetResponse = VirtualWAN;

// @public
export interface VirtualWansListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualWansListByResourceGroupNextResponse = ListVirtualWANsResult;

// @public
export interface VirtualWansListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualWansListByResourceGroupResponse = ListVirtualWANsResult;

// @public
export interface VirtualWansListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualWansListNextResponse = ListVirtualWANsResult;

// @public
export interface VirtualWansListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualWansListResponse = ListVirtualWANsResult;

// @public
export interface VirtualWansUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VirtualWansUpdateTagsResponse = VirtualWAN;

// @public
export interface VirtualWanVpnProfileParameters {
    authenticationMethod?: AuthenticationMethod;
    vpnServerConfigurationResourceId?: string;
}

// @public
export type Vm = Resource & {};

// @public
export interface VnetRoute {
    readonly bgpConnections?: SubResource[];
    staticRoutes?: StaticRoute[];
}

// @public
export type VpnAuthenticationType = string;

// @public
export interface VpnClientConfiguration {
    aadAudience?: string;
    aadIssuer?: string;
    aadTenant?: string;
    radiusServerAddress?: string;
    radiusServers?: RadiusServer[];
    radiusServerSecret?: string;
    vpnAuthenticationTypes?: VpnAuthenticationType[];
    vpnClientAddressPool?: AddressSpace;
    vpnClientIpsecPolicies?: IpsecPolicy[];
    vpnClientProtocols?: VpnClientProtocol[];
    vpnClientRevokedCertificates?: VpnClientRevokedCertificate[];
    vpnClientRootCertificates?: VpnClientRootCertificate[];
}

// @public
export interface VpnClientConnectionHealth {
    allocatedIpAddresses?: string[];
    readonly totalEgressBytesTransferred?: number;
    readonly totalIngressBytesTransferred?: number;
    vpnClientConnectionsCount?: number;
}

// @public
export interface VpnClientConnectionHealthDetail {
    readonly egressBytesTransferred?: number;
    readonly egressPacketsTransferred?: number;
    readonly ingressBytesTransferred?: number;
    readonly ingressPacketsTransferred?: number;
    readonly maxBandwidth?: number;
    readonly maxPacketsPerSecond?: number;
    readonly privateIpAddress?: string;
    readonly publicIpAddress?: string;
    readonly vpnConnectionDuration?: number;
    readonly vpnConnectionId?: string;
    readonly vpnConnectionTime?: string;
    readonly vpnUserName?: string;
}

// @public
export interface VpnClientConnectionHealthDetailListResult {
    value?: VpnClientConnectionHealthDetail[];
}

// @public
export interface VpnClientIPsecParameters {
    dhGroup: DhGroup;
    ikeEncryption: IkeEncryption;
    ikeIntegrity: IkeIntegrity;
    ipsecEncryption: IpsecEncryption;
    ipsecIntegrity: IpsecIntegrity;
    pfsGroup: PfsGroup;
    saDataSizeKilobytes: number;
    saLifeTimeSeconds: number;
}

// @public
export interface VpnClientParameters {
    authenticationMethod?: AuthenticationMethod;
    clientRootCertificates?: string[];
    processorArchitecture?: ProcessorArchitecture;
    radiusServerAuthCertificate?: string;
}

// @public
export type VpnClientProtocol = string;

// @public
export type VpnClientRevokedCertificate = SubResource & {
    name?: string;
    readonly etag?: string;
    thumbprint?: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type VpnClientRootCertificate = SubResource & {
    name?: string;
    readonly etag?: string;
    publicCertData: string;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type VpnConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    remoteVpnSite?: SubResource;
    routingWeight?: number;
    dpdTimeoutSeconds?: number;
    readonly connectionStatus?: VpnConnectionStatus;
    vpnConnectionProtocolType?: VirtualNetworkGatewayConnectionProtocol;
    readonly ingressBytesTransferred?: number;
    readonly egressBytesTransferred?: number;
    connectionBandwidth?: number;
    sharedKey?: string;
    enableBgp?: boolean;
    usePolicyBasedTrafficSelectors?: boolean;
    ipsecPolicies?: IpsecPolicy[];
    trafficSelectorPolicies?: TrafficSelectorPolicy[];
    enableRateLimiting?: boolean;
    enableInternetSecurity?: boolean;
    useLocalAzureIpAddress?: boolean;
    readonly provisioningState?: ProvisioningState;
    vpnLinkConnections?: VpnSiteLinkConnection[];
    routingConfiguration?: RoutingConfiguration;
};

// @public
export interface VpnConnectionPacketCaptureStartParameters {
    filterData?: string;
    linkConnectionNames?: string[];
}

// @public
export interface VpnConnectionPacketCaptureStopParameters {
    linkConnectionNames?: string[];
    sasUrl?: string;
}

// @public
export interface VpnConnections {
    beginCreateOrUpdate(resourceGroupName: string, gatewayName: string, connectionName: string, vpnConnectionParameters: VpnConnection, options?: VpnConnectionsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VpnConnectionsCreateOrUpdateResponse>, VpnConnectionsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, gatewayName: string, connectionName: string, vpnConnectionParameters: VpnConnection, options?: VpnConnectionsCreateOrUpdateOptionalParams): Promise<VpnConnectionsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, gatewayName: string, connectionName: string, options?: VpnConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, gatewayName: string, connectionName: string, options?: VpnConnectionsDeleteOptionalParams): Promise<void>;
    beginStartPacketCapture(resourceGroupName: string, gatewayName: string, vpnConnectionName: string, options?: VpnConnectionsStartPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VpnConnectionsStartPacketCaptureResponse>, VpnConnectionsStartPacketCaptureResponse>>;
    beginStartPacketCaptureAndWait(resourceGroupName: string, gatewayName: string, vpnConnectionName: string, options?: VpnConnectionsStartPacketCaptureOptionalParams): Promise<VpnConnectionsStartPacketCaptureResponse>;
    beginStopPacketCapture(resourceGroupName: string, gatewayName: string, vpnConnectionName: string, options?: VpnConnectionsStopPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VpnConnectionsStopPacketCaptureResponse>, VpnConnectionsStopPacketCaptureResponse>>;
    beginStopPacketCaptureAndWait(resourceGroupName: string, gatewayName: string, vpnConnectionName: string, options?: VpnConnectionsStopPacketCaptureOptionalParams): Promise<VpnConnectionsStopPacketCaptureResponse>;
    get(resourceGroupName: string, gatewayName: string, connectionName: string, options?: VpnConnectionsGetOptionalParams): Promise<VpnConnectionsGetResponse>;
    listByVpnGateway(resourceGroupName: string, gatewayName: string, options?: VpnConnectionsListByVpnGatewayOptionalParams): PagedAsyncIterableIterator<VpnConnection>;
}

// @public
export interface VpnConnectionsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnConnectionsCreateOrUpdateResponse = VpnConnection;

// @public
export interface VpnConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VpnConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnConnectionsGetResponse = VpnConnection;

// @public
export interface VpnConnectionsListByVpnGatewayNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnConnectionsListByVpnGatewayNextResponse = ListVpnConnectionsResult;

// @public
export interface VpnConnectionsListByVpnGatewayOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnConnectionsListByVpnGatewayResponse = ListVpnConnectionsResult;

// @public
export interface VpnConnectionsStartPacketCaptureOptionalParams extends coreClient.OperationOptions {
    parameters?: VpnConnectionPacketCaptureStartParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnConnectionsStartPacketCaptureResponse = {
    body: string;
};

// @public
export interface VpnConnectionsStopPacketCaptureOptionalParams extends coreClient.OperationOptions {
    parameters?: VpnConnectionPacketCaptureStopParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnConnectionsStopPacketCaptureResponse = {
    body: string;
};

// @public
export type VpnConnectionStatus = string;

// @public
export interface VpnDeviceScriptParameters {
    deviceFamily?: string;
    firmwareVersion?: string;
    vendor?: string;
}

// @public
export type VpnGateway = Resource & {
    readonly etag?: string;
    virtualHub?: SubResource;
    connections?: VpnConnection[];
    bgpSettings?: BgpSettings;
    readonly provisioningState?: ProvisioningState;
    vpnGatewayScaleUnit?: number;
    readonly ipConfigurations?: VpnGatewayIpConfiguration[];
    enableBgpRouteTranslationForNat?: boolean;
    isRoutingPreferenceInternet?: boolean;
    natRules?: VpnGatewayNatRule[];
};

// @public
export type VpnGatewayGeneration = string;

// @public
export interface VpnGatewayIpConfiguration {
    id?: string;
    privateIpAddress?: string;
    publicIpAddress?: string;
}

// @public
export type VpnGatewayNatRule = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    readonly provisioningState?: ProvisioningState;
    typePropertiesType?: VpnNatRuleType;
    mode?: VpnNatRuleMode;
    internalMappings?: VpnNatRuleMapping[];
    externalMappings?: VpnNatRuleMapping[];
    ipConfigurationId?: string;
    readonly egressVpnSiteLinkConnections?: SubResource[];
    readonly ingressVpnSiteLinkConnections?: SubResource[];
};

// @public
export interface VpnGatewayPacketCaptureStartParameters {
    filterData?: string;
}

// @public
export interface VpnGatewayPacketCaptureStopParameters {
    sasUrl?: string;
}

// @public
export interface VpnGateways {
    beginCreateOrUpdate(resourceGroupName: string, gatewayName: string, vpnGatewayParameters: VpnGateway, options?: VpnGatewaysCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VpnGatewaysCreateOrUpdateResponse>, VpnGatewaysCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, gatewayName: string, vpnGatewayParameters: VpnGateway, options?: VpnGatewaysCreateOrUpdateOptionalParams): Promise<VpnGatewaysCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysDeleteOptionalParams): Promise<void>;
    beginReset(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysResetOptionalParams): Promise<PollerLike<PollOperationState<VpnGatewaysResetResponse>, VpnGatewaysResetResponse>>;
    beginResetAndWait(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysResetOptionalParams): Promise<VpnGatewaysResetResponse>;
    beginStartPacketCapture(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysStartPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VpnGatewaysStartPacketCaptureResponse>, VpnGatewaysStartPacketCaptureResponse>>;
    beginStartPacketCaptureAndWait(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysStartPacketCaptureOptionalParams): Promise<VpnGatewaysStartPacketCaptureResponse>;
    beginStopPacketCapture(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysStopPacketCaptureOptionalParams): Promise<PollerLike<PollOperationState<VpnGatewaysStopPacketCaptureResponse>, VpnGatewaysStopPacketCaptureResponse>>;
    beginStopPacketCaptureAndWait(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysStopPacketCaptureOptionalParams): Promise<VpnGatewaysStopPacketCaptureResponse>;
    beginUpdateTags(resourceGroupName: string, gatewayName: string, vpnGatewayParameters: TagsObject, options?: VpnGatewaysUpdateTagsOptionalParams): Promise<PollerLike<PollOperationState<VpnGatewaysUpdateTagsResponse>, VpnGatewaysUpdateTagsResponse>>;
    beginUpdateTagsAndWait(resourceGroupName: string, gatewayName: string, vpnGatewayParameters: TagsObject, options?: VpnGatewaysUpdateTagsOptionalParams): Promise<VpnGatewaysUpdateTagsResponse>;
    get(resourceGroupName: string, gatewayName: string, options?: VpnGatewaysGetOptionalParams): Promise<VpnGatewaysGetResponse>;
    list(options?: VpnGatewaysListOptionalParams): PagedAsyncIterableIterator<VpnGateway>;
    listByResourceGroup(resourceGroupName: string, options?: VpnGatewaysListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VpnGateway>;
}

// @public
export interface VpnGatewaysCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnGatewaysCreateOrUpdateResponse = VpnGateway;

// @public
export interface VpnGatewaysDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VpnGatewaysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnGatewaysGetResponse = VpnGateway;

// @public
export interface VpnGatewaysListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnGatewaysListByResourceGroupNextResponse = ListVpnGatewaysResult;

// @public
export interface VpnGatewaysListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnGatewaysListByResourceGroupResponse = ListVpnGatewaysResult;

// @public
export interface VpnGatewaysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnGatewaysListNextResponse = ListVpnGatewaysResult;

// @public
export interface VpnGatewaysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnGatewaysListResponse = ListVpnGatewaysResult;

// @public
export interface VpnGatewaysResetOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnGatewaysResetResponse = VpnGateway;

// @public
export interface VpnGatewaysStartPacketCaptureOptionalParams extends coreClient.OperationOptions {
    parameters?: VpnGatewayPacketCaptureStartParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnGatewaysStartPacketCaptureResponse = {
    body: string;
};

// @public
export interface VpnGatewaysStopPacketCaptureOptionalParams extends coreClient.OperationOptions {
    parameters?: VpnGatewayPacketCaptureStopParameters;
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnGatewaysStopPacketCaptureResponse = {
    body: string;
};

// @public
export interface VpnGatewaysUpdateTagsOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnGatewaysUpdateTagsResponse = VpnGateway;

// @public
export type VpnGatewayTunnelingProtocol = string;

// @public
export interface VpnLinkBgpSettings {
    asn?: number;
    bgpPeeringAddress?: string;
}

// @public
export type VpnLinkConnectionMode = string;

// @public
export interface VpnLinkConnections {
    beginGetIkeSas(resourceGroupName: string, gatewayName: string, connectionName: string, linkConnectionName: string, options?: VpnLinkConnectionsGetIkeSasOptionalParams): Promise<PollerLike<PollOperationState<VpnLinkConnectionsGetIkeSasResponse>, VpnLinkConnectionsGetIkeSasResponse>>;
    beginGetIkeSasAndWait(resourceGroupName: string, gatewayName: string, connectionName: string, linkConnectionName: string, options?: VpnLinkConnectionsGetIkeSasOptionalParams): Promise<VpnLinkConnectionsGetIkeSasResponse>;
    beginResetConnection(resourceGroupName: string, gatewayName: string, connectionName: string, linkConnectionName: string, options?: VpnLinkConnectionsResetConnectionOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginResetConnectionAndWait(resourceGroupName: string, gatewayName: string, connectionName: string, linkConnectionName: string, options?: VpnLinkConnectionsResetConnectionOptionalParams): Promise<void>;
    listByVpnConnection(resourceGroupName: string, gatewayName: string, connectionName: string, options?: VpnLinkConnectionsListByVpnConnectionOptionalParams): PagedAsyncIterableIterator<VpnSiteLinkConnection>;
}

// @public
export interface VpnLinkConnectionsGetIkeSasOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnLinkConnectionsGetIkeSasResponse = {
    body: string;
};

// @public
export interface VpnLinkConnectionsListByVpnConnectionNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnLinkConnectionsListByVpnConnectionNextResponse = ListVpnSiteLinkConnectionsResult;

// @public
export interface VpnLinkConnectionsListByVpnConnectionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnLinkConnectionsListByVpnConnectionResponse = ListVpnSiteLinkConnectionsResult;

// @public
export interface VpnLinkConnectionsResetConnectionOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VpnLinkProviderProperties {
    linkProviderName?: string;
    linkSpeedInMbps?: number;
}

// @public
export interface VpnNatRuleMapping {
    addressSpace?: string;
    portRange?: string;
}

// @public
export type VpnNatRuleMode = string;

// @public
export type VpnNatRuleType = string;

// @public
export interface VpnPacketCaptureStartParameters {
    filterData?: string;
}

// @public
export interface VpnPacketCaptureStopParameters {
    sasUrl?: string;
}

// @public
export interface VpnProfileResponse {
    profileUrl?: string;
}

// @public
export interface VpnServerConfigRadiusClientRootCertificate {
    name?: string;
    thumbprint?: string;
}

// @public
export interface VpnServerConfigRadiusServerRootCertificate {
    name?: string;
    publicCertData?: string;
}

// @public
export type VpnServerConfiguration = Resource & {
    readonly etag?: string;
    namePropertiesName?: string;
    vpnProtocols?: VpnGatewayTunnelingProtocol[];
    vpnAuthenticationTypes?: VpnAuthenticationType[];
    vpnClientRootCertificates?: VpnServerConfigVpnClientRootCertificate[];
    vpnClientRevokedCertificates?: VpnServerConfigVpnClientRevokedCertificate[];
    radiusServerRootCertificates?: VpnServerConfigRadiusServerRootCertificate[];
    radiusClientRootCertificates?: VpnServerConfigRadiusClientRootCertificate[];
    vpnClientIpsecPolicies?: IpsecPolicy[];
    radiusServerAddress?: string;
    radiusServerSecret?: string;
    radiusServers?: RadiusServer[];
    aadAuthenticationParameters?: AadAuthenticationParameters;
    readonly provisioningState?: string;
    readonly p2SVpnGateways?: P2SVpnGateway[];
    readonly etagPropertiesEtag?: string;
};

// @public
export interface VpnServerConfigurations {
    beginCreateOrUpdate(resourceGroupName: string, vpnServerConfigurationName: string, vpnServerConfigurationParameters: VpnServerConfiguration, options?: VpnServerConfigurationsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VpnServerConfigurationsCreateOrUpdateResponse>, VpnServerConfigurationsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, vpnServerConfigurationName: string, vpnServerConfigurationParameters: VpnServerConfiguration, options?: VpnServerConfigurationsCreateOrUpdateOptionalParams): Promise<VpnServerConfigurationsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, vpnServerConfigurationName: string, options?: VpnServerConfigurationsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, vpnServerConfigurationName: string, options?: VpnServerConfigurationsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, vpnServerConfigurationName: string, options?: VpnServerConfigurationsGetOptionalParams): Promise<VpnServerConfigurationsGetResponse>;
    list(options?: VpnServerConfigurationsListOptionalParams): PagedAsyncIterableIterator<VpnServerConfiguration>;
    listByResourceGroup(resourceGroupName: string, options?: VpnServerConfigurationsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VpnServerConfiguration>;
    updateTags(resourceGroupName: string, vpnServerConfigurationName: string, vpnServerConfigurationParameters: TagsObject, options?: VpnServerConfigurationsUpdateTagsOptionalParams): Promise<VpnServerConfigurationsUpdateTagsResponse>;
}

// @public
export interface VpnServerConfigurationsAssociatedWithVirtualWan {
    beginList(resourceGroupName: string, virtualWANName: string, options?: VpnServerConfigurationsAssociatedWithVirtualWanListOptionalParams): Promise<PollerLike<PollOperationState<VpnServerConfigurationsAssociatedWithVirtualWanListResponse>, VpnServerConfigurationsAssociatedWithVirtualWanListResponse>>;
    beginListAndWait(resourceGroupName: string, virtualWANName: string, options?: VpnServerConfigurationsAssociatedWithVirtualWanListOptionalParams): Promise<VpnServerConfigurationsAssociatedWithVirtualWanListResponse>;
}

// @public
export interface VpnServerConfigurationsAssociatedWithVirtualWanListOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnServerConfigurationsAssociatedWithVirtualWanListResponse = VpnServerConfigurationsResponse;

// @public
export interface VpnServerConfigurationsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnServerConfigurationsCreateOrUpdateResponse = VpnServerConfiguration;

// @public
export interface VpnServerConfigurationsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VpnServerConfigurationsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnServerConfigurationsGetResponse = VpnServerConfiguration;

// @public
export interface VpnServerConfigurationsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnServerConfigurationsListByResourceGroupNextResponse = ListVpnServerConfigurationsResult;

// @public
export interface VpnServerConfigurationsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnServerConfigurationsListByResourceGroupResponse = ListVpnServerConfigurationsResult;

// @public
export interface VpnServerConfigurationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnServerConfigurationsListNextResponse = ListVpnServerConfigurationsResult;

// @public
export interface VpnServerConfigurationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnServerConfigurationsListResponse = ListVpnServerConfigurationsResult;

// @public
export interface VpnServerConfigurationsResponse {
    vpnServerConfigurationResourceIds?: string[];
}

// @public
export interface VpnServerConfigurationsUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnServerConfigurationsUpdateTagsResponse = VpnServerConfiguration;

// @public
export interface VpnServerConfigVpnClientRevokedCertificate {
    name?: string;
    thumbprint?: string;
}

// @public
export interface VpnServerConfigVpnClientRootCertificate {
    name?: string;
    publicCertData?: string;
}

// @public
export type VpnSite = Resource & {
    readonly etag?: string;
    virtualWan?: SubResource;
    deviceProperties?: DeviceProperties;
    ipAddress?: string;
    siteKey?: string;
    addressSpace?: AddressSpace;
    bgpProperties?: BgpSettings;
    readonly provisioningState?: ProvisioningState;
    isSecuritySite?: boolean;
    vpnSiteLinks?: VpnSiteLink[];
    o365Policy?: O365PolicyProperties;
};

// @public
export interface VpnSiteId {
    readonly vpnSite?: string;
}

// @public
export type VpnSiteLink = SubResource & {
    readonly etag?: string;
    name?: string;
    readonly type?: string;
    linkProperties?: VpnLinkProviderProperties;
    ipAddress?: string;
    fqdn?: string;
    bgpProperties?: VpnLinkBgpSettings;
    readonly provisioningState?: ProvisioningState;
};

// @public
export type VpnSiteLinkConnection = SubResource & {
    name?: string;
    readonly etag?: string;
    readonly type?: string;
    vpnSiteLink?: SubResource;
    routingWeight?: number;
    vpnLinkConnectionMode?: VpnLinkConnectionMode;
    readonly connectionStatus?: VpnConnectionStatus;
    vpnConnectionProtocolType?: VirtualNetworkGatewayConnectionProtocol;
    readonly ingressBytesTransferred?: number;
    readonly egressBytesTransferred?: number;
    connectionBandwidth?: number;
    sharedKey?: string;
    enableBgp?: boolean;
    usePolicyBasedTrafficSelectors?: boolean;
    ipsecPolicies?: IpsecPolicy[];
    enableRateLimiting?: boolean;
    useLocalAzureIpAddress?: boolean;
    readonly provisioningState?: ProvisioningState;
    ingressNatRules?: SubResource[];
    egressNatRules?: SubResource[];
};

// @public
export interface VpnSiteLinkConnections {
    get(resourceGroupName: string, gatewayName: string, connectionName: string, linkConnectionName: string, options?: VpnSiteLinkConnectionsGetOptionalParams): Promise<VpnSiteLinkConnectionsGetResponse>;
}

// @public
export interface VpnSiteLinkConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSiteLinkConnectionsGetResponse = VpnSiteLinkConnection;

// @public
export interface VpnSiteLinks {
    get(resourceGroupName: string, vpnSiteName: string, vpnSiteLinkName: string, options?: VpnSiteLinksGetOptionalParams): Promise<VpnSiteLinksGetResponse>;
    listByVpnSite(resourceGroupName: string, vpnSiteName: string, options?: VpnSiteLinksListByVpnSiteOptionalParams): PagedAsyncIterableIterator<VpnSiteLink>;
}

// @public
export interface VpnSiteLinksGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSiteLinksGetResponse = VpnSiteLink;

// @public
export interface VpnSiteLinksListByVpnSiteNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSiteLinksListByVpnSiteNextResponse = ListVpnSiteLinksResult;

// @public
export interface VpnSiteLinksListByVpnSiteOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSiteLinksListByVpnSiteResponse = ListVpnSiteLinksResult;

// @public
export interface VpnSites {
    beginCreateOrUpdate(resourceGroupName: string, vpnSiteName: string, vpnSiteParameters: VpnSite, options?: VpnSitesCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VpnSitesCreateOrUpdateResponse>, VpnSitesCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, vpnSiteName: string, vpnSiteParameters: VpnSite, options?: VpnSitesCreateOrUpdateOptionalParams): Promise<VpnSitesCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, vpnSiteName: string, options?: VpnSitesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, vpnSiteName: string, options?: VpnSitesDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, vpnSiteName: string, options?: VpnSitesGetOptionalParams): Promise<VpnSitesGetResponse>;
    list(options?: VpnSitesListOptionalParams): PagedAsyncIterableIterator<VpnSite>;
    listByResourceGroup(resourceGroupName: string, options?: VpnSitesListByResourceGroupOptionalParams): PagedAsyncIterableIterator<VpnSite>;
    updateTags(resourceGroupName: string, vpnSiteName: string, vpnSiteParameters: TagsObject, options?: VpnSitesUpdateTagsOptionalParams): Promise<VpnSitesUpdateTagsResponse>;
}

// @public
export interface VpnSitesConfiguration {
    beginDownload(resourceGroupName: string, virtualWANName: string, request: GetVpnSitesConfigurationRequest, options?: VpnSitesConfigurationDownloadOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDownloadAndWait(resourceGroupName: string, virtualWANName: string, request: GetVpnSitesConfigurationRequest, options?: VpnSitesConfigurationDownloadOptionalParams): Promise<void>;
}

// @public
export interface VpnSitesConfigurationDownloadOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VpnSitesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VpnSitesCreateOrUpdateResponse = VpnSite;

// @public
export interface VpnSitesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VpnSitesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSitesGetResponse = VpnSite;

// @public
export interface VpnSitesListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSitesListByResourceGroupNextResponse = ListVpnSitesResult;

// @public
export interface VpnSitesListByResourceGroupOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSitesListByResourceGroupResponse = ListVpnSitesResult;

// @public
export interface VpnSitesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSitesListNextResponse = ListVpnSitesResult;

// @public
export interface VpnSitesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSitesListResponse = ListVpnSitesResult;

// @public
export interface VpnSitesUpdateTagsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VpnSitesUpdateTagsResponse = VpnSite;

// @public
export type VpnType = string;

// @public
export type WebApplicationFirewallAction = string;

// @public
export interface WebApplicationFirewallCustomRule {
    action: WebApplicationFirewallAction;
    readonly etag?: string;
    matchConditions: MatchCondition[];
    name?: string;
    priority: number;
    ruleType: WebApplicationFirewallRuleType;
}

// @public
export type WebApplicationFirewallEnabledState = string;

// @public
export type WebApplicationFirewallMatchVariable = string;

// @public
export type WebApplicationFirewallMode = string;

// @public
export type WebApplicationFirewallOperator = string;

// @public
export interface WebApplicationFirewallPolicies {
    beginDelete(resourceGroupName: string, policyName: string, options?: WebApplicationFirewallPoliciesDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, policyName: string, options?: WebApplicationFirewallPoliciesDeleteOptionalParams): Promise<void>;
    createOrUpdate(resourceGroupName: string, policyName: string, parameters: WebApplicationFirewallPolicy, options?: WebApplicationFirewallPoliciesCreateOrUpdateOptionalParams): Promise<WebApplicationFirewallPoliciesCreateOrUpdateResponse>;
    get(resourceGroupName: string, policyName: string, options?: WebApplicationFirewallPoliciesGetOptionalParams): Promise<WebApplicationFirewallPoliciesGetResponse>;
    list(resourceGroupName: string, options?: WebApplicationFirewallPoliciesListOptionalParams): PagedAsyncIterableIterator<WebApplicationFirewallPolicy>;
    listAll(options?: WebApplicationFirewallPoliciesListAllOptionalParams): PagedAsyncIterableIterator<WebApplicationFirewallPolicy>;
}

// @public
export interface WebApplicationFirewallPoliciesCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebApplicationFirewallPoliciesCreateOrUpdateResponse = WebApplicationFirewallPolicy;

// @public
export interface WebApplicationFirewallPoliciesDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface WebApplicationFirewallPoliciesGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebApplicationFirewallPoliciesGetResponse = WebApplicationFirewallPolicy;

// @public
export interface WebApplicationFirewallPoliciesListAllNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebApplicationFirewallPoliciesListAllNextResponse = WebApplicationFirewallPolicyListResult;

// @public
export interface WebApplicationFirewallPoliciesListAllOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebApplicationFirewallPoliciesListAllResponse = WebApplicationFirewallPolicyListResult;

// @public
export interface WebApplicationFirewallPoliciesListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebApplicationFirewallPoliciesListNextResponse = WebApplicationFirewallPolicyListResult;

// @public
export interface WebApplicationFirewallPoliciesListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebApplicationFirewallPoliciesListResponse = WebApplicationFirewallPolicyListResult;

// @public
export type WebApplicationFirewallPolicy = Resource & {
    readonly etag?: string;
    policySettings?: PolicySettings;
    customRules?: WebApplicationFirewallCustomRule[];
    readonly applicationGateways?: ApplicationGateway[];
    readonly provisioningState?: ProvisioningState;
    readonly resourceState?: WebApplicationFirewallPolicyResourceState;
    managedRules?: ManagedRulesDefinition;
    readonly httpListeners?: SubResource[];
    readonly pathBasedRules?: SubResource[];
};

// @public
export interface WebApplicationFirewallPolicyListResult {
    readonly nextLink?: string;
    readonly value?: WebApplicationFirewallPolicy[];
}

// @public
export type WebApplicationFirewallPolicyResourceState = string;

// @public
export type WebApplicationFirewallRuleType = string;

// @public
export type WebApplicationFirewallTransform = string;

// @public
export interface WebCategories {
    get(name: string, options?: WebCategoriesGetOptionalParams): Promise<WebCategoriesGetResponse>;
    listBySubscription(options?: WebCategoriesListBySubscriptionOptionalParams): PagedAsyncIterableIterator<AzureWebCategory>;
}

// @public
export interface WebCategoriesGetOptionalParams extends coreClient.OperationOptions {
    expand?: string;
}

// @public
export type WebCategoriesGetResponse = AzureWebCategory;

// @public
export interface WebCategoriesListBySubscriptionNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebCategoriesListBySubscriptionNextResponse = AzureWebCategoryListResult;

// @public
export interface WebCategoriesListBySubscriptionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type WebCategoriesListBySubscriptionResponse = AzureWebCategoryListResult;

// (No @packageDocumentation comment for this package)

```
